/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {
	
		document.getElementById('Type').selectedItem = document.getElementById('TypeG');
		var paramlist = "&Page=Compta/GetRDF/Dossier.tmpl&ContentType=xml";
    load_rdf_async('Exercice', getUrlOpeneas(paramlist), initExercice);
		
		paramlist = "&Page=Compta/GetRDF/types_export.tmpl&ContentType=xml";
    load_rdf_async('Type_Export', getUrlOpeneas(paramlist), initType_Export);
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#init : ' + e);
  }
}


function initExercice() {
	try {
	
		document.getElementById('Exercice').selectedIndex = 0;
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#initExercice : ' + e);
  }
}


function initType_Export() {
	try {
		
		document.getElementById('Type_Export').selectedIndex = 0;
		loadFormats(document.getElementById('Type_Export').value);
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#initType_Export : ' + e);
  }
}


function initFormat_Export() {
	try {
	
		document.getElementById('Format_Export').selectedIndex = 0;
		if (document.getElementById('Format_Export').value=="E_TABLEUR_ASC") {
			document.getElementById('Tableur').collapsed=false;
		}
		else {
			document.getElementById('Tableur').collapsed=true;
		}
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#initFormat_Export : ' + e);
  }
}


function loadFormats(export_id) {
	try {
		
		deleteFormats();
		
		var paramlist = "&Page=Compta/GetRDF/formats_export.tmpl&ContentType=xml&Export_Id="+ export_id;
  	load_rdf_async('Format_Export', getUrlOpeneas(paramlist), initFormat_Export);

	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#loadFormats : ' + e);
  }
}

function disableDates(b) {
	try {
		
		document.getElementById('Date_Debut').disabled = b;
		document.getElementById('Date_Fin').disabled = b;
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#disableDates : ' + e);
  }
}

function deleteFormats() {
  try {
	
    var database = document.getElementById("Format_Export").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }		
		document.getElementById('Format_Export').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#deleteFormats : ' + e);
  }
}


function exporter() {
	try {
	
		document.getElementById('progression').collapsed = false;
		document.getElementById('pm').setAttribute("mode", "undetermined");
		document.getElementById('bExporter').disabled = true;
		
		var base = document.getElementById('Exercice').value;
		var format = document.getElementById('Format_Export').value;
		var date_debut = document.getElementById('Date_Debut').value;
		var date_fin = document.getElementById('Date_Fin').value;
		if (document.getElementById('PeriodeDD').selected && (!isDate(date_fin) || !isDate(date_debut) || !isDateInterval(date_debut, date_fin))) {
			showMessage("Plage de dates invalide !");
			document.getElementById('progression').collapsed = true;
			document.getElementById('bExporter').disabled = false;			
		}
		else {

			var fichier_sugg = get_cookie("Dossier_Id")+ ".txt";

			if (format=="CE_OPENSI_XML") fichier_sugg = get_cookie("Dossier_Id")+ ".xml";
			else if (format=="E_TABLEUR_ASC") fichier_sugg = get_cookie("Dossier_Id")+ ".csv";
			var corps = cookie() + "&Page=Compta/Export/ProcessExport.tmpl&ContentType=xml&Base="+ base;
			corps += "&Date_Debut="+ date_debut;
			corps += "&Date_Fin="+ date_fin;
			corps += "&Periode="+ document.getElementById('Periode').value;
			corps += "&Format="+ format+"&Type="+ document.getElementById('Type').value;
			req1 = new XMLHttpRequest();
    	requeteHTTP(corps,req1,exporter_2,fichier_sugg);
		}
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#exporter_1 : ' + e);
  }
}


function exporter_2(req1, fichier_sugg) {
	try {
	
		var contenu = req1.responseXML;

		var action_error = contenu.documentElement.getAttribute('action_error');
		var fichier_export = contenu.documentElement.getAttribute('fichier_export');

		document.getElementById('pm').setAttribute("mode", "none");
		document.getElementById('progression').collapsed = true;
		document.getElementById('bExporter').disabled = false;

		if (action_error!="") {
			showWarning(action_error);
		}
		else {		
			var file = fileChooser("save", fichier_sugg);

			if (file!=null) {
				downloadFile(getDirBuffer()+ fichier_export, file);
			}
		}

	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#exporter_2 : ' + e);
  }
}


// en souvenir...
function test_download() {
	try {	
	
	/*var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	 	
		file.initWithPath("/home/franck/test_export.txt");
		file.create(file.NORMAL_FILE_TYPE, 511);*/
	
	//var url = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIStandardURL);
	//url.init(url.URLTYPE_STANDARD, 8080, getDirServeur() +"export/"+ fichier_export);
	
	//var uri = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	//var url = uri.newURI(getDirServeur() +"iobuffer/test.txt", "", null);
	//var fileurl = uri.newFileURI(file);
	
	//var wp = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
	//wp.saveURI(url,null,null,null,null,file);
	
	//var dl = Components.classes["@mozilla.org/download;1"].createInstance(Components.interfaces.nsIDownload);
	
	//var mime = Components.classes["@mozilla.org/mime-info;1"].createInstance(Components.interfaces.nsIMIMEInfo);
	
	//var obs = Components.classes["@mozilla.org/download-manager;1"].createInstance(Components.interfaces.nsIDownloadManager);
	//dl.init(url, fileurl, "exportopensi", null, 0, null);
	//alert(dl.percentComplete);
	
	//var dm = Components.classes["@mozilla.org/download-manager;1"].getService(Components.interfaces.nsIDownloadManager);
	//dm.addDownload(1, url, fileurl, "exportopensi", "", null, 0, null);
	//dm.open(this, null);
	
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#test_download : ' + e);
  }
}


function retour_menu_autres() {
  try {
	
    var page = "chrome://opensi/content/compta/user/autres/menu_autres.xul?" + cookie() ;
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#retour_menu_autres : ' + e);
  }
}

function retour_menu_principal() {
  try {
	
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie() ;
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/export.js#retour_menu_principal : ' + e);
  }
}
