/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {
	
		var paramlist = "&Page=Compta/GetRDF/Dossier.tmpl&ContentType=xml";
    load_rdf_async('Exercice', getUrlOpeneas(paramlist), initExercice);
		
		paramlist = "&Page=Compta/GetRDF/types_import.tmpl&ContentType=xml";
    load_rdf_async('Type_Import', getUrlOpeneas(paramlist), initType_Import);

		paramlist = "&Page=Compta/GetRDF/liste_journaux.tmpl&ContentType=xml&Type_Journal=VE";
    load_rdf_async('Journal', getUrlOpeneas(paramlist), initJournal);

	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#init : ' + e);
  }
}

function initExercice() {
	try {
	
		document.getElementById('Exercice').selectedIndex = 0;
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#initExercice : ' + e);
  }
}

function initType_Import() {
	try {
		
		document.getElementById('Type_Import').selectedIndex = 0;
		loadFormats(document.getElementById('Type_Import').value);
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#initType_Import : ' + e);
  }
}

function initFormat_Import() {
	try {
	
		document.getElementById('Format_Import').selectedIndex = 0;
		cacher();
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#initFormat_Import : ' + e);
  }
}

function initJournal() {
	try {
	
		document.getElementById('Journal').selectedIndex = 0;
		cacher();
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#initJournal : ' + e);
  }
}

function cacher () {
	try {

		var fact=(document.getElementById('Format_Import').value=="CE_CSV_ASC");
		document.getElementById('ecr').collapsed=fact;
		document.getElementById('jour').collapsed=!fact;
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#cacher : ' + e);
  }
}

function loadFormats(import_id) {
	try {
		
		deleteFormats();
		
		var paramlist = "&Page=Compta/GetRDF/formats_import.tmpl&ContentType=xml&Import_Id="+ import_id;
  	load_rdf_async('Format_Import', getUrlOpeneas(paramlist), initFormat_Import);

	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#loadFormats : ' + e);
  }
}

function deleteFormats() {
  try {
	
    var database = document.getElementById("Format_Import").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }		
		document.getElementById('Format_Import').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#deleteFormats : ' + e);
  }
}

function importer() {
	try {
		
		//if (get_cookie("Writeable")==1) {
		
			var base = document.getElementById('Exercice').value;
			var format = document.getElementById('Format_Import').value;
			var ecraser = document.getElementById('Ecraser').value;
			var ecraser = document.getElementById('Ecraser').value;
			var journal = document.getElementById('Journal').value;
			var fact=(format=="CE_CSV_ASC");

			if (isEmpty(document.getElementById('FichierImport').value)) {
				showWarning('Vous devez selectionner un fichier  importer !');
			}
			else if (isEmpty(ecraser) && !fact) {
				showWarning('Vous devez indiquer si les anciennes critures doivent tre crases !');
			}
			else if (isEmpty(journal) && fact) {
				showWarning('Vous devez indiquer un journal de vente !');
			}
			else {

				delete_tree();

				document.getElementById('boxJournal').collapsed = true;		
				document.getElementById('bImporter').disabled = true;
				document.getElementById('progression').collapsed = false;
				document.getElementById('pm').setAttribute("mode", "undetermined");

				fichierImport = getFileName(document.getElementById('FichierImport').value);
				var url = "chrome://opensi/content/compta/util/upload.xul?"+ cookie();
    		url += "&file="+ document.getElementById('FichierImport').value;
				url += "&dir=iobuffer";
   			window.openDialog(url,'','chrome,modal');

				var paramlist = "&Page=Compta/Import/ProcessImport.tmpl&ContentType=xml&FichierImport="+ fichierImport; 
				paramlist += "&Base="+ base +"&Format="+ format;
				if (!fact) {
					paramlist += "&Ecraser="+ ecraser+"&Journal=0";
				}
				else {
					paramlist += "&Ecraser=0&Journal="+ journal;
				}
				load_rdf_async("journal", getUrlOpeneas(paramlist), importer_2);	
    	}
		/*}
		else {
			showWarning("L'");
		}*/
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#importer : ' + e);
  }
}


function importer_2() {
	try {
	
		//req1.responseXML;

		/*var action_error = contenu.documentElement.getAttribute('action_error');*/
		
		document.getElementById('pm').setAttribute("mode", "none");
		document.getElementById('progression').collapsed = true;
		document.getElementById('bImporter').disabled = false;
		document.getElementById('boxJournal').collapsed = false;
		
		showMessage("Import termin");
	
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#importer_2 : ' + e);
  }
}


function delete_tree() {
  try {
	
    var database = document.getElementById("journal").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }		
		document.getElementById('journal').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#delete_tree : ' + e);
  }
}


function retour_menu_autres() {
  try {
    var page = "chrome://opensi/content/compta/user/autres/menu_autres.xul?" + cookie() ;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#retour_menu_autres : ' + e);
  }
}

function retour_menu_principal() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie() ;
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/import.js#retour_menu_principal : ' + e);
  }
}
