/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var focus_input = ''; // id du textbox ayant le focus.
var id_select = -1;
var force = false;
var dsource; // source de donnes RDF de l'arbre.
var rExp = / /gi;
var anc_value;
var debit_tot;
var credit_tot;
var debit_aff ;
var credit_aff ;

/*****************************************************
 *  @return l'id de l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree_id(){
  return 'ventilation';
}

/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree(){
  try {
    return document.getElementById(get_tree_id());
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#get_tree : ' + e);
  }
}

function get_root() {
  try {
    return dsource.getNode("http://www.opensi.org/compta/bank/ventilation");
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#get_root : ' + e);
  }
}

/****************************************************
 *  Correspondance entre l'id d'un textbox et le target RDF associ
 *  @param id : l'identifiant du textbox
 *  @return le target associ
 ****************************************************/
function targetname(id) {
  
  try {
  
    switch(id) {
      case 'input_compte':
        return "http://www.opensi.org/compta/bank/ventilation/rdf#compte";
        break;
      case 'input_libelle':
        return "http://www.opensi.org/compta/bank/ventilation/rdf#libelle";
        break;
      case 'input_debit':
        return "http://www.opensi.org/compta/bank/ventilation/rdf#debit";
        break;
      case 'input_credit':
        return "http://www.opensi.org/compta/bank/ventilation/rdf#credit";
        break;
      case 'input_debit_aff':
        return "http://www.opensi.org/compta/bank/ventilation/rdf#debitaff";
        break;
      case 'input_credit_aff':
        return "http://www.opensi.org/compta/bank/ventilation/rdf#creditaff";
        break;
      default:
        return '';
    }
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#targetname : ' + e);
  }

}

function get_child(id) {

  try {
  
    var child = null;

    var index = id + 1;
    var root = get_root();
    var children = root.getChildren();
    var found = false;

    while ((children.hasMoreElements()) && (! found) ) {
      var c = children.getNext();
      if (root.getChildIndex(c) == index) {
        child = c;
        found = true;
      }
    }

    return child;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#get_child : ' + e);
  }
  
}

function init() {
	try {
    var x = screen.width * 0.1 ;
    var y = screen.height * 0.3 ;
    var w = screen.width * 0.8 ;
    var h = screen.height * 0.4 ;    
//    var x = (screen.width / 2) - 400;
//    var y = (screen.height / 2) - 200;
    window.resizeTo(w,h);
    window.moveTo(x,y);
    debit_tot = ParamValeur('debit');
    credit_tot = ParamValeur('credit');
    if (isEmpty(debit_tot) || debit_tot == 0) {
      document.getElementById('debit_tot').value = '';
    } else {
      document.getElementById('debit_tot').value = format(debit_tot,2,' ',0);
    }
    if (isEmpty(credit_tot) || credit_tot == 0) {
      document.getElementById('credit_tot').value = '';
    } else {
      document.getElementById('credit_tot').value = format(credit_tot,2,' ',0);
    }
    debit_aff = 0;
    credit_aff = 0;
    maj_aff_solde();
    dsource = new RDFDataSource(); 
    var datasource = dsource.getRawDataSource();
    get_tree().database.AddDataSource(datasource);
    document.getElementById("input_libelle").focus();
    document.getElementById("input_debit").focus();
    document.getElementById("input_credit").focus();
    focus_input = "input_compte";
    document.getElementById(focus_input).focus();
    init_tree();
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#init : ' + e);
  }
}

function init_tree() {

  try {
    
    var uri = "http://www.opensi.org/compta/bank/ventilation";
    var root = dsource.getNode(uri);
    root.makeSeq();   
    var child = dsource.getAnonymousNode();
    root.addChild(child);

    select_begin();
    
	} catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#init_tree : ' + e);
  }

}

/****************************************************
 *  Excut lorsqu'une zone de saisie prend le focus.
 *  affecte le nom de classe 'focus'  la zone.
 *  @param t : la zone de saisie.
 *  @param id : l'identifieur de la zone de saisie.
 ****************************************************/
function focus_field(t,id){

  try {

    t.setSelectionRange(0,t.textLength);
    focus_input = id;
    anc_value = t.value;
    switch (id) {
      case 'input_compte':
      case 'input_libelle':
        t.className = 'focus';
        break;
      case 'input_debit':
      case 'input_credit':
        t.className = 'debitcredit-focus';
        break;
    }
    get_tree().treeBoxObject.focused = true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#focus_field : ' + e);
  }

}

/****************************************************
 * Rcupre le nombre d'critures sur la base
 ****************************************************/
function get_nb_pages(){

  try {

    var corps = cookie() + "&Page=Compta/GetNbEcrituresBanque.tmpl&ContentType=xml";
    var p = requeteHTTP(corps);

    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
      return '';
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      var nbecr =  session.getAttribute('nb');
      return parseInt(nbecr/20+1);
    }  
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#get_nb_pages : ' + e);
  }

}

/****************************************************
 *  Excut lorsqu'une zone de saisie perd le focus.
 *  affecte le nom de classe 'focus'  la zone.
 *  @param t : la zone de saisie.
 *  @param id : l'identifieur de la zone de saisie.
 ****************************************************/
function blur_field(t,id){
  switch(id) {
      case 'input_compte':
      case 'input_libelle':
        t.className = 'normal';
        break;
      case 'input_debit':
      case 'input_credit':
        t.className = 'debitcredit-normal';
        break;
    }
}

/****************************************************
 *  Affecte aux zones de saisie les valeurs correspondant
 *   la ligne slectionne de l'arbre.
 ****************************************************/
function reporter() {
  
  try {
    
    id_select = get_tree().currentIndex;
    var v = get_tree().view;

    if (id_select == -1) return false;
      
    var compte = v.getCellText(v.selection.currentIndex,'compte');
    document.getElementById('input_compte').value = compte;
    if (isEmpty(compte)) {
      document.getElementById('libelle_compte').value = '';
      document.getElementById('solde_compte').value = '';
    } else {
      maj_aff_compte(document.getElementById('input_compte'),false) ;
    }
    var libelle = v.getCellText(v.selection.currentIndex,'libelle');
    document.getElementById("input_libelle").value = libelle;
    var debit = v.getCellText(v.selection.currentIndex,'debit');
    document.getElementById("input_debit").value = debit;
    var credit = v.getCellText(v.selection.currentIndex,'credit');
    document.getElementById("input_credit").value = credit;
    document.getElementById(focus_input).focus();

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#reporter : ' + e);
  }

}

/****************************************************
 *  Mise  jour des valeurs du solde et du libell
 * du compte affich dans la ligne de saisie.
 ****************************************************/
function maj_aff_compte(t,rech) {
  
  try {
  
    var compte = t.value;
    while (compte.length < 8) compte += '0';
    var paramlist = cookie() + "&Page=Compta/GetRDF/liste_comptes.tmpl&ContentType=xml";
    paramlist += "&Numero_Compte=" + compte;
  
    var p = requeteHTTP(paramlist);
  
    if (p.status == "0") return false;
    
    if ( p.status != "200" ) {
      alert("Rception erreur " + p.status);
    } else {
      var contenu=p.responseXML;
      var session = contenu.documentElement;
      if (session.getElementsByTagName('numero').length  == 0 ) {
        if (rech) {
          recherche_compte(t);
          return '';
        }
      } else if (t.id == 'input_compte') {
        var l = session.getElementsByTagName('libelle')[0];
        document.getElementById('libelle_compte').value = l.firstChild.data;
        var l = session.getElementsByTagName('gen')[0];
        document.getElementById('type_compte').value = l.firstChild.data;
        var s = session.getElementsByTagName('solde')[0];
        var d = session.getElementsByTagName('debit')[0]; 
        var c = session.getElementsByTagName('credit')[0];
        document.getElementById('solde_compte').value = s.firstChild.data;
        document.getElementById('debit_compte').value = d.firstChild.data;
        document.getElementById('credit_compte').value = c.firstChild.data;
        var os = session.getElementsByTagName('old_solde')[0];
        var od = session.getElementsByTagName('old_debit')[0]; 
        var oc = session.getElementsByTagName('old_credit')[0];
        document.getElementById('old_solde_compte').value = os.firstChild.data;
        document.getElementById('old_debit_compte').value = od.firstChild.data;
        document.getElementById('old_credit_compte').value = oc.firstChild.data;
      }

    }
    
    return compte;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#maj_aff_compte : ' + e);
  }

}

/****************************************************
 *  Effectue une recherche de compte
 *  @param t la zone de saisie  affecter.
 ****************************************************/
function recherche_compte(t){
  try {
    var compte = t.value;
    var id = t.id
    var url = "chrome://opensi/content/config/util/rechcompte.xul?" + cookie();
    window.openDialog(url,'rechcompte','chrome,modal',compte,id,true);
    change_compte();
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#recherche_compte : ' + e);
  }
}


/****************************************************
 *  Excut lorsque l'utilisateur appuie sur une touche du clavier.
 *  @param e : la touche du clavier
 ****************************************************/
function keypress(e) {
  try {
    switch (e.keyCode) {
      case 33: // 'PageUp'
        select_up();
        break;
      case 34: // 'PageDown'
        select_down();
        break;
      case 35: // 'Fin'
        select_end();
        break;
      case 36: // 'Debut'
        select_begin();
        break;
      case 37: // '<-'
      case 27: // 'Echap'
        focus_prev();
        break;
      case 38: // '^'
        select_prev();
        break;
      case 13: // 'Enter'
      case 39: // '->'
        focus_next();
        break;
      case 9: // TAB
//        var f;
//        switch (focus_input) {
//        }
//        f.focus();
        break;
      case 40: // 'v'
        select_next();
        break;
/*
      case 46: // 'Suppr'
        supprimer();
        break;
*/
      case 114: // 'F3'
        reprise_lib_compte();
        break;
        
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#keypress : ' + e);
  }
}


/****************************************************
 ****************************************************/
function reprise_lib_compte() {
  try {
    if (focus_input == 'input_libelle') {
      var libelle_compte = document.getElementById('libelle_compte').value;
      document.getElementById('input_libelle').value = libelle_compte;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#reprise_num_compte : ' + e);
  }
}

/****************************************************
 *  selectionne un ligne dans l'arbre.
 *  @param index : l'index de la ligne de l'arbre  slectionner
 ****************************************************/
function select_row(index) {
  try {
    var tree = get_tree();
    if (tree.view != null) {
      tree.view.selection.select(index);
      tree.treeBoxObject.ensureRowIsVisible(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#select_row : ' + e);
  }
}

/****************************************************
 *  slection de la premire ligne de l'arbre
 ****************************************************/
function select_begin(){
  select_row(0);
}

/****************************************************
 *  slection de la dernire ligne de l'arbre
 ****************************************************/
function select_end(){
  try {
    var v = get_tree().view;
    select_row(v.rowCount - 1);
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#select_end : ' + e);
  }
}

/****************************************************
 *  slection d'une ligne 10 lignes au dessus de la ligne slectionne
 ****************************************************/
function select_up(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 10;
    if (index < 0) {
      select_begin();
    } else {
      while (v.isSeparator(index)) index--;
      if (index >= 0) {
        select_row(index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#select_up : ' + e);
  }
}

/****************************************************
 *  slection d'une ligne 10 lignes en dessous de la ligne slectionne
 ****************************************************/
function select_down(){
  try {
    var v = get_tree().view;
    var rc = v.rowCount;
    var index = v.selection.currentIndex + 10 ;
    if (index >= rc) {
      select_end();
    } else {
      while (v.isSeparator(index)) index++;
      if (index < rc) {
        select_row(index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#select_down : ' + e);
  }
}

/****************************************************
 *  slection de la ligne prcdente  la ligne slectionne
 ****************************************************/
function select_prev(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 1;
    if (index < 0) return false;
    while (v.isSeparator(index)) index--;
    if (index >= 0) {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#select_prev : ' + e);
  }
}

/****************************************************
 *  slection de la ligne suivante  la ligne slectionne
 ****************************************************/
function select_next(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex + 1;
    if (index >= v.rowCount) return false;
    while ((index < v.rowCount) && (v.isSeparator(index))) index++;
    if (index < v.rowCount ) {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#select_next : ' + e);
  }
}

/****************************************************
 *  focus sur la zone de saisie prcdant la zone
 *  ayant couramment le focus.
 ****************************************************/
function focus_prev(){
  
  try {
  
    var f = focus_input;
    var t = document.getElementById(f);
    switch (f) {
      case 'input_libelle':
        if (t.value != anc_value) {
          if(change_libelle()) {
            f = 'input_compte';
          } else {
            f = 'input_libelle';
          }
        } else {
          f = 'input_compte';
        }
        break;
      case 'input_debit':
        if (t.value != anc_value) {
          if(change_debit()) {
            f = 'input_libelle';
          } else {
            f = 'input_debit';
          }
        } else {
          f = 'input_libelle';
        }
        break;
      case 'input_credit':
        if (t.value != anc_value) {
          if(change_credit()) {
            if (isEmpty(t.value)) {
              f = 'input_debit';
            } else {
              f = 'input_libelle';
            } 
          } else {
            f = 'input_credit';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_debit';
        } else {
          f = 'input_libelle';
        }
        break;
    }
    document.getElementById(f).focus();

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#focus_prev : ' + e);
  }

}

/****************************************************
 *  focus sur la zone de saisie suivant la zone
 *  ayant couramment le focus.
 ****************************************************/
function focus_next(){
  
  try {
  
    var f = focus_input;
    var t = document.getElementById(f);
    var debit = document.getElementById('input_debit').value;
    var credit = document.getElementById('input_credit').value;
    switch (f) {
      case 'input_compte':
        if (t.value != anc_value) {
          if (change_compte()) {
            f = 'input_libelle';
          } else {
            f = 'input_compte';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_compte';
        } else {
          f = 'input_libelle';
        }
        break;
      case 'input_libelle':
        if (t.value != anc_value) {
          if (change_libelle()) {
            f = 'input_debit';
          } else {
            f = 'input_libelle';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_libelle';
        } else {
          if ((isEmpty(debit)) && (! isEmpty(credit))) {
            f = 'input_credit';
          } else {
            f = 'input_debit';
          }
        }
        break;
      case 'input_debit':
        var view = get_tree().view;
        if (t.value != anc_value) {
          if (change_debit()) {
            if (isEmpty(t.value)) {
              f = 'input_credit';
            } else {
              ligne_suivante();
              f = 'input_compte';
            }
          } else {
            ligne_suivante();
            f = 'input_compte';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_credit';
        } else {
          ligne_suivante();
          f = 'input_compte';
        }
        break;
      case 'input_credit':
        var view = get_tree().view;
        if (t.value != anc_value) {
          if (change_credit()) {
            if (isEmpty(t.value)) {
              f = 'input_debit';
            } else {
              ligne_suivante();
              f = 'input_compte';
            }
          } else {
            ligne_suivante();
            f = 'input_compte';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_debit';
        } else {
          ligne_suivante();
          f = 'input_compte';
        }
        break;
    }
    document.getElementById(f).focus();

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#focus_next : ' + e);
  }

}
/****************************************************
 *  Excut lorsque la valeur du dbit ou du crdit a t modifie
 *  @name 'debit' ou 'credit'
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_debitcredit(name) {

  if ((name != 'debit') && (name != 'credit')) {
    recup_erreur("erreur dans compta/user/autres/bank/ventilation.js#change_debitcredit :"
                 + " paramtre <name> invalide : '" + name + "'");
    return false;
  }

  try {

    var id = 'input_' + name;
    var t = document.getElementById(id);
    var v = t.value;
    var value = 0;
    if (! isEmpty(v)) {
      if (v == '*') {
        var solde_tot = credit_tot - debit_tot;
        var solde_aff = credit_aff - debit_aff;
        var aux = solde_tot - solde_aff;
        var solde_rest = parseFloat(format(aux,2,'',0));
        switch (name) {
          case 'debit':
            if (solde_rest < 0) value = 0 - solde_rest;
            break;
          case 'credit':
            if (solde_rest > 0) value = solde_rest;
            break;
        }
      } else {
        try {
         value = eval(v.replace(rExp,''));
        } catch (e) {
          t.value = anc_value;
          alert('Valeur incorrecte');
          return false;
        }
      }
    }
    if (value != 0) {
      t.value = format(value,2,'',0);
    } else {
      t.value = '';
    }
    var aux = parseFloat(anc_value.replace(rExp,''));
    if (isNaN(aux)) aux = 0;
    var delta = value - aux;
    modif_field(name,delta);
    change_field(id);
    return true;
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#change_debitcredit : ' + e);
  }
    
}
  
/****************************************************
 *  Excut lorsque la valeur du dbit a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_debit() {
  return change_debitcredit('debit');
}

/****************************************************
 *  Excut lorsque la valeur du crdit a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_credit() {
  return change_debitcredit('credit');
}

/****************************************************
 *  Excut lorsque la valeur du dbit ou du crdit a t modifie
 *  @param fieldname 'debit' ou 'credit'
 *  @param delta la diffrence de dbit  appliquer
 ****************************************************/
function modif_field(fieldname,delta) {
  
  if ((fieldname != 'debit') && (fieldname != 'credit')) {
    recup_erreur("erreur dans compta/user/autres/bank/ventilation.js#modif_field :"
                 + " paramtre <fieldname> invalide : '" + fieldname + "'");
    return -1;
  }

  try {

    var tot_name = fieldname + '_aff';
    switch(fieldname) {
      case 'debit':
        debit_aff += delta;
        break;
      case 'credit':
        credit_aff += delta;
        break;
    }

    maj_aff_solde();
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#modif_field : ' + e);
  }

}

/****************************************************
 *  Mise  jour des valeurs du total crdit, du total dbit
 * et du solde de l'criture en cours de saisie.
 ****************************************************/
function maj_aff_solde() {
  
  try {
    

    var solde_tot = parseFloat(format(credit_tot - debit_tot,2,'',0));
    var solde_aff = parseFloat(format(credit_aff - debit_aff,2,'',0));
    var solde_rest = parseFloat(format(solde_tot - solde_aff,2,'',0));
    if (debit_aff == 0) {
      document.getElementById('debit_aff').value = '';
    } else {
      document.getElementById('debit_aff').value = format(debit_aff,2,' ',0);
    }
    if (credit_aff == 0) {
      document.getElementById('credit_aff').value = '';
    } else {
      document.getElementById('credit_aff').value = format(credit_aff,2,' ',0);
    }

    if (solde_rest == 0) {
      document.getElementById('debit_rest').value = '';
      document.getElementById('credit_rest').value = '';
      document.getElementById('ok').collapsed = false;
    } else {
      document.getElementById('ok').collapsed = true;
      if (solde_rest > 0) {
        document.getElementById('debit_rest').value = '';
        document.getElementById('credit_rest').value = format(solde_rest,2,' ',0);
      } else {
        document.getElementById('credit_rest').value = '';
        document.getElementById('debit_rest').value = format( 0 - solde_rest ,2,' ',0);
      }
    }
  
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#maj_aff_solde : ' + e);
  }

}

function ligne_suivante() {
  try{
    var view = get_tree().view;
    if (view.rowCount == view.selection.currentIndex + 1) {
      ajout_ligne();
    } else {
      select_next();
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#ligne_suivante : ' + e);
  }
}

/****************************************************
 *  insre une ligne de saisie vierge dans une criture
 ****************************************************/
function ajout_ligne() {

  try {
    
    var v = get_tree().view;
    var index = v.selection.currentIndex;

    var child = dsource.getAnonymousNode();
    
    var root = get_root();
    root.addChildAt(child,index+2);
      
    select_row(index + 1);
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajout_ligne : ' + e);
  }
}

/****************************************************
 *  Excut lorsqu'une zone de saisie a t modifie
 *  
 *  @param id : l'identifiant de la zone de saisie.
 ****************************************************/
function change_field(id){
  try{
        
    var t = document.getElementById(id);
    var child = get_child(get_tree().currentIndex);
    var value = t.value;
    if (id == 'input_debit' || id == 'input_credit') {
      var idaff = id + '_aff';
      child.addTargetOnce(targetname(idaff),format(value,2,' ',0));
    }
    child.addTargetOnce(targetname(id),value);
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#change_field : ' + e);
  }
}

/****************************************************
 *  Excut lorsque le numero de compte a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_compte() {
  
  try {

    var t = document.getElementById('input_compte');
//    var comptes = document.getElementById('liste_comptes');
    if (isEmpty(t.value)) {
      return false;
    }
    if (force) {
      maj_aff_compte(t,false);
      force = false;
    } else {
      if (t.value == '*') t.value = ' ';
      var compte = maj_aff_compte(t,true);
      if (isEmpty(compte)) return false;
      t.value = compte;
    }

    
    change_field('input_compte');

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#change_compte : ' + e);
  }

}

/****************************************************
 *  Excut lorsque le libell a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_libelle() {
  
  try {
  
    var t = document.getElementById('input_libelle');
    if (isEmpty(t.value)) {
      return false;
    }
    change_field('input_libelle');

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#change_libelle : ' + e);
  }

}

function ok() {
  
  try {
    var id = ParamValeur('id');
    var day = ParamValeur('day');
    var month = ParamValeur('month');
    var year = ParamValeur('year');
    var date = ParamValeur('date');
    var num = ParamValeur('num');
    var base = ParamValeur('base');
    opener.supprimer(id);
    var v = get_tree().view;
    
    for (i = 0;i<v.rowCount;i++) {
      id++;
      var compte = v.getCellText(i,'compte');
      var libelle = v.getCellText(i,'libelle');
      var debit = v.getCellText(i,'debit');
      var credit = v.getCellText(i,'credit');
      if (! (isEmpty(debit) && isEmpty(credit)))
        opener.ajouter(id,date,day,month,year,compte,libelle,debit,credit,num,base);
    }

    opener.focus();
    window.close();
    
  } catch (e) {
    recup_erreur('erreur dans compta/user/autres/bank/ventilation.js#ok : ' + e);
  }

}

function cancel() {
  opener.focus();
  window.close();
}