/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fentre <compta/user/cloture/options_cloture.xul>
 * @include chrome://opensi/content/libs/util.js
 * @include chrome://opensi/content/libs/verif.js
 *
 */

var nouvel_exercice = false; // variable globale indiquant s'il faut creer un nouvel exercice

function init() {
	try {		
	
		document.getElementById("AExtourner").value = "non"; 
		document.getElementById("DetailTiers").value = "oui";
		document.getElementById("Ancien_Exercice").value = "Ancien Exercice: Du " +get_cookie('Date_Debut_Exercice')+ " au " +get_cookie('Date_Fin_Exercice');
		document.getElementById("JournalAN").focus();
		
		var paramlist = "&Page=Compta/GetRDF/liste_journaux_an.tmpl&ContentType=xml";
    load_rdf_async("JournalAN", getUrlOpeneas(paramlist), selectJournalAN);
		
		var corps = cookie() +"&Page=Compta/GetNonBloque.tmpl&ContentType=text";
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,init_2);

  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#init : ' + e);
  }
}

function init_2(httpRequest) {
	try {
	
    if ( httpRequest.status != "200" ) {
   	 alert("Rception erreur " + httpRequest.status);
    } 
	  else {
		  if (parseIntBis(httpRequest.responseText)>1) {			  
  			var num_exo = parseIntBis(get_cookie('Num_Exercice'))+1;
				var corps = cookie() + "&Page=Compta/GetDateExercice.tmpl&ContentType=text&Quand=debut&Num_Exercice="+ num_exo;
        var httpRequest = new XMLHttpRequest();
        requeteHTTP(corps,httpRequest,init_3,num_exo);
		  } 
			else {
			  // il faut creer un nouvel exercice
				nouvel_exercice = true;
				document.getElementById('labelDate_Fin').collapsed = false;
				document.getElementById('Date_Fin').collapsed = false;
				var date_fin_exercice = get_cookie('Date_Fin_Exercice');
				document.getElementById('Date_Fin').value = date_fin_exercice.substring(0,6)+(parseIntBis(date_fin_exercice.substring(6,10))+1);
		  }
	  }
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#init_2 : ' + e);
  }
}


function init_3(httpRequest,num_exo) {
  try {
	
  	if (httpRequest.status != "200") {
      alert("Rception erreur " + httpRequest.status);
    }
		else {
      var date_debut = trim(httpRequest.responseText);
  		var corps = cookie() + "&Page=Compta/GetDateExercice.tmpl&ContentType=text&Quand=fin&Num_Exercice="+ num_exo;
      var httpRequest = new XMLHttpRequest();
      requeteHTTP(corps,httpRequest,init_4,date_debut);
    }
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#init_3 : ' + e);
  }
}


function init_4(httpRequest,date_debut) {
  try {
	
    if (httpRequest.status != "200") {
      alert("Rception erreur " + p.status);
    }
		else {
      var date_fin = trim(httpRequest.responseText);
			document.getElementById("Nouvel_Exercice").value = "Nouvel Exercice: Du "+ date_debut +" au "+ date_fin;
    }
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#init_4 : ' + e);
  }
}


function displayEX(d) {
  try {  
	  document.getElementById('JournalEX').collapsed = d;
	  document.getElementById('DateEX').collapsed = d;
	  document.getElementById('labelJournalEX').collapsed = d;
	  document.getElementById('labelDateEX').collapsed = d;

    if (d) {
			delete_journaux();
			delete_periodes();
		}
		else {
			init_journaux();
    }
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#displayEX : ' + e);
  }
}

function selectJournal() {
	try {
    document.getElementById('JournalEX').selectedIndex = 0;
		init_periodes();
	} catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#selectJournal : ' + e);
  }
}

function selectJournalAN() {
	try {
    document.getElementById('JournalAN').selectedIndex = 0;
	} catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#selectJournalAN : ' + e);
  }
}

function selectPeriode() {
	try {
    document.getElementById('DateEX').selectedIndex = 0;
	} catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#selectPeriode : ' + e);
  }
}

function reinit() {
	try {
	
		document.getElementById('progression').collapsed = true;
		document.getElementById('pm').setAttribute('mode', 'none');
		
    document.getElementById('bMenuPrincipal').disabled = false;
    document.getElementById('bFermerSession').disabled = false;
    document.getElementById('Date_Fin').disabled = false;
    document.getElementById('JournalAN').disabled = false;
    document.getElementById('DetailTiers').disabled = false;
    document.getElementById('AExtourner').disabled = false;
    document.getElementById('bOK').disabled = false;
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#reinit : ' + e);
  }
}
  

function precloture() {	
	try {
	
		document.getElementById('progression').collapsed = false;
		document.getElementById('pm').setAttribute('mode', 'undetermined');
		
    document.getElementById('bMenuPrincipal').disabled = true;
    document.getElementById('bFermerSession').disabled = true;
    document.getElementById('Date_Fin').disabled = true;
    document.getElementById('JournalAN').disabled = true;
    document.getElementById('DetailTiers').disabled = true;
    document.getElementById('AExtourner').disabled = true;
    document.getElementById('bOK').disabled = true;
	
		var Date_Fin = '';
		if (nouvel_exercice) {
			var Date_Fin = document.getElementById('Date_Fin').value;
		}
		var JournalAN = document.getElementById('JournalAN').value;
		var DetailTiers = document.getElementById('DetailTiers').value;
		var AExtourner = document.getElementById('AExtourner').value;
		var JournalEX = '';
		var DateEX = '';
		if (AExtourner=="oui") {
			var JournalEX = document.getElementById('JournalEX').value;
			var DateEX = document.getElementById('DateEX').value;
		}

		if (isEmpty(JournalAN)) {
			showWarning('Impossible de cloturer l\'exercice aucun journal d\'A Nouveau disponible !');
  		reinit();
		}
		else if (AExtourner=="oui" && isEmpty(JournalEX)) {
			showWarning('Impossible d\'extourner un journal, aucun journal disponible !');
  		reinit();
		}
		else if (AExtourner=="oui" && (isEmpty(DateEX) || !isPeriode(DateEX))) {
			showWarning('Priode d\'extournation incorrecte !');
  		reinit();
		}
		else if (nouvel_exercice && (isEmpty(Date_Fin) || !isDate(Date_Fin))) {
			showWarning('Date de fin du nouvel exercice incorrecte !');
  		reinit();
		}
		else {
			var cloture = 1;
      var httpParams = new Array(Date_Fin,JournalAN,DetailTiers,AExtourner,JournalEX,DateEX);
			
			if (nouvel_exercice) {				
				Date_Fin = prepareDateJava(Date_Fin);
  			var corps = cookie() + "&Page=Compta/UpdateDatabase/CreerExercice.tmpl&ContentType=xml";
        corps += "&Fin_Exercice="+ Date_Fin +"&JournalAN="+ JournalAN;
        var httpRequest = new XMLHttpRequest();
        requeteHTTP(corps,httpRequest,precloture_2,httpParams);
			}
			else {
        precloture_3(httpParams);
      }
		}

	} catch (e) {
  	recup_erreur('erreur dans compta/user/cloture/options_cloture.js#precloture : ' + e);
	}
}


function precloture_2(httpRequest,httpParams) {
  try {
    if (httpRequest.status != "200") {
      alert("Rception erreur " + p.status);
  		reinit();
    } else {
      var contenu = httpRequest.responseXML.documentElement;
      showMessage(contenu.getAttribute('msg'));
      var cloture = parseIntBis(contenu.getAttribute('ok'));
      if (cloture==0) {
        document.getElementById('Date_Fin').focus();
      }
      if (cloture==1) {
        precloture_3(httpParams);
      } else {
    		reinit();
      }
    }
	} catch (e) {
  	recup_erreur('erreur dans compta/user/cloture/options_cloture.js#precloture_2 : ' + e);
	}  
}


function precloture_3(httpParams) {
  try {
    var Date_Fin = httpParams[0];
    var JournalAN = httpParams[1];
    var DetailTiers = httpParams[2];
    var AExtourner = httpParams[3];
    var JournalEX = httpParams[4];
    var DateEX = httpParams[5];

    if (AExtourner=="oui") DateEX = preparePeriodeJava(DateEX);

    var corps = cookie() + "&Page=Compta/UpdateDatabase/PreCloture.tmpl&ContentType=text";
    var httpParams4 = new Array(Date_Fin,JournalAN,DetailTiers,AExtourner,JournalEX,DateEX);
    var httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,precloture_4,httpParams4);
    
	} catch (e) {
  	recup_erreur('erreur dans compta/user/cloture/options_cloture.js#precloture_3 : ' + e);
	}
}


function precloture_4(httpRequest,httpParams) {
  try {

    var Date_Fin = httpParams[0];
    var JournalAN = httpParams[1];
    var DetailTiers = httpParams[2];
    var AExtourner = httpParams[3];
    var JournalEX = httpParams[4];
    var DateEX = httpParams[5];

		if (httpRequest.status != "200") {
      alert("Rception erreur " + httpRequest.status);
  		reinit();
    } else {
      var resultat = formatNumber(trim(httpRequest.responseText));
			var corps = cookie() + "&Page=Compta/UpdateDatabase/VerifCloture.tmpl&ContentType=text";		
      var httpParams5 = new Array(Date_Fin,JournalAN,DetailTiers,AExtourner,JournalEX,DateEX,resultat);
      var httpRequest = new XMLHttpRequest();
      requeteHTTP(corps,httpRequest,precloture_5,httpParams5);
    }

	} catch (e) {
  	recup_erreur('erreur dans compta/user/cloture/options_cloture.js#precloture_4 : ' + e);
	}
}

function precloture_5(httpRequest,httpParams) {
  try {
      
    var Date_Fin = httpParams[0];
    var JournalAN = httpParams[1];
    var DetailTiers = httpParams[2];
    var AExtourner = httpParams[3];
    var JournalEX = httpParams[4];
    var DateEX = httpParams[5];
    var resultat = httpParams[6];

    var resultat2 = formatNumber(trim(httpRequest.responseText));

    if (parseFloat(resultat) != parseFloat(resultat2)) {
      var msg = "Attention: Incohrence lors de la cloture.\n";
      msg += "La diffrence entre les produits(7) et les charges(6) ";
      msg += "n\'est pas gale  la variation thorique de vos capitaux propres !"; 
			showWarning(msg);
		}
		else {
			var page = "chrome://opensi/content/compta/user/cloture/confirmation_cloture.xul?" + cookie();
      page += "&Resultat="+ resultat;
      page += "&JournalAN="+ JournalAN;
      page += "&DetailTiers="+ DetailTiers;
      page += "&AExtourner="+ AExtourner;
      page += "&JournalEX="+ JournalEX;
      page += "&DateEX="+ DateEX;
			page += "&Dates=" + parent.document.getElementById("date_exercice").value;
			window.location = page;
		}
		reinit();

	} catch (e) {
  	recup_erreur('erreur dans compta/user/cloture/options_cloture.js#precloture_5 : ' + e);
	}  
}

function init_journaux() {
  try {
    var paramlist = "&Page=Compta/GetRDF/liste_journaux_od.tmpl&ContentType=xml";
    load_rdf_async("JournalEX", getUrlOpeneas(paramlist), selectJournal);
    document.getElementById("JournalEX").builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#init_journaux : ' + e);
  }
}

function delete_journaux() {
  try {
    var database = document.getElementById("JournalEX").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#delete_journaux : ' + e);
  }
}

function init_periodes() {
	try {	
    var paramlist = "&Page=Compta/GetRDF/periodes_extourne.tmpl&ContentType=xml&Code_Journal="+ document.getElementById('JournalEX').value;
    load_rdf_async("DateEX", getUrlOpeneas(paramlist), selectPeriode);
    document.getElementById("DateEX").builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#init_periodes : ' + e);
  }
}

function delete_periodes() {
  try {
    var database = document.getElementById("DateEX").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#delete_periodes : ' + e);
  }
}

function retour_menu_principal() {
	try {
  	var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie();
		page += "&Dates=" + parent.document.getElementById("date_exercice").value;
  	window.location = page;
	} catch (e) {
    recup_erreur('erreur dans compta/user/cloture/options_cloture.js#retour_menu_principal : ' + e);
  }
}

