/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");

var arbre_operation = new Arbre("cpta","Consultation.tmpl","lignes");

var page = 1;
var nb_pages = 1;

var lettrage_en_cours = 0;
var lettre;
var debit = 0;
var credit = 0;
var solde = 0;
var dsource; // source de donnes RDF de l'arbre.
var rExp = / /gi;
var compteprec = '';
var comptesuiv = '';
var comptedebut = '';
var comptefin = '';
var numop = '';
var force = false;
var charge = false;
var listeop = new Array();


function init() {
  try {

    var compte = ParamValeur('compte');
    var prec = ParamValeur('prec');
    var nomprec = ParamValeur('nomprec');
    numop = ParamValeur('numop');

		var httpRequest = new QueryHttp("Compta/Consultation/getComptes.tmpl");
		var p=httpRequest.execute();

		comptedebut = p.responseXML.documentElement.getAttribute('Compte_Premier');
    comptefin = p.responseXML.documentElement.getAttribute('Compte_Dernier');

    if (isEmpty(compte)) {
      document.getElementById('compte').focus();
    }
		else {
      document.getElementById('compte').value = compte;
      ok();
    }

    if (!isEmpty(nomprec)) {
      document.getElementById('bRetour'+ nomprec).collapsed = false;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#init : ' + e);
  }
}


/*****************************************************
 *  @return le pointeur vers l'arbre contenant les critures comptables.
 ****************************************************/
function get_tree() {
  try {

    return document.getElementById('lignes');

	} catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#get_tree : ' + e);
  }
}

/****************************************************
 *  Correspondance entre l'id d'un textbox et le target RDF associ
 *  @param id : l'identifiant du textbox
 *  @return le target associ
 ****************************************************/
function targetname(id) {
  try {
    switch(id) {
      case 'lettre':
        return "http://www.opensi.org/compta/lignes_ecriture/rdf#lettre";
        break;
      case 'input_prop':
        return "http://www.opensi.org/compta/lignes_ecriture/rdf#prop";
        break;
      default:
        return '';
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#targetName : ' + e);
  }
}


/****************************************************
 *  Chargement de l'arbre depuis la source.
 *  @param dsource2 : la source du RDF
 ****************************************************/
function init_tree(dsource2) {
  try {

    dsource.deleteRecursive("http://www.opensi.org/compta/lignes_ecriture");
    var datasource = dsource.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource);

    dsource2.copyAllToDataSource(dsource);

    var datasource2 = dsource2.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource2);
    var datasource = dsource.getRawDataSource();
    get_tree().database.AddDataSource(datasource);

    setTimeout('focus_tree()',100);

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#init_tree : ' + e);
  }
}


function reinit(p) {
  try {

    nb_pages = get_nb_pages();
		if (!isNaN(p)) {
			if (parseIntBis(p)>nb_pages) {
				page = nb_pages;
			}
			else if (parseIntBis(p)<1) {
				page = 1;
			}
			else {
				page = p;
			}
		}

		loadsuite();
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#reinit : ' + e);
  }
}


function loadCompte(cpte) {
  try {

    var let = ParamValeur('let');
    if (isEmpty(let)) {
			let='0';
    }
		else if (let!='0') {
			document.getElementById('let').checked=true;
		}

		compte = cpte;

    nb_pages = get_nb_pages();
    page = 1;

    if (!isEmpty(numop)) {
      var corps = cookie() +"&Page=Compta/GetNumPageOperation.tmpl&ContentType=xml&NumCompte="+ compte;
      corps += "&NumOp="+ numop;
			corps += "&nbOp=50";
      var p = requeteHTTP(corps);
			page = p.responseXML.documentElement.getAttribute("page");
		}

		loadsuite();

  } catch(e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#loadCompte : ' + e);
  }
}

function loadsuite() {
  try {

		charge=false;
    var nonlet = '0';
    if (document.getElementById('nonlet').checked) {
      nonlet = '1';
    }
    var let = '0';
    if (document.getElementById('let').checked) {
      let = '1';
    }
		arbre_operation.setParam("NumCompte", compte);
		arbre_operation.setParam("nbPage",page);
		arbre_operation.setParam("lop", listeop);
		arbre_operation.setParam("let", let);
		arbre_operation.setParam("nonlet",nonlet);

		if (isPositive(document.getElementById('nbOp').value)) {
			arbre_operation.setParam("nbOp",document.getElementById('nbOp').value);
		}
		else {
			arbre_operation.setParam("nbOp", 50);
		}
    document.getElementById('page').value = "Page N";
    document.getElementById('numpage').value = page;
    document.getElementById('finpage').value="/ " + nb_pages;

    document.getElementById('nbOp').disabled = true;
    document.getElementById('boutonDebut').disabled = true;
    document.getElementById('boutonPrec').disabled = true;
    document.getElementById('boutonFin').disabled = true;
    document.getElementById('boutonSuiv').disabled = true;
    document.getElementById('numpage').disabled = true;
    document.getElementById('let').disabled = true;
    document.getElementById('nonlet').disabled = true;
    document.getElementById('bCpteDebut').disabled = true;
    document.getElementById('bCptePrec').disabled = true;
    document.getElementById('compte').disabled = true;
    document.getElementById('bCpteSuiv').disabled = true;
    document.getElementById('bCpteFin').disabled = true;
    document.getElementById('ok').disabled = true;
		if (nb_pages == 0) {
    	document.getElementById('numpage').value=0;		
		}

    dsource = new RDFDataSource();
		arbre_operation.initTree(init_tree);

  } catch(e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#loadsuite : ' + e);
  }
}



function retour_prec() {
  try {

    window.location = ParamValeur('prec');

	} catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#retour_prec : ' + e);
  }
}


function keypress(e,id,p) {
  try {

    switch(e.keyCode){
      case 13: // 'Enter'
				if (id=="lignes") {
    	ecritures();
    }
    else if (id=="numpage") {
    	reinit(p);
    }
    else if (id=="nbOp") {
    	reinit(1);
    }
				else if (id=="compte") {
    	ok();
    }
        break;
      case 32: // Barre d'Espace
        lettrage();
        break;
      case 118 : // 'F7'
        validLettrage();
        break;
      case 119 : // 'F8'
        annulLettrage();
        break;
      case 123: // 'F12'
        rechecr();
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#keypress : ' + e);
  }
}


function rechecr() {
  try {

    var page = "chrome://opensi/content/compta/util/rechecriture.xul?"+ cookie();
    window.openDialog(page,'','chrome,modal,centerscreen');

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#rechecr : ' + e);
  }
}


function ok() {
  try {

		razLettrage();
		
    var numero_compte = document.getElementById('compte').value;

		if (isEmpty(numero_compte)) {
      document.getElementById('compte').focus();
    }
		else {
    	force = false;

			var httpRequest = new QueryHttp("Compta/Commun/existeCompte.tmpl");
			httpRequest.setParam("Numero_Compte", numero_compte);
			httpRequest.execute(ok_2, numero_compte);
		}

  } catch(e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#ok : ' + e);
  }
}


function ok_2(result, numero_compte) {
  try {

		if (result.responseXML.documentElement.getAttribute("existe")=="true") {

			loadCompte(numero_compte);
		}
		else if (result.responseXML.documentElement.getAttribute("compte_like")!="") {

			loadCompte(result.responseXML.documentElement.getAttribute("compte_like"));
		}
		else {
			recherche_compte(numero_compte);
			document.getElementById('compte').focus();
			loadCompte(document.getElementById('compte').value);
		}

	} catch(e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#ok2 : ' + e);
  }
}


function compteSuiv() {
  try {

    document.getElementById('compte').value = comptesuiv;
    ok();

	} catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#compteSuiv : ' + e);
  }
}


function comptePrec() {
  try {

    document.getElementById('compte').value = compteprec;
    ok();

	} catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#comptePrec : ' + e);
  }
}


function compteDebut() {
  try {

		document.getElementById('compte').value = comptedebut;
    ok();

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#compteDebut : ' + e);
  }
}


function compteFin() {
  try {

		document.getElementById('compte').value = comptefin;
		ok();

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#compteFin : ' + e);
  }
}


function recherche_compte(numero_compte) {
  try {

    var url = "chrome://opensi/content/config/util/rechcompte.xul?"+ cookie() +"&ignoreG=true";
    window.openDialog(url,'','chrome,modal',numero_compte,"compte",false);

	} catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#recherche_compte : ' + e);
  }
}


function get_nb_pages() {
  try {

    var corps = cookie() +"&Page=Compta/GetNbOperationsCompte.tmpl&ContentType=xml&NumCompte="+ compte;
    var nonlet = '0';
    if (document.getElementById('nonlet').checked) {
      nonlet = '1';
    }
    var let = '0';
    if (document.getElementById('let').checked) {
      let = '1';
    }
    corps += "&let="+ let;
    corps += "&nonlet="+ nonlet;

    var p = requeteHTTP(corps);

    var nbecr = p.responseXML.documentElement.getAttribute('nb');
    nbOp = document.getElementById('nbOp').value;

		if (!isPositive(nbOp)) {
			nbOp = 50;
		}
		if (nbecr%nbOp==0) {
			return parseIntBis((nbecr/nbOp));
		}
		else {
    	return parseIntBis((nbecr/nbOp)+1);
		}

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_nb_pages : ' + e);
  }
}

/* Chargement de la premire page d'criture */
function pageDebut() {
  try {

    reinit(1);

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageDebut : ' + e);
  }
}

/* Chargement de la dernire page d'criture */
function pageFin() {
  try {

    reinit(nb_pages);

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageFin : ' + e);
  }
}

/* Chargement de la page prcdente */
function pagePrec() {
  try {

		reinit(parseIntBis(page)-1);

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pagePrec : ' + e);
  }
}

/* Chargement de la page suivante */
function pageSuiv() {
  try {

	  reinit(parseIntBis(page)+1);

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageSuiv : ' + e);
  }
}


function focus_tree() {
  try {

    var tree = get_tree();

    if (tree.view != null) {

      var lignefocus = 0;
      if (!isEmpty(numop)) {
        var found = false;
        while (!found) {
          if (getCellText(tree,lignefocus,'opid') == numop) {
            found = true;
          }
					else {
            lignefocus++;
          }
        }
        numop = '';
      }

			charge=true;

			if (tree.view.rowCount>0) {
      	tree.view.selection.select(lignefocus);
     		tree.treeBoxObject.ensureRowIsVisible(lignefocus);
				tree.focus();
			}
    }

		lettre = get_cookie('Lettre');

		var httpRequest = new QueryHttp("Compta/Consultation/getInfosCompte.tmpl");
		httpRequest.setParam("Numero_Compte", compte);
		httpRequest.execute(focusTree_2);

    document.getElementById('nbOp').disabled = (nb_pages == 0);
    document.getElementById('boutonDebut').disabled = (page == 1) || (nb_pages == 0);
    document.getElementById('boutonPrec').disabled = (page == 1) || (nb_pages == 0);
    document.getElementById('boutonFin').disabled = (page == nb_pages) || (nb_pages == 0);
    document.getElementById('boutonSuiv').disabled = (page == nb_pages) || (nb_pages == 0);
    document.getElementById('numpage').disabled = (nb_pages == 0) || (nb_pages == 1);
    document.getElementById('let').disabled = false;
    document.getElementById('nonlet').disabled = false;
    document.getElementById('bCpteDebut').disabled = false;
    document.getElementById('bCptePrec').disabled = false;
    document.getElementById('compte').disabled = false;
    document.getElementById('bCpteSuiv').disabled = false;
    document.getElementById('bCpteFin').disabled = false;
    document.getElementById('ok').disabled = false;

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#focus_tree : ' + e);
  }
}


function focusTree_2(result) {
  try {

		var contenu = result.responseXML.documentElement;

    document.getElementById('compte').value = contenu.getAttribute('Numero_Compte');
    document.getElementById('libelle_compte').value = contenu.getAttribute('Libelle');
    document.getElementById('type_compte').value = contenu.getAttribute('Compte_Gen');

    document.getElementById('solde_compte').value = contenu.getAttribute('SoldeN');
    document.getElementById('debit_compte').value = contenu.getAttribute('DebitN');
    document.getElementById('credit_compte').value = contenu.getAttribute('CreditN');

    document.getElementById('old_solde_compte').value = contenu.getAttribute('SoldeN1');
    document.getElementById('old_debit_compte').value = contenu.getAttribute('DebitN1');
    document.getElementById('old_credit_compte').value = contenu.getAttribute('CreditN1');

    compteprec = contenu.getAttribute('Compte_Prec');
    comptesuiv = contenu.getAttribute('Compte_Suiv');

    document.getElementById('bCptePrec').disabled = (compteprec == '-');
    document.getElementById('bCpteSuiv').disabled = (comptesuiv == '-');
    document.getElementById('bCpteDebut').disabled = (document.getElementById('compte').value == comptedebut);
    document.getElementById('bCpteFin').disabled = (document.getElementById('compte').value == comptefin);

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#focusTree2 : ' + e);
  }
}


function lettresuivante(l) {
  try {

    if (l.length == 1) {
      if (l=='z' || l =='Z') {
        return 'A';
      } else {
        return String.fromCharCode(l.charCodeAt(0)+1);
      }
    } else {
      var c = l.substr(l.length-1,1);
      var aux = l.substr(0,l.length-1);
      if (c=='z' || c=='Z') {
        c = 'A';
        aux = lettresuivante(aux);
      } else {
        c = String.fromCharCode(c.charCodeAt(0)+1);
      }
      return aux + c;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#lettresuivante : ' + e);
  }
}


function incr_lettre() {
  try {
    if (isEmpty(lettre)) {
      lettre = 'AAA';
    } else {
      lettre = lettresuivante(lettre);
    }
    return lettre;
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#incr_lettre : ' + e);
  }
}


function lettrage() {
  try {

		if (charge) {
    	var tree = get_tree();

    	var aux = getCellText(tree,tree.currentIndex,'debit');
    	var aux2 = '';
    	for (i = 0;i<aux.length;i++) {
      	var c = aux.charCodeAt(i);
      	if ((c != 160) && (c != 32)) aux2 += aux.charAt(i);
    	}
    	var td = parseFloat(aux2.replace(',','.'));
    	if (isNaN(td)) td = 0;

    	aux = getCellText(tree,tree.currentIndex,'credit');
    	aux2 = '';
    	for (i = 0;i<aux.length;i++) {
      	var c = aux.charCodeAt(i);
      	if ((c != 160) && (c != 32)) aux2 += aux.charAt(i);
    	}
    	var tc = parseFloat(aux2.replace(',','.'));
    	if (isNaN(tc)) tc = 0;

    	var tl = getCellText(tree,tree.currentIndex,'lettre');

    	var child = get_child(get_tree().currentIndex);

    	if (peut_lettrer()) {
      	if (isEmpty(tl)) {
        	debit = debit + td;
        	credit = credit + tc;
        	solde =  parseFloat(format(credit - debit,2,'',0));
        	maj_aff_solde();
        	child.addTargetOnce(targetname('lettre'),'+');
        	lettrage_en_cours++;
					ajouterListeOp(getCellText(tree,tree.currentIndex,'opid'));
      	} else if (tl == '+') {
        	child.addTargetOnce(targetname('lettre'),'');
        	debit = debit - td;
        	credit = credit - tc;
        	solde = parseFloat(format(credit - debit,2,'',0));
        	lettrage_en_cours--;
        	if (lettrage_en_cours == 0) {
          	document.getElementById('lettrage').collapsed = true;
        	} else {
          	maj_aff_solde();
        	}
					ajouterListeOp(getCellText(tree,tree.currentIndex,'opid'));
      	}
      	if (lettrage_en_cours > 0 && solde == 0) {
        	validLettrage();
      	}
    	}
		}
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#lettrage : ' + e);
  }
}

function ajouterListeOp(opid) {
  try {
		var i=0;
		supp=false;
  	while (i<listeop.length && !supp) {
			if (listeop[i]==opid) {
				supp=true;
			}
			i++;
		}
		if (supp) {
			listeop.splice(i-1,1);
		}
		else {
			listeop.push(opid);
		}
		listeop.sort();
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#ajouterListeOp : ' + e);
  }
}




function peut_lettrer() {
  try {
    if (premier_exo_ouvert()) {
      return true;
    } else {
      var tree = get_tree();
      var type_journal = getCellText(tree,tree.currentIndex,'type_journal');
      return (type_journal != 'AN');
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#peut_lettrer : ' + e);
  }
}


/* retourne VRAI si l'exercice courant est le plus ancien exercice non clotur */
function premier_exo_ouvert() {
  try {

    var corps = cookie() +"&Page=Compta/GetPremierOuvert.tmpl&ContentType=text";
	  var p = requeteHTTP(corps);

    return ((get_cookie('Writeable') > '0') && (parseIntBis(p.responseText) == 0));

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#premier_exo_ouvert : ' + e);
  }
}


function annulLettrage() {
  try {

    if (get_cookie('Writeable') > '0') {

      var tree = get_tree();
      var tl = getCellText(tree,tree.currentIndex,'lettre');

      if (isEmpty(tl)) return -1;
      if (tl == '+') return -1;

      if (confirm("Voulez vous annuler le lettrage des lignes d'critures lettres par "+ tl +" ?")) {

        var corps = cookie() +"&Page=Compta/UpdateDatabase/update.tmpl&ContentType=xml&req=annullettrage";

        for (i=0;i<tree.view.rowCount;i++) {
          var tl2 = getCellText(tree,i,'lettre');
          if (tl == tl2) {
            var opid = getCellText(tree,i,'opid');
            var child = get_child(i);
            child.addTargetOnce(targetname('lettre'),'');
            child.addTargetOnce(targetname('input_prop'),'disabled');
          }
        }
        corps += "&Lettre="+ tl;
        requeteHTTP(corps);
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#annulLettrage : ' + e);
  }
}


function get_child(id) {
  try {

    var child = null;
    var index = id + 1;
    var root = dsource.getNode("http://www.opensi.org/compta/lignes_ecriture");
    var children = root.getChildren();
    var found = false;

    while ((children.hasMoreElements()) && (! found) ) {
      var c = children.getNext();
      if (root.getChildIndex(c) == index) {
        child = c;
        found = true;
      }
    }

    return child;

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#lettrage : ' + e);
  }
}


function maj_aff_solde() {
  try {
    document.getElementById('lettrage').collapsed = false;
    document.getElementById('total_debit_lett').value = format(debit,2,' ',0);
    document.getElementById('total_credit_lett').value = format(credit,2,' ',0);
    document.getElementById('total_solde_lett').value = format(solde,2,' ',0);
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#maj_aff_solde : ' + e);
  }
}


function razLettrage() {
  try {
    debit = 0;
    credit = 0;
    solde = 0;
    lettrage_en_cours = 0;
		listeop = new Array();
    document.getElementById('lettrage').collapsed = true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#razLettrage : ' + e);
  }
}


function lettrer(ll) {
  try {

    if (lettrage_en_cours>0) {

      var corps = cookie() +"&Page=Compta/UpdateDatabase/update.tmpl&ContentType=xml&req=lettrage";
      corps += "&Num_Compte="+ compte;
      corps += "&Lettre="+ ll;

      var list_op = '';
      var tree = get_tree();
      for (i=0;i<listeop.length;i++) {
        list_op += listeop[i]+',';
        var child = get_child(i);
        child.addTargetOnce(targetname('lettre'),ll);
        child.addTargetOnce(targetname('input_prop'),'enabled');
      }
      corps += "&Operations="+ list_op;

      requeteHTTP(corps);
      razLettrage();
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#lettrer : ' + e);
  }
}


function validLettrage() {
  try {

    if (get_cookie('Writeable') > '0') {

      if (solde == 0) {
        lettrer(incr_lettre());
      }
			else if (confirm("Le lettrage n'est pas quilibr. Voulez vous saisir une criture de lettrage ?")) {
        var ll = incr_lettre();
        var nom = "ecr_lettrage" ;
        var page = "chrome://opensi/content/compta/user/consultation/lettrage.xul?"+ cookie();
        page += "&NumCompte="+ compte;
        page += "&Lettre="+ ll;
        page += "&solde="+ (0 - solde);
        window.open(page,nom,'chrome,modal');
        reinit(1);
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#validLettrage : ' + e);
  }
}


function ecritures() {
  try {

    var tree = get_tree();
    var journal = getCellText(tree,tree.currentIndex,'journal');
    var date = getCellText(tree,tree.currentIndex,'dateaff');

    var annee = date.substr(6,4);
    var mois = date.substr(3,2);
    var aux = parseIntBis(annee)*12;
    aux += parseIntBis(mois);
    var periode = mois + date.substr(8,2);
		
    if (aux < parseIntBis(get_cookie('Premier_Mois_Exercice'))) {
      var date_debut = get_cookie('Date_Debut_Exercice');
      periode = date_debut.substr(3,2) + date_debut.substr(8,2);
    }

    var paramlist = cookie();
    paramlist += "&Code_Journal="+ journal;
    paramlist += "&Periode="+ periode;
    paramlist += "&numop="+ getCellText(tree,tree.currentIndex,'opid');
    var page = "chrome://opensi/content/compta/user/saisie/menu_saisie.xul?"+ paramlist;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#ecritures : ' + e);
  }
}


function plan_comptable() {
  try {

    var page = "chrome://opensi/content/config/util/liste_plan.xul?"+ cookie();
    window.openDialog(page,'plancomptable','chrome,modal','1','compte');

	} catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#plan_comptable : ' + e);
  }
}


function retour_consultation() {
  try {

    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie();
    page += "&Dates="+ parent.document.getElementById("date_exercice").value;
    window.location = page;

	} catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#retour_consultation : ');
  }
}


function retour_exercice() {
  try {

    var page = "chrome://opensi/content/compta/user/menu_dossier.xul?"+ cookie();
    page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;

	} catch (e) {
    recup_erreur('erreur dans compta/user/consultation/menu_consultation.js#retour_exercice : ' + e);
  }
}

