/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
  try {

		t = ParamValeur("Type");
		if (t=="T") t="G";

		loadBalance(t,'');

	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#init : ' + e);
  }
}


var like = "";
var compte_gen = "";
var enableGoTo = false;


function disableBoutons(b) {
	try {

		document.getElementById('bMenuPrincipal').disabled = b;
		document.getElementById('bMenuEdition').disabled = b;
		document.getElementById('bRetourOptions').disabled = b;
		document.getElementById('bG').disabled = b;
		document.getElementById('bC').disabled = b;
		document.getElementById('bF').disabled = b;
		document.getElementById('b1').disabled = b;
		document.getElementById('b2').disabled = b;
		document.getElementById('b3').disabled = b;
		document.getElementById('b4').disabled = b;
		document.getElementById('b5').disabled = b;
		document.getElementById('b6').disabled = b;
		document.getElementById('b7').disabled = b;

		enableGoTo = !b;

	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#disableBoutons : ' + e);
  }
}


function loadBalance(t,l) {
	try {

		disableBoutons(true);

		like = l;
		compte_gen = t;

		var titre = "";

		if (t=="F") {
			titre = "Fournisseurs";
		}
		else if (t=="C") {
			titre = "Clients";
		}
		else if (t=="G" && l=="") {
			titre = "Gnraux";
		}
		else {
			titre = "de la classe "+ l;
		}

		document.getElementById('Titre').value = "Edition de la balance : Comptes "+ titre;

		document.getElementById('TotalDebit').value = '0.00';
		document.getElementById('TotalCredit').value = '0.00';
		document.getElementById('TotalSolde').value = '0.00';

		delete_tree();
		init_tree();

	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#loadBalance : ' + e);
  }
}


function endLoading() {
	try {

		var tree = document.getElementById('balance');
		if (tree.view==null) {
      endLoading2();
    } else if (tree.view.rowCount < 1) {
      endLoading2();
    } else {
			if (getCellText(tree,0,'ColDebit')=="") {
				setTimeout("endLoading()",50);
			}
			else {
				var debit = 0;
				var credit = 0;

				document.getElementById('Progression').collapsed = true;
				document.getElementById('pm').setAttribute('mode','none');

				for (i=0;i<tree.view.rowCount;i++) {
					debit += parseFloat(getCellText(tree,i,'ColDebit').replace(/ /i,''));
					credit += parseFloat(getCellText(tree,i,'ColCredit').replace(/ /i,''));
				}

				if (debit<0.01 && debit>-0.01) debit = 0;
				if (credit<0.01 && credit>-0.01) credit = 0;
				var solde = debit - credit;

				if (solde<0.01 && solde>-0.01) solde = 0;

				document.getElementById('TotalDebit').value = format(debit,2,' ',0);
				document.getElementById('TotalCredit').value = format(credit,2,' ',0);
				document.getElementById('TotalSolde').value = format(solde,2,' ',0);

				disableBoutons(false);
			}
		}

	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#endLoading : ' + e);
  }
}

function endLoading2() {
  try {
    document.getElementById('Progression').collapsed = true;
		document.getElementById('pm').setAttribute('mode','none');
		disableBoutons(false);
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#endLoading2 : ' + e);
  }
}

function init_tree() {
  try {

		document.getElementById('Progression').collapsed = false;
		document.getElementById('pm').setAttribute('mode','undetermined');

    var paramlist = "&Page=Compta/GetRDF/balance.tmpl&ContentType=xml"+ ParamValeur("ListeOptions")+ "&Like="+ like +"&Compte_Gen="+ compte_gen;
    load_rdf_async('balance', getUrlOpeneas(paramlist), endLoading);

  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#init_tree : ' + e);
  }
}

function delete_tree() {
  try {

    var database = document.getElementById("balance").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('balance').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#delete_tree : ' + e);
  }
}

function keypress(ev) {
	try {
		switch (ev.keyCode) {
      case 13: goToCompte(); break;
    }
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#keypress : ' + e);
  }
}

function goToCompte() {
	try {

		if (enableGoTo) {

	 		var tree = document.getElementById('balance');

			if (tree.view!=null && tree.currentIndex!=-1) {

  			var numero_compte = getCellText(tree,tree.view.selection.currentIndex,'ColCompte');

   			var prec = "chrome://opensi/content/compta/user/edition/balance_ecran.xul?"+ cookie();
				prec += "&ListeOptions="+ urlEncode(ParamValeur("ListeOptions"));
				prec += "&Type="+ ParamValeur("Type");

      	var page = "chrome://opensi/content/compta/user/consultation/menu_consultation.xul?"+ cookie();
      	page += "&compte="+ numero_compte;
				page += "&nomprec=Balance";
      	page += "&prec="+ urlEncode(prec);
      	window.location = page;
			}
		}

	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#goToCompte : ' + e);
  }
}

function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie();
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#retour_menu_principal : ' + e);
  }
}

function retour_menu_edition() {
  try {

    window.location = "chrome://opensi/content/compta/user/edition/menu_edition.xul?"+ cookie();

  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#retour_menu_edition : ' + e);
  }
}

function retour_options_balance() {
  try {

    window.location = "chrome://opensi/content/compta/user/edition/options_balance.xul?"+ cookie();

  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/balance_ecran.js#retour_options_balance : ' + e);
  }
}

