/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

 
function init() {
  try {
    
		document.getElementById('Type').selectedItem = document.getElementById('TypeG');
		document.getElementById('Periode').selectedItem = document.getElementById('PeriodeEC');
		document.getElementById('Edition').selectedItem = document.getElementById('EditionC');
		document.getElementById('Ed_Cpte').selectedItem = document.getElementById('EdCpteT');
		document.getElementById('Ed_Ecriture').selectedItem = document.getElementById('EdEcrT');
		document.getElementById('Sortie').selectedItem = document.getElementById('SortieP');
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#init : ' + e);
  }
}

function cacheChampsMail(b) {
	try {
		document.getElementById('ChampsMail').collapsed = b;
		
		if (b) {
			document.getElementById('BoutonEdition').label = "EDITER LE GRAND LIVRE";
		}
		else {
			document.getElementById('BoutonEdition').label = "ENVOYER LE GRAND LIVRE";
		}
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#cacheChampsMail : ' + e);
  }
}


function disableDates(b) {
	try {
		
		document.getElementById('Date_Debut').disabled = b;
		document.getElementById('Date_Fin').disabled = b;
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#disableDates : ' + e);
  }
}

function disableCptes(b) {
	try {
		
		document.getElementById('Cpte_Debut').disabled = b;
		document.getElementById('Cpte_Fin').disabled = b;
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#disableCptes : ' + e);
  }
}


function retour_menu_principal() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie();
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#retour_menu_principal : ' + e);
  }
}

function retour_menu_edition() {
  try {
    var page = "chrome://opensi/content/compta/user/edition/menu_edition.xul?" + cookie();
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#retour_menu_edition : ' + e);
  }
}


function editerGrandLivre() {
	try {
	
		var date_debut = document.getElementById('Date_Debut').value;
		var date_fin = document.getElementById('Date_Fin').value;
		var cpte_debut = document.getElementById('Cpte_Debut').value;
		var cpte_fin = document.getElementById('Cpte_Fin').value;
	
		if (document.getElementById('EditionP').selected && (!isCompteCorrect(cpte_debut) || !isCompteCorrect(cpte_fin))) {
			showMessage("Numros de compte invalides !");
		}
		else if (document.getElementById('PeriodeDD').selected && (!isDate(date_fin) || !isDate(date_debut) || !isDateInterval(date_debut, date_fin))) {
			showMessage("Plage de dates invalide !");
		}
		else {
			var liste_options = "&Date_Debut="+ date_debut;
			liste_options += "&Date_Fin="+ date_fin;
			liste_options += "&Cpte_Debut="+ cpte_debut;
			liste_options += "&Cpte_Fin="+ cpte_fin;
			liste_options += "&Type="+ document.getElementById('Type').value;
			liste_options += "&Periode="+ document.getElementById('Periode').value;
			liste_options += "&Edition="+ document.getElementById('Edition').value;
			liste_options += "&Ed_Cpte="+ document.getElementById('Ed_Cpte').value;
			liste_options += "&Ed_Ecriture="+ document.getElementById('Ed_Ecriture').value;
		
			var sortie = document.getElementById('Sortie').value;
		
			if (sortie=="M") {
			
				var email = document.getElementById('Email').value;
				var sujet = document.getElementById('Sujet').value;
				var message = document.getElementById('Message').value;
			
				if (!isEmail(email)) {
					showMessage("Adresse e-mail incorrecte !");
				}
				else {
					var corps = cookie() + "&Page=Compta/Etats/grandlivre_pdf.tmpl&ContentType=Text&EnvoiMail=y";
          corps += liste_options+"&Email="+urlEncode(email)+"&Sujet="+urlEncode(sujet)+"&Message="+urlEncode(message);
          var httpRequest = new XMLHttpRequest();
          requeteHTTP(corps,httpRequest,suiteEditer);
				}
			}
			else {
				var page = "chrome://opensi/content/compta/user/edition/afficher_grandlivre.xul?"+ cookie() +"&ListeOptions="+ urlEncode(liste_options);
				window.location = page;
			}
		}

	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#editerGrandLivre : ' + e);
  }
}


function suiteEditer(httpRequest) {
  try {
    if (httpRequest.status != "200") {
      alert("Rception erreur " + httpRequest.status);
    } else {
      showMessage("Le grand livre a t envoy !");
    }
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_grandlivre.js#suiteEditer : ' + e);
  }    
}
