/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

 
function init() {
  try {
    var paramlist = "&Page=Compta/GetRDF/liste_journaux_used.tmpl&ContentType=xml";
    load_rdf_async("Code_Journal", getUrlOpeneas(paramlist), selectJournal);

		document.getElementById('Sortie').selectedItem = document.getElementById('SortieP');
		
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_journaux.js#init : ' + e);
  }
}

function selectJournal() {
	try {
		document.getElementById('Code_Journal').selectedIndex = 0;
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_journaux.js#selectJournal : ' + e);
  }
}

function cacheChampsMail(b) {
	try {
		document.getElementById('ChampsMail').collapsed = b;
		
		if (b) {
			document.getElementById('BoutonEdition').label = "EDITER LES JOURNAUX";
		}
		else {
			document.getElementById('BoutonEdition').label = "ENVOYER LES JOURNAUX";
		}
		
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_journaux.js#cacheChampsMail : ' + e);
  }
}

function retour_menu_principal() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?" + cookie();
    page += "&Dates=" + parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_journaux.js#retour_menu_principal : ' + e);
  }
}

function retour_menu_edition() {
  try {
    var page = "chrome://opensi/content/compta/user/edition/menu_edition.xul?" + cookie();
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_journaux.js#retour_menu_edition : ' + e);
  }
}


function editerJournaux() {
	try {	
	
		var date_debut = document.getElementById('Date_Debut').value;
		var date_fin = document.getElementById('Date_Fin').value;
	
		if (!isEmpty(date_debut) && !isEmpty(date_fin) && (!isPeriode(date_debut) || !isPeriode(date_fin) || !isPeriodeInterval(date_debut, date_fin))) {
			alert("Plage de dates incorrecte !");
		}
		else if (isEmpty(date_fin) && !isEmpty(date_debut) && !isPeriode(date_debut)) {
			alert("Date de dbut priode invalide (mmaa) !");
		}
		else {
			var liste_options = "&Date_Debut="+ date_debut;
			liste_options += "&Date_Fin="+ date_fin;
			liste_options += "&Code_Journal="+ document.getElementById('Code_Journal').value;
		
			var sortie = document.getElementById('Sortie').value;
		
			if (sortie=="M") {
			
				var email = document.getElementById('Email').value;
				var sujet = document.getElementById('Sujet').value;
				var message = document.getElementById('Message').value;
			
				if (!isEmail(email)) {
					showMessage("Adresse e-mail incorrecte !");
				}
				else {
					var corps = cookie() + "&Page=Compta/Etats/journaux_pdf.tmpl&ContentType=Text&EnvoiMail=y";
          corps += liste_options+"&Email="+urlEncode(email)+"&Sujet="+urlEncode(sujet)+"&Message="+urlEncode(message);
          var httpRequest = new XMLHttpRequest();
          requeteHTTP(corps,httpRequest,suiteEditer);
				}
			} else {
				var page = "chrome://opensi/content/compta/user/edition/afficher_journaux.xul?" + cookie() + "&ListeOptions="+ urlEncode(liste_options);
				window.location = page;
			}
		}

	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_journaux.js#editerJournaux : ' + e);
  }
}

function suiteEditer(httpRequest) {
  try {
    if (httpRequest.status != "200") {
      alert("Rception erreur " + httpRequest.status);
    } else {
      alert("Les journaux ont t envoys !");
    }
	} catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_journaux.js#suiteEditer : ' + e);
  }    
}
	
/*function retour_exercice() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_dossier.xul?" + cookie();
    page += "&Libelle=" + parent.document.getElementById("nom_dossier").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/edition/options_journaux.js#retour_exercice : ' + e);
  }
}*/
