/******************************************************************************/
/* OpenSi : Outils libres de gestiion d'entreprise                            */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var bInserer;
var bModifier;
var bSupprimer;

var periode;
var journal;

var arbre = new Arbre("cpta","info_operation_equilibre.tmpl","inserecr");

var modif = false;
var id = 0;


function init(){
	try{
		journal = window.arguments[0];
		periode = window.arguments[1];

		arbre.addParam("Code_Journal",journal);
		arbre.addParam("Periode",periode);
		arbre.initTree();

		document.getElementById("dateOp").focus();
		window.addEventListener("close",fermer,false);

		id = 0;

		bAnnuler = document.getElementById("bAnnuler");
		bValider = document.getElementById("bValider");
		bSupprimer = document.getElementById("bSupprimer");
	}
	catch(e){
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#init : ' +e);
	}
}

function fermer(){
	try{
		if (modif){
			window.arguments[2]();
		}
		window.close();
	}
	catch(e){
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#valider : ' +e);
	}
}

function affiche() {
	try{
		var tree = document.getElementById("inserecr");
		var indx = tree.currentIndex;
		if ( indx != -1 ){
			id = getCellValue(tree,indx,"op_id");
			var dateOp = getCellText(tree,indx,"date_op");
			var libelle = getCellText(tree,indx,"libell");
			var depense = getCellText(tree,indx,"dpenses");
			var recette = getCellText(tree,indx,"recettes");
			document.getElementById("dateOp").value = dateOp;
			document.getElementById("libelle").value = libelle;
			document.getElementById("depense").value = depense;
			document.getElementById("recette").value = recette;
			test_complete();
		}
	}
	catch(e){
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#affiche : ' +e);
	}
}

function test_complete(){
	try{
		test_rempli();
		var dateOp = document.getElementById("dateOp").value;
		var libelle = document.getElementById("libelle").value;
		var depense = document.getElementById("depense").value;
		var recette = document.getElementById("recette").value;

		if ( isDate(dateOp) && !isEmpty(libelle) && ( (!isEmpty(depense) && checkDecimal(parseFloat(depense),2)  ) || (!isEmpty(recette) && checkDecimal(parseFloat(recette),2))) ){
				bValider.disabled = false;
				if ( id != 0 ){
					bSupprimer.disabled = false;
				}
		}
		else{
			bValider.disabled = true;
			bSupprimer.disabled = true;
		}

	}
	catch(e){
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#test_complete : ' +e);
	}
}

function test_rempli(){
	try{
		var dateOp = document.getElementById("dateOp").value;
		var libelle = document.getElementById("libelle").value;
		var depense = document.getElementById("depense").value;
		var recette = document.getElementById("recette").value;

		if ( !isEmpty(dateOp) || !isEmpty(libelle) || !isEmpty(depense) || !isEmpty(recette) ){
			bAnnuler.disabled = false;
		}
	}
	catch(e){
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#test_rempli : ' +e);
	}
}

function annuler() {
	try {

		effacer();

	}	catch(e){
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#annuler : ' +e);
	}
}

function valider(){
	try{
		var valeur = true;
		var dateOp = document.getElementById("dateOp").value;
		dateOp = prepareDateJava(dateOp);
		var libelle = document.getElementById("libelle").value;
		var depense = document.getElementById("depense").value;
		var recette = document.getElementById("recette").value;

		if ( isEmpty(depense) && !isEmpty(recette) ){
			parseFloat(recette);
			depense = 0.00;
		}
		else if ( !isEmpty(depense) && isEmpty(recette) ){
			parseFloat(depense);
			recette = 0.00;
		}
		else{
			valeur = false;
		}

		switch(valeur){
			case false:
				showWarning("Vous ne pouvez pas avoir une criture qui crdite et dbite  la fois");
				break;
			default:
				switch(id){
					case 0:
						var corps = cookie() + "&Page=Compta/Rapprochement/inserOp.tmpl&ContentType=xml&Code_Journal=" + journal + "&Periode=" + periode + "&DateOp=" + dateOp + "&Libelle=" + urlEncode(libelle) + "&Depense=" + depense + "&Recette=" + recette;
						var p = requeteHTTP(corps);
						effacer();
						bValider.disabled = true;
						arbre.initTree();
						modif = true;
						break;
					default:
						var corps = cookie() + "&Page=Compta/Rapprochement/updtOp.tmpl&ContentType=xml&Code_Journal=" + journal + "&Periode=" + periode + "&Id=" + id + "&DateOp=" + dateOp + "&Libelle=" + libelle + "&Depense=" + depense + "&Recette=" + recette;
						var p = requeteHTTP(corps);
						effacer();
						var rep = p.responseXML.documentElement.getAttribute("mss");
						if ( rep == 1 ){
							bValider.disabled = true;
							bSupprimer.disabled = true;
							arbre.initTree();
							modif = true;
						}
						else{
							alert("Id inexistant");
						}
						break;
				}
				break;
		}
	}
	catch(e){
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#valider : ' +e);
	}
}

function supprimer(){
	try{
		var valeur = true;
		var dateOp = document.getElementById("dateOp").value;
		dateOp = prepareDateJava(dateOp);
		var libelle = document.getElementById("libelle").value;
		var depense = document.getElementById("depense").value;
		var recette = document.getElementById("recette").value;

		if ( isEmpty(depense) && !isEmpty(recette) ){
			parseFloat(recette);
			depense = 0.00;
		}
		else if ( !isEmpty(depense) && isEmpty(recette) ){
			parseFloat(depense);
			recette = 0.00;
		}
		else{
			valeur = false;
		}

		switch(valeur){
			case false:
				showWarning("Vous ne pouvez pas avoir une criture qui crdite et dbite  la fois");
				break;
			default:
				var corps = cookie() + "&Page=Compta/Rapprochement/delOp.tmpl&ContentType=xml&Id=" + id;
				var p = requeteHTTP(corps);
				effacer();
				var rep = p.responseXML.documentElement.getAttribute("mss");
				if ( rep == 1 ){
					bValider.disabled = true;
					bSupprimer.disabled = true;
					arbre.initTree();
					modif = true;
				}
				else{
					alert("Id inexistant");
				}
				break;
		}
	}
	catch(e){
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#supprime : ' +e);
	}
}


function effacer() {
	try {

		id = 0;
		document.getElementById("dateOp").value = "";
		document.getElementById("libelle").value = "";
		document.getElementById("depense").value = "";
		document.getElementById("recette").value = "";
		bValider.disabled = true;
		bSupprimer.disabled = true;
		bAnnuler.disabled = true;
		document.getElementById("dateOp").focus();

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/inser_ecriture.js#effacer : ' +e);
	}
}


