/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var info = new Arbre("cpta","info_journal.tmpl","tree_rapprochement");
var journaux = new Arbre("cpta","liste_journaux_t.tmpl","listejournaux");
var periode = new Arbre("cpta","liste_periodes_rb.tmpl","listeperiode");

var date;
var journal;
var date_affiche;
var date_periode;
var periode_test_affiche;

var anciensolde;

var recette_p;
var depense_p;

var Total_np;
var Depense_np;
var Recette_np;

var clos = 'n';

var rep;

var mutex = true;


//Fonction execut  l'ouverture de la fenetre
function init() {
	try {

		if ( !(isEmpty(ParamValeur("journal"))) ) {
			journal = ParamValeur("journal");
			date = ParamValeur("date");
			date_affiche = ParamValeur("dateaffiche");
			date_periode = ParamValeur("dateperiode");
			init_tree();
			frompdf();
		}
		else {
			init_tree();
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#init : ' +e);
	}
}


function retour_menu_principal() {
  try {

		var page = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie() ;
    page += "&Dates="+ parent.document.getElementById("date_exercice").value;
    window.location = page;

	} catch (e) {
    recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#menu_principal : ' + e);
  }
}

//initialise les combo box permettant de choisir son RB
function init_tree() {
  try {

		journaux.initTree();
		periode.initTree();

	} catch (e) {
  	recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#init_tree : ' + e);
  }
}

function frompdf(){
	try {

		var corps = cookie() +"&Page=Compta/Rapprochement/getlibelle.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date;
		var p = requeteHTTP(corps);

		var libelle = p.responseXML.documentElement.getAttribute("Libelle");

		document.getElementById("listejournaux").value = journal;
		document.getElementById("listejournaux").setAttribute("label",journal+" : "+libelle);

		document.getElementById("listeperiode").value = date_periode;
		document.getElementById("listeperiode").setAttribute("label",date_affiche);

		info.clearParams();
		test_cloture();
		info.addParam("Clos",clos);
		info.addParam("Code_Journal",journal);
		info.addParam("Periode",date);
		info.initTree(recup);

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/frompdf.js#ok : ' + e);
	}
}


//initialise l'arbre "tree_rapprochement" lors de l'activation du bouton OK
function ok() {
	try {

		journal = document.getElementById("listejournaux").value;
		date = document.getElementById("listeperiode").value;
		date_affiche = document.getElementById("listeperiode").getAttribute("label");

		if ( !(isEmpty(journal)) && !(isEmpty(date)) ) {
			date_periode = date;
			date = preparePeriodeJava(date);
			test_cloture();
			if (clos != 'y') {
				test = rech_dernier_rb()
				switch ( test ) {
					case 1:
						var url = "chrome://opensi/content/compta/user/rapprochement/alerte_RB.xul?";
						window.openDialog(url,'Warning','chrome,modal',reponse);
						if ( !rep ) {
							break;
						}
					case 2:
						showWarning("Vous ne pouvez pas faire de nouveau Rapprochement Bancaire tant que vous n'avez pas clotur celui de : "+periode_test_affiche);
						break;
					case 3:
						showWarning("Vous ne pouvez pas commencer un RB ce mois ci car vous avez commenc ou fini un RB ulterieur");
						break;
					default:
						info.clearParams();
						info.addParam("Code_Journal",journal);
						info.addParam("Periode",date);
						info.addParam("Clos",clos);
						info.initTree(recup);
						break;
				}
			}
			else {
				info.clearParams();
				info.addParam("Code_Journal",journal);
				info.addParam("Periode",date);
				info.addParam("Clos",clos);
				info.initTree(recup);
			}
		}
		else {
			showWarning("Veuillez indiquer un journal et une date");
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#ok : ' + e);
	}
}


function maj_dernier_rb() {
	try {

		var corps = cookie() +"&Page=Compta/Rapprochement/maj_dernier_rb.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date;
		var p = requeteHTTP(corps);

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#maj_dernier_rb : ' + e);
	}
}


function reponse(valeur) {
	try {

		rep = valeur;

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#reponse : ' + e);
	}
}


function rech_dernier_rb() {
	try {
		var corps = cookie() +"&Page=Compta/Rapprochement/rech_rb.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date;
		var p = requeteHTTP(corps);
		var periode_test = p.responseXML.documentElement.getAttribute("Periode");
		periode_test_affiche = p.responseXML.documentElement.getAttribute("Periode_Affiche");
		var ex_rb_clos = p.responseXML.documentElement.getAttribute("Clos");
		var moisAvant = p.responseXML.documentElement.getAttribute("Mois_Avant");
		var dateLong = p.responseXML.documentElement.getAttribute("Date_Long");

		if ( periode_test < dateLong ) {
			if ( ex_rb_clos == 'y' ) {
				if ( moisAvant == 1 ) {
					return 5;
				}
				else {
					return 1;
				}
			}
			else {
				return 2;
			}
		}
		else if ( periode_test > dateLong ) {
			return 3;
		}
		else {
			return 4;
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#rech_dernier_rb : ' + e);
	}
}


//rcupre les valeur de l'ancien solde et du solde comptable (fonctionne en asynchrone avec l'initialisation de l'arbre
function recup() {
	try {

		recup_anciensolde();
		recup_soldecomptable();

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#recup : ' + e);
	}
}

//rcupre les valeurs total pointe et non pointe dans la BD
//Calcul le nouveausoldevirtuel et Remplit les champs de la page
function calculnouveausolde() {
	try {

		var solde = document.getElementById("lblAncienSolde").value;
		var corps= cookie() +"&Page=Compta/Rapprochement/total.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date +"&Solde="+ solde;
		var p = requeteHTTP(corps);

		var nvSolde = p.responseXML.documentElement.getAttribute("Total");

		var Total_p = p.responseXML.documentElement.getAttribute("Total_p");
		var Depense_p = p.responseXML.documentElement.getAttribute("Depense_p");
		var Recette_p = p.responseXML.documentElement.getAttribute("Recette_p");

		Total_np = p.responseXML.documentElement.getAttribute("Total_np");
		Depense_np = p.responseXML.documentElement.getAttribute("Depense_np");
		Recette_np = p.responseXML.documentElement.getAttribute("Recette_np");

		var nvsoldebanque = p.responseXML.documentElement.getAttribute("nvSolde");

		document.getElementById("recette_p").value = Recette_p;
		document.getElementById("depense_p").value = Depense_p;
		document.getElementById("total_p").value = Total_p;

		document.getElementById("nvsoldevirtuel").value = nvSolde;

		document.getElementById("nvsoldebanque").value = parseFloat(nvsoldebanque);

		difference();

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#calculnouveausolde : ' + e);
	}
}

//fonction enregistre le nouveausoldebanque dans la BD
function recup_nouveausolde(valeur) {
	try {

		var corps = cookie() +"&Page=Compta/Rapprochement/majnouveausolde.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date +"&Solde="+ valeur;
		var p = requeteHTTP(corps);
		calculnouveausolde();

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#recup_nouveausolde : ' + e);
	}
}

//fonction qui rcupre l'ancien solde de banque dans la BD
function recup_anciensolde() {
	try {

		var corps = cookie() +"&Page=Compta/Rapprochement/anciensolde.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date;
		var p = requeteHTTP(corps);
		if ( p.status != "200" ) {
			showWarning("Rception erreur "+ p.status);
		}
		else {
			var Solde = p.responseXML.documentElement.getAttribute("Solde");
			document.getElementById("lblAncienSolde").value = Solde;
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#recup_anciensolde : ' + e);
	}
}

//fonction qui rcupre le solde comptable dans la BD
function recup_soldecomptable() {
	try {

		var corps = cookie() +"&Page=Compta/Rapprochement/soldecomptable.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date +"&Clos="+ clos;
		var p = requeteHTTP(corps);

		var Solde = p.responseXML.documentElement.getAttribute("Solde");
		var existe = p.responseXML.documentElement.getAttribute("Existe");
		if (existe == 0) {
			document.getElementById("lblSoldeComptable").value = Solde;
			demande_nvsolde();
		}
		else {
			document.getElementById("lblSoldeComptable").value = Solde;
			calculnouveausolde();
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#recup_soldecomptable : ' + e);
	}
}

//fonction qui apelle la fenetre "nvsoldebanque.xul" afin de rcuprer le nouveau solde de banque lors du premier rapprochement bancaire du journal
function demande_nvsolde() {
	try {

		if (journal != null) {
			var url = "chrome://opensi/content/compta/user/rapprochement/nvsoldebanque.xul?";
			window.openDialog(url,'Nouveau Solde','chrome,modal',recup_nouveausolde);
		}
		else {
			showWarning("Vous n'avez pas encore choisi de journal");
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#demande_nvsolde : ' + e);
	}
}

//permet de pointer ou de dpointer une criture avec la touche entre
function keypress(e) {
	try {

		switch(e.keyCode) {
			case 13:
				if ( mutex ) {
					mutex = ! mutex;
					var arbre = document.getElementById("tree_rapprochement");
					var indx = arbre.currentIndex;
					var equilibre = getCellValue(arbre,indx,"equilibre");

					if ( indx != -1 && clos != 'y' && equilibre == 'n') {
		            		var numColonne = 5;
        		      		var objet_XUL = arbre.view.getItemAtIndex(indx);
                				var ligne = objet_XUL.childNodes[0].childNodes;
	                			var cellule = ligne[numColonne];
        	            		var old_valeur = cellule.getAttribute("label");

						if( old_valeur == "*" ) {
        		      			cellule.setAttribute("label","");
                				}
	                  		else {
	        	      			cellule.setAttribute("label","*");
        	        			}

						var val = getCellValue(arbre,indx,"op_id");
						pointe(val);
						recalcul(indx);
					}
					mutex = ! mutex;
				}
			break;
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#keypress : ' + e);
	}
}

//modifie la valeur de "Pointe" dans la BD
function pointe(val) {
	try {

		var corps = cookie() +"&Page=Compta/Rapprochement/pointe.tmpl&ContentType=xml&Op_Id="+ val;
		var p = requeteHTTP(corps);

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#pointe : ' + e);
	}
}


//Recalcul les valeurs des differents champs lors d'un pointage/dpointage
function recalcul(indx) {
	try {

		var tree = document.getElementById("tree_rapprochement");

		var nvSolde;
		var nvRecette_p;
		var nvDepense_p;
		var nvTotal_p;

		var nvRecette_np;
		var nvDepense_np;
		var nvTotal_np;

		var exSolde = parseFloat(document.getElementById("nvsoldevirtuel").value);

		var exRecette_p = parseFloat(document.getElementById("recette_p").value);
		var exDepense_p = parseFloat(document.getElementById("depense_p").value);

		var exRecette_np = parseFloat(Recette_np);
		var exDepense_np = parseFloat(Depense_np);

		var point = getCellText(tree, indx,"pointe");

		var recette = getCellText(tree,indx,"recettes");
		recette = parseFloat(recette);
		if ( isNaN(recette) ) {
			recette = 0.00;
		}

		var depense = getCellText(tree,indx,"dpenses");
		depense = parseFloat(depense);
		if ( isNaN(depense) ) {
			depense = 0.00;
		}

		if (point == "") {
			nvRecette_p = exRecette_p - parseFloat(recette);
			nvDepense_p = exDepense_p - parseFloat(depense);
			nvTotal_p = parseFloat(nvRecette_p) - parseFloat(nvDepense_p);

			nvRecette_np = exRecette_np + parseFloat(recette);
			nvDepense_np = exDepense_np + parseFloat(depense);
			nvTotal_np =  parseFloat(nvRecette_np) - parseFloat(nvDepense_np);

			nvSolde = exSolde - parseFloat(recette) + parseFloat(depense);
		}
		else {
			nvRecette_p = exRecette_p + parseFloat(recette);
			nvDepense_p = exDepense_p + parseFloat(depense);
			nvTotal_p = parseFloat(nvRecette_p) - parseFloat(nvDepense_p);

			nvRecette_np = exRecette_np - parseFloat(recette);
			nvDepense_np = exDepense_np - parseFloat(depense);
			nvTotal_np = parseFloat(nvRecette_np) - parseFloat(nvDepense_np);

			nvSolde = exSolde + parseFloat(recette) - parseFloat(depense);
		}
		document.getElementById("nvsoldevirtuel").value = formatNombre(nvSolde,"0.00");

		document.getElementById("recette_p").value = formatNombre(nvRecette_p,"0.00");
		document.getElementById("depense_p").value = formatNombre(nvDepense_p,"0.00");
		document.getElementById("total_p").value = formatNombre(nvTotal_p,"0.00");

		Recette_np = formatNombre(nvRecette_np,"0.00");
		Depense_np = formatNombre(nvDepense_np,"0.00");
		Total_np = formatNombre(nvTotal_np,"0.00");

		difference();

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#recalcul : ' + e);
	}
}

//fonction qui modifie le nvsoldevirtuel lors d'une modification de l'ancien solde
function recalcul_valeur(valeur) {
	try {

		if ( isNaN(anciensolde) ) {
			anciensolde = 0.00;
		}
		var nvSolde;
		var exSolde = parseFloat(document.getElementById("nvsoldevirtuel").value);
		nvSolde = exSolde + parseFloat(valeur) - anciensolde;
		document.getElementById("nvsoldevirtuel").value = formatNombre(nvSolde,"0.00");
		difference();

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#recalcul_valeur : ' + e);
	}
}

//fonction qui apelle la fenetre recherche.xul
function rechercher() {
	try {

		if ( journal != null ) {
			var url = "chrome://opensi/content/compta/user/rapprochement/recherche.xul?"+ cookie();
			window.openDialog(url,'Recherche','chrome,modal',journal,date,recalcul_by_id);
		}
		else {
			showWarning("Vous n'avez pas encore choisi de journal");
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#rechercher : ' + e);
	}
}


//fonction qui permet les modifications lors de pointage dpointage dans la fenetre rechercher
function recalcul_by_id(val) {
	try {

		pointe(val);

		var arbre = document.getElementById("tree_rapprochement");
		nb = arbre.view.rowCount;
		var i = 0;
		while ( val != getCellValue(arbre,i,"op_id") ) {
			i++;
		}

		changePoint(i);

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#recalcul_by_id : ' + e);
	}
}

//change la valeur du "point" dans l'arbre (pour ne pas avoir a recharger l'arbre  chaque modification)
function changePoint(i) {
	try {

		var arbre = document.getElementById("tree_rapprochement");
		if ( i != -1 ) {
			var numColonne = 5;
      var objet_XUL = arbre.view.getItemAtIndex(i);
      var ligne = objet_XUL.childNodes[0].childNodes;
	    var cellule = ligne[numColonne];
      var old_valeur = cellule.getAttribute("label");

			if( old_valeur == "*" ) {
      	cellule.setAttribute("label","");
      }
	    else {
	    	cellule.setAttribute("label","*");
      }

			recalcul(i);
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#changePoint : ' + e);
	}
}

//calcul la diffrence entre le nvsoldevirtuel et le nvsoldebanque
function difference() {
	try {

		var nvsoldevirtuel = parseFloat( document.getElementById("nvsoldevirtuel").value );
		var nvsoldebanque = parseFloat( document.getElementById("nvsoldebanque").value );
		var dif = nvsoldevirtuel - nvsoldebanque;
		dif = Math.abs(dif);
		document.getElementById("difference").value = formatNombre(dif,"0.00");

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#difference : ' + e);
	}
}

//test si la cloture du cmpt est possible puis apelle la fenetre "validation.xul"
function cloture() {
	try {

		if (journal != null) {
			var test = document.getElementById("difference").value;
			test = formatNombre(test,"0.00");
			if ( test != 0.00 ) {
				showWarning("La Difference n'est pas nulle, vous ne pouvez cloturer votre rapprochement bancaire");
			}
			else {
				var soldevirt = parseFloat(document.getElementById("nvsoldevirtuel").value );
				var soldecmpt = parseFloat(document.getElementById("lblSoldeComptable").value );
				var soldeaveccmpt = ( soldecmpt - parseFloat(Total_np) );
				soldeaveccmpt = formatNombre(soldeaveccmpt,"0.00");

				if ( soldeaveccmpt == soldevirt ) {
					var ancienSolde = document.getElementById("lblAncienSolde").value;
					var nouveauSolde = document.getElementById("nvsoldebanque").value;
					var depense = document.getElementById("depense_p").value;
					var recette = document.getElementById("recette_p").value;

					var url = "chrome://opensi/content/compta/user/rapprochement/validation.xul?"+ cookie();
					window.openDialog(url,'Validation','chrome,modal',ancienSolde,depense,recette,nouveauSolde,journal,date,pdf,test_cloture);
				}
				else {
					showWarning("La diffrence est nul mais il y a une incohrence avec le solde comptable");
				}
			}
		}
		else {
			showWarning("Vous n'avez pas encore choisi de journal");
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#cloture : ' + e);
	}
}

//apelle la fenetre "pdf_rapprochement.xul" lors de la validation
function pdf() {
	try {

		var page = "chrome://opensi/content/compta/user/rapprochement/pdf_rapprochement.xul?"+ cookie() ;
		page += "&journal="+journal+"&periode="+date+"&dateaffiche="+date_affiche+"&dateperiode="+date_periode;
		window.location = page;

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#pdf : ' +e);
	}
}

function pdfpointe() {
	try {

		var page = "chrome://opensi/content/compta/user/rapprochement/pdf_pointe.xul?"+ cookie() ;
		page += "&journal="+journal+"&periode="+date+"&dateaffiche="+date_affiche+"&dateperiode="+date_periode;
		window.location = page;

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#pdfpointe : ' +e);
	}
}


function test_cloture() {
	try {

		var corps = cookie() +"&Page=Compta/Rapprochement/test_cloture.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+date;
		var p = requeteHTTP(corps);

		clos = p.responseXML.documentElement.getAttribute("Clos");

		if (clos == 'y') {
			document.getElementById("tree_rapprochement").disabled = true;
			document.getElementById("cloture").disabled = true;
			document.getElementById("recherche").disabled = true;
			document.getElementById("saisieecriture").disabled = true;
			document.getElementById("saisiecompte").disabled = true;
			document.getElementById("modifnvsolde").disabled = true;
			document.getElementById("toutpointer").disabled = true;
			document.getElementById("toutdepointer").disabled = true;
			document.getElementById("editer").disabled = false;
			document.getElementById("editepointe").disabled = false;
			document.getElementById("indic").collapsed = false;
		}
		else {
			document.getElementById("tree_rapprochement").disabled = false;
			document.getElementById("cloture").disabled = false;
			document.getElementById("recherche").disabled = false;
			document.getElementById("saisieecriture").disabled = false;
			document.getElementById("saisiecompte").disabled = false;
			document.getElementById("modifnvsolde").disabled = false;
			document.getElementById("toutpointer").disabled = false;
			document.getElementById("toutdepointer").disabled = false;
			document.getElementById("editer").disabled = true;
			document.getElementById("editepointe").disabled = true;
			document.getElementById("indic").collapsed = true;
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#test_cloture : ' + e);
	}
}


function saisiecompte() {
	try {

		if (journal != null) {
			var url = "chrome://opensi/content/compta/user/rapprochement/inser_ecriture.xul?"+ cookie();
			window.openDialog(url,'InserEcriture','chrome,modal',journal,date,recharge);
		}
		else {
			showWarning("Vous devez choisir un journal et une date");
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#saisiecompte : ' + e);
	}
}


function recharge() {
	try {

		var corps = cookie() +"&Page=Compta/Rapprochement/updateanciensolde.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date;
		var p = requeteHTTP(corps);
		info.initTree(recup);
		test_cloture();

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#recharge : ' + e);
	}
}


//fonctions qui pointe ou dpointe toute les critures
function pointe_tout() {
	try {

		if (journal != null) {
			var typep = "pointe";
			var corps = cookie() +"&Page=Compta/Rapprochement/pointe_tout.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date +"&Type="+typep;
			var p = requeteHTTP(corps);
			info.initTree(recup);
			test_cloture();
		}
		else {
			showWarning("Vous n'avez pas encore choisi de journal");
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#pointe_tout : ' + e);
	}
}


function depointe_tout() {
	try {

		if (journal != null) {
			var typep = "depointe";
			var corps = cookie() +"&Page=Compta/Rapprochement/pointe_tout.tmpl&ContentType=xml&Code_Journal="+ journal +"&Periode="+ date +"&Type="+typep;
			var p = requeteHTTP(corps);
			info.initTree(recup);
			test_cloture();
		}
		else {
			showWarning("Vous n'avez pas encore choisi de journal");
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#depointe_tout : ' + e);
	}
}















