/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var arbrerech = new Arbre("cpta","rech_rapprochement_bancaire.tmpl","rechercheur");
var journal;
var periode;


function init() {
	try {

		journal = window.arguments[0];
		periode = window.arguments[1];

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/recherche.js#init : ' +e);
	}
}


function recup_rech() {
	try {

		arbrerech.deleteTree();
		var libelle = document.getElementById("libelle").value;
		var piece = document.getElementById("piece").value;
		var date_d = document.getElementById("date_d").value ;
		var date_f = document.getElementById("date_f").value ;
		var minvaleur = document.getElementById("min").value ;
		var maxvaleur = document.getElementById("max").value ;
		var choix = document.getElementById("lequel").selectedItem;
		rech(libelle,piece,date_d,date_f,minvaleur,maxvaleur,choix);

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/recherche.js#recup_rech : ' +e);
	}
}


function test_valeur(minvaleur, maxvaleur) {
	try {

		if ( !isEmpty(minvaleur) && !isEmpty(maxvaleur) ) {
			minvaleur = parseFloat(minvaleur);
			maxvaleur = parseFloat(maxvaleur);
			if( checkDecimal(minvaleur,2) ) {
				if ( checkDecimal(maxvaleur,2) ) {
					if ( minvaleur <= maxvaleur ) {
						return 1; // minvaleur et maxvaleur existe, sont correct et minvaleur <= maxvaleur
					}
					else{
						return 2;//minvaleur et maxvaleur existe, sont correct mais minvaleur > maxvaleur
					}
				}
				else{
					return 3;// minvaleur et maxvaleur existe mais maxvaleur n'est pas correct
				}
			}
			else{
				return 4;//minvaleur et maxvaleur existe mais minvaleur est incorrect
			}
		}
		else if ( minvaleur == "" &&  maxvaleur != "") {
			maxvaleur = parseFloat(maxvaleur);
			if ( checkDecimal(maxvaleur,2) ) {
				return 5;//maxvaleur existe et est correct
			}
			else{
				return 6;//maxvaleur existe mais n'est pas correct
			}
		}
		else if ( minvaleur != "" && maxvaleur == "") {
			minvaleur = parseFloat(minvaleur);
			if ( checkDecimal(minvaleur,2) ) {
				return 7;//minvaleur existe et est correct
			}
			else{
				return 8;//minvaleur existe mais n'est pas correct
			}
		}
		else{
			return 9;//aucune des deux valeurs n'existe
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/recherche.js#test_valeur : ' +e);
	}
}


function rech(libelle,piece,date_d,date_f,minvaleur,maxvaleur,choix) {
	try {

		var lequel;

		arbrerech.clearParams();
		arbrerech.addParam("Code_Journal",journal);
		arbrerech.addParam("Periode",periode);
		arbrerech.addParam("Libelle",libelle);
		arbrerech.addParam("Piece",piece);

		if ( date_d != "" ) {
			switch( isDate(date_d) ) {
				case true:
					var dated = prepareDateJava(date_d);
					arbrerech.addParam("Dated",dated);
					break;
				case false:
					showWarning("Date dbut non valide");
					break;
			}
		}
		if ( date_f != "" ) {
			switch( isDate(date_f) ) {
				case true:
					var datef = prepareDateJava(date_f);
					arbrerech.addParam("Datef",datef);
					break;
				case false:
					showWarning("Date fin non valide");
					break;
			}
		}
		switch( test_valeur(minvaleur,maxvaleur) ) {
			case 1:
				arbrerech.addParam("Minvaleur",parseFloat(minvaleur));
				arbrerech.addParam("Maxvaleur",parseFloat(maxvaleur));
				break;
			case 2:
				showWarning("Problme: Valeur min > valeur max");
				break;
			case 3:
				showWarning("Valeur max incorrect");
				break;
			case 4:
				showWarning("Valeur min incorrect");
				break;
			case 5:
				arbrerech.addParam("Maxvaleur",parseFloat(maxvaleur));
				break;
			case 6:
				showWarning("Valeur max incorrect");
				break;
			case 7:
				arbrerech.addParam("Minvaleur",parseFloat(minvaleur));
				break;
			case 8:
				showWarning("Valeur min incorrect");
				break;
			case 9:
				break;
		}
		switch( choix ) {
			case document.getElementById("recette"):
				lequel = "r";
				arbrerech.addParam("Lequel",lequel);
				break;
			case document.getElementById("depense"):
				lequel = "d";
				arbrerech.addParam("Lequel",lequel);
				break;
			case document.getElementById("lesdeux"):
				lequel = "l";
				arbrerech.addParam("Lequel",lequel);
				break;
			default:
				lequel = "a";
				break;
		}

		if ( libelle != "" || piece != "" || minvaleur != "" || maxvaleur != "" || isDate(date_d) || isDate(date_f) ) {
			arbrerech.initTree();
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/recherche.js#rech : ' +e);
	}
}


function keypress(e) {
	try {

		switch(e.keyCode) {
			case 13:
				var arbre = document.getElementById("rechercheur");
				var indx = arbre.currentIndex;
				if (arbre.currentIndex != -1) {

		      var numColonne = 5;
        	var objet_XUL = arbre.view.getItemAtIndex(indx);
          var ligne = objet_XUL.childNodes[0].childNodes;
	        var cellule = ligne[numColonne];
        	var old_valeur = cellule.getAttribute("label");

					if (old_valeur == "*") {
        		cellule.setAttribute("label","");
          }
	        else {
	        	cellule.setAttribute("label","*");
        	}

					var val = getCellValue(arbre,indx,"op_id");
					window.arguments[2](val);
				}
				break;
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#keypress : ' + e);
	}
}


function fermer() {
	try {

		window.close();

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#fermer : ' + e);
	}
}


function use() {
	try {

		var valmin = document.getElementById("min").value;
		var valmax = document.getElementById("max").value;

		if (valmin=="" && valmax=="") {
			document.getElementById("lequel").selectedItem = null;
		}
		else if (document.getElementById("lequel").selectedItem == null) {
			document.getElementById("lequel").selectedItem = document.getElementById("lesdeux");
		}

	}	catch(e) {
		recup_erreur('erreur dans compta/user/rapprochement/rapprochement.js#use : ' + e);
	}
}










