/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");


var ismenu = true;
var numop = '';


function saisiedirecte() {
  try {

    if (ismenu) {
      var avancement = document.getElementById('frmavancement').contentDocument;
      document.getElementById('journaux').value = avancement.getElementById('journal').value;
      document.getElementById('periode').value = avancement.getElementById('periode').value;
      oksaisie();
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#saisiedirecte : ' + e);
  }
}

function init() {
  try {

    numop = ParamValeur('numop');

    var urlavancement = "&Page=Compta/Etats/Avancement.tmpl&ContentType=xul";
    urlavancement += "&date="+ parent.document.getElementById('date_courante').value;

		document.getElementById('frmavancement').setAttribute("src", getUrlOpeneas(urlavancement));

		var aJournaux = new Arbre('cpta', "liste_journaux.tmpl", 'journaux');
		aJournaux.initTree(suite_init);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#init : ' + e);
  }
}

function suite_init() {
  try {

		var aPeriodes = new Arbre('cpta', "liste_periodes.tmpl", 'periode');
		aPeriodes.initTree(fin_init);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#suite_init : ' + e);
  }
}

function fin_init() {
  try {

    if (isEmpty(numop)) {
      document.getElementById('journaux').focus();
      ismenu = true;
    }
		else {
      document.getElementById('journaux').value = ParamValeur('Code_Journal');
      document.getElementById('periode').value = ParamValeur('Periode');
      oksaisie();
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#fin_init : ' + e);
  }
}

function isPeriode(p) {
  try {

    if (!isFinite(p)) return false;
    if (p.length != 4) return false;
    var mois = eval(p.substring(0,2));
    var annee = eval(p.substring(2,4));
    var aux = (annee + MODULO) % 100;
    annee = aux + BASE_CALENDRIER;
    var date = annee * 12 + mois;
    var debut_exercice = parseInt(get_cookie('Premier_Mois_Exercice'));
    var fin_exercice = parseInt(get_cookie('Dernier_Mois_Exercice'));
    if (date < debut_exercice ) return false;
    if (date > fin_exercice ) return false;
    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#isPeriode : ' + e);
  }
}

function labelJournal(journal) {
  try {

    var tab_journaux = document.getElementById('journaux').getElementsByTagName('menuitem');
    for (i=1;i<tab_journaux.length;i++) {
      var tab_journal = tab_journaux[i];
      if (journal.toUpperCase() == tab_journal.value.toUpperCase())
        return tab_journal.label;
      if (journal.toUpperCase() == tab_journal.label.toUpperCase())
        return tab_journal.label;
    }
    return '';

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#labelJournal : ' + e);
  }
}

function labelPeriode(periode) {
  try {

    var tab_periodes = document.getElementById('periode').getElementsByTagName('menuitem');
    for (i=1;i<tab_periodes.length;i++) {
      var tab_periode = tab_periodes[i];
      if (periode.toUpperCase() == tab_periode.value.toUpperCase())
        return tab_periode.label;
      if (periode.toUpperCase() == tab_periode.label.toUpperCase())
        return tab_periode.label;
    }
    return '';

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#labelPeriode : ' + e);
  }
}

function retour_saisie() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie();
    page += "&Dates="+ parent.document.getElementById("date_exercice").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#retour_saisie : ' + e);
  }
}

function retour_exercice() {
  try {
    var page = "chrome://opensi/content/compta/user/menu_dossier.xul?"+ cookie();
    page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#retour_exercice : ' + e);
  }
}

function keypress(e) {
  try {
    switch (e.keyCode) {
      case 13:
        oksaisie();
        break;
      case 123: // 'F12'
        rechecr();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#keypress : ' + e);
  }
}

function oksaisie() {
  try {

    var journaux = document.getElementById('journaux');

    if (journaux.selectedIndex==-1) {

      var journal = journaux.value;
      if (isEmpty(journal)) {
        journaux.focus();
      }
			else {
        var nom_journal = labelJournal(journal);
        if (isEmpty(nom_journal)) {
          showWarning("Le journal "+ journal +" n'existe pas. Veuillez en slectionner un dans la liste.");
          journaux.value = "";
          journaux.focus();
        }
				else {
          journaux.value = nom_journal;
          var type_journal = journaux.selectedItem.tooltip;
          validPeriode(journal,type_journal);
        }
      }
		}
    else {
      var journal = journaux.selectedItem.value;
      var type_journal = journaux.selectedItem.tooltip;
      validPeriode(journal,type_journal);
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#ok : ' + e);
  }
}

function validPeriode(journal,type_journal) {
  try {

    var periode = document.getElementById('periode');

    var p = '';

    if (periode.selectedIndex==-1) {

      p = periode.value;
      if (isEmpty(p)) {
        periode.focus();
        return false;
      }
			else {
        var nom_periode = labelPeriode(p);
        if (isEmpty(nom_periode)) {
          showWarning("Priode incorrecte !");
          periode.value = '';
          periode.focus();
          return false;
        }
				else {
          periode.value = nom_periode;
        }
      }
		}
    else {
    	p = periode.selectedItem.value;
    }


    if (isEmpty(p)) {
      periode.focus();
    }
		else if (!isPeriode(p)) {
      showWarning("Priode incorrecte !");
      periode.value = '';
      periode.focus();
    }
		else {
      document.getElementById('boxavancement').collapsed = true;
      document.getElementById('boxsaisie').collapsed = false;
      ismenu = false;
      var paramlist = "&Code_Journal="+ journal;
      paramlist += "&Type_Journal="+ type_journal;
      paramlist += "&Periode="+ p;
      paramlist += "&numop="+ numop;
      var page = "chrome://opensi/content/compta/user/saisie/saisie.xul?"+ cookie() + paramlist;
      document.getElementById("frmsaisie").setAttribute("src",page);
      document.getElementById("frmsaisie").focus();
      document.getElementById('revision').collapsed = false;
      document.getElementById('plan').collapsed = false;
      numop = '';
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#validPeriode : ' + e);
  }
}

function rechecr() {
  try {

    var page = "chrome://opensi/content/compta/util/rechecriture.xul?"+ cookie();
    window.openDialog(page,'','chrome,modal,centerscreen');

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#rechecr : ' + e);
  }
}

function revision() {
  try {

    if (!document.getElementById("frmsaisie").contentWindow.revision()) {
      window.location = "chrome://opensi/content/compta/user/consultation/menu_consultation.xul?"+ cookie();
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#revision : ' + e);
  }
}

function plan_comptable() {
  try {

    document.getElementById("frmsaisie").contentWindow.plan_comptable();

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/menu_saisie.js#plan_comptable : ' + e);
  }
}
