/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://libopensi/content/rdfds.js");
jsLoader.loadSubScript("chrome://libopensi/content/load_rdf.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");


var force = false;
var rExp = / /gi;

var focus_input = ''; // id du textbox ayant le focus.
var id_timeout = 0;
var mustwait = false;

var dsource; // source de donnes RDF de l'arbre.

var nb_ecritures = 0; // nombre d'critures
var ecritures; // la liste des critures du journal de saisie courant.

var debut_periode = 0;

var modif_solde = false;
var id_select = -1;

var writeable = true; // indique si l'exercice en cours est ditable ou non.

var page = 0;
var nb_pages = 0;
var numop = '';

var anc_value;

var page_chargee = true;

var ecrStable = false;
var chpModifie = false;
var prevnext = "next";



var qMajField = new QueryHttp("Compta/Saisie/update.tmpl");
var qInfosCompte = new QueryHttp("Compta/Saisie/getInfosCompte.tmpl");
var qExCompte = new QueryHttp("Compta/Commun/existeCompte.tmpl");
var qInfosEcr = new QueryHttp("Compta/Saisie/GetInfosEcriture.tmpl");


var nfJour = new NumberFormat("00", false);
var nfIPart = new NumberFormat("0", false);
var nfNb = new NumberFormat("0.00", false);
var nfMt = new NumberFormat("0.00", true);



/* @return le pointeur vers l'arbre contenant les critures comptables */
function get_tree() {
  try {

    return document.getElementById('tree_ecritures');

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_tree : '+ e);
  }
}

function get_root() {
  try {

    return dsource.getNode("http://www.opensi.org/compta/operations");

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_root : '+ e);
  }
}

/****************************************************
 *  Correspondance entre l'id d'un textbox et le target RDF associ
 *  @param id : l'identifiant du textbox
 *  @return le target associ
 ****************************************************/
function targetname(id) {
  try {

    switch(id) {
      case 'input_date':					return "http://www.opensi.org/compta/operations/rdf#date";					break;
      case 'input_compte':  			return "http://www.opensi.org/compta/operations/rdf#compte";				break;
      case 'input_type':    			return "http://www.opensi.org/compta/operations/rdf#type";    			break;
      case 'input_raccourci': 		return "http://www.opensi.org/compta/operations/rdf#raccourci";			break;
      case 'input_libelle':   		return "http://www.opensi.org/compta/operations/rdf#libelle";   		break;
      case 'input_contrepartie':	return "http://www.opensi.org/compta/operations/rdf#contrepartie";	break;
      case 'input_echeance':      return "http://www.opensi.org/compta/operations/rdf#echeance";      break;
      case 'input_piece':	        return "http://www.opensi.org/compta/operations/rdf#piece";         break;
      case 'input_debit':	        return "http://www.opensi.org/compta/operations/rdf#debit";	        break;
      case 'input_credit':        return "http://www.opensi.org/compta/operations/rdf#credit";        break;
      case 'num_ecriture':        return "http://www.opensi.org/compta/operations/rdf#num_ecriture";	break;
      case 'ecrid':				        return "http://www.opensi.org/compta/operations/rdf#ecrid";	        break;
      case 'opid':				        return "http://www.opensi.org/compta/operations/rdf#opid";	        break;
      case 'numop':				        return "http://www.opensi.org/compta/operations/rdf#numop";	        break;
      case 'nouv':				        return "http://www.opensi.org/compta/operations/rdf#nouv";	        break;
      case 'type_desc':		        return "http://www.opensi.org/compta/operations/rdf#type_desc";			break;
      case 'prop':				        return "http://www.opensi.org/compta/operations/rdf#prop";					break;
      default:						        return "";
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#targetname : '+ e);
  }
}


/* @return le nombre de jours dans le mois correspondant  la saisie */
function nb_jours_periode() {
  try {

    var p = ParamValeur('Periode');
    var mois = parseIntBis(p.substr(0,2));
    var annee = parseIntBis(p.substr(2,2));
    return nb_jours(mois,annee);

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#nb_jours_periode : '+ e);
  }
}


/* Rcupre le nombre d'critures sur la base */
function get_nb_pages() {
  try {

    var corps = cookie() +"&Page=Compta/GetNbEcritures.tmpl&ContentType=xml";
    corps += "&Periode="+ ParamValeur('Periode');
    corps += "&Code_Journal="+ ParamValeur('Code_Journal');

    var p = requeteHTTP(corps);
    var nbecr = p.responseXML.documentElement.getAttribute('nb');

    return parseInt(nbecr/10+1);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_nb_pages : '+ e);
  }
}


/* Initialisation des critures */
function init() {
  try {

    document.getElementById('nom_dossier').value = parent.parent.document.getElementById("nom_dossier").value;
    document.getElementById('date_exercice').value = parent.parent.document.getElementById("date_exercice").value;
    document.getElementById('input_box').collapsed = true;

    modif_solde = false;
    var paramlist = '';

    nb_pages = get_nb_pages();
    var page_courante = ParamValeur('page');

		if (isEmpty(page_courante)) {
      page = nb_pages;
    }
		else {
      page = parseInt(page_courante);
    }

    document.getElementById('boutonDebut').disabled = (page == 1);
    document.getElementById('boutonPrec').disabled = (page == 1);
    document.getElementById('boutonFin').disabled = (page == nb_pages);
    document.getElementById('boutonSuiv').disabled = (page == nb_pages);

    writeable = ((get_cookie('Writeable')=='1') && (ParamValeur('Type_Journal')!='AN'));
    var periode = ParamValeur('Periode');
    var mois = get_mois(periode.substr(0,2));
    var annee = '20'+ periode.substr(2,2);
    document.getElementById('periode').value = mois +' '+ annee;

    numop = ParamValeur('numop');
    if (isEmpty(numop)) {
      pageFin();
    }
		else {
      pageNumOp(numop);
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#init : '+ e);
  }
}

/* Supprime le contenu de l'arbre */
function delete_tree() {
  try {
    if (dsource != null) {
      dsource.deleteRecursive(get_root());
      dsource.deleteRecursive(ecritures);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#delete_tree : '+ e);
  }
}

/****************************************************
 *  Chargement des critures dans l'arbre.
 *  @param dsUrl : l'URL de la source de donnes RDF.
 ****************************************************/
function load_tree(dsUrl) {
  try {
    document.getElementById("pgload").collapsed = false;
    // initialise la source de donnes de l'arbre.
    dsource = new RDFDataSource();
    // Gnre une source de donnes  partir de l'URL dfinie en paramtres,
    // et appelle la fonction init_tree() une fois la source charge.
    load_rdf_async('tree_ecritures', dsUrl, init_tree);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#load_tree'+ e);
  }
}

function get_child(id) {
  try {
    var child = null;
    var index = id + 1;
    var root = get_root();
    var children = root.getChildren();
    var found = false;
    while ((children.hasMoreElements()) && (! found) ) {
      var c = children.getNext();
      if (root.getChildIndex(c) == index) {
        child = c;
        found = true;
      }
    }
    return child;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#get_child : '+ e);
  }
}

/****************************************************
 *  Chargement de l'arbre depuis la source.
 *  @param dsource2 : la source du RDF
 ****************************************************/
function init_tree(dsource2) {
  try {

    dsource.deleteRecursive("http://www.opensi.org/compta/operations");
    dsource.deleteRecursive("http://www.opensi.org/compta/ecritures");
    var datasource = dsource.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource);

    dsource2.copyAllToDataSource(dsource);

    var datasource2 = dsource2.getRawDataSource();
    get_tree().database.RemoveDataSource(datasource2);
    var datasource = dsource.getRawDataSource();
    get_tree().database.AddDataSource(datasource);

    focus_input = "input_date";

    debut_periode = parseIntBis(get_cookie('Debut_Periode'));

    ecritures = dsource.getNode("http://www.opensi.org/compta/ecritures");
    ecritures.makeBag();
    setTimeout('init_ecritures()',100);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#init_tree'+ e);
  }
}

/****************************************************
 *  Initialise le conteneur d'objets Ecritures
 *  @return le nombre d'critures du journal
 *          (en comptant la nouvelle criture en fin de saisie)
 ****************************************************/
function init_ecritures() {
  try {

    var nb_ecr = 0;

    var root = get_root();
    var children = root.getChildren();
    while (children.hasMoreElements()) {
      var child = children.getNext();
      var id = root.getChildIndex(child) - 1;
      var aux = getCellText(get_tree(),id,'ecrid');
      var num_ecr = parseIntBis(aux);
      if (isEmpty(aux) || isNaN(num_ecr)) num_ecr = -1;
      if (num_ecr > nb_ecr) nb_ecr = num_ecr;
      if (num_ecr > -1) {
        var uri = "http://www.opensi.org/compta/ecritures/"+ num_ecr;
        var ecriture = dsource.getNode(uri);
        ecriture.makeBag();
        ecriture.addChild(child);
        ecritures.addChild(ecriture);
      }
    }

    nb_ecritures = nb_ecr;

    setTimeout('focus_saisie()',100);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#init_ecritures : '+ e);
  }
}


// Slectionne la dernire ligne de l'arbre et met le focus sur la ligne de saisie.
function focus_saisie() {
  try {

    if (writeable) {
      document.getElementById('input_box').collapsed = false;
      document.getElementById("input_compte").focus();
      document.getElementById("input_contrepartie").focus();
      document.getElementById("input_type").focus();
      document.getElementById("input_raccourci").focus();
      document.getElementById("input_libelle").focus();
      document.getElementById("input_debit").focus();
      document.getElementById("input_credit").focus();
      document.getElementById("input_echeance").focus();
      document.getElementById("input_piece").focus();
      focus_input = "input_date";
      document.getElementById(focus_input).focus();
    }
		else {
      document.getElementById('input_box').collapsed = true;
      get_tree().focus();
    }

    if (isEmpty(numop)) {
    	if (writeable && page==nb_pages) {
        select_end();
      }
			else if (get_tree().view != null) {
        select_begin();
      }
    }
		else {
      select_op(numop);
      numop = '';
    }

    page_chargee = true;
    document.getElementById("pgload").collapsed = true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_saisie : '+ e);
  }
}


function select_op(opid) {
  try {

    var index = 0;
    var tree = get_tree();
    var found = false;

		if (tree.view!=null) {
    	while (!found) {
      	if ((!tree.view.isSeparator(index)) && (getCellText(tree,index,'opid') == opid)) {
        	found = true;
      	}
				else {
        	index++;
      	}
    	}
    	select_row(index);
		}

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_op : '+ e);
  }
}

/****************************************************
 *  Affecte aux zones de saisie les valeurs correspondant
 *   la ligne slectionne de l'arbre.
 ****************************************************/
function reporter() {
  try {

    if (page_chargee) {
      if (id_select == -1) {
        do_reporter();
      } else {
        var tree = get_tree();
        var id = tree.currentIndex ;
        if (id == -1) {
          select_row(id_select);
        } else if (tree.view.isSeparator(id)) {
          select_row(id_select);
        } else if (modif_solde) {
          var ecr1 = getCellText(tree,id,'ecrid');
          var ecr2 = getCellText(tree,id_select,'ecrid');
          if (ecr1 == ecr2) {
            do_reporter();
          } else {
            select_row(id_select);
          }
        } else {
          do_reporter();
        }
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#reporter : '+ e);
  }
}


function do_reporter() {
  try {

		clearTimeout(id_timeout);
    id_timeout = setTimeout("do_reporter2();",500);

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#do_reporter : '+ e);
  }
}

function do_reporter2() {
  try {

    if (writeable) {

      var tree = get_tree();
      id_select = tree.currentIndex;

      if (id_select == -1) return false;

      var lettre = getCellText(tree,tree.currentIndex,'lettre');
      if (isEmpty(lettre)) {
        set_editable(false);
      } else {
        set_editable(true);
      }

      document.getElementById('input_date').value = getCellText(tree,tree.currentIndex,'date');

      var compte = getCellText(tree,tree.currentIndex,'compte');
      document.getElementById('input_compte').value = compte;

      if (isEmpty(compte)) {
        document.getElementById('libelle_compte').value = '';
        document.getElementById('solde_compte').value = '';
      }
			else {
        maj_aff_compte(document.getElementById('input_compte'),false) ;
      }

      document.getElementById("input_type").value = getCellText(tree,tree.currentIndex,'type');
      document.getElementById("input_raccourci").value = getCellText(tree,tree.currentIndex,'raccourci');
      document.getElementById("input_libelle").value = getCellText(tree,tree.currentIndex,'libelle');
      document.getElementById("input_contrepartie").value = getCellText(tree,tree.currentIndex,'contrepartie');
      var debit = getCellText(tree,tree.currentIndex,'debit').replace(',','.');
      document.getElementById("input_debit").value = debit;
      var credit = getCellText(tree,tree.currentIndex,'credit').replace(',','.');
      document.getElementById("input_credit").value = credit;
      document.getElementById("input_echeance").value = getCellText(tree,tree.currentIndex,'echeance');
      document.getElementById("input_piece").value = getCellText(tree,tree.currentIndex,'piece');
      if (isEmpty(focus_input)) focus_input = "input_date";
      switch (focus_input) {
        case 'input_debit':
          if (isEmpty(debit) && (! isEmpty(credit))) focus_input = 'input_credit';
          break;
        case 'input_credit':
          if (isEmpty(credit) && (! isEmpty(debit))) focus_input = 'input_debit';
          break;
      }
      document.getElementById(focus_input).focus();
      anc_value = document.getElementById(focus_input).value;

      document.getElementById('controle_coherence').value = "";
      document.getElementById('controle_coherence').collapsed = true;
    }

    setTimeout('maj_aff_solde()',100);

  } catch(e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#do_reporter2 : '+ e);
  }
}


function set_editable(b) {
  try {

    document.getElementById("input_date").readonly = b;
    document.getElementById("input_compte").readonly = b;
    document.getElementById("input_type").readonly = b;
    document.getElementById("input_raccourci").readonly = b;
    document.getElementById("input_libelle").readonly = b;
    document.getElementById("input_contrepartie").readonly = b;
    document.getElementById("input_debit").readonly = b;
    document.getElementById("input_credit").readonly = b;
    document.getElementById("input_echeance").readonly = b;
    document.getElementById("input_piece").readonly = b;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#set_editable : '+ e);
  }
}


function verif_coherence() {
  try {

    switch (ParamValeur('Type_Journal')) {
      case 'AC':
        switch (document.getElementById('type_compte').value) {
          case 'F':
            if (isEmpty(document.getElementById("input_debit").value)) {
              document.getElementById('controle_coherence').value = "";
              document.getElementById('controle_coherence').collapsed = true;
            } else {
              var msg = "Attention ! Vous dbitez un compte fournisseur. ";
              msg += "tes vous sr que vous comptabilisez un avoir ?";
              document.getElementById('controle_coherence').value = msg;
              document.getElementById('controle_coherence').collapsed = false;
            }
            break;
          case 'C':
            if (isEmpty(document.getElementById("input_credit").value)) {
              document.getElementById('controle_coherence').value = "";
              document.getElementById('controle_coherence').collapsed = true;
            } else {
              var msg = "Attention ! Vous crditez un compte client. ";
              msg += "tes vous sr que vous comptabilisez un avoir ?";
              document.getElementById('controle_coherence').value = msg;
              document.getElementById('controle_coherence').collapsed = false;
            }
            break;
          default:
            document.getElementById('controle_coherence').value = "";
            document.getElementById('controle_coherence').collapsed = true;
            break;
        }
        break;
      case 'VE':
        switch (document.getElementById('type_compte').value) {
          case 'F':
            if (isEmpty(document.getElementById("input_debit").value)) {
              document.getElementById('controle_coherence').value = "";
              document.getElementById('controle_coherence').collapsed = true;
            } else {
              var msg = "Attention ! Vous dbitez un compte fournisseur. ";
              msg += "tes vous sr que vous comptabilisez un avoir ?";
              document.getElementById('controle_coherence').value = msg;
              document.getElementById('controle_coherence').collapsed = false;
            }
            break;
          case 'C':
            if (isEmpty(document.getElementById("input_credit").value)) {
              document.getElementById('controle_coherence').value = "";
              document.getElementById('controle_coherence').collapsed = true;
            } else {
              var msg = "Attention ! Vous crditez un compte client. ";
              msg += "tes vous sr que vous comptabilisez un avoir ?";
              document.getElementById('controle_coherence').value = msg;
              document.getElementById('controle_coherence').collapsed = false;
            }
            break;
          default:
            document.getElementById('controle_coherence').value = "";
            document.getElementById('controle_coherence').collapsed = true;
            break;
        }
        break;
      case 'TR':
        if (ParamValeur('Code_Journal') == 'CA') {
        }
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#verif_coherence : '+ e);
  }
}


function maj_aff_compte(t,rech) {
  try {

		var compte = t.value;

		qExCompte.setParam("Numero_Compte", t.value);
		result = qExCompte.execute();

		if (result.responseXML.documentElement.getAttribute("existe")=="true") {
			compte = t.value;
		}
		else if (result.responseXML.documentElement.getAttribute("compte_like")!="") {

			compte = result.responseXML.documentElement.getAttribute("compte_like");
		}
		else if (rech) {
			recherche_compte(t);
			compte = t.value;
		}

		if (t.id=="input_compte") {
			qInfosCompte.setParam("Numero_Compte", compte);
			qInfosCompte.execute(majAffCompte_2);
		}

		return compte;

 	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#maj_aff_compte : '+ e);
  }
}


// Mise  jour des valeurs du solde et du libell du compte affich dans la ligne de saisie.
function majAffCompte_2(result) {
  try {

		var contenu = result.responseXML.documentElement;

    document.getElementById('libelle_compte').value = contenu.getAttribute('Libelle');
    document.getElementById('type_compte').value = contenu.getAttribute('Compte_Gen');

    document.getElementById('solde_compte').value = contenu.getAttribute('SoldeN');
    document.getElementById('debit_compte').value = contenu.getAttribute('DebitN');
    document.getElementById('credit_compte').value = contenu.getAttribute('CreditN');

    document.getElementById('old_solde_compte').value = contenu.getAttribute('SoldeN1');
    document.getElementById('old_debit_compte').value = contenu.getAttribute('DebitN1');
    document.getElementById('old_credit_compte').value = contenu.getAttribute('CreditN1');

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#majAffCompte_2 : '+ e);
  }
}


// Mise  jour des valeurs de crdit, dbit et solde de l'criture en cours de saisie.
function maj_aff_solde() {
  try {

    var tree = get_tree();
		if (tree.view!=null && tree.currentIndex!=-1) {
    	var num_ecriture = getCellText(tree,tree.currentIndex,'num_ecriture');
			qInfosEcr.setParam("Num_Ecriture", num_ecriture);
    	qInfosEcr.execute(maj_aff_solde2);
		}

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#maj_aff_solde : '+ e);
  }
}


function maj_aff_solde2(result) {
  try {

    var contenu = result.responseXML.documentElement;

    var tot_credit = parseFloat(contenu.getAttribute('tot_credit'));
    var tot_debit = parseFloat(contenu.getAttribute('tot_debit'));
    var solde = parseFloat(contenu.getAttribute('solde'));

    document.getElementById("total_debit").value = nfMt.format(tot_debit);
    document.getElementById("total_credit").value = nfMt.format(tot_credit);

    var input_solde = document.getElementById("solde");
    input_solde.value = nfMt.format(solde);
    if (solde == 0) {
      input_solde.className = 'nombre';
      modif_solde = false;
    } else {
      input_solde.className = 'debitcredit-totfocus';
      modif_solde = true;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#maj_aff_solde2 : '+ e);
  }
}

/****************************************************
 *  Excut lorsqu'une zone de saisie prend le focus.
 *  affecte le nom de classe 'focus'  la zone.
 *  @param t : la zone de saisie.
 *  @param id : l'identifieur de la zone de saisie.
 ****************************************************/
function focus_field(t,id) {
  try {
    t.setSelectionRange(0,t.textLength);
    focus_input = id;
    get_tree().treeBoxObject.focused = true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_field : '+ e);
  }
}


/* Suppression d'une ligne ou d'une criture */
function supprimer() {
  try {

    var tree = get_tree();
    var index = tree.currentIndex;
    var num_ecr = getCellText(tree,index,'num_ecriture');
    var ecrid = getCellText(tree,index,'ecrid');
    var msg = "Voulez-vous effacer l'criture en cours de saisie ?";

    if (ecrid == nb_ecritures) {
      msg = "Voulez-vous annuler l'criture en cours de saisie ?";
    }

    if (peutSupprimer(index)) {

      if (confirm(msg)) {

        while ((index > 0) && (getCellText(tree,index-1,'ecrid') == ecrid)) index--;

        var paramlist = cookie() +"&Page=Compta/Saisie/SupprimerEcriture.tmpl&ContentType=text&Num_Ecriture="+ num_ecr;

        if (ecrid == nb_ecritures) {
          requeteHTTP(paramlist +"&nouvelle=1",new XMLHttpRequest(),supprimer3);
        }
				else {
          requeteHTTP(paramlist,new XMLHttpRequest(),supprimer2,index);
        }
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#supprimer : '+ e);
  }
}

function supprimer2(httpRequest,index) {
  try {

    var i = index;
    var root = get_root();
    var tree = get_tree();

    var num_ecr = getCellText(tree,tree.currentIndex,'num_ecriture');
    var ecrid = getCellText(tree,tree.currentIndex,'ecrid');
    var uri = "http://www.opensi.org/compta/ecritures/"+ ecrid;
    var ecriture = dsource.getNode(uri);
    var children = ecriture.getChildren();
    while (children.hasMoreElements()) {
      var child = children.getNext();
      root.removeChild(child);
    }
    ecritures.removeChild(ecriture);
    while ((i < tree.view.rowCount) && tree.view.isSeparator(i)) i++;
    if (i == tree.view.rowCount) {
      select_end();
    }
		else {
      select_row(i);
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#supprimer2 : '+ e);
  }
}

function supprimer3(httpRequest) {
  try {

    pageFin();

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#supprimer3 : '+ e);
  }
}

function peutSupprimer(index) {
  try {
    if (!writeable) return false;
    var tree = get_tree();
    var i = index;
    while ((i >= 0) && (! tree.view.isSeparator(i))) {
      if (! isEmpty(getCellText(tree,i,'lettre'))) return false;
      i--;
    }
    i = index + 1;
    while ((i < tree.view.rowCount) && (! tree.view.isSeparator(i))) {
      if (! isEmpty(getCellText(tree,i,'lettre'))) return false;
      i++;
    }
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#peutSupprimer : '+ e);
  }
}

function peutSupprimerLigne(index) {
  try {

		if (!writeable) return false;

    var tree = get_tree();

    var lettre = getCellText(tree,tree.currentIndex,'lettre');
    if (!isEmpty(lettre)) return false;

		var ecrid = getCellText(tree,tree.currentIndex,'ecrid');
    var uri = "http://www.opensi.org/compta/ecritures/"+ ecrid;
    var ecriture = dsource.getNode(uri);
    if (ecriture.getChildCount() < 2) return false;

		return true;

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#peutSupprimer : '+ e);
  }
}

/****************************************************
 *  Excut lorsqu'une zone de saisie a t modifie
 *  @param id : l'identifiant de la zone de saisie.
 ****************************************************/
function change_field(id) {
  try {

    var child = get_child(get_tree().currentIndex);
    child.addTargetOnce(targetname(id),document.getElementById(id).value);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_field : '+ e);
  }
}

/****************************************************
 *  Excut lorsque la date a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_date() {
  try {

    var t = document.getElementById('input_date');
    if (t.value == ' ' || t.value == '  ') {
      t.value = '';
    }
    if (isEmpty(t.value)) {
      return false;
    }
    if (isNaN(t.value)) {
      showWarning("Date incorrecte");
      t.value = anc_value;
      return false;
    }
    var v = parseIntBis(t.value);
    if ((v < 1) || (v > nb_jours_periode())) {
      showWarning("Date incorrecte");
      t.value = anc_value;
      return false;
    }
    t.value = nfJour.format(v);
    change_field('input_date');

    var tree = get_tree();
    majbase_field('input_date',tree.currentIndex);

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_date : '+ e);
  }
}

/****************************************************
 *  Effectue une recherche de compte
 *  @param t la zone de saisie  affecter.
 ****************************************************/
function recherche_compte(t) {
  try {

    var compte = t.value;
    var id = t.id
    var url = "chrome://opensi/content/config/util/rechcompte.xul?"+ cookie() +"&ignoreG=true";
    window.openDialog(url,'','chrome,modal',compte,id,true);
    switch(t.id) {
      case 'input_compte' :
        change_compte();
        break;
      case 'input_contrepartie' :
        change_contrepartie();
        break;
    }

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#recherche_compte : '+ e);
  }
}

/****************************************************
 *  Excut lorsque le numero de compte a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_compte() {
  try {

    var t = document.getElementById('input_compte');

    if (isEmpty(t.value)) {
      return false;
    }
    if (force) {
      maj_aff_compte(t,false);
      force = false;
    } else {
      if (t.value == '*') t.value = ' ';
      var compte = maj_aff_compte(t,true);
      if (isEmpty(compte)) return false;
      t.value = compte;
    }

    change_field('input_compte');

    var tree = get_tree();
    majbase_field('input_compte',tree.currentIndex);

    verif_coherence();

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_compte : '+ e);
  }
}

/****************************************************
 *  Excut lorsque le libell a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_libelle() {
  try {
    var t = document.getElementById('input_libelle');
    if (isEmpty(t.value)) {
      return false;
    }
    change_field('input_libelle');
    var tree = get_tree();
    majbase_field('input_libelle',tree.currentIndex);
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_libelle : '+ e);
  }
}

/****************************************************
 *  Excut lorsque le compte de contrepartie a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_contrepartie() {
  try {

    var t = document.getElementById('input_contrepartie');
    if (isEmpty(t.value)) {
      change_field('input_contrepartie');
      return true;
    }
    if (force) {
      force = false;
    } else {
      if (t.value == '*') t.value = ' ';
      var compte = maj_aff_compte(t,true);
      if (isEmpty(compte)) return false;
      t.value = compte;
    }
    change_field('input_contrepartie');

    var tree = get_tree();
    majbase_field('input_contrepartie',tree.currentIndex);

    return true;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_contrepartie : '+ e);
  }
}

/****************************************************
 *  Excut lorsque la valeur du dbit ou du crdit a t modifie
 *  @name 'debit' ou 'credit'
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_debitcredit(name) {
	try {

  	mustwait = true;

  	var idMontant = (name=="debit"?"setMontantD":"setMontantC");

  	var tree = get_tree();  

    if (id_select == tree.currentIndex) {

      var id = 'input_'+ name;
      var t = document.getElementById(id);
      var v = t.value;
      var value = 0;
      if (! isEmpty(v)) {
        if (v == '*') {
          var solde = eval(document.getElementById("solde").value.replace(rExp,''));
          var aux1 = anc_value.replace(rExp,'');
          var aux = 0;
          if (! isEmpty(aux1) && ! isNaN(aux1)) {
            aux = eval(aux1);
          }
          switch (name) {
            case 'debit':
              newval = solde + aux;
              break;
            case 'credit':
              newval = aux - solde;
              break;
          }
          if (newval > 0) value = newval;
        } else {
          try {
            value = eval(v.replace(rExp,''));
          } catch (e) {
            t.value = anc_value;
            showWarning("Valeur incorrecte");
            chpModifie = false;
            mustwait = false;
            return false;
          }
        }
      }
      if (value!=undefined && value!=0) {
        t.value = nfMt.format(value);
      } else {
        t.value = '';
      }
      change_field(id);
      var index = tree.currentIndex;
      var num_ecr = getCellText(tree,index,'num_ecriture');
      var num_op = getCellText(tree,index,'numop');
      var valeur = getCellText(tree,index,name).replace(rExp,'');
      valeur = valeur * 100;
      chpModifie = true;
      changeMontant(idMontant,valeur,num_ecr,num_op);
      verif_coherence();

    } else {
      mustwait = false;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_debitcredit : '+ e);
  }
}


/****************************************************
 *  Excut lorsque la valeur du dbit ou du crdit a t modifie
 *  @param fieldname 'debit' ou 'credit'
 *  @param delta la diffrence de dbit  appliquer
 ****************************************************/
function modif_field(fieldname,delta) {

  if ((fieldname != 'debit') && (fieldname != 'credit')) {
    recup_erreur("erreur dans compta/user/saisie/saisie.js#modif_field :"
                 + " paramtre <fieldname> invalide : '" + fieldname + "'");
    return -1;
  }

  try {

    var tot_name = 'tot_' + fieldname;
    var delta_name = 'delta_' + fieldname;
    var tree = get_tree();
    var index = tree.currentIndex;
    var num_ecr = getCellText(tree,index,'ecrid');
    var tot_value = parseFloat(getCellText(tree,index,tot_name).replace(rExp,''));
    if (isNaN(tot_value)) tot_value = 0;
    var delta_value = parseFloat(getCellText(tree,index,delta_name));
    if (isNaN(delta_value)) delta_value = 0;
    tot_value += delta;
    delta_value += delta;
    var uri = "http://www.opensi.org/compta/ecritures/" + num_ecr;
    var ecriture = dsource.getNode(uri);
    var children = ecriture.getChildren();
    while (children.hasMoreElements()) {
      var child = children.getNext();
      child.addTargetOnce(targetname(tot_name),nfNb.format(tot_value));
    }

    var nouv = getCellText(tree,index,'nouv');
    if (nouv == 'false') {

      index ++;
      var root = get_root();
      children = root.getChildren();
      var child = null;
      var found = false;

      while ((children.hasMoreElements()) && (! found) ) {
        var c = children.getNext();
        if (root.getChildIndex(c) == index) {
          child = c;
          found = true;
        }
      }
      if (found) child.addTargetOnce(targetname(delta_name),'' + delta_value);
    }

    setTimeout('maj_aff_solde()',100);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#modif_field : '+ e);
  }
}

/****************************************************
 *  Excut lorsque la date d'chance a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_echeance() {
  try {
    var val = document.getElementById('input_echeance').value;
    if ((! isEmpty(val)) && (! isDate(val))) {
      showWarning("Date d'chance non valide");
      return false;
    }
    change_field('input_echeance');
    var tree = get_tree();
    majbase_field('input_echeance',tree.currentIndex);
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_echeance : '+ e);
  }
}

/****************************************************
 *  Excut lorsque le type a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_type() {
  try {
    change_field('input_type');
    var tree = get_tree();
    majbase_field('input_type',tree.currentIndex);
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_type : '+ e);
  }
}

/****************************************************
 *  Excut lorsque le raccourci a t modifi
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_raccourci() {
  try {
    change_field('input_raccourci');
    var tree = get_tree();
    majbase_field('input_raccourci',tree.currentIndex);
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_raccourci : '+ e);
  }
}

/****************************************************
 *  Excut lorsque a t modifie
 *  @return true si la valeur est valable, false sinon
 ****************************************************/
function change_piece() {
  try {
    change_field('input_piece');
    var tree = get_tree();
    majbase_field('input_piece',tree.currentIndex);
    return true;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#change_piece : '+ e);
  }
}


function keypresstree(e) {
  try {

		if (e.keyCode==13) {
    	revision();
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#keypresstree : '+ e);
  }
}


/****************************************************
 *  Excut lorsque l'utilisateur appuie sur une touche du clavier.
 *  @param e : la touche du clavier
 ****************************************************/
function keypresssaisie(e) {
  try {

		if (!mustwait) {
     	var soldeecr = parseFloat(document.getElementById("solde").value);
     	switch (e.keyCode) {
       case 13: // Enter
       	enter_pressed();
        break;
       case 33: // 'PageUp'
        if (soldeecr == 0) select_up();
        break;
       case 34: // 'PageDown'
        if (soldeecr == 0) select_down();
        break;
       case 35: // 'Fin'
        if (soldeecr == 0) select_end();
        break;
       case 36: // 'Debut'
        if (soldeecr == 0) select_begin();
        break;
       case 27: // 'Echap'
        focus_prev();
        break;
       case 38: // '^'
        select_prev();
        break;
       case 9: // TAB
        var f;
        switch (focus_input) {
         case 'input_date':
          f = get_tree();
          break;
         case 'input_compte':
          f = document.getElementById('input_date');
          break;
         case 'input_type':
          f = document.getElementById('input_compte');
          break;
         case 'input_raccourci':
          f = document.getElementById('input_type');
          break;
         case 'input_libelle':
          f = document.getElementById('input_compte');
          break;
         case 'input_contrepartie':
          f = document.getElementById('input_libelle');
          break;
         case 'input_debit':
          f = document.getElementById('input_contrepartie');
          break;
         case 'input_credit':
          f = document.getElementById('input_debit');
          break;
         case 'input_echeance':
          f = document.getElementById('input_credit');
          break;
         case 'input_piece':
          f = document.getElementById('input_echeance');
          break;
        }
        if (writeable) f.focus();
        break;
       case 40: // 'v'
        select_next();
        break;
       case 45: // 'Inser'
        if (e.ctrlKey) {
          insererLigne();
        }
        break;
       case 46: // 'Suppr'
        if (e.ctrlKey) {
          supprimerLigne();
        } else if (e.altKey) {
          supprimer();
        }
        break;
       case 113: // 'F2'
        revision();
        break;
       case 114: // 'F3'
        reprise_lib_compte();
        break;
       case 123: // 'F12'
        rechecr();
        break;
     }
     }
	} catch (e) {
  	recup_erreur('erreur dans compta/user/saisie/saisie.js#keypresssaisie : '+ e);
	}
}


function rechecr() {
  try {

    var page = "chrome://opensi/content/compta/util/rechecriture.xul?"+ cookie();
    window.openDialog(page,'','chrome,modal,centerscreen');

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#rechecr : ' + e);
  }
}


function supprimerLigne() {
  try {
    var tree = get_tree();
    var index = tree.currentIndex;
    var num_ecr = getCellText(tree,index,'num_ecriture');
    var ecrid = getCellText(tree,index,'ecrid');
    var num_op = getCellText(tree,index,'numop');
    if (peutSupprimerLigne(index)) {
      if (confirm("Voulez vous effacer la ligne courante ?")) {
        var root = get_root();
        var uri = "http://www.opensi.org/compta/ecritures/"+ ecrid;
        var ecriture = dsource.getNode(uri);
        var child = get_child(index);
        ecriture.removeChild(child);
        root.removeChild(child);

        var i = index;
        while ( (i < tree.view.rowCount) && (!tree.view.isSeparator(i))) {
          var num_op2 = parseIntBis(getCellText(tree,i,'numop'));
          num_op2--;
          var child2 = get_child(i);
          child2.addTargetOnce(targetname('numop'),'' + num_op2);
          i++;
        }

        var paramlist = cookie() +"&Page=Compta/Saisie/SupprimerLigne.tmpl&ContentType=text";
        paramlist += "&Num_Ecriture="+ num_ecr;
        paramlist += "&Num_Ligne="+ num_op;
        requeteHTTP(paramlist,new XMLHttpRequest(),supprimerLigne2,index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#supprimerLigne : '+ e);
  }
}

function supprimerLigne2(httpRequest,index) {
  try {

		var tree = get_tree();
    var i = index;
    while ((i > 0) && (tree.view.isSeparator(i))) i--;
    select_row(i);
    var ecrid = getCellText(tree,index,'ecrid');
    setToModif(ecrid);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#supprimerLigne2 : '+ e);
  }
}

function insererLigne() {
  ajout_ligne(get_tree().currentIndex);
}

function revision() {
  try {

    var tree = get_tree();
    var compte = getCellText(tree,tree.currentIndex,'compte');
    var opid = getCellText(tree,tree.currentIndex,'opid');
    var lettre = getCellText(tree,tree.currentIndex,'lettre');

    if (isEmpty(compte)) {
      return false;
    } else {

      var prec = "chrome://opensi/content/compta/user/saisie/menu_saisie.xul?"+ cookie();
      prec += "&Code_Journal="+ ParamValeur('Code_Journal');
      prec += "&Type_Journal="+ ParamValeur('Type_Journal');
      prec += "&Periode="+ ParamValeur('Periode');
      prec += "&numop="+ opid;

      var let = '1';
      if (isEmpty(lettre)) {
        let = '0';
      }

      var page = "chrome://opensi/content/compta/user/consultation/menu_consultation.xul?"+ cookie();
      page += "&compte="+ compte;
      page += "&let="+ let;
      page += "&numop="+ opid;
      page += "&prec="+ urlEncode(prec);
      page += "&nomprec=Saisie";
      window.parent.location = page;
      return true;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#revision : '+ e);
  }
}


function reprise_lib_compte() {
  try {

    if (focus_input=="input_libelle") {
      document.getElementById('input_libelle').value = document.getElementById('libelle_compte').value;
    }

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#reprise_lib_compte : '+ e);
  }
}

/****************************************************
 *  selectionne un ligne dans l'arbre.
 *  @param index : l'index de la ligne de l'arbre  slectionner
 ****************************************************/
function select_row(index) {
  try {
    var tree = get_tree();
    if (tree.view != null) {
      tree.view.selection.select(index);
      tree.treeBoxObject.ensureRowIsVisible(index);
    }
    do_reporter();
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_row : '+ e);
  }
}

/* slection de la premire ligne de l'arbre */
function select_begin() {
  select_row(0);
}

/* slection de la dernire ligne de l'arbre */
function select_end() {
  try {
    var v = get_tree().view;
    var index = v.rowCount - 1 ;
    while (v.isSeparator(index)) index--;
    select_row(index);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_end : '+ e);
  }
}

/* slection d'une ligne 10 lignes au dessus de la ligne slectionne */
function select_up() {
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 10;
    if (index < 0) {
      select_begin();
    } else {
      while (v.isSeparator(index)) index--;
      if (index >= 0) {
        select_row(index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_up : '+ e);
  }
}

/* slection d'une ligne 10 lignes en dessous de la ligne slectionne */
function select_down(){
  try {
    var v = get_tree().view;
    var rc = v.rowCount;
    var index = v.selection.currentIndex + 10 ;
    if (index >= rc) {
      select_end();
    } else {
      while (v.isSeparator(index)) index++;
      if (index < rc) {
        select_row(index);
      }
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_down : '+ e);
  }
}

/* slection de la ligne prcdente  la ligne slectionne */
function select_prev(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex - 1;
    if (index < 0) return false;
    var soldeecr = parseFloat(document.getElementById("solde").value);
    if ((v.isSeparator(index)) && (soldeecr != 0)) return false;
    while (v.isSeparator(index)) index--;
    if (index >= 0) {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_prev : '+ e);
  }
}

/* slection de la ligne suivante  la ligne slectionne */
function select_next(){
  try {
    var v = get_tree().view;
    var index = v.selection.currentIndex + 1;
    if (index >= v.rowCount) return false;
    var soldeecr = parseFloat(document.getElementById("solde").value);
    if ((v.isSeparator(index)) && (soldeecr != 0)) return false;
    while ((index < v.rowCount) && (v.isSeparator(index))) index++;
    if (index < v.rowCount ) {
      select_row(index);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#select_next : '+ e);
  }
}

/* focus sur la zone de saisie prcdant la zone ayant couramment le focus */
function focus_prev() {
  try {

		var doAncValue = true;
    var f = focus_input;
    var t = document.getElementById(f);
    var aff = true;
    switch (f) {
      case 'input_compte':
        if (t.value != anc_value) {
          if(change_compte()) {
            f = 'input_date';
          } else {
            f = 'input_compte';
          }
        } else {
          f = 'input_date';
        }
        break;
      case 'input_raccourci':
        if (t.value != anc_value) {
          if(change_raccourci()) {
            f = 'input_compte';
          } else {
            f = 'input_raccourci';
          }
        } else {
          f = 'input_compte';
        }
        break;
      case 'input_type':
        if (t.value != anc_value) {
          if(change_type()) {
            f = 'input_raccourci';
          } else {
            f = 'input_type';
          }
        } else {
          f = 'input_raccourci';
        }
        break;
      case 'input_libelle':
        if (t.value != anc_value) {
          if(change_libelle()) {
            f = 'input_type';
          } else {
            f = 'input_libelle';
          }
        } else {
          f = 'input_type';
        }
        break;
      case 'input_contrepartie':
        if (t.value != anc_value) {
          if(change_contrepartie()) {
            f = 'input_libelle';
          } else {
            f = 'input_contrepartie';
          }
        } else {
          f = 'input_libelle';
        }
        break;
      case 'input_echeance':
        if (t.value != anc_value) {
          if(change_echeance()) {
            f = 'input_contrepartie';
          } else {
						doAncValue = false;
            f = 'input_echeance';
          }
        } else {
          f = 'input_contrepartie';
        }
        break;
      case 'input_piece':
        var debit = document.getElementById('input_debit').value;
        var credit = document.getElementById('input_credit').value;
        if (t.value != anc_value) {
          if(change_piece()) {
            if ((isEmpty(credit)) && (! isEmpty(debit))) {
              f = 'input_debit';
            } else {
              f = 'input_credit';
            }
          } else {
            f = 'input_piece';
          }
        } else if ((isEmpty(credit)) && (! isEmpty(debit))) {
          f = 'input_debit';
        } else {
          f = 'input_credit';
        }
        break;
      case 'input_debit':
        aff = false;
        prevnext = "prev";
        change_debitcredit('debit');
        break;
      case 'input_credit':
        aff = false;
        prevnext = "prev";
        change_debitcredit('credit');
        break;
    }
    if (writeable && aff) {
      document.getElementById(f).focus();
			if (doAncValue) {
      	anc_value = document.getElementById(f).value;
			}
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_prev : '+ e);
  }
}

/* focus sur la zone de saisie suivant la zone ayant couramment le focus */
function focus_next() {
  try {

		var doAncValue = true;
    var f = focus_input;
    var t = document.getElementById(f);
    var aff = true;

    switch (f) {
      case 'input_date':
        if (t.value != anc_value) {
          if (change_date()) {
            f = 'input_compte';
          } else {
            f = 'input_date';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_date';
        } else {
          f = 'input_compte';
        }
        break;
      case 'input_compte':
        if (t.value != anc_value) {
          if (change_compte()) {
            f = 'input_raccourci';
          } else {
            f = 'input_compte';
          }
        } else if (t.value.length < 8) {
          if (change_compte()) {
            f = 'input_raccourci';
          } else {
            f = 'input_compte';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_compte';
        } else {
          f = 'input_raccourci';
        }
        break;
      case 'input_raccourci':
        if (t.value != anc_value) {
          if (change_raccourci()) {
            f = 'input_type';
          } else {
            f = 'input_raccourci';
          }
        } else {
          f = 'input_type';
        }
        break;
      case 'input_type':
        if (t.value != anc_value) {
          if (change_type()) {
            f = 'input_libelle';
          } else {
            f = 'input_type';
          }
        } else {
          f = 'input_libelle';
        }
        break;
      case 'input_libelle':
        if (t.value != anc_value) {
          if (change_libelle()) {
            f = 'input_contrepartie';
          } else {
            f = 'input_libelle';
          }
        } else if (isEmpty(t.value)) {
          f = 'input_libelle';
        } else {
          f = 'input_contrepartie';
        }
        break;
      case 'input_contrepartie':
        if (t.value != anc_value) {
          if (change_contrepartie()) {
            f = 'input_echeance';
          } else {
            f = 'input_contrepartie';
          }
        } else {
          f = 'input_echeance';
        }
        break;
      case 'input_echeance':
        var debit = document.getElementById('input_debit').value;
        var credit = document.getElementById('input_credit').value;
        if (t.value != anc_value) {
          if (change_echeance()) {
            if ((isEmpty(debit)) && (! isEmpty(credit))) {
              f = 'input_credit';
            } else {
              f = 'input_debit';
            }
          } else {
						doAncValue = false;
            f = 'input_echeance';
          }
        } else if ((isEmpty(debit)) && (! isEmpty(credit))) {
          f = 'input_credit';
        } else {
          f = 'input_debit';
        }
        break;
      case 'input_debit':
        aff = false;
        prevnext = "next";
        change_debitcredit('debit');
        break;
      case 'input_credit':
        aff = false;
        prevnext = "next";
        change_debitcredit('credit');
        break;
    }

    if (writeable && aff) {
      document.getElementById(f).focus();
			if (doAncValue) anc_value = document.getElementById(f).value;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_next : '+ e);
  }
}

function focus_debitcredit() {
  try {
    var f = focus_input;
    var t = document.getElementById(f);
    switch (prevnext) {
      case "prev":
        switch (f) {
          case 'input_debit':
            if (t.value != anc_value) {
              if (chpModifie) {
                f = 'input_echeance';
              } else {
                f = 'input_debit';
              }
            } else {
              f = 'input_echeance';
            }
            break;
          case 'input_credit':
            if (t.value != anc_value) {
              if (chpModifie) {
                if (isEmpty(t.value)) {
                  f = 'input_debit';
                } else {
                  f = 'input_echeance';
                }
              } else {
                f = 'input_credit';
              }
            } else if (isEmpty(t.value)) {
              f = 'input_debit';
            } else {
              f = 'input_echeance';
            }
            break;
        }
        break;
      case "next":
        switch (f) {
          case 'input_debit':
            var tree = get_tree();
            var nouv = getCellText(tree,tree.currentIndex,'nouv');
            if ((nouv == 'true') || ecrStable) {
              if (t.value != anc_value) {
                if (chpModifie) {
                  if (isEmpty(t.value)) {
                    f = 'input_credit';
                  } else if (nouv == 'true') {
                    f = 'input_piece';
                  } else {
                    f = focus_debitcredit_modif(ecrStable);
                  }
                } else {
                  f = 'input_debit';
                }
              } else if (isEmpty(t.value)) {
                f = 'input_credit';
              } else {
                f = 'input_piece';
              }
            } else if (chpModifie) {
              if (isEmpty(t.value)) {
                f = 'input_credit';
              } else {
                f = focus_debitcredit_modif(ecrStable);
              }
            } else {
              f = focus_debitcredit_modif(ecrStable);
            }
            break;
          case 'input_credit':
            var tree = get_tree();
            var nouv = getCellText(tree,tree.currentIndex,'nouv');
            if ((nouv == 'true') || ecrStable) {
              if (t.value != anc_value) {
                if (chpModifie) {
                  if (isEmpty(t.value)) {
                    f = 'input_debit';
                  } else if (nouv == 'true') {
                    f = 'input_piece';
                  } else {
                    f = focus_debitcredit_modif(ecrStable);
                  }
                } else {
                  f = 'input_credit';
                }
              } else if (isEmpty(t.value)) {
                f = 'input_debit';
              } else {
                f = 'input_piece';
              }
            } else if (chpModifie) {
              if (isEmpty(t.value)) {
                f = 'input_debit';
              } else {
                f = focus_debitcredit_modif(ecrStable);
              }
            } else {
              f = focus_debitcredit_modif(ecrStable);
            }
            break;
        }
    }
    if (writeable) {
      document.getElementById(f).focus();
      anc_value = document.getElementById(f).value;
    }
    setTimeout('maj_aff_solde()',100);
    mustwait = false;
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_debitcredit : '+ e);
  }
}

/****************************************************
 *  gestion du focus sur les saisies de dbit/crdit
 * lors d'une criture modifie.
 * @return l'id de la zone de saisie ayant le focus
 ****************************************************/
function focus_debitcredit_modif(isStable) {
  try {
    var tree = get_tree();
    var index = tree.currentIndex;
    if (isStable) {
      select_row(index);
      var ecrid = getCellText(tree,index,'ecrid');
      setNouvToFalse(ecrid);
      return 'input_piece';
    } else {
      var ecrid = getCellText(tree,index,'ecrid');
      var uri = "http://www.opensi.org/compta/ecritures/" + ecrid;
      var ecriture = dsource.getNode(uri);
      var nb_lignes = ecriture.getChildCount();
      var num_op = parseIntBis(getCellText(tree,index,'numop'));
      if (num_op == nb_lignes - 1) {
        ajout_ligne(index);
      } else {
        select_next();
      }
      setToModif(ecrid);
      return focus_input;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#focus_debitcredit_modif : '+ e);
  }
}


function checkStable(fonction) {
  try {

		var tree = get_tree();
		if (tree.view!=null && tree.currentIndex!=-1) {
    	var num_ecriture = getCellText(tree,tree.currentIndex,'num_ecriture');
			qInfosEcr.setParam("Num_Ecriture", num_ecriture);
    	qInfosEcr.execute(checkStable2,fonction);
		}

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#checkStable : '+ e);
  }
}

function checkStable2(result,fonction) {
  try {

    ecrStable = (result.responseXML.documentElement.getAttribute('stable') == "true");
    setTimeout(fonction,0);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#checkStable2 : '+ e);
  }
}

/* appele lorsque l'utilisateur appuie sur 'Enter' */
function enter_pressed() {
  try {

    switch (focus_input) {
      case 'input_piece':
        var tree = get_tree();
        var num_ecr = getCellText(tree,tree.currentIndex,'ecrid');
        var nouv = getCellText(tree,tree.currentIndex,'nouv');
        var solde = parseFloat(document.getElementById('solde').value.replace(rExp,''));
        var v = document.getElementById(focus_input).value;
        if (v != anc_value) {
          change_piece();
        }
        var date = getCellText(tree,tree.currentIndex,'date');
        if (isEmpty(date)) {
          if (writeable) document.getElementById('input_date').focus();
          anc_value = '';
          return -1;
        }
        var compte = getCellText(tree,tree.currentIndex,'compte');
        if (isEmpty(compte)) {
          if (writeable) document.getElementById('input_compte').focus();
          anc_value = '';
          return -1;
        }
        var libelle = getCellText(tree,tree.currentIndex,'libelle');
        if (isEmpty(libelle)) {
          if (writeable) document.getElementById('input_libelle').focus();
          anc_value = '';
          return -1;
        }
        var debit = getCellText(tree,tree.currentIndex,'debit').replace(rExp,'');
        var credit = getCellText(tree,tree.currentIndex,'credit').replace(rExp,'');
        if (isEmpty(debit) && isEmpty(credit)) {
          if (writeable) document.getElementById('input_debit').focus();
          anc_value = '';
          return -1;
        }
        checkStable("enter_pressed2()");
        break;
      default:
        focus_next();
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#enter_pressed : '+ e);
  }
}


function enter_pressed2() {
  try {

    var tree = get_tree();
    var num_ecr = getCellText(tree,tree.currentIndex,'ecrid');
    var nouv = getCellText(tree,tree.currentIndex,'nouv');
    var solde = parseFloat(document.getElementById('solde').value.replace(rExp,''));
    var v = document.getElementById(focus_input).value;

    if (ecrStable) {
      setNouvToFalse(num_ecr);
      if (get_root().getChildCount() == tree.currentIndex+1) {
        ajout_ecriture();
      } else {
        select_next();
        if (writeable) document.getElementById('input_date').focus();
        anc_value = document.getElementById('input_date').value;
      }
    } else {
      setToModif(num_ecr);
      var uri = "http://www.opensi.org/compta/ecritures/"+ num_ecr;
      var ecriture = dsource.getNode(uri);
      var nb_lignes = ecriture.getChildCount();
      var num_op = parseIntBis(getCellText(tree,tree.currentIndex,'numop'));
      if (num_op == nb_lignes - 1) {
        ajout_ligne(tree.currentIndex);
      } else {
        select_next();
        focus_prev();
      }
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#enter_pressed2 : '+ e);
  }
}

/* insre une ligne de saisie vierge dans une criture */
function ajout_ligne(index) {
  try {

    var tree = get_tree();
    var num_ecr = getCellText(tree,index,'num_ecriture');
    var ecrid = getCellText(tree,index,'ecrid');
    var num_op = parseIntBis(getCellText(tree,index,'numop'));
    var num_new_op = num_op + 1;
    var i = index + 2;
    var child = new_ligne(ecrid, num_ecr,num_new_op, i);

    var date = getCellText(tree,index,'date');
    var type = getCellText(tree,index,'type');
    var raccourci = getCellText(tree,index,'raccourci');
    var libelle = getCellText(tree,index,'libelle');
    var echeance = getCellText(tree,index,'echeance');
    var piece = getCellText(tree,index,'piece');
    child.addTargetOnce(targetname('input_date'), date);
    child.addTargetOnce(targetname('input_type'), type);
    child.addTargetOnce(targetname('input_raccourci'), raccourci);
    child.addTargetOnce(targetname('input_libelle'), libelle);
    child.addTargetOnce(targetname('input_echeance'), echeance);
    child.addTargetOnce(targetname('input_piece'), piece);

    num_op++;
    var paramlist = cookie() +"&Page=Compta/Saisie/CreerLigne.tmpl&ContentType=text";
    paramlist += "&Num_Ecriture="+ num_ecr;
    paramlist += "&Num_Ligne="+ num_op;
    paramlist += "&date="+ valeurDate(date,debut_periode) ;
    paramlist += "&type="+ urlEncode(type);
    paramlist += "&raccourci="+ urlEncode(raccourci);
    paramlist += "&libelle="+ urlEncode(libelle);
    if (!isEmpty(echeance)) {
      paramlist += "&echeance="+ prepareDateJava(echeance);
    }
    paramlist += "&piece="+ urlEncode(piece);

    requeteHTTP(paramlist,new XMLHttpRequest(),ajout_ligne2,index);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajout_ligne : '+ e);
  }
}


function ajout_ligne2(httpRequest,index) {
  try {

  	select_row(index + 1);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajout_ligne2 : '+ e);
  }
}

/* cre une nouvelle criture */
function ajout_ecriture() {
  try {

    var paramlist = cookie() +"&Page=Compta/Saisie/CreerEcriture.tmpl&ContentType=xml";
    paramlist += "&date="+ valeurDate('01',debut_periode) ;
    paramlist += "&journal="+ ParamValeur('Code_Journal');
    requeteHTTP(paramlist,new XMLHttpRequest(),ajout_ecriture2);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajout_ecriture : '+ e);
  }
}

function ajout_ecriture2(httpRequest) {
  try {

    var tree = get_tree();

    var contenu = httpRequest.responseXML.documentElement;

    ajout_separateur();

    nb_ecritures++;

    var uri = "http://www.opensi.org/compta/ecritures/"+ nb_ecritures;
    var ecriture = dsource.getNode(uri);
    ecriture.makeBag();

    var ecrid = contenu.getAttribute('ecrid');
    var num_op = contenu.getAttribute('numop');
    var num_ecr = nb_ecritures;
    var index = tree.currentIndex + 3;
    var child = new_ligne(num_ecr, ecrid, num_op, index);

    select_end();
    if (writeable) document.getElementById('input_date').focus();
    anc_value = '';

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajout_ecriture2 : '+ e);
  }
}


// met  <false> l'attribut 'nouv' de toutes les lments de l'criture d'id <ecrid>
function setNouvToFalse(ecrid) {
  try {

    var uri = "http://www.opensi.org/compta/ecritures/"+ ecrid;
    var children = dsource.getNode(uri).getChildren();
    while (children.hasMoreElements()) {
      var child = children.getNext();
      child.addTargetOnce(targetname('nouv'),'false');
      child.addTargetOnce(targetname('prop'),'');
    }

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#setNouvToFalse : '+ e);
  }
}


function setToModif(ecrid) {
  try {

    var uri = "http://www.opensi.org/compta/ecritures/"+ ecrid;
    var children = dsource.getNode(uri).getChildren();
		if (children!=null) {
    	while (children.hasMoreElements()) {
      	var child = children.getNext();
      	child.addTargetOnce(targetname('prop'),'enabled');
    	}
		}

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#setToModif : '+ e);
  }
}

/* insre une ligne de sparation dans l'arbre de saisie */
function ajout_separateur() {
  try {

     var child = dsource.getAnonymousNode();
     child.addTargetOnce(targetname('type_desc'), 'separator');
     var root = get_root();
     root.addChildAt(child,get_tree().view.rowCount+1);

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#ajout_separateur : '+ e);
  }
}

/****************************************************
 *  insre une ligne de saisie vierge
 *  @param num_ecr le numro de l'criture  laquelle
 *                 il faut rajouter la ligne
 *  @param index l'index o il faut insrer le noeud dans l'arbre
 *  @return le noeud de l'arbre correspondant  la nouvelle ligne
 ****************************************************/
function new_ligne(ecrid, num_ecr, num_op, index) {
  try {

    var child = dsource.getAnonymousNode();
    var root = get_root();
    root.addChildAt(child,index);
    child.addTargetOnce(targetname('ecrid'), '' + ecrid);
    child.addTargetOnce(targetname('num_ecriture'), '' + num_ecr);
    var tree = get_tree();
    var i = index - 1;
    while ( (i < tree.view.rowCount) && (! tree.view.isSeparator(i))) {
      var num_op2 = parseIntBis(getCellText(tree,i,'numop'));
      num_op2++;
      var child2 = get_child(i);
      child2.addTargetOnce(targetname('numop'),'' + num_op2);
      i++;
    }
    var uri = "http://www.opensi.org/compta/ecritures/" + ecrid;
    var ecriture = dsource.getNode(uri);
    child.addTargetOnce(targetname('numop'),'' + num_op);
    child.addTargetOnce(targetname('opid'),'0');
    child.addTargetOnce(targetname('nouv'),'true');
    child.addTargetOnce(targetname('prop'),'enabled');
    if (ecriture.getChildCount() == 0) {
      ecriture.addChild(child);
    } else {
      ecriture.addChildAt(child,num_op);
    }
    ecritures.addChild(ecriture);

    if (writeable) {
      document.getElementById('input_date').focus();
      anc_value = document.getElementById('input_date').value;
    }

    return child;

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#new_ligne : '+ e);
  }
}


/*========= Fonctions de mise  jour de la base de donnes =========*/


/* mise  jour du champs */
function majbase_field(chps, index) {
  try {

    var tree = get_tree();
    var num_ecr = getCellText(tree,index,'num_ecriture');
    var num_op = getCellText(tree,index,'numop');
    switch (chps) {
      case 'input_date':
        var valeur = parseIntBis(getCellText(tree,index,'date'));
        changeDate(valeur,num_ecr,num_op,debut_periode);
        break;
      case 'input_compte':
        var valeur = getCellText(tree,index,'compte');
        changeValue('setNumeroCompte',valeur,num_ecr,num_op);
        break;
      case 'input_raccourci':
        var valeur = getCellText(tree,index,'raccourci');
        changeValue('setRaccourci',valeur,num_ecr,num_op);
        break;
      case 'input_type':
        var valeur = getCellText(tree,index,'type');
        changeValue('setType',valeur,num_ecr,num_op);
        break;
      case 'input_libelle':
        var valeur = getCellText(tree,index,'libelle');
        changeValue('setLibelle',valeur,num_ecr,num_op);
        break;
      case 'input_echeance':
        var valeur = getCellText(tree,index,'echeance');
        changeEcheance(valeur,num_ecr,num_op);
        break;
      case 'input_contrepartie':
        var valeur = getCellText(tree,index,'contrepartie');
        changeValue('setContrepartie',valeur,num_ecr,num_op);
        break;
      case 'input_piece':
        var valeur = getCellText(tree,index,'piece');
        changeValue('setNumPiece',valeur,num_ecr,num_op);
        break;
      case 'input_debit':
        var valeur = getCellText(tree,index,'debit').replace(rExp,'');
        valeur = valeur * 100;
        changeMontant('setMontantD',valeur,num_ecr,num_op);
        break;
      case 'input_credit':
        var valeur = getCellText(tree,index,'credit').replace(rExp,'');
        valeur = valeur * 100;
        changeMontant('setMontantC',valeur,num_ecr,num_op);
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#majbase_field : '+ e);
  }
}


function changeValue(champs,valeur,num_ecr,num_op) {
  try {

		qMajField.clearParams();
		qMajField.setParam("NumOp", num_op);
		qMajField.setParam("NumEcr", num_ecr);
		qMajField.setParam("champs", champs);
		qMajField.setParam("valeur", valeur);
		qMajField.setParam("req", "majchps");
		qMajField.execute();

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#changeValue : '+ e);
  }
}


function changeMontant(champs,valeur,num_ecr,num_op) {
  try {

    var val = 0
    if (!isEmpty(val) && !isNaN(val)) {
    	val = parseFloat(valeur);
    }

		qMajField.clearParams();
		qMajField.setParam("NumOp", num_op);
		qMajField.setParam("NumEcr", num_ecr);
		qMajField.setParam("champs", champs);
		qMajField.setParam("valeur", nfIPart.format(val));
		qMajField.setParam("req", "majmontant");
		qMajField.execute(changeMontant2);

	} catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#changeMontant : '+ e);
  }
}

function changeMontant2(httpRequest) {
  try {

    checkStable("focus_debitcredit()");

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#changeMontant2 : '+ e);
  }
}

function changeEcheance(valeur,num_ecr,num_op) {
  try {

    var date = "";
    if (!isEmpty(valeur)) {
      if (isDate(valeur)) {
        date = prepareDateJava(valeur);
      } else {
        showWarning("Date d'chance incorrecte");
      }
    }

		qMajField.clearParams();
		qMajField.setParam("NumOp", num_op);
		qMajField.setParam("NumEcr", num_ecr);
		qMajField.setParam("date", date);
		qMajField.setParam("req", "majecheance");
		qMajField.execute();

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#changeEcheance : '+ e);
  }
}

function valeurDate(valeur,debut_periode) {
  return debut_periode + ((parseIntBis(valeur) - 1) * 24 * 60 * 60 * 1000);
}

function changeDate(valeur,num_ecr,num_op,debut_periode) {
// associ  l'vnement onchange des entres 'Jour' sur les anciennes critures
// valide la modification de la valeur du champs dans la base de donnes
  try {

    var date = valeurDate(valeur,debut_periode);

		qMajField.clearParams();
		qMajField.setParam("NumOp", num_op);
		qMajField.setParam("NumEcr", num_ecr);
		qMajField.setParam("date", date);
		qMajField.setParam("req", "majdate");
		qMajField.execute();

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#changeDate : '+ e);
  }
}


/*======================= Fonctions Annexes ========================*/


/* Chargement d'une page d'criture */
function loadPage(p) {
  try {
    if (page_chargee) {
      page_chargee = false;
      delete_tree();
      page = p;
      document.getElementById('page').value="Page N "+ page +" / "+ nb_pages;
      var periode = ParamValeur('Periode');
      paramlist = "&Page=Compta/GetRDF/Ecritures.tmpl&ContentType=xml";
      paramlist += "&Code_Journal="+ ParamValeur('Code_Journal');
      paramlist += "&Periode="+ periode;
      paramlist += "&Pagination="+ page;
      load_tree(getUrlOpeneas(paramlist));
      document.getElementById('boutonDebut').disabled = (page == 1);
      document.getElementById('boutonPrec').disabled = (page == 1);
      document.getElementById('boutonFin').disabled = (page == nb_pages);
      document.getElementById('boutonSuiv').disabled = (page == nb_pages);
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#loadPage : '+ e);
  }
}

/* Chargement de la premire page d'criture */
function pageDebut() {
  try {
    loadPage(1);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageDebut : '+ e);
  }
}

/* Chargement de la dernire page d'criture */
function pageFin() {
  try {
    loadPage(nb_pages);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageFin : '+ e);
  }
}

/* Chargement de la page prcdente */
function pagePrec() {
  try {
    loadPage(page-1);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pagePrec : '+ e);
  }
}

/* Chargement de la page suivante */
function pageSuiv() {
  try {
    loadPage(page+1);
  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageSuiv : '+ e);
  }
}

/* Chargement de la page contenant l'opration d'Id num_op */
function pageNumOp(no) {
  try {

    if (no == 0) {
      pageFin();
    }
		else {
      delete_tree();

			var qNumPage = new QueryHttp("Compta/GetNumPage.tmpl");
      qNumPage.setParam("Periode", ParamValeur('Periode'));
      qNumPage.setParam("Code_Journal", ParamValeur('Code_Journal'));
      qNumPage.setParam("NumOp", no);
      qNumPage.execute(PageNumOp2);
    }

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#pageNumOp : '+ e);
  }
}


function PageNumOp2(httpRequest) {
  try {

    page = httpRequest.responseXML.documentElement.getAttribute('page');
    var periode = ParamValeur('Periode');
    paramlist = "&Page=Compta/GetRDF/Ecritures.tmpl&ContentType=xml";
    paramlist += "&Code_Journal="+ ParamValeur('Code_Journal');
    paramlist += "&Periode="+ periode;
    paramlist += "&Pagination="+ page;
    load_tree(getUrlOpeneas(paramlist));
    document.getElementById('page').value = "Page N "+ page +" / "+ nb_pages;
    document.getElementById('boutonDebut').disabled = (page == 1);
    document.getElementById('boutonPrec').disabled = (page == 1);
    document.getElementById('boutonFin').disabled = (page == nb_pages);
    document.getElementById('boutonSuiv').disabled = (page == nb_pages);

  } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#PageNumOp2 : '+ e);
  }
}


function plan_comptable() {
  try {
    if (focus_input != 'input_contrepartie') {
      document.getElementById("input_compte").focus();
    }
    var page = "chrome://opensi/content/config/util/liste_plan.xul?"+ cookie();
    window.openDialog(page,'plancomptable','chrome,modal','1',focus_input);
    switch(focus_input) {
      case 'input_compte' :
        change_compte();
        break;
      case 'input_contrepartie' :
        change_contrepartie();
        break;
    }
 } catch (e) {
    recup_erreur('erreur dans compta/user/saisie/saisie.js#plan_comptable : '+ e);
  }
}
