/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");

var rExp = / /gi;
var aEcritures = new Arbre("cpta", "rechEcritures.tmpl", "ecritures");


function init() {
  try {

		var aJournaux = new Arbre("cpta", "liste_journaux.tmpl", "journaux");
		aJournaux.initTree();

    document.getElementById('compte').focus();

  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#init : ' + e);
  }
}


function labelJournal(journal) {
  try {

    var tab_journaux = document.getElementById('journaux').getElementsByTagName('menuitem');
    for (i=1;i<tab_journaux.length;i++) {
      var tab_journal = tab_journaux[i];
      if (journal.toUpperCase() == tab_journal.value.toUpperCase())
        return tab_journal.label;
      if (journal.toUpperCase() == tab_journal.label.toUpperCase())
        return tab_journal.label;
    }
    return '';

  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#labelJournal : ' + e);
  }
}


function ok() {
  try {

		aEcritures.clearParams();

		var compte = document.getElementById('compte').value;
    var toutvide = isEmpty(compte);

 		if (!isEmpty(compte))
    	aEcritures.setParam("Numero_Compte", compte);

    switch(document.getElementById('debitbox').selectedItem.id){
      case 'isdebitexact':
        var debit = document.getElementById('debit').value;
				if (!isEmpty(debit))
        	aEcritures.setParam("debit", debit.replace(rExp,''));
				toutvide = toutvide && isEmpty(debit);
        break;
      case 'isdebitinter':
        var debitinf = document.getElementById('debitinf').value;
        var debitsup = document.getElementById('debitsup').value;
				if (!isEmpty(debitinf))
					aEcritures.setParam("debitinf", debitinf.replace(rExp,''));
				if (!isEmpty(debitsup))
					aEcritures.setParam("debitsup", debitsup.replace(rExp,''));
        toutvide = toutvide && isEmpty(debitinf) && isEmpty(debitsup);
        break;
    }

    switch(document.getElementById('creditbox').selectedItem.id){
      case 'iscreditexact':
        var credit = document.getElementById('credit').value;
				if (!isEmpty(credit))
        	aEcritures.setParam("credit", credit.replace(rExp,''));
        toutvide = toutvide && isEmpty(credit);
        break;
      case 'iscreditinter':
        var creditinf = document.getElementById('creditinf').value;
        var creditsup = document.getElementById('creditsup').value;
				if (!isEmpty(creditinf))
					aEcritures.setParam("creditinf", creditinf.replace(rExp,''));
				if (!isEmpty(creditsup))
					aEcritures.setParam("creditsup", creditsup.replace(rExp,''));
        toutvide = toutvide && isEmpty(creditinf) && isEmpty(creditsup);
        break;
    }

    switch(document.getElementById('datebox').selectedItem.id){
      case 'isdateexact':
        var date = document.getElementById('date');
        if (isDate(date.value)) {
					aEcritures.setParam("date", prepareDateJava(date.value));
        }
				else if (!isEmpty(date.value)) {
          showWarning('Date invalide');
          date.focus();
          return false;
        }
        toutvide = toutvide && isEmpty(date.value);
        break;
      case 'isdateinter':
        var dateinf = document.getElementById('dateinf');
        var datesup = document.getElementById('datesup');
        if (isDate(dateinf.value)) {
          aEcritures.setParam("dateinf", prepareDateJava(dateinf.value));
        }
				else if (!isEmpty(dateinf.value)) {
          showWarning('Date invalide');
          dateinf.focus();
          return false;
        }
        if (isDate(datesup.value)) {
          aEcritures.setParam("datesup", prepareDateJava(datesup.value));
        } else if (!isEmpty(datesup.value)) {
          showWarning('Date invalide');
          datesup.focus();
          return false;
        }
        toutvide = toutvide && isEmpty(dateinf.value) && isEmpty(datesup.value);
        break;
    }

    var libelle = document.getElementById('libelle').value;
		var piece = document.getElementById('piece').value;

		if (!isEmpty(libelle))
			aEcritures.setParam("Libelle", libelle);
    if (!isEmpty(piece))
			aEcritures.setParam("Num_Piece", piece);

    var journaux = document.getElementById('journaux');
    var journal = '';
    switch(journaux.selectedIndex) {
      case -1:
        journal = journaux.value;
        if (!isEmpty(journal)) {
          var nom_journal = labelJournal(journal);
          if (!isEmpty(nom_journal)) {
            journaux.value = nom_journal;
            journal = journaux.selectedItem.value;
          }
        }
        break;
      default:
        journal = journaux.selectedItem.value;
        break;
    }

		if (!isEmpty(journal))
    	aEcritures.setParam("Code_Journal", journal);

    toutvide = toutvide && isEmpty(libelle) && isEmpty(piece) && isEmpty(journal);

    if (toutvide) {
      showWarning("Vous devez spcifier au moins un critre de recherche");
      document.getElementById('compte').focus();
    }
		else {
			document.getElementById('labelpm').value = "Recherche en cours...";
			document.getElementById('pm').setAttribute("mode", "undetermined");
			document.getElementById('pm').collapsed = false;			
      aEcritures.initTree(finRecherche);
    }

  } catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#ok : ' + e);
  }
}


function finRecherche() {
  try {

		document.getElementById('labelpm').value = "Recherche termine.";
		document.getElementById('pm').setAttribute("mode", "none");

	} catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#finRecherche : ' + e);
  }
}


function selectradio(t) {
  try {

    switch(t.id) {
      case 'debitbox':
        switch(t.selectedItem.id){
          case 'isdebitexact':
            var tb = document.getElementById('debit');
            tb.readonly = false;
            tb.focus();
            tb = document.getElementById('debitinf');
            tb.value = '';
            tb.readonly = true;
            tb = document.getElementById('debitsup');
            tb.value = '';
            tb.readonly = true;
            break;
          case 'isdebitinter':
            var tb = document.getElementById('debitinf');
            tb.readonly = false;
            tb.focus();
            document.getElementById('debitsup').readonly = false;
            tb = document.getElementById('debit');
            tb.value = '';
            tb.readonly = true;
            break;
        }
        break;
      case 'creditbox':
        switch(t.selectedItem.id){
          case 'iscreditexact':
            var tb = document.getElementById('credit');
            tb.readonly = false;
            tb.focus();
            tb = document.getElementById('creditinf');
            tb.value = '';
            tb.readonly = true;
            tb = document.getElementById('creditsup');
            tb.value = '';
            tb.readonly = true;
            break;
          case 'iscreditinter':
            var tb = document.getElementById('creditinf');
            tb.readonly = false;
            tb.focus();
            document.getElementById('creditsup').readonly = false;
            tb = document.getElementById('credit');
            tb.value = '';
            tb.readonly = true;
            break;
        }
        break;
      case 'datebox':
        switch(t.selectedItem.id){
          case 'isdateexact':
            var tb = document.getElementById('date');
            tb.readonly = false;
            tb.focus();
            tb = document.getElementById('dateinf');
            tb.value = '';
            tb.readonly = true;
            tb = document.getElementById('datesup');
            tb.value = '';
            tb.readonly = true;
            break;
          case 'isdateinter':
            var tb = document.getElementById('dateinf');
            tb.readonly = false;
            tb.focus();
            document.getElementById('datesup').readonly = false;
            tb = document.getElementById('date');
            tb.value = '';
            tb.readonly = true;
        }
			}

  } catch (e) {
    recup_erreur('erreur dans compta/util/selectradio.js#ok : ' + e);
  }
}


function keypress(e, id) {
  try {

    switch (e.keyCode) {
      case 13:
				if (id=="ecritures")
					goToSaisie();
				else
        	ok();
        break;
      case 123: // F12
        recherche_compte();
        break;
    }

	} catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#keypress : ' + e);
  }
}


function goToSaisie() {
  try {

  	var tree = document.getElementById('ecritures');

		if (tree.view!=null && tree.currentIndex!=-1) {

    	var page = "chrome://opensi/content/compta/user/saisie/menu_saisie.xul?"+ cookie();
    	page += "&Code_Journal="+ getCellText(tree,tree.currentIndex,'ColCode_Journal');
			page += "&Periode="+ getCellText(tree,tree.currentIndex,'ColPeriode');
			page += "&numop="+ getCellText(tree,tree.currentIndex,'ColOp_Id');

     	window.opener.location = page;
    	window.close();
		}

	} catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#goToSaisie : ' + e);
  }
}


function blurmontant(t) {
  try {
    var v = eval(t.value.replace(rExp,''));
    if (isNaN(v)) {
      t.value = '';
    } else {
      t.value = format(eval(v),2,' ',0);
    }
  } catch (e) {
    t.value = '';
  }
}


function recherche_compte() {
  try {

    var compte = document.getElementById('compte').value;
    var url = "chrome://opensi/content/config/util/rechcompte.xul?"+ cookie();
    window.openDialog(url,'','chrome,modal',compte,'compte',false);

	} catch (e) {
    recup_erreur('erreur dans compta/util/rechecriture.js#recherche_compte : ' + e);
  }
}

