/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var login = "";
var dossier = "";
var etat = 0;


function init() {
	try {

		login = ParamValeur('login');
		dossier = get_cookie('Dossier_Id');
		document.getElementById("titre").value = "MODIFICATION DES DROITS DU DOSSIER '"+ dossier +"'";
		document.getElementById("sous-titre").value = "POUR L'UTILISATEUR '"+ login +"'";
		var corps = cookie() +"&Page=Config/getUtilisateur.tmpl&ContentType=xml&Login="+ login;
		var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps, httpRequest, init_2);
		
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#init : ' + e);
  }
}


function init_2(httpRequest) {
	try {

		var contenu = httpRequest.responseXML.documentElement;
		
		if (contenu.getAttribute('admin')==1) {
			document.getElementById('manager').disabled = "true";
		}
		
		var corps = cookie() +"&Page=Config/getDroits.tmpl&ContentType=xml&Login="+ login;
		var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps, httpRequest, init_3);    

	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#init_2 : ' + e);
  }
}


function init_3(httpRequest) {
	try {

		var contenu = httpRequest.responseXML.documentElement;
		
		if (contenu.getAttribute('message')=="inexistant") {
			etat = 1;
		}
		
		document.getElementById('manager').checked = (contenu.getAttribute('manager')==1);
		document.getElementById('comptabilite').checked = (contenu.getAttribute('comptabilite')==1);
		document.getElementById('commerciale').checked = (contenu.getAttribute('commerciale')==1);
		
		init_tree();
		document.getElementById('Enlever').disabled = true;
		document.getElementById('Ajouter').disabled = true;

	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#init_3 : ' + e);
  }
}


function init_tree() {
  try {
	
		var corps = cookie() +"&Page=Config/getLastExercice.tmpl&ContentType=xml&Dossier_Id="+ dossier;
		var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps, httpRequest, init_tree_2); 		
		
  } catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#init_tree : ' + e);
  }
}


function init_tree_2(httpRequest) {
  try {
		
		var base = httpRequest.responseXML.documentElement.getAttribute('nom_base');

		var paramlist = "&Page=Config/GetRDF/listeDroitsJournaux.tmpl&ContentType=xml&Login="+ login +"&Dossier_Id="+ dossier +"&Base="+ base;			
		load_rdf('liste_droits_journaux', getUrlOpeneas(paramlist));

		var paramliste = "&Page=Config/GetRDF/listeNonDroitsJournaux.tmpl&ContentType=xml&Login="+ login +"&Dossier_Id="+ dossier +"&Base="+ base;
		load_rdf('liste_non_droits_journaux', getUrlOpeneas(paramliste));		

	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#init_tree_2 : ' + e);
  }
}


function delete_tree() {
  try {
	
    var database = document.getElementById("liste_droits_journaux").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById("liste_droits_journaux").builder.rebuild();
	
    var database = document.getElementById("liste_non_droits_journaux").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById("liste_non_droits_journaux").builder.rebuild();
		
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#delete_tree : ' + e);
  }
}


function affecterDroits() {
	try {
	
		var tree = document.getElementById('liste_non_droits_journaux');
		var rangeCount = tree.view.selection.getRangeCount();

		for(var i=0; i<rangeCount; i++)	{
		
			var start = {};
			var end = {};
			tree.view.selection.getRangeAt(i,start,end);
			
			for (var c=start.value; c<=end.value; c++) {

				var Code_Journal = getCellText(tree,c,'Code');
				if (isEmpty(Code_Journal)) {
					showWarning('Aucun Journal slectionn !');
				}	else {
					var corps = cookie() +"&Page=Config/droits/changerDroitsJournaux.tmpl&ContentType=xml&Login="+ login +"&Dossier_Id="+ dossier +"&Code_Journal="+ Code_Journal;
					var p = requeteHTTP(corps);
  				
					var message=p.responseXML.documentElement.getAttribute("message");
					if (message!="fini") {
						showWarning("erreur serveur");
					}
				}
			}
		}
		delete_tree();
		init_tree();
		document.getElementById('Ajouter').disabled = true;
		
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#affecterDroits : ' + e);
  }
}


function supprimerDroits() {
	try {
	
		var tree = document.getElementById('liste_droits_journaux');
		var rangeCount = tree.view.selection.getRangeCount();
		
		for(var i=0; i<rangeCount; i++) {
		
			var start = {};
			var end = {};
			tree.view.selection.getRangeAt(i,start,end);
			
			for(var c=start.value; c<=end.value; c++) {
			
				var Code_Journal = getCellText(tree,c,'Code');
				if (isEmpty(Code_Journal)) {
					showWarning('Aucun journal slectionn !');
				}
				else {
					var corps = cookie() +"&Page=Config/droits/changerDroitsJournaux.tmpl&ContentType=xml&Login="+ login +"&Dossier_Id="+ dossier+"&Code_Journal="+ Code_Journal;
					var p = requeteHTTP(corps);
  				
					var message=p.responseXML.documentElement.getAttribute("message");
					
					if (message!="fini") {
						showWarning("erreur serveur");
					}					
				}
			}
		}
		delete_tree();
		init_tree();
		document.getElementById('Enlever').disabled = true;
		
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#supprimerDroits : ' + e);
  }
}


function enregistrerDroits() {
	try {
	
		var manager = document.getElementById('manager').checked?"1":"0";
		var comptabilite = document.getElementById('comptabilite').checked?"1":"0";
		var commerciale = document.getElementById('commerciale').checked?"1":"0";
		var annul = 0;
		
		if (manager==0 && comptabilite==0 && commerciale==0) {
			if (window.confirm("Attention cet utilisateur n'aura plus aucun droit sur ce dossier\nVoulez vous quand mme modifier ses droits ?")) {
				var corps = cookie() +"&Page=Config/droits/modifierDroits.tmpl&ContentType=xml&Login="+ login;
			}
			else {
				annul = 1;
			}
		}
		else if (etat==0) {
			var corps = cookie() +"&Page=Config/droits/modifierDroits.tmpl&ContentType=xml&Login="+login;
		}
		else {
			var corps = cookie() +"&Page=Config/droits/creerDroits.tmpl&ContentType=xml&Login="+login;
		}
		
		if (!annul) {		
			corps +="&Manager="+ manager +"&Comptabilite="+ comptabilite +"&Commerciale="+ commerciale;
			
			var httpRequest = new XMLHttpRequest();			
			requeteHTTP(corps, httpRequest, enregistrerDroits_2);			
		}
		
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#enregistrerDroits : ' + e);
  }
}


function enregistrerDroits_2(httpRequest) {
	try {

		var message = httpRequest.responseXML.documentElement.getAttribute("message");
		
		if (message=="inexistant") {
			showWarning("Droits non modifi !");
		}
		else if (message=="fini") {
			showMessage("Les droits de l'utilisateur ont t changs avec succs !");
		}
		else {
			showWarning("Erreur du serveur !");
		}

	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#enregistrerDroits_2 : ' + e);
  }
}


function EnableBoutons(e,a) {
	try {
		
		var tree = (a==true?document.getElementById('liste_droits_journaux'):document.getElementById('liste_non_droits_journaux'));
		
		if ((tree.view!=null && tree.currentIndex!=-1)) {
			document.getElementById('Enlever').disabled = e;
			document.getElementById('Ajouter').disabled = a;
		}
	
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#enableBoutons : ' + e);
  }
}


function retour_choixUtilisateur() {
	try {

  	window.location = "chrome://opensi/content/config/droits/menu_droits.xul?"+ cookie();
		
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#retour_choixUtilisateur : ' + e);
  }
}


function retour_menuManager() {
	try {
	
		var page = "chrome://opensi/content/config/menu_manager.xul?" + cookie();
   	page += "&Libelle="+parent.document.getElementById("nom_dossier").value;
  	window.location = page;
		
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#retour_menuManager : ' + e);
  }
}


function retour_choixDossier() {
	try {

		window.location = "chrome://opensi/content/config/menu.xul?"+ cookie();
		
	} catch (e) {
    recup_erreur('erreur dans config/droits/modifier_droits.js#retour_menuDossiers : ' + e);
  }
}
