/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var code_tva = "";
var taux_tva;


function init() {
	try {

		init_tree();

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#init : ' + e);
  }
}


function init_tree() {
  try {

    var paramlist = "&Page=Config/GetRDF/listeTauxTva.tmpl&ContentType=xml";
    load_rdf("liste_TVA", getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {

    var database = document.getElementById("liste_TVA").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
   	document.getElementById("liste_TVA").builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#delete_tree : ' + e);
  }
}


function reporter() {
  try {

    var tree = document.getElementById("liste_TVA");
		if (tree.view!=null && tree.view.selection.currentIndex!=-1) {
    	document.getElementById('Taux_TVA').value = getCellText(tree,tree.view.selection.currentIndex,'ColMode');
			taux_tva = getCellText(tree,tree.view.selection.currentIndex,'ColMode');
			code_tva = getCellValue(tree,tree.view.selection.currentIndex,'ColMode');
			if (getCellText(tree,tree.view.selection.currentIndex,'ColCptTVAAchats')!="") {
				document.getElementById('cptTVAAchats').value = getCellText(tree,tree.view.selection.currentIndex,'ColCptTVAAchats');
      }
			if (getCellText(tree,tree.view.selection.currentIndex,'ColCptTVAVentes')!="") {
				document.getElementById('cptTVAVentes').value = getCellText(tree,tree.view.selection.currentIndex,'ColCptTVAVentes');
			}
			document.getElementById('bEnregistrer').disabled = false;
			disable(false);
		}

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#reporter : ' + e);
  }
}


function disable(b) {
	try {

		if (b) {
			document.getElementById('Taux_TVA').value = '';
			code_tva = "";
		}
		document.getElementById('bEnregistrer').disabled = b;

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#disable : ' + e);
  }
}


function supprimerTVA_2(httpRequest) {
	try {

		var message = httpRequest.responseXML.documentElement.getAttribute("message");

		if (message!="suppr") {
			showWarning("Erreur du serveur !");
		}
		delete_tree();
		init_tree();
		disable(true);

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#supprimerTVA_2 : ' + e);
  }
}


function enregistrerTVA() {
	try {

		if (code_tva=="") return false;

		var compte_TVA_Achats = document.getElementById('cptTVAAchats').value;
		var compte_TVA_Ventes = document.getElementById('cptTVAVentes').value;

		if (compte_TVA_Achats.length != 8 || compte_TVA_Achats.charAt(0)!=4 || compte_TVA_Achats.charAt(1)!=4 || compte_TVA_Achats.charAt(2)!=5 || !isDigitList(compte_TVA_Achats)) {
			showWarning("Compte TVA incorrect !  standard : 445.....");
		}
		else if (compte_TVA_Ventes.length != 8 || compte_TVA_Ventes.charAt(0)!=4 || compte_TVA_Ventes.charAt(1)!=4 || compte_TVA_Ventes.charAt(2)!=5 || !isDigitList(compte_TVA_Ventes)) {
			showWarning("Compte TVA incorrect !  standard : 445.....");
		}
		else {
			var corps = cookie() +"&Page=Config/gestion_commerciale/comptabilite/modifierTVA.tmpl&ContentType=xml";
      corps += "&Code_TVA="+ code_tva;
      corps += "&Compte_TVA_Achats="+ compte_TVA_Achats;
      corps += "&Compte_TVA_Ventes="+ compte_TVA_Ventes;
			var httpRequest = new XMLHttpRequest();
			requeteHTTP(corps, httpRequest, enregistrerTVA_2);
		}

  } catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#enregistrerTVA : ' + e);
  }
}


function enregistrerTVA_2(httpRequest) {
	try {

		delete_tree();
		init_tree();
		disable(true);

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#enregistrerTVA_2 : ' + e);
  }
}


function changer(id){
  try {

		var nom = "TVA";
    var compte = "445";
    var id = document.getElementById(id).id;
    var url = "chrome://opensi/content/config/util/rechcompte.xul?"+ cookie() +"&Force_Deb=445&Compte_Gen=G&nom="+urlEncode(nom);
    window.openDialog(url,'rechcompte','chrome,modal',compte,id,false);

  } catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#changer : ' + e);
  }
}


function keypress(e){
  try {

    if (e.keyCode==13) {
        enregistrerTVA();
    }

  } catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/comptabilite/tva.js#keypress : ' + e);
  }
}
