/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var org_cour = '';


function init() {
	try {
		
		init_tree();
  
	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#init : ' + e);
  }
}


function ouvrirOrg() {
	try {
	
		var tree = document.getElementById('liste_org');
		
		if (tree.view!=null && tree.currentIndex!=-1) {		
			
			var num_org = tree.view.getCellValue(tree.currentIndex,'ColOrg');		
			
			var corps = cookie() + "&Page=Config/gestion_commerciale/livraison/champsOrgLivraison.tmpl&ContentType=xml&Num_Org="+ num_org;
			var httpRequest = new XMLHttpRequest();
			requeteHTTP(corps, httpRequest, ouvrirOrg_2, num_org);	
		}
	
	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#ouvrirOrg : ' + e);
  }
}


function ouvrirOrg_2(httpRequest, num_org) {
	try {

		var contenu = httpRequest.responseXML.documentElement;
		
		document.getElementById('Nom_Org').value = contenu.getAttribute('nom_org');
		document.getElementById('Adresse').value = contenu.getAttribute('adresse');
		document.getElementById('Code_Postal').value = contenu.getAttribute('code_postal');
		document.getElementById('Ville').value = contenu.getAttribute('ville');
		document.getElementById('Tel').value = contenu.getAttribute('tel');
		document.getElementById('Fax').value = contenu.getAttribute('fax');

		document.getElementById('bSupprimer').disabled = false;
		document.getElementById('bNouveau').disabled = false;
		document.getElementById('bModifier').disabled = false;
		document.getElementById('bModifier').collapsed = false;
		document.getElementById('bCreer').disabled = true;
		document.getElementById('bCreer').collapsed = true;

		org_cour = num_org;		

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#ouvrirOrg_2 : ' + e);
  }
}


function keypress(e) {  
  try {
	
    if (e.keyCode==13) {
      ouvrirOrg();
    }
		
  } catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#keypress : ' + e);
  }
}


function supprimerOrg() {
	try {
	
		if (org_cour != '') {

			if (window.confirm("Confirmez-vous la suppression de l'organisme de livraison '"+ document.getElementById('Nom_Org').value +"' ?")) {
				
				var corps = cookie() + "&Page=Config/gestion_commerciale/livraison/supprimerOrgLivraison.tmpl&ContentType=text&Num_Org="+ org_cour;
				var httpRequest = new XMLHttpRequest();
				requeteHTTP(corps, httpRequest, supprimerOrg_2);
			}
		}
		
	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#supprimerOrg : ' + e);
  }
}


function supprimerOrg_2(httpRequest) {
	try {

		delete_tree();
		init_tree();
		nouveauOrg();

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#supprimerOrg_2 : ' + e);
  }
}


function modifierOrg() {
	try {
	
		if (org_cour != '') {
		
			var nom_org = document.getElementById('Nom_Org').value;
			var adresse = document.getElementById('Adresse').value;
			var code_postal = document.getElementById('Code_Postal').value;
			var ville = document.getElementById('Ville').value;
			var tel = document.getElementById('Tel').value;
			var fax = document.getElementById('Fax').value;
		
			if (isEmpty(nom_org)) {
				showWarning("Veuillez remplir le champ 'Organisme de livraison' !");
			}
			else if (!isEmpty(code_postal) && (code_postal.length !=5 || !isDigitList(code_postal))) {
				showWarning("Code postal incorrect !");
			}
			else if (!isEmpty(tel) && !isPhone(tel)) {
				showWarning("Numro de tlphone incorrect !");
			}
			else if (!isEmpty(fax) && !isPhone(fax)) {
				showWarning("Numro de fax incorrect !");
			}
			else {
				var corps = cookie() + "&Page=Config/gestion_commerciale/livraison/modifierOrgLivraison.tmpl&ContentType=xml&Num_Org="+ org_cour;			
				corps += "&Nom_Org="+ urlEncode(nom_org);
				corps += "&Adresse="+ urlEncode(adresse);
				corps += "&Code_Postal="+ urlEncode(code_postal);
				corps += "&Ville="+ urlEncode(ville);
				corps += "&Tel="+ urlEncode(tel);
				corps += "&Fax="+ urlEncode(fax);

				var httpRequest = new XMLHttpRequest();
				requeteHTTP(corps, httpRequest, modifierOrg_2);
			}
		}
		
	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#modifierOrg : ' + e);
  }
}


function modifierOrg_2(httpRequest) {
	try {

		delete_tree();
		init_tree();
		nouveauOrg();

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#modifierOrg_2 : ' + e);
  }
}


function nouveauOrg() {
	try {
	
		document.getElementById('Nom_Org').value = "";
		document.getElementById('Adresse').value = "";
		document.getElementById('Code_Postal').value = "";
		document.getElementById('Ville').value = "";
		document.getElementById('Tel').value = "";
		document.getElementById('Fax').value = "";
		
		document.getElementById('bSupprimer').disabled = true;
		document.getElementById('bNouveau').disabled = true;
		document.getElementById('bModifier').disabled = true;
		document.getElementById('bModifier').collapsed = true;
		document.getElementById('bCreer').disabled = false;
		document.getElementById('bCreer').collapsed = false;
		
		org_cour = '';
		
	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#nouveauOrg : ' + e);
  }
}


function enregistrerOrg() {
	try {
		
		var nom_org = document.getElementById('Nom_Org').value;
		var adresse = document.getElementById('Adresse').value;
		var code_postal = document.getElementById('Code_Postal').value;
		var ville = document.getElementById('Ville').value;
		var tel = document.getElementById('Tel').value;
		var fax = document.getElementById('Fax').value;
 
		if (isEmpty(nom_org)) {
			showWarning("Veuillez remplir le champ 'Organisme de livraison' !");
		}
		else if (!isEmpty(code_postal) && (code_postal.length !=5 || !isDigitList(code_postal))) {
			showWarning("Code postal incorrect !");
		}
		else if (!isEmpty(tel) && !isPhone(tel)) {
			showWarning("Numro de tlphone incorrect !");
		}
		else if (!isEmpty(fax) && !isPhone(fax)) {
			showWarning("Numro de fax incorrect !");
		}
		else {
			var corps = cookie() +"&Page=Config/gestion_commerciale/livraison/creerOrgLivraison.tmpl&ContentType=xml";
			corps += "&Nom_Org="+ urlEncode(nom_org);
			corps += "&Adresse="+ urlEncode(adresse);
			corps += "&Code_Postal="+ urlEncode(code_postal);
			corps += "&Ville="+ urlEncode(ville);
			corps += "&Tel="+ urlEncode(tel);
			corps += "&Fax="+ urlEncode(fax);

			var httpRequest = new XMLHttpRequest();
			requeteHTTP(corps, httpRequest, enregistrerOrg_2);
		}
		
	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#enregistrerOrg : ' + e);
  }
}


function enregistrerOrg_2(httpRequest) {
	try {
	
		delete_tree();
		init_tree();
		nouveauOrg();
	
	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#enregistrerOrg_2 : ' + e);
  }
}


function init_tree() {
  try {		
    
		var paramlist = "&Page=Config/GetRDF/listeOrgLivraison.tmpl&ContentType=xml";    
    load_rdf('liste_org', getUrlOpeneas(paramlist));
    
  } catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {
	
    var database = document.getElementById("liste_org").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('liste_org').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/livraison/livraison.js#delete_tree : ' + e);
  }
}
