/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");


var aReg = new Arbre('mcnf', 'listeReglement.tmpl', 'liste_modes');


function init() {
	try {

		aReg.initTree();

		setTimeout("initTypeR();", 1);

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/reglement/reglement.js#init : ' + e);
  }
}


function initTypeR() {
	document.getElementById('Type_R').selectedIndex = 0;
}


function disableSup() {
	try {

		var tree = document.getElementById('liste_modes');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById('bSupprimer').disabled = false;
			document.getElementById('ajouter').collapsed = true;
			document.getElementById('modifier').collapsed = false;
			document.getElementById('Mode_R').disabled=true;
			document.getElementById('nouveau').disabled = false;
			document.getElementById('Mode_R').value=getCellText(tree,tree.currentIndex,'ColMode');
			document.getElementById('Type_R').value=getCellText(tree,tree.currentIndex,'ColType');
		}

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/reglement/reglement.js#enableSup : ' + e);
  }
}

function nouveauMode() {
	try {

		document.getElementById('liste_modes').view.selection.clearSelection();

		document.getElementById('bSupprimer').disabled = true;
		document.getElementById('ajouter').collapsed = false;
		document.getElementById('modifier').collapsed = true;
		document.getElementById('nouveau').disabled = true;
		document.getElementById('Mode_R').disabled=false;
		document.getElementById('Mode_R').value="";
		document.getElementById('Type_R').selectedIndex = 0;
		
	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/reglement/reglement.js#enableSup : ' + e);
  }
}

function supprimerMode() {
	try {

		var tree = document.getElementById('liste_modes');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var mode_r = getCellText(tree,tree.currentIndex,'ColMode');

			if (window.confirm("Confirmez-vous la suppression du mode de rglement '"+ mode_r +"' ?")) {

				var querySup = new QueryHttp("Config/gestion_commerciale/reglement/supprimerReglement.tmpl");
				querySup.setParam('Mode_R', mode_r);
				querySup.execute();

				aReg.initTree();
				document.getElementById('bSupprimer').disabled = true;
			}
		}

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/reglement/reglement.js#supprimerMode : ' + e);
  }
}


function enregistrerMode(mode) {
	try {

		var mode_r = document.getElementById('Mode_R').value;

		if (isEmpty(mode_r)) {
			showWarning("Veuillez remplir le champ 'Mode de rglement' !");
		}
		else {
			var querySave = new QueryHttp("Config/gestion_commerciale/reglement/creerReglement.tmpl");
			querySave.setParam('Mode_R', mode_r);
			querySave.setFullParamById('Type_R');
			var rep = querySave.execute();

			if (rep.responseXML.documentElement.getAttribute('existe')=="true") {
				showWarning("Le mode de rglement '"+ mode_r +"' existe dj");
			}
			else {
				aReg.initTree();
				document.getElementById('bSupprimer').disabled = true;
				document.getElementById('Mode_R').value = '';
				document.getElementById('Type_R').selectedIndex = 0;
			}
		}

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/reglement/reglement.js#enregistrerMode : ' + e);
  }
}

function modifierMode() {
	try {

		var mode_r = document.getElementById('Mode_R').value;

		if (isEmpty(mode_r)) {
			showWarning("Veuillez remplir le champ 'Mode de rglement' !");
		}
		else {
			var queryMod = new QueryHttp("Config/gestion_commerciale/reglement/modifierReglement.tmpl");
			queryMod.setParam('Mode_R', mode_r);
			queryMod.setFullParamById('Type_R');
			var rep = queryMod.execute();

			if (rep.responseXML.documentElement.getAttribute('existe')=="true") {
				showWarning("Le mode de rglement '"+ mode_r +"' existe dj");
			}
			else {
				aReg.initTree();
				nouveauMode();
			}
		}

	} catch (e) {
    recup_erreur('erreur dans config/gestion_commerciale/reglement/reglement.js#enregistrerMode : ' + e);
  }
}
