/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var base;
var ouvert = 0;
var Classe = -1;
var dossier;
var numero_compte;
var Code_Plan;
var id = 0;
var nomClasse = new Array(10);
var valeur;


function init() {
	try {
	
		dossier = get_cookie('Dossier_Id');

    var x = (screen.width / 2) - 400;
    var y = (screen.height / 2) - 300;
    window.resizeTo(800,600);
    window.moveTo(x,y);
		Classe = 1;

		valeur = window.arguments[0];

		if (valeur.charAt(0)>=1 && (valeur.charAt(0))<=7) {
			Classe = parseInt(valeur.charAt(0));
		}		
	
		choisirPlan();		
		
	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#init : ' + e);
  }
}


function choisirPlan() {
	try {

		var corps = cookie() +"&Page=Config/dossiers/getDossier.tmpl&ContentType=xml";		
  	var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps, httpRequest,choisirPlan_2);
  	
	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#choisirPlan : ' + e);
  }
}


function choisirPlan_2(httpRequest) {
	try {

		Code_Plan = httpRequest.responseXML.documentElement.getAttribute('Code_Plan');		
		
		var corps = cookie() +"&Page=Config/comptabilite/plan_comptable/getPlan.tmpl&ContentType=xml";		
  	var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps, httpRequest, choisirPlan_3);

	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#choisirPlan_2 : ' + e);
  }
}


function choisirPlan_3(httpRequest) {
	try {

		var contenu = httpRequest.responseXML;
		Libelle = contenu.documentElement.getAttribute('Libelle');
		Code = contenu.documentElement.getAttribute('Code');
		
		enregistrerTitre();
		tab(Classe);

	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#choisirPlan_3 : ' + e);
  }
}


function tab(Cl) {
	try {
	
		Classe = Cl;
		afficherTitre();
		
    var database = document.getElementById("Classe").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById("Classe").builder.rebuild();

		var paramlist ="&Page=Config/GetRDF/listeClasses.tmpl&ContentType=xml&Classe="+ Classe +"&Code="+ Code_Plan;
 		load_rdf("Classe", getUrlOpeneas(paramlist));

	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#tab : ' + e);
  }
}


function enregistrerTitre() {
	try {
	
		var corps = cookie() +"&Page=Config/comptabilite/plan_comptable/getTitrePlan.tmpl&ContentType=xml&Code_Plan="+ Code_Plan;		
		var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps, httpRequest, enregistrerTitre_2);  	
		
	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#enregistrerTitre : ' + e);
  }
}


function enregistrerTitre_2(httpRequest) {
	try {
	
		for (var i=0;i<nomClasse.length;i++) {
			nomClasse[i]="";
		}
		
		var ent = httpRequest.responseXML.documentElement.getElementsByTagName('Entete');
		
		for (var i=0;i<ent.length;i++) {
			var nom=ent.item(i).getAttribute('libelle');
			var numero = ent.item(i).getAttribute('num');
			var num = parseInt(numero);
			nomClasse[num+1] = "Classe "+(num)+" - "+nom;
		}
		
		afficherTitre();
	
	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#enregistrerTitre_2 : ' + e);
  }
}


function afficherTitre() {
	try {
	
		document.getElementById("titre").value = nomClasse[Classe+1];

	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#afficherTitre : ' + e);
  }
}


function ouvrirClasse() {
	try {
	
		var t = document.getElementById('Classe');
		if(t.view!=null && t.currentIndex!=-1){
  		var code = getCellText(t,t.view.selection.currentIndex,'num');
      var id = window.arguments[1];
      window.opener.document.getElementById(id).value = code;
      window.opener.document.getElementById(id).focus();
      window.opener.force = true;
      window.close();
		}
		
	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#ouvrirClasse : ' + e);
  }
}


function keypress(e) {
	try {
	
		if (e.keyCode==13) {
      ouvrirClasse();
    }
		
	} catch (e) {
    recup_erreur('erreur dans config/util/liste_plan.js#keypress : ' + e);
  }
}
