/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");

var aComptes = new Arbre('mcnf', 'listeComptes.tmpl', 'comptes_tree');

var noresult = false;
var cookieWrapper;


function init() {
  try {

    cookieWrapper = getWrapper();

    var x = (screen.width / 2) - 350;
    var y = (screen.height / 2) - 250;
    window.resizeTo(700,500);
    window.moveTo(x,y);

		document.getElementById('titre').value = "RECHERCHE DE COMPTE "+ ParamValeur("nom");

		var compte_gen = ParamValeur("Compte_Gen");
		var force_deb = ParamValeur("Force_Deb");
		var ignoreG = ParamValeur("ignoreG");

		if (!isEmpty(force_deb)) {
     	aComptes.setParam('Force_Deb', force_deb);
		}
		if (!isEmpty(compte_gen)) {
      aComptes.setParam('Compte_Gen', compte_gen);
    }
    if (!isEmpty(ignoreG)) {
			aComptes.setParam('ignoreG', ignoreG);
    }

    document.getElementById('num_compte').value = window.arguments[0].replace(' ','');

    init_tree();

		document.getElementById('num_compte').focus();

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#init : ' + e);
  }
}


function init_tree() {
  try {

    var numc = document.getElementById('num_compte').value;
    var libc = document.getElementById('lib_compte').value;

		aComptes.setParam('Numero_Compte', numc);

    if (isEmpty(libc)) {
			aComptes.removeParam('Libelle');
		}
		else {
      aComptes.setParam('Libelle', libc);
    }

    aComptes.initTree(fin_chargement);

	} catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#init_tree : ' + e);
  }
}


function fin_chargement() {
  try {

    if (document.getElementById('comptes_tree').view == null) {
      var libc = document.getElementById('num_compte').value;
      if (noresult || isEmpty(libc)) {
        document.getElementById('num_compte').value = document.getElementById('lib_compte').value;
        document.getElementById('lib_compte').value = '';
      }
			else {
        document.getElementById('lib_compte').value = libc;
        document.getElementById('num_compte').value = '';
        noresult = true;
        init_tree();
        return false;
      }
    }
    noresult = false;

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#fin_chargement : ' + e);
  }
}


function reporter() {
  try {

		var tree = document.getElementById('comptes_tree');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById("num_compte").value = getCellText(tree, tree.currentIndex, 'num');
		}

	} catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#reporter : ' + e);
  }
}


function ok() {
  try {

    if (doOK()) {
      var num_compte = document.getElementById('num_compte').value;
      var id = window.arguments[1];
      cookieWrapper.getElementById(id).value = num_compte;
      window.opener.force = true;
      window.close();
    }
		else {
      document.getElementById('num_compte').focus();
    }

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#ok : ' + e);
  }
}


function doOK() {
  try {

    var input_compte = document.getElementById('num_compte');
    var num_compte = input_compte.value;
    if (num_compte.length < 8) {
      init_tree();
      return false;
    }
		else {
      if (belongs(num_compte)) {
        return true;
      }
			else {
        var msg = "Le compte numro "+ num_compte +" n'existe pas";
        if (window.arguments[2]) {
          msg += "Voulez-vous crer un nouveau compte ?";
          if (confirm(msg)) {
            creer_compte();
            return false;
          }
					else {
            return false;
          }
        }
				else {
          showWarning(msg);
          return false;
        }
      }
    }

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#doOK : ' + e);
  }
}


function creer_compte() {
  try {

    var num_compte = document.getElementById('num_compte').value;
    var url = "chrome://opensi/content/config/util/nouveau_compte.xul?"+ cookie();
    window.openDialog(url,'','chrome,modal',num_compte);

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#creer_compte : ' + e);
  }
}


function keypress(e, id) {
  try {
    switch (e.keyCode) {
      case 33: // 'PageUp'
        select_up();
        break;
      case 34: // 'PageDown'
        select_down();
        break;
      case 38: // '^'
        select_prev();
        break;
      case 40: // 'v'
        select_next();
        break;
      case 13: // <Enter>
				if (id=="lib_compte")
					init_tree();
				else
					ok();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#keypress : ' + e);
  }
}


// slection de la ligne prcdente  la ligne slectionne
function select_prev() {
  try {

    var tree = document.getElementById('comptes_tree');

		if (tree.view!=null) {
    	var index = tree.currentIndex - 1;
    	if (index >= 0) {
      	select_row(index);
    	}
			else {
      	select_row(0);
    	}
		}

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#select_prev : ' + e);
  }
}


// slection de la ligne suivante  la ligne slectionne
function select_next() {
  try {

    var tree = document.getElementById('comptes_tree');

		if (tree.view!=null) {
    	var index = tree.currentIndex + 1;
    	if (index < tree.view.rowCount) {
      	select_row(index);
    	}
			else {
      	select_row(tree.view.rowCount - 1);
    	}
		}

	} catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#select_next : ' + e);
  }
}


// slection d'une ligne 10 lignes au dessus de la ligne slectionne
function select_up() {
  try {

    var tree = document.getElementById('comptes_tree');

		if (tree.view!=null) {
    	var index = tree.currentIndex - 10;
    	if (index < 0) {
      	select_row(0);
    	}
			else {
      	select_row(index);
    	}
		}

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#select_up : ' + e);
  }
}


// slection d'une ligne 10 lignes en dessous de la ligne slectionne
function select_down() {
  try {

		var tree = document.getElementById('comptes_tree');

		if (tree.view!=null) {
    	var index = tree.currentIndex + 10 ;
    	if (index >= tree.view.rowCount) {
      	select_row(tree.view.rowCount - 1);
    	}
			else {
      	select_row(index);
    	}
		}

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#select_down : ' + e);
  }
}

/****************************************************
 *  selectionne un ligne dans l'arbre.
 *  @param index : l'index de la ligne de l'arbre  slectionner
 ****************************************************/
function select_row(index) {
  try {

    var tree = document.getElementById('comptes_tree');
    tree.treeBoxObject.focused = true;
    tree.view.selection.select(index);
    tree.treeBoxObject.ensureRowIsVisible(index);

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#select_row : ' + e);
  }
}


function belongs(num_compte) {
  try {

    var tree = document.getElementById('comptes_tree');
    if (tree.view == null) return false;
    for (i=0;i<tree.view.rowCount;i++) {
      if (num_compte.toUpperCase() == getCellText(tree,i,'num').toUpperCase()) {
        return true;
      }
    }
    return false;

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#belongs : ' + e);
    return false;
  }
}


function cancel() {
  try {

    var id = window.arguments[1];
    cookieWrapper.getElementById(id).value = '';
    window.opener.force = true;
    window.close();

  } catch (e) {
    recup_erreur('erreur dans config/util/rechcompte.js#cancel : ' + e);
  }
}
