/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");

var com_id;
var mode_ligne;
var client_id;
var affaire_id;
var mode;
var etat_commande;
var mode_tarif;
var typeVente = "N";
var initLigne = false;
var currentRank = 0;
var type_remise = 'P';


function init() {
  try {

		setModeTarif();

		var paramlist = "&Page=Manager/GetRDF/taux_tva.tmpl&ContentType=xml";
    load_rdf_async('Code_TVA', getUrlOpeneas(paramlist), init_2);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#init : ' + e);
	}
}


function init_2() {
  try {

		initTVA();

		affaire_id = ParamValeur("Affaire_Id");

		document.getElementById("Raison_Sociale").value = ParamValeur("Raison_Sociale");
		document.getElementById("Adresse_Fact").value = ParamValeur("Adresse_Fact");
		document.getElementById("CP_Fact").value = ParamValeur("CP_Fact");
		document.getElementById("Ville_Fact").value = ParamValeur("Ville_Fact");
		client_id = ParamValeur("Client_Id");
		document.getElementById("Client").setAttribute("label","Client N "+ client_id);
		document.getElementById("Affaire").setAttribute("label","Affaire N "+ ParamValeur("Num_Affaire"));
		document.getElementById("Nom_Affaire").value = ParamValeur("Nom_Affaire");
		document.getElementById("Responsable").value = ParamValeur("Responsable");

		window.parent.addEventListener("close",demandeEnregistrement,false);

		mode = ParamValeur("Mode");

		if (mode=="C") {
			nouvelleCommande();
		}
		else {

			// chargement

			com_id = ParamValeur("Com_Id");

			initLigne = true;

			init_tree();

			var corps = cookie() +"&Page=Facturation/Affaires/loadArticleComTemp.tmpl&ContentType=xml&Com_Id="+ com_id;
			var p = requeteHTTP(corps);
		}

		var corps = cookie() +"&Page=Facturation/Commun/getIndicationsCommandeClient.tmpl&ContentType=xml&Client_Id="+ client_id;
		var p = requeteHTTP(corps);

		document.getElementById('Indications').value = p.responseXML.documentElement.getAttribute("Indications");

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#init_2 : ' + e);
	}
}


function setModeTarif() {
	try {

    var corps = cookie() + "&Page=Manager/ParamDossier/getParamDossier.tmpl&ContentType=xml&Dossier_Id="+ get_cookie("Dossier_Id");
    var p = requeteHTTP(corps);

		mode_tarif = p.responseXML.documentElement.getAttribute('Mode_Tarif');

		if (mode_tarif=='Q') {
			document.getElementById('row_tarif').collapsed = true;
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#setModeTarif : ' + e);
	}
}


function desinit() {
	try {

		window.parent.removeEventListener("close",demandeEnregistrement,false);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#desinit : ' + e);
  }
}


function switchRemise() {
	try {

		if (type_remise=='P') {
			document.getElementById('bRemise').setAttribute("label", "\u20AC");
			type_remise = 'M';
		}
		else {
			document.getElementById('bRemise').setAttribute("label", "%");
			type_remise = 'P';
		}
		calculTotaux();
		setModifie(true);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#switchRemise : ' + e);
  }
}


function initTVA() {
	try {

   	document.getElementById('Code_TVA').value = 4;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#initTVA : ' + e);
  }
}


function disableAll() {
	try {

		mode = "V";

		document.getElementById('Commentaires').disabled = true;
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('Remise').disabled = true;
		document.getElementById('Escompte').disabled = true;
		document.getElementById('Acompte').disabled = true;
		document.getElementById('Ref_Com').disabled = true;
		document.getElementById('Frais_Port').disabled = true;
		document.getElementById('Delai').disabled = true;

		document.getElementById('bCommentaire').disabled = true;
		document.getElementById('bArticle').disabled = true;
		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bValiderCommande').disabled = true;
		document.getElementById('bRemise').disabled = true;

		formatLigne("");

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#disableAll : ' + e);
  }
}


function ajouterLigne(type_ligne) {
  try {

		document.getElementById('bSupprimer').disabled = true;
		mode_ligne = "C";

		document.getElementById("Type_Ligne").value = type_ligne;

		formatLigne(type_ligne);

		switch(type_ligne) {
			case "S":
				var url = "chrome://opensi/content/facturation/user/stocks/rech_stocks.xul?"+ cookie() +"&Nouv=false&Modif_Action=false&Field_Article=Reference";
    		window.openDialog(url,'','chrome,modal');

				var reference = document.getElementById("Reference").value;

				if (!isEmpty(reference)) {

					if (mode_tarif=='Q') {

						var url = "chrome://opensi/content/facturation/user/affaires/choix_tarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    				window.openDialog(url,'','chrome,modal');

						var tarif_id = document.getElementById('Tarif_Id').value;

						if (!isEmpty(tarif_id)) {

							var corps = cookie() + "&Page=Facturation/Affaires/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
							corps += "&Tarif_Id="+ tarif_id;

							var p = requeteHTTP(corps);

							var contenu = p.responseXML.documentElement;

							document.getElementById("Designation").value = contenu.getAttribute("Designation");
							document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
							document.getElementById("PU").value = contenu.getAttribute("Prix");
							document.getElementById('Ristourne').value = "0.00";
							document.getElementById("Code_TVA").value = (typeVente=="N"?contenu.getAttribute("Code_TVA"):1);
							document.getElementById("Tarif_Id").value = "";
							document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
						}
						else {
							ajouterLigne("I");
						}
					}
					else {
						var corps = cookie() + "&Page=Facturation/Affaires/getArticleTarif.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
						corps += "&Code_Tarif="+ document.getElementById('Code_Tarif').value +"&Client_Id="+ urlEncode(client_id);
						var p = requeteHTTP(corps);

						var contenu = p.responseXML.documentElement;

						document.getElementById("Designation").value = contenu.getAttribute("Designation");
						document.getElementById('Quantite').value = 1;
						document.getElementById("PU").value = contenu.getAttribute("Prix");
						document.getElementById('Ristourne').value = "0.00";
						document.getElementById("Code_TVA").value = (typeVente=="N"?contenu.getAttribute("Code_TVA"):1);
						document.getElementById("Libelle").value = "";
					}
				}
				else {
					ajouterLigne("I");
				}

				break;

			case "I":

				document.getElementById('Reference').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById('Quantite').value = 1;
				document.getElementById('PU').value = "";
				document.getElementById('Ristourne').value = "0.00";
				document.getElementById('Code_TVA').value = (typeVente=="N"?4:1);
				document.getElementById('Libelle').value = "";
				break;
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#ajouterLigne : ' + e);
	}
}


function formatLigne(type_ligne) {
  try {

		switch(type_ligne) {
			case "S":
				document.getElementById('Reference').disabled = true;
				document.getElementById('Designation').disabled = true;
				document.getElementById('Quantite').disabled = false;
				document.getElementById('PU').disabled = false;
				document.getElementById('Ristourne').disabled = false;
				document.getElementById('Code_TVA').disabled = (typeVente=="N"?false:true);
				document.getElementById('bValider').disabled = false;
				document.getElementById('bAnnuler').disabled = false;
				break;

			case "I":
				document.getElementById('Reference').disabled = false;
				document.getElementById('Designation').disabled = false;
				document.getElementById('Quantite').disabled = false;
				document.getElementById('PU').disabled = false;
				document.getElementById('Ristourne').disabled = false;
				document.getElementById('Code_TVA').disabled = (typeVente=="N"?false:true);
				document.getElementById('bValider').disabled = false;
				document.getElementById('bAnnuler').disabled = false;
				break;

			default:
				document.getElementById('Reference').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById('Quantite').value = "";
				document.getElementById('PU').value = "";
				document.getElementById('Ristourne').value = "";
				document.getElementById('Code_TVA').value = (typeVente=="N"?4:1);
				document.getElementById('Libelle').value = "";
				document.getElementById('Reference').disabled = true;
				document.getElementById('Designation').disabled = true;
				document.getElementById('Quantite').disabled = true;
				document.getElementById('PU').disabled = true;
				document.getElementById('Ristourne').disabled = true;
				document.getElementById('Code_TVA').disabled = true;
				document.getElementById('bSupprimer').disabled = true;
				document.getElementById('bValider').disabled = true;
				document.getElementById('bAnnuler').disabled = true;
				break;
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#formatLigne : ' + e);
	}
}


function pressOnWindow(ev) {
	try {

		if (ev.altKey) {
			switch(ev.charCode) {
      	case 97: // 'a'
        	ajouterLigne("S");
        	break;
				case 116: // 't'
					modifierTarif();
					break;
    	}
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#pressOnWindow : ' + e);
  }
}


function modifierTarif() {
	try {

		if (mode_ligne = "M" && document.getElementById('Type_Ligne').value=='S') {

			if (mode_tarif=='Q') {

				var reference = document.getElementById('Reference').value;

				var url = "chrome://opensi/content/facturation/user/affaires/choix_tarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    		window.openDialog(url,'','chrome,modal');

				var tarif_id = document.getElementById('Tarif_Id').value;

				if (!isEmpty(tarif_id)) {

					var corps = cookie() + "&Page=Facturation/Affaires/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
					corps += "&Tarif_Id="+ tarif_id;

					var p = requeteHTTP(corps);

					var contenu = p.responseXML.documentElement;

					document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
					document.getElementById("PU").value = contenu.getAttribute("Prix");
					document.getElementById("Tarif_Id").value = "";
					document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
				}
			}
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#modifierTarif : ' + e);
  }
}


function ouvrirLigne() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1 && mode=="M") {

			if (getCellText(tree,tree.currentIndex,'ColType_Ligne')=="C") {
				ajouterLigne("I");
			}
			else {
				mode_ligne = "M";
				document.getElementById('bSupprimer').disabled = false;

				document.getElementById("Reference").value = getCellText(tree,tree.currentIndex,'ColReference');
				document.getElementById("Designation").value = getCellText(tree,tree.currentIndex,'ColDesignation');
				document.getElementById("Quantite").value = getCellText(tree,tree.currentIndex,'ColQuantite');
				document.getElementById("PU").value = getCellText(tree,tree.currentIndex,'ColPU');
				document.getElementById("Code_TVA").value = getCellText(tree,tree.currentIndex,'ColCode_TVA');
				document.getElementById("Ristourne").value = getCellText(tree,tree.currentIndex,'ColRistourne');
				document.getElementById("Type_Ligne").value = getCellText(tree,tree.currentIndex,'ColType_Ligne');
				document.getElementById("Rank").value = getCellText(tree,tree.currentIndex,'ColRank');
				document.getElementById("Libelle").value = getCellText(tree,tree.currentIndex,'ColLibelle');

				formatLigne(document.getElementById("Type_Ligne").value);
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#ouvrirLigne : ' + e);
	}
}

function ouvrirCommentaire() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1 && mode=="M") {

			if (getCellText(tree,tree.currentIndex,'ColType_Ligne')=="C") {
				editerCommentaire();
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#ouvrirCommentaire : ' + e);
	}
}


function validerLigne() {
  try {

		var ok;

		if (mode=="C") {
			ok = enregistrerCommande();
		}
		else {
			ok = true;
		}

		if (ok) {

			if (mode_ligne=="C") {
				var corps = cookie() +"&Page=Facturation/Affaires/ajouterArticleCom.tmpl&ContentType=xml";
			}
			else {
				var corps = cookie() +"&Page=Facturation/Affaires/modifierArticleCom.tmpl&ContentType=xml";
			}

			var type_ligne = document.getElementById("Type_Ligne").value;
			var reference = document.getElementById("Reference").value;
			var designation = document.getElementById("Designation").value;
			var quantite = document.getElementById("Quantite").value;
			var pu = document.getElementById("PU").value;
			var ristourne = document.getElementById("Ristourne").value;
			var code_tva = document.getElementById("Code_TVA").value;
			var rank = document.getElementById("Rank").value;
			var libelle = document.getElementById('Libelle').value;

			corps += "&Reference="+ urlEncode(reference) +"&Designation="+ urlEncode(designation) +"&Quantite="+ quantite +"&Type_Ligne="+ type_ligne;
			corps += "&Prix="+ pu +"&Ristourne="+ ristourne +"&Code_TVA="+ code_tva +"&Com_Id="+ com_id +"&Rank="+ rank +"&Libelle="+ urlEncode(libelle);

			if (isEmpty(designation)) { showWarning("Dsignation de l'article manquante !"); }
			else if (isEmpty(quantite) || !isPositive(quantite) || !checkDecimal(quantite,2)) { showWarning("Quantit incorrecte !");	}
			else if (isEmpty(pu) || !isPositiveOrNull(pu) || !checkDecimal(pu,4)) { showWarning("Prix unitaire incorrect !");	}
			else if (isEmpty(ristourne) || !isTaux(ristourne)) { showWarning("Taux de ristourne incorrect !");	}
			else {
				var p = requeteHTTP(corps);

  			currentRank = p.responseXML.documentElement.getAttribute('Rank');

				ajouterLigne("I");
				delete_tree();
				init_tree_temp();
				setModifie(true);
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#validerLigne : ' + e);
	}
}


function annulerLigne() {
  try {

		ajouterLigne("I");

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#annulerLigne : ' + e);
	}
}


function supprimerLigne() {
  try {

		var rank = document.getElementById("Rank").value;

		var corps = cookie() +"&Page=Facturation/Affaires/supprimerArticleCom.tmpl&ContentType=xml&Com_Id="+ com_id +"&Rank="+ rank;
		var p = requeteHTTP(corps);

		currentRank = 0;

		ajouterLigne("I");
		delete_tree();
		init_tree_temp();
		setModifie(true);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#supprimerLigne : ' + e);
	}
}


function validerCommande() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("La commande ne contient aucune ligne !");
		}
		else {
			if (window.confirm("Etes-vous sr de vouloir valider la commande ?")) {
				var corps = cookie() +"&Page=Facturation/Affaires/validerCommande.tmpl&ContentType=xml&Com_Id="+ com_id +"&Affaire_Id="+ affaire_id;
				var p = requeteHTTP(corps);

				showMessage("La commande a t valide !");
				retour_affaire();
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#validerCommande : ' + e);
	}
}


function enregistrerCommande() {
  try {

		var ok = false;

		var remise = document.getElementById('Remise').value;
		var taux_remise = 0;
		var montant_remise = 0;
		var frais_port = document.getElementById('Frais_Port').value;
		var escompte = document.getElementById('Escompte').value;
		var acompte = document.getElementById('Acompte').value;
		var ref_com = document.getElementById('Ref_Com').value;
		var delai = document.getElementById('Delai').value;

		if (isEmpty(ref_com)) { showWarning("Veuillez indiquer une rfrence commande !"); }
		else if (isEmpty(remise) || (type_remise=='P'?!isTaux(remise):!isPositiveOrNull(remise))) { showWarning("Remise incorrecte !"); }
		else if (isEmpty(frais_port) || !isPositiveOrNull(frais_port)) { showWarning("Frais de port incorrects !"); }
		else if (isEmpty(escompte) || !isTaux(escompte)) { showWarning("Taux d'escompte incorrect !"); }
		else if (isEmpty(acompte) || !isPositiveOrNull(acompte)) { showWarning("Montant d'acompte incorrect !"); }
		else if (!isEmpty(delai) && !isDate(delai)) { showWarning("Dlai de livraison incorrect !"); }
		else {

			var corps;

			if (mode=="C") {
				corps = cookie() +"&Page=Facturation/Affaires/creerCommande.tmpl&ContentType=xml&Affaire_Id="+ affaire_id +"&EtatAffaire="+ ParamValeur("EtatAffaire");
			}
			else {
				corps = cookie() +"&Page=Facturation/Affaires/modifierCommande.tmpl&ContentType=xml&Com_Id="+ com_id;
			}

			if (type_remise=='P') {
				taux_remise = remise;
			}
			else {
				var montant_ht = document.getElementById('MontantHT').value;
				taux_remise = (montant_ht>0?remise/montant_ht*100:0);
				montant_remise = remise;
			}

			corps += "&Taux_Remise="+ taux_remise +"&Frais_Port="+ frais_port +"&Escompte="+ escompte +"&Acompte="+ acompte +"&Montant_Remise="+ montant_remise;
			corps += "&Commentaires="+ urlEncode(document.getElementById('Commentaires').value);
			corps += "&Imp_Com="+ (document.getElementById('Imp_Com').checked?"1":"0");
			corps += "&Total_HT="+ document.getElementById('TotalHT').value;
			corps += "&Montant_TTC="+ document.getElementById('MontantTTC').value;
			corps += "&Ref_Com="+ urlEncode(ref_com);
			corps += "&Code_Tarif="+ document.getElementById('Code_Tarif').value;
			corps += "&Delai="+ (!isEmpty(delai)?prepareDateJava(delai):"");
			corps += "&Type_Vente="+ typeVente;

			var p = requeteHTTP(corps);

			if (mode=="C") {
				var contenu = p.responseXML.documentElement;
				com_id = contenu.getAttribute("Com_Id");
				chargerCommande();
			}

			if (mode=="M") {
				corps = cookie() + "&Page=Facturation/Affaires/saveArticleComTemp.tmpl&ContentType=xml&Com_Id="+ com_id;
				p = requeteHTTP(corps);
			}
			setModifie(false);

			ok = true;
		}

		return ok;

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#enregistrerCommande : ' + e);
	}
}


function calculTotaux() {
  try {

		var remise = parseFloat(document.getElementById('Remise').value);
		var taux_escompte = parseFloat(document.getElementById('Escompte').value);
		var frais_port = parseFloat(document.getElementById('Frais_Port').value);
		var montant_acompte = parseFloat(document.getElementById('Acompte').value);

		if ((type_remise=='P'?isTaux(remise):isPositiveOrNull(remise)) && isTaux(taux_escompte) && isPositiveOrNull(frais_port)) {

			var tree = document.getElementById("articles");

			var montant_tva = 0;
			var montant_ht = 0;
			var tva_port = (typeVente=="N"?getTva(4):0);

			if (tree.view!=null) {

				for (var i=0;i<tree.view.rowCount;i++) {

					if (getCellText(tree,i,'ColType_Ligne')!="C") {

						montant_ht += parseFloat(getCellText(tree,i,'ColTotal'));
						montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * getTva(getCellText(tree,i,'ColCode_TVA'))/100;

					}
				}
			}

			var taux_remise = (type_remise=='P'?remise:(montant_ht==0?0:remise/montant_ht*100));

			var montant_remise = montant_ht * parseFloat(taux_remise/100);

			var total_ht = montant_ht * (1 - parseFloat(taux_remise/100)) + frais_port;

			montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100);

			var montant_ttc = total_ht + montant_tva;

			var montant_escompte = formatNombre(montant_ttc * parseFloat(taux_escompte/100), "0.00");

			var total_ttc = montant_ttc - montant_escompte - montant_acompte;

			document.getElementById('MontantHT').value = formatNombre(montant_ht,"0.00");
			document.getElementById('MontantRemise').value = formatNombre(montant_remise,"0.00");
			document.getElementById('MontantFrais_Port').value = formatNombre(frais_port,"0.00");
			document.getElementById('TotalHT').value = formatNombre(total_ht,"0.00");
			document.getElementById('TVA').value = formatNombre(montant_tva,"0.00");
			document.getElementById('MontantTTC').value = formatNombre(montant_ttc,"0.00");
			document.getElementById('MontantEscompte').value = formatNombre(montant_escompte,"0.00");
			document.getElementById('MontantAcompte').value = formatNombre(montant_acompte,"0.00");
			document.getElementById('TotalTTC').value = formatNombre(total_ttc,"0.00");
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#calculTotaux : ' + e);
	}
}


function afterRefreshArticles() {
	try {

		calculTotaux();
		scrollToRank();

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#afterRefreshArticles : ' + e);
	}
}


function scrollToRank() {
	try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.view.rowCount>0 && currentRank>0) {

			var tb = document.getElementById("articles").treeBoxObject;
			var i = 0;
			var trouve = false;

			while (!trouve && i<tree.view.rowCount) {

				if (getCellText(tree,i,'ColRank')==currentRank) {
					tb.ensureRowIsVisible(i);
					trouve = true;
				}

				i++;
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#scrollToRank : ' + e);
	}
}


function demandeEnregistrement() {
  try {

		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes  la commande ?")) {
				enregistrerCommande();
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#demandeEnregistrement : ' + e);
	}
}


function setModifie(m) {
  try {

		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelCommande').setAttribute("label","Commande (modifie)");
			document.getElementById('bVisualiser').disabled = true;
			document.getElementById('bValiderCommande').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelCommande').setAttribute("label","Commande");
			document.getElementById('bVisualiser').disabled = false;
			document.getElementById('bValiderCommande').disabled = (etat_commande=='V');
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#setModifie : ' + e);
	}
}


function init_tree() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_com_client.tmpl&ContentType=xml&Com_Id="+ com_id;
    load_rdf_async('articles', getUrlOpeneas(paramlist),chargerCommande);

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#init_tree : ' + e);
  }
}

function delete_tree() {
  try {

    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('articles').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#delete_tree : ' + e);
  }
}


function nouvelleCommande() {
  try {

		mode = "C";

		document.getElementById('Ref_Com').value = "";
		document.getElementById('Commentaires').value = "";
		document.getElementById('Date_Com').value = "";
		document.getElementById('Imp_Com').checked = false;
		document.getElementById('Remise').value = "0.00";
		document.getElementById('Acompte').value = "0.00";
		document.getElementById('Escompte').value = "0.00";
		document.getElementById('Frais_Port').value = "0.00";
		document.getElementById('Delai').value = "";

		document.getElementById('MontantHT').value = "0.00";
		document.getElementById('MontantRemise').value = "0.00";
		document.getElementById('MontantFrais_Port').value = "0.00";
		document.getElementById('TotalHT').value = "0.00";
		document.getElementById('TVA').value = "0.00";
		document.getElementById('MontantTTC').value = "0.00";
		document.getElementById('MontantEscompte').value = "0.00";
		document.getElementById('MontantAcompte').value = "0.00";
		document.getElementById('TotalTTC').value = "0.00";

		document.getElementById('Creation').label = "";
		document.getElementById('Modification').label = "";
		document.getElementById('Creation').collapsed = true;
		document.getElementById('Modification').collapsed = true;
		document.getElementById('Fiche').label = "";

		var corps = cookie() +"&Page=Facturation/Affaires/getDefaultCommande.tmpl&ContentType=xml&Client_Id="+ client_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;
		document.getElementById('Remise').value = contenu.getAttribute("Remise");
		document.getElementById('Code_Tarif').value = contenu.getAttribute("Code_Tarif");
		typeVente = contenu.getAttribute("Type_Vente");

		ajouterLigne("I");

		delete_tree();

		setModifie(false);
		document.getElementById('bVisualiser').disabled = true;

    document.getElementById('Ref_Com').focus();

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/edition_commande.js#nouvelleCommande : ' + e);
  }
}


function chargerCommande() {
  try {

		mode = "M";

		var corps = cookie() +"&Page=Facturation/Affaires/getCommande.tmpl&ContentType=xml&Com_Id="+ com_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		document.getElementById('Remise').value = contenu.getAttribute('Remise');
		type_remise = contenu.getAttribute('Type_Remise');
		document.getElementById('bRemise').setAttribute("label", (type_remise=='P'?"%":"\u20AC"));
		document.getElementById('Escompte').value = contenu.getAttribute('Escompte');
		document.getElementById('Acompte').value = contenu.getAttribute('Acompte');
		document.getElementById('Frais_Port').value = contenu.getAttribute('Frais_Port');
		document.getElementById('Commentaires').value = contenu.getAttribute('Commentaires');
		document.getElementById('Imp_Com').checked = contenu.getAttribute('Imp_Com')=="1";
		document.getElementById('Date_Com').value = contenu.getAttribute('Date_Com');
		document.getElementById('Ref_Com').value = contenu.getAttribute('Ref_Com');
		document.getElementById('Code_Tarif').value = contenu.getAttribute('Code_Tarif');
		document.getElementById('Delai').value = contenu.getAttribute('Delai');
		typeVente = contenu.getAttribute('Type_Vente');

		document.getElementById('Creation').label = "Commande cre le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "Commande N "+ contenu.getAttribute('Ref_Com');
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		setModifie(false);

		etat_commande = contenu.getAttribute("Etat");

		if (etat_commande=='V') {
			disableAll();
		}
		else if (initLigne) {
			ajouterLigne("I");
			initLigne = false;
		}

		calculTotaux();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#chargerCommande : ' + e);
  }
}

function init_tree_temp() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_com_client.tmpl&ContentType=xml&Com_Id="+ com_id +"&Temp=true";
    load_rdf_async('articles', getUrlOpeneas(paramlist), afterRefreshArticles);

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#init_tree_temp : ' + e);
  }
}

function visualiserCommande() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("La commande ne contient aucune ligne !");
		}
		else {

			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&EtatAffaire="+ urlEncode(ParamValeur("EtatAffaire"));
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

			var page = "chrome://opensi/content/facturation/user/affaires/com_client.xul?"+ cookie() +"&Com_Id="+ com_id +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#visualiserCommande : ' + e);
  }
}


function editerCommentaire() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var rank = getCellText(tree,tree.view.selection.currentIndex,'ColRank');

			var url = "chrome://opensi/content/facturation/user/affaires/commentaire.xul?"+ cookie() +"&Com_Id="+ com_id +"&Rank="+ rank;
    	window.openDialog(url,'','chrome,modal');

			delete_tree();
			init_tree_temp();
			ajouterLigne("I");
			setModifie(true);
		}
		else {
			showWarning("Aucun article ou commentaire slectionn !");
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#editerCommentaire : ' + e);
  }
}


function evaluer(elem, ev) {	
	try {
		
		if (ev.keyCode==13) {			
			var nf = new NumberFormat("0.00##", false);
			elem.value = nf.format(calcExpr(elem.value));
		}
		
	}	catch(e) {
		recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#evaluer : ' + e);
	}
}


function retour_affaire() {
  try {

    var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?"+ cookie() +"&Mode=M&Affaire_Id="+ affaire_id;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#retour_affaire : ' + e);
  }
}

function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_commande.js#retour_menu_principal : ' + e);
  }
}
