/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var facture_id;
var client_id;
var affaire_id;
var mode;
var com_id;
var gen;
var mode_fact;
var tva_port;
var type_remise = 'P';


function init() {
  try {

		var paramlist = "&Page=Facturation/GetRDF/liste_reglements.tmpl&ContentType=xml";
    load_rdf_async('Mode_Reg', getUrlOpeneas(paramlist), init_2);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#init : ' + e);
	}
}


function init_2() {
	try {

		com_id = ParamValeur("ComValide");
		affaire_id = ParamValeur("Affaire_Id");

		document.getElementById("Raison_Sociale").value = ParamValeur("Raison_Sociale");
		document.getElementById("Adresse_Fact").value = ParamValeur("Adresse_Fact");
		document.getElementById("CP_Fact").value = ParamValeur("CP_Fact");
		document.getElementById("Ville_Fact").value = ParamValeur("Ville_Fact");
		client_id = ParamValeur("Client_Id");
		document.getElementById("Client").setAttribute("label","Client N "+ client_id);
		document.getElementById("Affaire").setAttribute("label","Affaire N "+ ParamValeur("Num_Affaire"));
		document.getElementById("Nom_Affaire").value = ParamValeur("Nom_Affaire");
		document.getElementById("Responsable").value = ParamValeur("Responsable");
		mode_fact = ParamValeur("Type_Fact");

		window.parent.addEventListener("close",demandeEnregistrement,false);

		mode = ParamValeur("Mode");

		if (mode=="C") {
			creer_facture();
		}
		else {
			facture_id = ParamValeur("Facture_Id");
			charger_facture();
		}

		setModifie(false);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/elems_fact.js#init_2 : ' + e);
  }
}


function desinit() {
	try {

		window.parent.removeEventListener("close",demandeEnregistrement,false);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#desinit : ' + e);
  }
}


function switchRemise() {
	try {

		if (type_remise=='P') {
			document.getElementById('bRemise').setAttribute("label", "\u20AC");
			type_remise = 'M';
		}
		else {
			document.getElementById('bRemise').setAttribute("label", "%");
			type_remise = 'P';
		}
		calculTotaux();
		setModifie(true);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/edition_devis.js#switchRemise : ' + e);
  }
}


function disableAll() {
	try {

		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('Acompte').disabled = true;
		document.getElementById('Escompte').disabled = true;
		document.getElementById('Frais_Port').disabled = true;
		document.getElementById('Remise').disabled = true;
		document.getElementById('Echeance').disabled = true;
		document.getElementById('Mode_Reg').disabled = true;
		document.getElementById('Commentaires').disabled = true;
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('bRemise').disabled = true;
		mode = "V";

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#disableAll : ' + e);
  }
}


function creer_facture() {
  try {

		var corps = cookie() +"&Page=Facturation/Affaires/creerFacture.tmpl&ContentType=xml&Com_Id="+ com_id +"&Client_Id="+ client_id +"&Affaire_Id="+ affaire_id;

		if (mode_fact=="B") {
			corps += "&Bon_Id="+ ParamValeur("Bon_Id");
		}

		var p = requeteHTTP(corps);

		facture_id = p.responseXML.documentElement.getAttribute("Facture_Id");

		charger_facture();

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/edition_facture.js#creer_facture : ' + e);
  }
}


function charger_facture() {
  try {

		init_tree_facture();

		mode = "M";

		var corps = cookie() +"&Page=Facturation/Affaires/getFacture.tmpl&ContentType=xml&Facture_Id="+ facture_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		var numero = contenu.getAttribute("Numero");

		if (numero==0) {
			gen = false;
		}
		else {
			gen = true;
			disableAll();
		}

		document.getElementById('Date_Facture').value = contenu.getAttribute("Date_Facture");
		document.getElementById('Commentaires').value = contenu.getAttribute("Commentaires");
		document.getElementById('Numero').value = contenu.getAttribute('Num_Entier');
		document.getElementById('Imp_Com').checked = contenu.getAttribute("Imp_Com")=="1";
		document.getElementById('Echeance').value = contenu.getAttribute("Echeance");
		document.getElementById('Mode_Reg').value = contenu.getAttribute("Mode_Reg");
		document.getElementById('Acompte').value = contenu.getAttribute("Acompte");
		document.getElementById('Escompte').value = contenu.getAttribute("Escompte");
		document.getElementById('Remise').value = contenu.getAttribute("Remise");
		type_remise = contenu.getAttribute('Type_Remise');
		document.getElementById('bRemise').setAttribute("label", (type_remise=='P'?"%":"\u20AC"));
		document.getElementById('Frais_Port').value = contenu.getAttribute("Frais_Port");
		tva_port = contenu.getAttribute("Taux_TVA_Port");

		document.getElementById('Creation').label = "Facture cre le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "Facture N "+ contenu.getAttribute('Num_Entier');
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		setModifie(false);

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/edition_facture.js#charger_facture : ' + e);
  }
}


function enregistrerFacture() {
  try {

		var corps = cookie() +"&Page=Facturation/Affaires/modifierFacture.tmpl&ContentType=xml&Facture_Id="+ facture_id;

		var echeance = document.getElementById('Echeance').value;
		var acompte = document.getElementById('Acompte').value;
		var escompte = document.getElementById('Escompte').value;
		var remise = document.getElementById('Remise').value;
		var taux_remise = 0;
		var montant_remise = 0;
		var frais_port = document.getElementById('Frais_Port').value;

		if (isEmpty(echeance)) {
			showWarning("Vous devez indiquer une date d'chance avant d'enregistrer la facture !");
		}
		else if (!isDate(echeance)) {
			showWarning("Date d'chance incorrecte !");
		}
		else if (isEmpty(acompte) || !isPositiveOrNull(acompte)) { showWarning("Montant d'acompte incorrect !"); }
		else if (isEmpty(frais_port) || !isPositiveOrNull(frais_port)) { showWarning("Montant des frais de port incorrect !"); }
		else if (isEmpty(remise) || (type_remise=='P'?!isTaux(remise):!isPositiveOrNull(remise))) { showWarning("Remise incorrecte !"); }
		else if (isEmpty(escompte) || !isPositiveOrNull(escompte)) { showWarning("Taux d'escompte incorrect !"); }
		else {
		
			if (type_remise=='P') {
				taux_remise = remise;
			}
			else {
				var montant_ht = document.getElementById('MontantHT').value;
				taux_remise = (montant_ht>0?remise/montant_ht*100:0);
				montant_remise = remise;
			}
		
			corps += "&Affaire_Id="+ affaire_id;
			corps += "&Commentaires="+ urlEncode(document.getElementById('Commentaires').value);
			corps += "&Imp_Com="+ (document.getElementById('Imp_Com').checked?"1":"0");
			corps += "&Mode_Reg="+ urlEncode(document.getElementById('Mode_Reg').value);
			corps += "&Echeance="+ prepareDateJava(echeance);
			corps += "&Acompte="+ acompte;
			corps += "&Escompte="+ escompte;
			corps += "&Frais_Port="+ frais_port;
			corps += "&Taux_Remise="+ taux_remise;
			corps += "&Montant_Remise="+ montant_remise;
			corps += "&Total_HT="+ document.getElementById('TotalHT').value;
			corps += "&Montant_TTC="+ document.getElementById('MontantTTC').value;

			var p = requeteHTTP(corps);

			setModifie(false);
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#enregistrerFacture : ' + e);
  }
}


function demandeEnregistrement() {
  try {

		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes  la facture ?")) {
				enregistrerFacture();
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#demandeEnregistrement : ' + e);
	}
}


function setModifie(m) {
  try {

		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelFacture').setAttribute("label","Facture (modifie)");
			document.getElementById('bVisualiser').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelFacture').setAttribute("label","Facture");
			document.getElementById('bVisualiser').disabled = false;
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#setModifie : ' + e);
	}
}


function init_tree_facture() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_facture.tmpl&ContentType=xml&Facture_Id="+ facture_id;
    load_rdf_async('facture', getUrlOpeneas(paramlist), calculTotaux);

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#init_tree_facture : ' + e);
  }
}


function delete_tree_facture() {
  try {

    var database = document.getElementById("facture").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('facture').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#delete_tree_facture : ' + e);
  }
}


function visualiserFacture() {
  try {

		var numero = document.getElementById("Numero").value;
		var tree = document.getElementById("facture");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("La facture ne contient aucune ligne !");
		}
		else if (gen || window.confirm("Confirmez-vous la gnration de la facture ?\n(Attention la facture gnre ne pourra plus tre modifie !)")) {
			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&ComValide="+ ParamValeur("ComValide");
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

			var page = "chrome://opensi/content/facturation/user/affaires/facture.xul?"+ cookie() +"&Com_Id="+ com_id +"&Affaire_Id="+ affaire_id +"&Facture_Id="+ facture_id +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#visualiserFacture : ' + e);
  }
}


function calculTotaux() {
  try {

		var remise = parseFloat(document.getElementById('Remise').value);
		var taux_escompte = parseFloat(document.getElementById('Escompte').value);
		var frais_port = parseFloat(document.getElementById('Frais_Port').value);
		var acompte = parseFloat(document.getElementById('Acompte').value);

		if ((type_remise=='P'?isTaux(remise):isPositiveOrNull(remise)) && isTaux(taux_escompte) && isPositiveOrNull(frais_port) && isPositiveOrNull(acompte)) {

			var tree = document.getElementById("facture");

			var montant_tva = 0;
			var montant_ht = 0;

			if (tree.view!=null) {

				for (var i=0;i<tree.view.rowCount;i++) {

					if (getCellText(tree,i,'ColType_LigneFact')!="C") {

						montant_ht += parseFloat(getCellText(tree,i,'ColTotalFact'));

						montant_tva += parseFloat(getCellText(tree,i,'ColTotalFact')) * getCellText(tree,i,'ColTauxTVAFact')/100;

					}
				}
			}

			var taux_remise = (type_remise=='P'?remise:(montant_ht==0?0:remise/montant_ht*100));
			
			var montant_remise = montant_ht * parseFloat(taux_remise/100);

			var total_ht = montant_ht * (1 - parseFloat(taux_remise/100)) + frais_port;

			montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100);

			var montant_ttc = total_ht + montant_tva;

			var montant_escompte = formatNombre(montant_ttc * parseFloat(taux_escompte/100), "0.00");

			var total_ttc = montant_ttc - montant_escompte - acompte;

			document.getElementById('MontantHT').value = formatNombre(montant_ht,"0.00");
			document.getElementById('MontantRemise').value = formatNombre(montant_remise,"0.00");
			document.getElementById('MontantFrais_Port').value = formatNombre(frais_port,"0.00");
			document.getElementById('TotalHT').value = formatNombre(total_ht,"0.00");
			document.getElementById('TVA').value = formatNombre(montant_tva,"0.00");
			document.getElementById('MontantTTC').value = formatNombre(montant_ttc,"0.00");
			document.getElementById('MontantAcompte').value = formatNombre(acompte,"0.00");
			document.getElementById('MontantEscompte').value = formatNombre(montant_escompte,"0.00");
			document.getElementById('TotalTTC').value = formatNombre(total_ttc,"0.00");
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#calculTotaux : ' + e);
	}
}


function retour_affaire() {
  try {

    var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?"+ cookie() +"&Mode=M&Affaire_Id="+ affaire_id;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#retour_affaire : ' + e);
  }
}


function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ urlEncode(parent.document.getElementById("nom_dossier").value);
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_facture.js#retour_menu_principal : ' + e);
  }
}
