/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var bon_id;
var client_id;
var affaire_id;
var mode;
var com_id;
var etat_bon;


function init() {
  try {

		com_id = ParamValeur("ComValide");
		affaire_id = ParamValeur("Affaire_Id");

		document.getElementById("Raison_Sociale").value = ParamValeur("Raison_Sociale");
		document.getElementById("Adresse_Fact").value = ParamValeur("Adresse_Fact");
		document.getElementById("CP_Fact").value = ParamValeur("CP_Fact");
		document.getElementById("Ville_Fact").value = ParamValeur("Ville_Fact");
		client_id = ParamValeur("Client_Id");
		document.getElementById("Client").setAttribute("label","Client N "+ client_id);
		document.getElementById("Affaire").setAttribute("label","Affaire N "+ ParamValeur("Num_Affaire"));
		document.getElementById("Nom_Affaire").value = ParamValeur("Nom_Affaire");
		document.getElementById("Responsable").value = ParamValeur("Responsable");

		window.parent.addEventListener("close",demandeEnregistrement,false);

		mode = ParamValeur("Mode");

		if (mode=="C") {
			nouveau_bon();
		}
		else {
			bon_id = ParamValeur("Bon_Id");
			charger_bon();
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#init : ' + e);
	}
}


function desinit() {
	try {

		window.parent.removeEventListener("close",demandeEnregistrement,false);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#desinit : ' + e);
  }
}


function reporterQteEntree() {
	try {

		var tree = document.getElementById('commande');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById("QteEntree").value = getCellText(tree,tree.view.selection.currentIndex,'ColQuantiteDev');
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#reporterQteEntree : ' + e);
  }
}


function reporterQteSortie() {
	try {

		var tree = document.getElementById('bon_livraison');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById("QteSortie").value = getCellText(tree,tree.view.selection.currentIndex,'ColQuantiteLiv');
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#reporterQteSortie : ' + e);
  }
}


function disableAjouter(b,arbre) {
	try {

		var tree = document.getElementById('commande');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1 && mode!="V")) {
			document.getElementById('bAjouter').disabled = b;
			document.getElementById('QteEntree').disabled = b;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#disableAjouter : ' + e);
  }
}


function disableEnlever(b,arbre) {
	try {

		var tree = document.getElementById('bon_livraison');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1 && mode!="V")) {
			document.getElementById('bEnlever').disabled = b;
			document.getElementById('QteSortie').disabled = b;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#disableEnlever : ' + e);
  }
}


function disableAll() {
	try {

		document.getElementById('bToutEnlever').disabled = true;
		document.getElementById('bToutAjouter').disabled = true;
		disableAjouter(true,false);
		disableEnlever(true,false);
		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bValider').disabled = true;
		document.getElementById('Commentaires').disabled = true;
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('Nb_Colis').disabled = true;
		document.getElementById('Frais_Sup').disabled = true;
		document.getElementById('Receptionnaire').disabled = true;
		document.getElementById('chercher_adresse').collapsed = true;
		document.getElementById('corps_commande').collapsed = true;
		document.getElementById('corps_transfert').collapsed = true;
		document.getElementById('titre_corps').collapsed = true;
		mode = "V";

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#disableAll : ' + e);
  }
}


function nouveau_bon() {
  try {

		mode = "C";

		document.getElementById('bToutEnlever').disabled = true;
		disableAjouter(true,false);
		disableEnlever(true,false);

		document.getElementById('Nom_Liv').value = "";
		document.getElementById('Adresse_Liv').value = "";
		document.getElementById('Comp_Adresse_Liv').value = "";
		document.getElementById('Adresse_3_Liv').value = "";
		document.getElementById('CP_Liv').value = "";
		document.getElementById('Ville_Liv').value = "";
		document.getElementById('Pays_Liv').value = "";
		document.getElementById('Receptionnaire').value = "";
		document.getElementById('Commentaires').value = "";
		document.getElementById('Date_Liv').value = "";
		document.getElementById('Numero').value = "";
		document.getElementById('Imp_Com').checked = false;
		document.getElementById('Nb_Colis').value = "";
		document.getElementById('Frais_Sup').value = "0.00";

		document.getElementById('Creation').label = "";
		document.getElementById('Modification').label = "";
		document.getElementById('Creation').collapsed = true;
		document.getElementById('Modification').collapsed = true;
		document.getElementById('Fiche').label = "";
		document.getElementById('Etat').label = "En cours";

		var corps = cookie() +"&Page=Facturation/Affaires/getDefaultAdresse.tmpl&ContentType=xml&Affaire_Id="+ affaire_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		document.getElementById('Nom_Liv').value = contenu.getAttribute('Raison_Sociale');
		document.getElementById('Adresse_Liv').value = contenu.getAttribute('Adresse');
		document.getElementById('Comp_Adresse_Liv').value = contenu.getAttribute('Comp_Adresse');
		document.getElementById('Adresse_3_Liv').value = contenu.getAttribute('Adresse_3');
		document.getElementById('CP_Liv').value = contenu.getAttribute('Code_Postal');
		document.getElementById('Ville_Liv').value = contenu.getAttribute('Ville');
		document.getElementById('Pays_Liv').value = contenu.getAttribute('Pays');
		document.getElementById('Receptionnaire').value = contenu.getAttribute('Receptionnaire');

		delete_tree_commande();
		delete_tree_bon();
		init_tree_commande();

		setModifie(false);
		document.getElementById('bVisualiser').disabled = true;
		document.getElementById('bValider').disabled = true;
		document.getElementById('bColisage').disabled = true;

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/edition_livraison.js#nouveau_bon : ' + e);
  }
}


function charger_bon() {
  try {

		var corps = cookie() +"&Page=Facturation/Affaires/loadArticleBonTemp.tmpl&ContentType=xml&Bon_Id="+ bon_id;

		var p = requeteHTTP(corps);

		delete_tree_commande();
		init_tree_commande();

		delete_tree_bon();
		init_tree_bon();

		mode = "M";
		document.getElementById('bToutEnlever').disabled = false;

		var corps = cookie() +"&Page=Facturation/Affaires/getBonLivraison.tmpl&ContentType=xml&Bon_Id="+ bon_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		if (contenu.getAttribute("Etat")=="V") {
			disableAll();
			etat_bon = 'V';
			document.getElementById('Etat').value = "Valid";
		}
		else {
			etat_bon = 'N';
			document.getElementById('Etat').value = "En cours";
		}

		document.getElementById('Date_Liv').value = contenu.getAttribute("Date_Liv");
		document.getElementById('Nom_Liv').value = contenu.getAttribute("Nom_Liv");
		document.getElementById('Adresse_Liv').value = contenu.getAttribute("Adresse_Liv");
		document.getElementById('Comp_Adresse_Liv').value = contenu.getAttribute("Comp_Adresse_Liv");
		document.getElementById('Adresse_3_Liv').value = contenu.getAttribute("Adresse_3_Liv");
		document.getElementById('Ville_Liv').value = contenu.getAttribute("Ville_Liv");
		document.getElementById('CP_Liv').value = contenu.getAttribute("CP_Liv");
		document.getElementById('Pays_Liv').value = contenu.getAttribute("Pays_Liv");
		document.getElementById('Commentaires').value = contenu.getAttribute("Commentaires");
		document.getElementById('Numero').value = contenu.getAttribute("Num_Entier");
		document.getElementById('Receptionnaire').value = contenu.getAttribute("Receptionnaire");
		document.getElementById('Imp_Com').checked = contenu.getAttribute("Imp_Com")=="1";
		document.getElementById('Nb_Colis').value = contenu.getAttribute("Nb_Colis");
		document.getElementById('Frais_Sup').value = contenu.getAttribute("Frais_Sup");

		document.getElementById('Creation').label = "Bon de livraison cr le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "Bon N "+ contenu.getAttribute('Num_Entier');
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		setModifie(false);

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/edition_livraison.js#charger_bon : ' + e);
  }
}


function enregistrerBon() {
  try {

		var corps;

		if (mode=="C") {
			corps = cookie() +"&Page=Facturation/Affaires/creerBonLivraison.tmpl&ContentType=xml";
		}
		else {
			corps = cookie() +"&Page=Facturation/Affaires/modifierBonLivraison.tmpl&ContentType=xml&Bon_Id="+ bon_id;
		}

		var nom_liv = document.getElementById('Nom_Liv').value;
		var nb_colis = document.getElementById('Nb_Colis').value;
		var frais_sup = document.getElementById('Frais_Sup').value;

		corps += "&Nom_Liv="+ urlEncode(nom_liv);
		corps += "&Affaire_Id="+ affaire_id;
		corps += "&Adresse_Liv="+ urlEncode(document.getElementById('Adresse_Liv').value);
		corps += "&Comp_Adresse_Liv="+ urlEncode(document.getElementById('Comp_Adresse_Liv').value);
		corps += "&Adresse_3_Liv="+ urlEncode(document.getElementById('Adresse_3_Liv').value);
		corps += "&CP_Liv="+ urlEncode(document.getElementById('CP_Liv').value);
		corps += "&Ville_Liv="+ urlEncode(document.getElementById('Ville_Liv').value);
		corps += "&Pays_Liv="+ urlEncode(document.getElementById('Pays_Liv').value);
		corps += "&Commentaires="+ urlEncode(document.getElementById('Commentaires').value);
		corps += "&Imp_Com="+ (document.getElementById('Imp_Com').checked?"1":"0");
		corps += "&Receptionnaire="+ urlEncode(document.getElementById('Receptionnaire').value);
		corps += "&Nb_Colis="+ nb_colis;
		corps += "&Frais_Sup="+ frais_sup;


		if (isEmpty(nom_liv)) {
			showWarning("Vous devez choisir une adresse de livraison avant d'enregistrer le bon !");
		}
		else if (!isEmpty(nb_colis) && !isPositiveOrNullInteger(nb_colis)) {
			showWarning("Nombre de colis incorrect !");
		}
		else if (isEmpty(frais_sup) || !isPositiveOrNull(frais_sup)) {
			showWarning("Frais de port supplmentaires incorrects !");
		}
		else {
			var p = requeteHTTP(corps);

			var contenu = p.responseXML.documentElement;

			if (mode=="C") {
				bon_id = contenu.getAttribute("Bon_Id");
				charger_bon();
			}

			if (mode=="M") {
				corps = cookie() +"&Page=Facturation/Affaires/saveArticleBonTemp.tmpl&ContentType=xml&Bon_Id="+ bon_id;
				requeteHTTP(corps);
			}

			setModifie(false);
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/edition_livraison.js#enregistrerBon : ' + e);
  }
}


function ToutTransferer() {
  try {

		if (mode=="C") {
			enregistrerBon();
		}

		corps = cookie() +"&Page=Facturation/Affaires/ajouterToutBon.tmpl&ContentType=xml&Bon_Id="+ bon_id +"&Com_Id="+ com_id;
		requeteHTTP(corps);

		delete_tree_commande();
		init_tree_commande();

		delete_tree_bon();
		init_tree_bon();
		setModifie(true);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#ToutTransferer : ' + e);
	}
}


function ToutEnlever() {
  try {

		corps = cookie() +"&Page=Facturation/Affaires/enleverToutBon.tmpl&ContentType=xml&Bon_Id="+ bon_id;
		requeteHTTP(corps);

		delete_tree_commande();
		init_tree_commande();

		delete_tree_bon();
		init_tree_bon();
		setModifie(true);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#ToutEnlever : ' + e);
	}
}


function Ajouter() {
  try {

		var tree = document.getElementById("commande");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var ligne = getCellText(tree,tree.view.selection.currentIndex,'ColLigneDev');
			var qteinit = getCellText(tree,tree.view.selection.currentIndex,'ColQuantiteDev');
			var quantite = document.getElementById("QteEntree").value;

			if (isEmpty(quantite)) {
				showWarning("Veuillez entrer une quantit  transfrer");
			}
			else if (!isPositive(quantite) || !checkDecimal(quantite,2)) {
				showWarning("Quantit incorrecte !");
			}
			else {

				var continuer = true;

				if (parseFloat(qteinit)-parseFloat(quantite)<0) {
					continuer = window.confirm("La quantit  transfrer dpasse la quantit restant  livrer !\n\nVoulez-vous vraiment livrer plus que la quantit commande ?");
				}

				if (continuer) {

					if (mode=="C") enregistrerBon();

					var corps = cookie() +"&Page=Facturation/Affaires/ajouterArticleBon.tmpl&ContentType=xml&Bon_Id="+ bon_id +"&Ligne="+ ligne +"&Quantite="+ quantite;
					var httpRequest = new XMLHttpRequest();
					requeteHTTP(corps, httpRequest, Ajouter_2);
				}
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#Ajouter : ' + e);
	}
}

function Ajouter_2() {
  try {

		delete_tree_commande();
		init_tree_commande();

		delete_tree_bon();
		init_tree_bon();
		setModifie(true);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#Ajouter_2 : ' + e);
	}
}


function Enlever() {
  try {

		var tree = document.getElementById("bon_livraison");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var ligne = getCellText(tree,tree.view.selection.currentIndex,'ColLigneLiv');
			var qteinit = getCellText(tree,tree.view.selection.currentIndex,'ColQuantiteLiv');
			var quantite = document.getElementById("QteSortie").value;

			if (isEmpty(quantite)) {
				showWarning("Veuillez entrer une quantit  enlever");
			}
			else if (!isPositive(quantite) || !checkDecimal(quantite,2)) {
				showWarning("Quantit incorrecte !");
			}
			else if (parseFloat(qteinit)-parseFloat(quantite)<0) {
				showWarning("La quantit  enlever ne peut dpasser la quantit prsente dans le bon de livraison !");
			}
			else {
				corps = cookie() +"&Page=Facturation/Affaires/enleverArticleBon.tmpl&ContentType=xml&Bon_Id="+ bon_id +"&Ligne="+ ligne +"&QteInit="+ qteinit +"&Quantite="+ quantite;
				requeteHTTP(corps);

				delete_tree_commande();
				init_tree_commande();

				delete_tree_bon();
				init_tree_bon();
				setModifie(true);
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#Enlever : ' + e);
	}
}


function demandeEnregistrement() {
  try {

		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes au bon de livraison ?")) {
				enregistrerBon();
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#demandeEnregistrement : ' + e);
	}
}


function setModifie(m) {
  try {

		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelBon').setAttribute("label","Bon de livraison (modifi)");
			document.getElementById('bValider').disabled = true;
			document.getElementById('bVisualiser').disabled = true;
			document.getElementById('bColisage').disabled = true;
			document.getElementById('bEditionBP').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelBon').setAttribute("label","Bon de livraison");
			document.getElementById('bValider').disabled = (etat_bon=='V');
			document.getElementById('bValider').collapsed = (etat_bon=='V');
			document.getElementById('bVisualiser').disabled = false;
			document.getElementById('bVisualiser').collapsed = (etat_bon!='V');
			document.getElementById('bColisage').disabled = false;
			document.getElementById('bEditionBP').disabled = false;
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#setModifie : ' + e);
	}
}


function init_tree_commande() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_a_livrer.tmpl&ContentType=xml&Com_Id="+ com_id;
		if (mode=="M") {
			paramlist += "&Bon_Id="+ bon_id;
		}
    load_rdf('commande', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#init_tree_commande : ' + e);
  }
}

function delete_tree_commande() {
  try {

    var database = document.getElementById("commande").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('commande').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#delete_tree_commande : ' + e);
  }
}


function init_tree_bon() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_bon.tmpl&ContentType=xml&Bon_Id="+ bon_id;
    load_rdf('bon_livraison', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#init_tree_bon : ' + e);
  }
}

function delete_tree_bon() {
  try {

    var database = document.getElementById("bon_livraison").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('bon_livraison').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#delete_tree_bon : ' + e);
  }
}


function visualiserBon() {
  try {

		var tree = document.getElementById("bon_livraison");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le bon de livraison ne contient aucune ligne !");
		}
		else {
			//if (gen || window.confirm("Confirmez-vous la gnration du bon de livraison ?\n(Attention le bon de livraison gnr ne pourra plus tre modifi !)")) {
			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&ComValide="+ ParamValeur("ComValide");
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

			//var solder = (document.getElementById('Solder').checked?"1":"0");

			var page = "chrome://opensi/content/facturation/user/affaires/bon_livraison.xul?"+ cookie();// +"&Solder="+ solder;
			page += "&Com_Id="+ ParamValeur("ComValide") +"&Affaire_Id="+ affaire_id +"&Bon_Id="+ bon_id +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#visualiserBon : ' + e);
  }
}


function validerBon() {
  try {

		var tree = document.getElementById("bon_livraison");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le bon de livraison ne contient aucune ligne !");
		}
		else if (window.confirm("Confirmez-vous la validation du bon de livraison ?\n(Attention le bon de livraison valid ne pourra plus tre modifi !)")) {
			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&ComValide="+ ParamValeur("ComValide");
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

			var solder = (document.getElementById('Solder').checked?"1":"0");

			var page = "chrome://opensi/content/facturation/user/affaires/bon_livraison.xul?"+ cookie() +"&Solder="+ solder +"&Valider=1";
			page += "&Com_Id="+ ParamValeur("ComValide") +"&Affaire_Id="+ affaire_id +"&Bon_Id="+ bon_id +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#validerBon : ' + e);
  }
}


function rechercherAdresse() {
  try {

		var url = "chrome://opensi/content/facturation/user/affaires/choix_adresse.xul?"+ cookie() +"&Client_Id="+ urlEncode(client_id);
    window.openDialog(url,'','chrome,modal');

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/affaires/fiche_affaire.js#rechercherAdresse : ' + e);
  }
}


function colisage() {
  try {
		var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
		param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
		param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
		param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
		param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
		param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
		param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
		param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
		param_retour += "&ComValide="+ ParamValeur("ComValide");
		param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

    var page = "chrome://opensi/content/facturation/user/affaires/colisage.xul?"+ cookie() +"&Bon_Id="+ bon_id +"&ParamRetour="+ urlEncode(param_retour);
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#colisage : ' + e);
  }
}


function editionBP() {
  try {

		var tree = document.getElementById("bon_livraison");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le bon de livraison ne contient aucune ligne !");
		}
		else {

			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&ComValide="+ ParamValeur("ComValide");
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

    	var page = "chrome://opensi/content/facturation/user/affaires/bon_preparation.xul?"+ cookie() +"&Bon_Id="+ bon_id +"&ParamRetour="+ urlEncode(param_retour);
    	window.location = page;
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#editionBP : ' + e);
  }
}


function retour_affaire() {
  try {

    var page = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?"+ cookie() +"&Mode=M&Affaire_Id="+ affaire_id;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#retour_affaire : ' + e);
  }
}


function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/affaires/edition_livraison.js#retour_menu_principal : ' + e);
  }
}
