/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {

		nouveauBanque();
		window.parent.document.getElementById('Loaded').setAttribute('label',nocache());

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#init : ' + e);
  }
}


function makeIBAN() {
	try {

		var suite_iban = document.getElementById('Code_Agence').value;
		suite_iban += document.getElementById('Code_Guichet').value;
		suite_iban += document.getElementById('Num_Compte').value;
		suite_iban += document.getElementById('Cle_RIB').value;

		document.getElementById('IBAN_Suite').value = suite_iban;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#makeIBAN : ' + e);
  }
}


function nouveauBanque() {
	try {

		// initialisation valeurs par dfaut
		document.getElementById('Nom').value = "";
		document.getElementById('Adresse').value = "";
		document.getElementById('Code_Agence').value = "";
		document.getElementById('Code_Guichet').value = "";
		document.getElementById('Num_Compte').value = "";
		document.getElementById('Cle_RIB').value = "";
		document.getElementById('IBAN').value = "";
		document.getElementById('BIC').value = "";
		document.getElementById('IBAN_Suite').value = "";
		document.getElementById('bNouveau').collapsed = true;
		document.getElementById('bSupprimer').collapsed = true;
		document.getElementById('bModifier').collapsed = true;
		document.getElementById('bCreer').collapsed = false;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#nouveauBanque : ' + e);
  }
}


function supprimerBanque() {
	try {

		var banque_id = document.getElementById('Banque_Id').value;
		var client_id = parent.document.getElementById('Client').value;
		var nom = document.getElementById('Nom').value;

		if (window.confirm("Confirmez-vous la suppression de la banque '"+nom +"' ?")) {
			var corps = cookie() + "&Page=Facturation/Clients/supprimerBanqueClient.tmpl&ContentType=text&Client_Id="+ client_id +"&Banque_Id="+ banque_id;

			var p = requeteHTTP(corps);

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		}
			else {
				document.getElementById('bSupprimer').collapsed = true;
				document.getElementById('bModifier').collapsed = true;
				document.getElementById('bCreer').collapsed = false;
				document.getElementById('bNouveau').collapsed = true;
				delete_tree();
				init_tree();
				nouveauBanque();
  		}
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#supprimerBanque : ' + e);
  }
}


function enregistrerBanque(mode) {
	try {

		var client_id = parent.document.getElementById('Client').value;
		var nom = document.getElementById('Nom').value;
		var adresse = document.getElementById('Adresse').value;
		var code_agence = document.getElementById('Code_Agence').value;
		var code_guichet = document.getElementById('Code_Guichet').value;
		var num_compte = document.getElementById('Num_Compte').value;
		var cle_rib = document.getElementById('Cle_RIB').value;
		var iban = document.getElementById('IBAN').value;
		var bic = document.getElementById('BIC').value;
		var bban = makeBBAN(code_agence, code_guichet, num_compte, cle_rib);

		var corps;

		if (mode=="C") {
			corps = cookie() +"&Page=Facturation/Clients/creerBanqueClient.tmpl&ContentType=xml";
		}
		else {
			var banque_id = document.getElementById('Banque_Id').value;
			corps = cookie() +"&Page=Facturation/Clients/modifierBanqueClient.tmpl&ContentType=text&Banque_Id="+ banque_id;
		}

		corps += "&Client_Id="+ urlEncode(client_id) +"&Nom="+ urlEncode(nom) +"&Adresse="+ urlEncode(adresse) +"&Code_Agence="+ code_agence;
		corps += "&Code_Guichet="+ code_guichet +"&Num_Compte="+ num_compte +"&Cle_RIB="+ cle_rib +"&IBAN="+ iban +"&BIC="+ bic;

		if (isEmpty(nom)) { showWarning("Veuillez spcifier le nom de la banque !"); }
		else if (isEmpty(adresse)) { showWarning("Veuillez spcifier la domiciliation"); }
		else if (isEmpty(code_agence)) { showWarning("Veuillez spcifier le code agence !"); }
		else if (isEmpty(code_guichet)) { showWarning("Veuillez spcifier le code guichet !"); }
		else if (isEmpty(num_compte)) { showWarning("Veuillez spcifier le numro de compte !"); }
		else if (isEmpty(cle_rib)) { showWarning("Veuillez spcifier la cl de RIB !"); }

		else if (!isCodeAgence(code_agence)) { showWarning("Code agence incorrect !"); }
		else if (!isCodeGuichet(code_guichet)) { showWarning("Code guichet incorrect !"); }
		else if (!isNumCompte(num_compte)) { showWarning("Numro de compte incorrect !"); }
		else if (!isCleRIB(cle_rib)) { showWarning("Cl de RIB incorrect !"); }
		else if (!isEmpty(iban) && !isPrefIBAN(iban)) { showWarning("IBAN incorrect !"); }
		else if (!isEmpty(bic) && !isBIC(bic)) { showWarning("BIC incorrect !"); }
		else if (!verifCleRIB(cle_rib, bban)) { showWarning("Echec du contrle de la cl de RIB ! Erreur probable sur Numro de compte, Code agence ou Code guichet"); }
		else if (!isEmpty(iban) && !verifCleIBAN(iban.substring(2,4), iban, bban)) { showWarning("Echec du contrle de la cl IBAN ! Erreur probable sur Numro IBAN, Numro de compte, Code agence ou Code guichet"); }

		else {
			var p = requeteHTTP(corps);

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		}
			else {
				if (mode=="C") {
					contenu = p.responseXML.documentElement;

					document.getElementById('Banque_Id').value = contenu.getAttribute('Banque_Id');
					document.getElementById('bCreer').collapsed = true;
					document.getElementById('bModifier').collapsed = false;
					document.getElementById('bNouveau').collapsed = false;
					document.getElementById('bSupprimer').collapsed = false;
				}

				delete_tree();
				init_tree();
  		}
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#enregistrerBanque : ' + e);
  }
}


function pressOnTree(e) {
	try {
		switch(e.keyCode){
      case 13: // 'Enter'
        chargerBanque();
        break;
    }
 	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#pressOnTree : ' + e);
  }
}

function chargerBanque() {
	try {

		var tree = document.getElementById('liste_banques');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var banque_id = getCellValue(tree,tree.view.selection.currentIndex,'ColNom');
			var client_id = parent.document.getElementById('Client').value;
			var corps = cookie() +"&Page=Facturation/Clients/getBanqueClient.tmpl&ContentType=xml&Banque_Id="+ banque_id +"&Client_Id="+ client_id;

			var p = requeteHTTP(corps);

  		if (p.status != "200") {
      	alert("Rception erreur " + p.status);
  		}
			else {

      	var contenu = p.responseXML.documentElement;

				document.getElementById('Banque_Id').value = contenu.getAttribute('Banque_Id');
				document.getElementById('Nom').value = contenu.getAttribute('Nom');
				document.getElementById('Adresse').value = contenu.getAttribute('Adresse');
				document.getElementById('Code_Agence').value = contenu.getAttribute('Code_Agence');
				document.getElementById('Code_Guichet').value = contenu.getAttribute('Code_Guichet');
				document.getElementById('Num_Compte').value = contenu.getAttribute('Num_Compte');
				document.getElementById('Cle_RIB').value = contenu.getAttribute('Cle_RIB');
				document.getElementById('IBAN').value = contenu.getAttribute('IBAN');
				document.getElementById('BIC').value = contenu.getAttribute('BIC');
				document.getElementById('bSupprimer').collapsed = false;
				document.getElementById('bModifier').collapsed = false;
				document.getElementById('bNouveau').collapsed = false;
				document.getElementById('bCreer').collapsed = true;
				makeIBAN();
  		}
		}

 	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#chargerBanque : ' + e);
  }
}


function init_tree() {
  try {

    var client_id = parent.document.getElementById('Client').value;

    var paramlist = "&Page=Facturation/GetRDF/banques_clients.tmpl&ContentType=xml&Client_Id="+ client_id;
    load_rdf('liste_banques', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {

    var database = document.getElementById("liste_banques").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('liste_banques').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/banques_client.js#delete_tree : ' + e);
  }
}
