/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
  try {

		window.parent.document.getElementById('Loaded').setAttribute('label',nocache());

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/historique.js#init: ' + e);
  }
}


function verifPlageDates() {
  try {

	 	document.getElementById('Periode').selectedItem = document.getElementById('PeriodeP');

    var date_debut = document.getElementById('Date_Debut').value;
		var date_fin = document.getElementById('Date_Fin').value;

		if (isEmpty(date_debut)) {
			showWarning("Vous devez indiquer une date de dbut de priode !");
		}
		else if (isEmpty(date_fin)) {
			showWarning("Vous devez indiquer une date de fin de priode !");
		}
		else if (!isDate(date_debut)) {
			showWarning("Date de dbut de priode incorrecte !");
		}
		else if (!isDate(date_fin)) {
			showWarning("Date de fin de priode incorrecte !");
		}
		else if (!isDateInterval(date_debut,date_fin)) {
			showWarning("Plage de dates incorrecte !");
		}
		else {
			delete_tree();
   		init_tree("P");
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/historique.js#verifPlageDates : ' + e);
  }
}

function loadHisto() {
  try {

	 	var periode = document.getElementById('Periode').value;
	 	delete_tree();
		init_tree(periode);

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/historique.js#loadHisto : ' + e);
  }
}

function selectPerso() {
  try {

	 	document.getElementById('Periode').selectedItem = document.getElementById('PeriodeP');

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/historique.js#selectPerso : ' + e);
  }
}


function calculCA() {
  try {

	 	var tree = document.getElementById('histo');

		var ca = 0;

		if (tree.view!=null) {
			for (var i=0; i<tree.view.rowCount; i++) {

				ca += parseFloat(getCellText(tree,i,'ColTotal_HT'));
			}
		}

		document.getElementById('cap').value = formatNombre(ca, "0.00");

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/historique.js#calculCA : ' + e);
  }
}


function delete_tree() {
  try {

    var database = document.getElementById("histo").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('histo').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/historique.js#delete_tree : ' + e);
  }
}

function init_tree(periode) {
  try {

    var client_id = parent.document.getElementById('Client').value;

    var paramlist = "&Page=Facturation/GetRDF/historique_client.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id) +"&Periode="+ periode;

		if (periode=="P") {
			var date_debut = document.getElementById('Date_Debut').value;
			var date_fin = document.getElementById('Date_Fin').value;
			paramlist += "&Date_Debut="+ prepareDateJava(date_debut) +"&Date_Fin="+ prepareDateJava(date_fin);
		}

    load_rdf_async('histo', getUrlOpeneas(paramlist), calculCA);

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/historique.js#init_tree: ' + e);
  }
}

/*function pressOnTree(ev) {
	try {
		switch(ev.keyCode){
      case 13: // 'Enter'
        afficherAffaire();
        break;
    }
 	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/historique.js#pressOnTree : ' + e);
  }
}*/

