/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {

  	nouveauAdresse();
		window.parent.document.getElementById('Loaded').setAttribute('label',nocache());

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/livraison#init : ' + e);
  }
}


function nouveauAdresse() {
	try {

		// initialisation valeurs par dfaut
		document.getElementById('Nom').value = "";
		document.getElementById('Raison_Sociale').value = "";
		document.getElementById('Adresse').value = "";
		document.getElementById('Comp_Adresse').value = "";
		document.getElementById('Adresse_3').value = "";
		document.getElementById('Code_Postal').value = "";
		document.getElementById('Ville').value = "";
		document.getElementById('Pays').value = "";
		document.getElementById('Defaut').checked = false;

		document.getElementById('bNouveau').collapsed = true;
		document.getElementById('bSupprimer').collapsed = true;
		document.getElementById('bModifier').collapsed = true;
		document.getElementById('bCreer').collapsed = false;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/livraison#nouveauAdresse : ' + e);
  }
}


function pressOnTree(e) {
	try {
		switch(e.keyCode){
      case 13: // 'Enter'
        chargerAdresse();
        break;
    }
 	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/livraison.js#pressOnTree : ' + e);
  }
}


function init_tree() {
  try {

	  var client_id = parent.document.getElementById("Client").value;
    var paramlist ="&Page=Facturation/GetRDF/adresses_livraison.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id);
    load_rdf('liste_adresses', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/livraison.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {

    var database = document.getElementById("liste_adresses").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('liste_adresses').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/livraison.js#delete_tree : ' + e);
  }
}


function enregistrerAdresse(mode) {
  try {

		var client_id = parent.document.getElementById("Client").value;
    var raison_sociale = document.getElementById('Raison_Sociale').value;
		var nom = document.getElementById('Nom').value;
		var adresse = document.getElementById('Adresse').value;
		var comp_adresse = document.getElementById('Comp_Adresse').value;
		var adresse_3 = document.getElementById('Adresse_3').value;
		var code_postal = document.getElementById('Code_Postal').value;
		var ville = document.getElementById('Ville').value;
		var pays = document.getElementById('Pays').value;
		var defaut = (document.getElementById('Defaut').checked?"1":"0");

		var corps;

		if (mode=="C") {
			corps = cookie() +"&Page=Facturation/Clients/creerAdresse.tmpl&ContentType=xml";
		}
		else {
			var num_adresse = document.getElementById('Num_Adresse').value;
			corps = cookie() +"&Page=Facturation/Clients/modifierAdresse.tmpl&ContentType=text&Num_Adresse="+ num_adresse;
		}

		corps += "&Client_Id="+ urlEncode(client_id) +"&Nom="+ urlEncode(nom) +"&Raison_Sociale="+ urlEncode(raison_sociale) +"&Comp_Adresse="+ urlEncode(comp_adresse);
		corps += "&Adresse="+ urlEncode(adresse) +"&Code_Postal="+ urlEncode(code_postal) +"&Ville="+ urlEncode(ville) +"&Pays="+ urlEncode(pays) +"&Defaut="+ defaut;
		corps += "&Adresse_3="+ urlEncode(adresse_3);

				 if (isEmpty(raison_sociale)) { showWarning("Veuillez spcifier la raison sociale de l'entreprise  livrer !"); }
		else if (isEmpty(adresse)) { showWarning("Veuillez spcifier l'adresse de livraison !"); }
		else if (isEmpty(code_postal)) { showWarning("Veuillez spcifier le code postal de livraison !"); }
		else if (isEmpty(ville)) { showWarning("Veuillez spcifier la ville de livraison !"); }

		else {
			var p = requeteHTTP(corps);

			if (mode=="C") {
				contenu = p.responseXML.documentElement;

				document.getElementById('Num_Adresse').value = contenu.getAttribute('Num_Adresse');

				document.getElementById('bCreer').collapsed = true;
				document.getElementById('bModifier').collapsed = false;
				document.getElementById('bNouveau').collapsed = false;
				document.getElementById('bSupprimer').collapsed = false;
			}

			delete_tree();
			init_tree();
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/livraison#enregistrerAdresse : ' + e);
  }
}


function supprimerAdresse() {
	try {

		var tree = document.getElementById('liste_adresses');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var num_adresse = document.getElementById('Num_Adresse').value;
			var client_id = parent.document.getElementById("Client").value;
			var raison_sociale = document.getElementById('Raison_Sociale').value;

			if (window.confirm("Confirmez-vous la suppression de l'adresse '"+ raison_sociale +"' ?")) {
				var corps = cookie() +"&Page=Facturation/Clients/supprimerAdresse.tmpl&ContentType=text&Client_Id="+ client_id +"&Num_Adresse="+ num_adresse;

				var p = requeteHTTP(corps);

				document.getElementById('bSupprimer').collapsed = true;
				document.getElementById('bModifier').collapsed = true;
				document.getElementById('bCreer').collapsed = false;
				document.getElementById('bNouveau').collapsed = true;
				delete_tree();
				init_tree();
				nouveauAdresse();
			}
		}
		else {
			showWarning("Impossible de supprimer l'adresse ! (1 adresse de livraison minimum)");
		}

  } catch (e) {
  	recup_erreur('erreur dans facturation/user/clients/livraison.js#supprimerAdresse : ' + e);
  }
}


function chargerAdresse() {
	try {

		var tree = document.getElementById('liste_adresses');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var num_adresse = getCellValue(tree,tree.currentIndex, 'ColRaison');

			var client_id = parent.document.getElementById("Client").value;

			var corps = cookie() +"&Page=Facturation/Clients/afficherAdresse.tmpl&ContentType=xml&Num_Adresse="+ num_adresse +"&Client_Id="+ urlEncode(client_id);

			var p = requeteHTTP(corps);

    	contenu = p.responseXML.documentElement;

			document.getElementById('Num_Adresse').value = contenu.getAttribute('Num_Adresse');
			document.getElementById('Nom').value = contenu.getAttribute('Nom');
			document.getElementById('Raison_Sociale').value = contenu.getAttribute('Raison_Sociale');
			document.getElementById('Adresse').value = contenu.getAttribute('Adresse');
			document.getElementById('Comp_Adresse').value = contenu.getAttribute('Comp_Adresse');
			document.getElementById('Adresse_3').value = contenu.getAttribute('Adresse_3');
			document.getElementById('Code_Postal').value = contenu.getAttribute('Code_Postal');
			document.getElementById('Ville').value = contenu.getAttribute('Ville');
			document.getElementById('Pays').value = contenu.getAttribute('Pays');
			document.getElementById('Defaut').checked = (contenu.getAttribute('Defaut')==1);

			document.getElementById('bSupprimer').collapsed = false;
			document.getElementById('bModifier').collapsed = false;
			document.getElementById('bNouveau').collapsed = false;
			document.getElementById('bCreer').collapsed = true;
		}

 	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/livraison.js#chargerAdresse : ' + e);
  }
}

