/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var mode_ligne;


function initContenuTarifs() {
  try {

		formatLigne("N");

		document.getElementById('Reference').value = "";
		document.getElementById('Designation').value = "";
		document.getElementById('Prix_Achat').value = "";
		document.getElementById('Taux_TVA').value = "";
		document.getElementById('Prix_HT').value = "";
		document.getElementById('Prix_TTC').value = "";
		document.getElementById('Coeff').value = "";
		document.getElementById('BasePrix_HT').value = "";
		document.getElementById('BasePrix_TTC').value = "";

		delete_tree_tarifs();
		init_tree_tarifs();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#initContenuTarifs : ' + e);
  }
}


function validerTarif() {
  try {

		var client_id = document.getElementById('Client').value;
		var article_id = document.getElementById('Reference').value;
		var prix_ht = document.getElementById('Prix_HT').value;
		var coeff = document.getElementById('Coeff').value;
		coeff = coeff/100 +1;

		if (isEmpty(prix_ht) || !isPositiveOrNull(prix_ht) || !checkDecimal(prix_ht,4)) {
			showWarning("Prix de vente HT incorrect !");
		}
		else {

			var corps = cookie() +"&Page=Facturation/Clients/"+ (mode_ligne=="C"?"creerArticleTarif.tmpl":"modifierArticleTarif.tmpl") +"&ContentType=xml";
			corps += "&Client_Id="+ urlEncode(client_id) +"&Article_Id="+ urlEncode(article_id) +"&Prix_HT="+ prix_ht +"&Coeff="+ coeff;

			var httpRequest = new XMLHttpRequest();

			requeteHTTP(corps, httpRequest, validerTarif_2);
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#validerTarif : ' + e);
  }
}


function validerTarif_2() {
  try {

		formatLigne("M");

		delete_tree_tarifs();
		init_tree_tarifs();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#validerTarif_2 : ' + e);
  }
}


function supprimerTarif() {
  try {

		var client_id = document.getElementById('Client').value;
		var article_id = document.getElementById('Reference').value;

		var corps = cookie() +"&Page=Facturation/Clients/supprimerArticleTarif.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id);
		corps += "&Client_Id="+ urlEncode(client_id);

		var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps, httpRequest, supprimerTarif_2);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#supprimerTarif : ' + e);
  }
}


function supprimerTarif_2() {
  try {

		formatLigne("N");

		document.getElementById('Reference').value = "";
		document.getElementById('Designation').value = "";
		document.getElementById('Prix_Achat').value = "";
		document.getElementById('Taux_TVA').value = "";
		document.getElementById('Prix_HT').value = "";
		document.getElementById('Prix_TTC').value = "";
		document.getElementById('Coeff').value = "";
		document.getElementById('BasePrix_HT').value = "";
		document.getElementById('BasePrix_TTC').value = "";

		delete_tree_tarifs();
		init_tree_tarifs();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#supprimerTarif_2 : ' + e);
  }
}


function nouveauTarif() {
  try {

		var url = "chrome://opensi/content/facturation/user/stocks/rech_stocks.xul?"+ cookie() +"&Nouv=false&Modif_Action=false&Field_Article=Reference";
		window.openDialog(url,'','chrome,modal');

		var article_id = document.getElementById('Reference').value;

		if (!isEmpty(article_id)) {

			if (existeTarifClient(article_id)) {
				showWarning("Cet article est dj prsent dans la liste");
			}
			else {
				
				var client_id = document.getElementById('Client').value;
		  	var corps = cookie() +"&Page=Facturation/Clients/getArticleTarif.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id) +"&Client_Id="+ urlEncode(client_id);
				var httpRequest = new XMLHttpRequest();

				requeteHTTP(corps, httpRequest, nouveauTarif_2);
			}
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#nouveauTarif : ' + e);
  }
}


function nouveauTarif_2(httpRequest) {
  try {

		var nf = new NumberFormat("0.00##", true);

		var contenu = httpRequest.responseXML.documentElement;

		document.getElementById('Designation').value = contenu.getAttribute('Designation');
		document.getElementById('Prix_Achat').value = nf.format(contenu.getAttribute('Prix_Achat'));
		document.getElementById('Taux_TVA').value = contenu.getAttribute('Taux_TVA');

		document.getElementById('Prix_HT').value = "";
		document.getElementById('Prix_TTC').value = "";
		document.getElementById('Coeff').value = "";
		document.getElementById('BasePrix_HT').value = nf.format(contenu.getAttribute('BasePrix_HT')); 
		document.getElementById('BasePrix_TTC').value = nf.format(contenu.getAttribute('BasePrix_TTC'));

		formatLigne("C");

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#nouveauTarif_2 : ' + e);
  }
}


function reporterTarif() {
  try {
		
		var nf = new NumberFormat("0.00##", false);
		
		var tree = document.getElementById('tarifs');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById('Reference').value = getCellText(tree,tree.currentIndex,'ColArticle_Id');
			document.getElementById('Designation').value = getCellText(tree,tree.currentIndex,'ColDesignation');
			document.getElementById('Prix_Achat').value = getCellText(tree,tree.currentIndex,'ColPrix_Achat');
			document.getElementById('Prix_HT').value = nf.format(getCellText(tree,tree.currentIndex,'ColPrix_HT'));
			document.getElementById('Taux_TVA').value = getCellText(tree,tree.currentIndex,'ColTaux_TVA');
			document.getElementById('Prix_TTC').value = nf.format(getCellText(tree,tree.currentIndex,'ColPrix_TTC'));
			document.getElementById('Coeff').value = getCellText(tree,tree.currentIndex,'ColCoeff');
			document.getElementById('BasePrix_HT').value = getCellText(tree,tree.currentIndex,'ColTarif_HT');
			document.getElementById('BasePrix_TTC').value = getCellText(tree,tree.currentIndex,'ColTarif_TTC');

			formatLigne("M");
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#reporterTarif : ' + e);
  }
}


function existeTarifClient(article_id) {
  try {

		var client_id = document.getElementById('Client').value;

		var corps = cookie() +"&Page=Facturation/Clients/existeTarifClient.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id) +"&Article_Id="+ urlEncode(article_id);
		var p = requeteHTTP(corps);

 		return p.responseXML.documentElement.getAttribute('existe')=="true";

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#existeTarifClient : ' + e);
  }
}


function delete_tree_tarifs() {
  try {

    var database = document.getElementById("tarifs").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('tarifs').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#delete_tree_tarifs : ' + e);
  }
}


function init_tree_tarifs() {
  try {

    var client_id = document.getElementById('Client').value;

    var paramlist = "&Page=Facturation/GetRDF/tarifs_client.tmpl&ContentType=xml&Client_Id="+ urlEncode(client_id);
    load_rdf('tarifs', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#init_tree_tarifs: ' + e);
  }
}


function calculerTarif(t) {
  try {

		var nfht = new NumberFormat("0.00##", false);

		var tva = parseFloat(document.getElementById('Taux_TVA').value)/100 + 1;
		var anTarif = document.getElementById('BasePrix_HT').value;

		var pr = document.getElementById('Prix_Achat').value;

		if (t=="h") {
			var pvht = parseFloat(document.getElementById('Prix_HT').value);
			document.getElementById('Prix_TTC').value = formatNombre(pvht * tva, "0.00");
			document.getElementById('Coeff').value = formatNombre(((pvht/anTarif)-1) * 100, "0.00");
		}
		else if (t=="t") {
			var pvht = parseFloat(document.getElementById('Prix_TTC').value) / tva;
			document.getElementById('Prix_HT').value = nfht.format(pvht);
			document.getElementById('Coeff').value = formatNombre(((pvht/anTarif)-1) * 100, "0.00");
		}
		else if (t=="c") {
			var pvht = anTarif * ((parseFloat(document.getElementById('Coeff').value)/100)+1);
			document.getElementById('Prix_HT').value = nfht.format(pvht);
			document.getElementById('Prix_TTC').value = formatNombre(pvht * tva, "0.00");
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#calculerTarif : ' + e);
	}
}


function formatLigne(typeLigne) {
  try {

		mode_ligne = typeLigne;

		if (typeLigne=="C") {
			document.getElementById('bSupprimerTarif').disabled = true;
			document.getElementById('bValiderTarif').disabled = false;
			document.getElementById('Prix_HT').disabled = false;
			document.getElementById('Prix_TTC').disabled = false;
			document.getElementById('Coeff').disabled = false;
		}
		else if (typeLigne=="M") {
			document.getElementById('bSupprimerTarif').disabled = false;
			document.getElementById('bValiderTarif').disabled = false;
			document.getElementById('Prix_HT').disabled = false;
			document.getElementById('Prix_TTC').disabled = false;
			document.getElementById('Coeff').disabled = false;
		}
		else {
			document.getElementById('bSupprimerTarif').disabled = true;
			document.getElementById('bValiderTarif').disabled = true;
			document.getElementById('Prix_HT').disabled = true;
			document.getElementById('Prix_TTC').disabled = true;
			document.getElementById('Coeff').disabled = true;
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#formatLigne : ' + e);
	}
}


function traitement_lot() {
	try {
	
		var client_id = document.getElementById('Client').value;
		var url = "chrome://opensi/content/facturation/user/clients/traitement_lot.xul?"+ cookie();
		window.openDialog(url,'Traitement par lot','chrome,modal',client_id,recharge_arbre);
	
	}	catch(e) {
		recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#traitement_lot : ' + e);
	}
}


function recharge_arbre() {
	try {
		
		delete_tree_tarifs();
		init_tree_tarifs();
	
	}	catch(e) {
		recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#recharge_arbre : ' + e);
	}
}


function change_affiche() {
	try {
		
		var ledeck = document.getElementById("switchboite");
		var lebouton = document.getElementById("changeur_affiche");
		if (ledeck.selectedIndex == 0) {
			lebouton.setAttribute("label","Afficher Tableau");
			ledeck.selectedIndex = 1;
			document.getElementById('bTraitementLot').collapsed = true;
			init_pdf();
		}
		else {
			lebouton.setAttribute("label","Editer les tarifs spcifiques");
			ledeck.selectedIndex = 0;
			document.getElementById('bTraitementLot').collapsed = false;
		}
	
	}	catch(e) {
		recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#editer_tarifs : ' + e);
	}
}


function init_pdf() {
	try {	
	
		var clientId = document.getElementById('Client').value;
		var page = cookie() +"&Page=Facturation/Clients/redirectPdfMajTarifsSpe.tmpl&Client_Id="+ urlEncode(clientId);
		document.getElementById("pdf").setAttribute("src",getUrlOpeneas(page));
	
	}	catch(e) {
		recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#init_pdf : ' + e);
	}
}


