/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var modif = false; //controle si des modifications ont t apportes

var listeFamille = new Arbre("fact","familles_article.tmpl","Famille");
var listeMarque = new Arbre("fact","marques_article.tmpl","Marque");
var listeCollection = new Arbre("fact","collections_article.tmpl","Collection");
var listeCouleur = new Arbre("fact","couleurs_article.tmpl","Couleur");
var listeTaille = new Arbre("fact","tailles_article.tmpl","Taille");
var listeSousFamille = new Arbre("fact","sousfamilles_article.tmpl","Sous_Famille");

var arbreArticles = new Arbre("fact","liste_articles_tarifs.tmpl","articles");
var clientId;
var tree;

var calcul_possible = false;


function init() {
	try {

		window.addEventListener("close",fermer,false);

		listeFamille.initTree();
		listeMarque.initTree();
		listeCollection.initTree();
		listeCouleur.initTree();
		listeTaille.initTree();

		tree = document.getElementById("articles");
		clientId = window.arguments[0];

		document.getElementById('Article_Id').focus();

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#init : ' + e);
	}
}


function initFamille() {
	try {

		document.getElementById('Famille').selectedIndex = 0;
		chargerSousFamilles();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#initFamille : ' + e);
  }
}


function chargerSousFamilles() {
	try {

		listeSousFamille.clearParams();
		listeSousFamille.addParam("Famille",document.getElementById('Famille').value);
		listeSousFamille.initTree();

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#chargerSousFamilles : ' + e);
	}
}


function selSousFamille() {
	try {

		document.getElementById('Sous_Famille').selectedIndex = 0;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#selSousFamille : ' + e);
	}
}


function initMarque() {
	try {

		document.getElementById('Marque').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#initMarque : ' + e);
  }
}


function initCollection() {
	try {

		document.getElementById('Collection').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#initCollection : ' + e);
  }
}


function initCouleur() {
	try {

		document.getElementById('Couleur').selectedIndex = 0;

	}	catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#initCouleur : ' + e);
	}
}


function initTaille() {
	try {

		document.getElementById('Taille').selectedIndex = 0;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#initTaille : ' + e);
	}
}


function pressOnId(ev) {
	try {

		if (ev.keyCode==13) {

			var code_article = document.getElementById('Article_Id').value;

			if (existeArticle(code_article))
				ouvrirArticle(code_article);
			else
				rechercher();
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#pressOnId : ' + e);
	}
}


function pressOnNom(ev) {
  try {

    if (ev.keyCode==13) {
			rechercher();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#pressOnNom : ' + e);
  }
}


function pressOnFamille() {
  try {

		rechercher();
		chargerSousFamilles();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#pressOnFamille : ' + e);
  }
}


function existeArticle(code_article) {
	try {

		var corps = cookie() +"&Page=Facturation/Stocks/existeArticle.tmpl&ContentType=xml&Article_Id="+ urlEncode(code_article);
		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;
		return (contenu.getAttribute('existe')=="true" && contenu.getAttribute('supprime')=="false");

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#existeArticle : ' + e);
	}
}


function choixArticle() {
	try {

		if (tree.view!=null && tree.currentIndex!=-1) {

			var code_article = getCellText(tree,tree.currentIndex, 'ColArticle_Id');
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#reporterId : ' + e);
	}
}


function rechercher() {
	try {

		arbreArticles.clearParams();

		var param = document.getElementById("Article_Id").value;
		arbreArticles.addParam("Article_Id",param);

		param = document.getElementById("Designation").value;
		arbreArticles.addParam("Designation",param);

		param = document.getElementById("Marque").value;
		arbreArticles.addParam("Marque",param);

		param = document.getElementById("Famille").value;
		arbreArticles.addParam("Famille",param);

		param = document.getElementById("Sous_Famille").value;
		arbreArticles.addParam("Sous_Famille",param);

		param = document.getElementById("Collection").value;
		arbreArticles.addParam("Collection",param);

		param = document.getElementById("Couleur").value;
		arbreArticles.addParam("Couleur",param);

		param = document.getElementById("Taille").value;
		arbreArticles.addParam("Taille",param);

		arbreArticles.addParam("Client_Id",clientId);

		arbreArticles.initTree();

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#rechercher : ' + e);
	}
}


function reinitialiser() {
	try {

		arbreArticles.deleteTree();

		document.getElementById('Article_Id').value = "";
		document.getElementById('Designation').value = "";
		document.getElementById('Marque').selectedIndex = 0;
		document.getElementById('Famille').selectedIndex = 0;
		document.getElementById('Sous_Famille').selectedIndex = 0;
		document.getElementById('Collection').selectedIndex = 0;
		document.getElementById('Couleur').selectedIndex = 0;
		document.getElementById('Taille').selectedIndex = 0;
		efface_champ();

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#reinitialiser : ' + e);
	}
}


function select_all() {
	try {
		
		if (tree.view!=null) {
			tree.view.selection.selectAll();
		}

	}	catch(e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#select_all : ' + e);
	}
}


function deselect_all() {
	try {

		tree.view.selection.clearSelection();

	}	catch(e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#select_all : ' + e);
	}
}


function remplit_champ() {
	try {

		efface_champ();
		if (tree.view!=null &&tree.view.selection.count != 0) {
			if ( tree.view.selection.count == 1 ){
				document.getElementById("infoart").collapsed = false;
				document.getElementById("nb_article_mod").collapsed = true;
				document.getElementById('Reference').value = getCellText(tree,tree.currentIndex,'ColArticle_Id');
				document.getElementById('Desig').value = getCellText(tree,tree.currentIndex,'ColDesignation');
				document.getElementById('PrixAchat').value = getCellText(tree,tree.currentIndex,'ColPrixAchat');
				calcul_possible = true;
			}
			else {
				document.getElementById("infoart").collapsed = true;
				document.getElementById("nb_article_mod").collapsed = false;

				document.getElementById('Reference').value = "";
				document.getElementById('Desig').value = "";
				document.getElementById('PrixAchat').value = "";
				document.getElementById("label_article_mod").value = " Nouveau tarif pour les "+tree.view.selection.count+" articles slectionns : ";
				calcul_possible = false;
			}
		}
		else {
			document.getElementById("infoart").collapsed = false;
			document.getElementById("nb_article_mod").collapsed = true;
			document.getElementById('Reference').value = "";
			document.getElementById('Desig').value = "";
			document.getElementById('PrixAchat').value = "";
			calcul_possible = false;
		}

	}	catch(e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#remplit_champ : ' + e);
	}
}


function efface_champ() {
	try {

		document.getElementById('Prix_HT').value = "";
		document.getElementById('Prix_TTC').value = "";
		document.getElementById('Coeff').value = "";

	}	catch(e){
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#efface_champ : ' + e);
	}
}


function calculerTarif(t) {
	try {

		if (calcul_possible) {
			var tva = parseFloat(getCellText(tree,tree.view.selection.currentIndex,"ColTVA"))/100 + 1;

			var pr = parseFloat(getCellText(tree,tree.view.selection.currentIndex,"ColPrixAchat"));
			var th = parseFloat(getCellText(tree,tree.view.selection.currentIndex,"ColTarif"));

			if (t=="h") {
				var pvht = parseFloat(document.getElementById('Prix_HT').value);
				document.getElementById('Prix_TTC').value = formatNombre(pvht * tva, "0.00");
				document.getElementById('Coeff').value = formatNombre(((pvht/th)-1)*100, "0.00");
			}
			else if (t=="t") {
				var pvht = parseFloat(document.getElementById('Prix_TTC').value / tva );
				document.getElementById('Prix_HT').value = formatNombre(pvht, "0.00");
				document.getElementById('Coeff').value = formatNombre(((pvht/th)-1)*100, "0.00");
			}
			else if (t=="m") {
				var coeff = parseFloat( (document.getElementById('Coeff').value/100) + 1);
				var pvht = parseFloat(th * coeff);
				document.getElementById('Prix_HT').value = formatNombre(pvht, "0.00");
				document.getElementById('Prix_TTC').value = formatNombre(pvht * tva, "0.00");
			}
		}
		else {
			if (t=="h") {
				document.getElementById('Prix_TTC').value = "";
				document.getElementById('Coeff').value = "";
			}
			else if (t=="t") {
				document.getElementById('Prix_HT').value = "";
				document.getElementById('Coeff').value = "";
			}
			else if (t=="m") {
				document.getElementById('Prix_HT').value = "";
				document.getElementById('Prix_TTC').value = "";
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/clients/tarifs_client.js#calculerTarif : ' + e);
	}
}


function valider() {
	try {

		var prixHT = document.getElementById("Prix_HT").value;
		var prixTTC = document.getElementById("Prix_TTC").value;
		var coeff = document.getElementById("Coeff").value;

		if (isNaN(prixTTC) ||isNaN(prixHT) ||isNaN(coeff)) {
			showWarning("Valeur incorrecte");
		}
		else {
			var nb = 0;
			
			var mod;

			if (isEmpty(prixTTC)) {
				nb++;
			}
			else {
				mod = 't';
			}

			if (isEmpty(prixHT)) {
				nb++;
			}
			else {
				mod = 'h';
			}

			if (isEmpty(coeff)) {
				nb++;
			}
			else {
				mod = 'c';
			}

			if (nb==3) {
				showWarning("Les champs ne sont pas remplis");
			}
			else {
				if (checkDecimal(prixHT,4) && checkDecimal(prixTTC,4) && checkDecimal(coeff,5)) {
					if (calcul_possible) {

						var articleId = getCellText(tree,tree.view.selection.currentIndex,"ColArticle_Id");

						var corps = cookie() +"&Page=Facturation/Clients/creerTarifSpecLot.tmpl&ContentType=xml";
						corps += "&Type=1&Client_Id="+ urlEncode(clientId);
						corps += "&Prix_HT="+ prixHT +"&Coeff="+ coeff;
						corps += "&Article_Id="+ urlEncode(articleId);

						requeteHTTP(corps);
						arbreArticles.initTree();
						modif = true;
					}
					else {
						if (nb == 2) {
						
							var it = 0;
							var listeArticlesSelect = new Array();
							var rangCompte = tree.view.selection.getRangeCount();
							
							var start = {};
							var end = {};

							for (var i=0;i<rangCompte;i++){
								tree.view.selection.getRangeAt(i,start,end);
								for (var j=start.value;j<=end.value;j++){
									listeArticlesSelect[it] = getCellText(tree,j,"ColArticle_Id");
									it++;
								}
							}

							var corps = cookie() +"&Page=Facturation/Clients/creerTarifSpecLot.tmpl&ContentType=xml";
							corps += "&Type=2&Client_Id="+ urlEncode(clientId);
							corps += "&Liste_Articles_Select="+ listeArticlesSelect;

							switch(mod) {
								case 't':
									corps += "&Prix_TTC="+ prixTTC;
									break;
								case 'h':
									corps += "&Prix_HT="+ prixHT;
									break;
								case 'c':
									corps += "&Coeff="+ coeff;
									break;
							}
							
							requeteHTTP(corps);
							arbreArticles.initTree();
							modif = true;
						}
						else {
							showWarning("Vous ne pouvez remplir qu'un seul champ");
						}
					}
				}
				else {
					showWarning("Vos valeurs comportent trop de dcimales. Le maximum est de 4 dcimales pour les tarifs et de 5 pour les coefficients");
				}
			}
		}

	}	catch(e) {
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#valider : ' + e);
	}
}


function fermer() {
	try {

		if (modif) {
			window.arguments[1]();
		}
		window.close();

	}	catch(e){
		recup_erreur('erreur dans facturation/user/clients/traitement_lot.js#fermer : ' + e);
	}
}












