/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var br_id;
var commande_id;
var fournisseur_id;
var mode;
var etat_br;


function init() {
  try {

		commande_id = ParamValeur("Commande_Id");
		fournisseur_id = ParamValeur("Fournisseur_Id");
		
		document.getElementById("Fournisseur").setAttribute("label","Fournisseur N "+ fournisseur_id);		

		window.parent.addEventListener("close",demandeEnregistrement,false);
		
		var corps = cookie() +"&Page=Facturation/Commandes/getCommande.tmpl&ContentType=xml&Commande_Id="+ commande_id;
		var p = requeteHTTP(corps);
		var contenu = p.responseXML.documentElement;

		document.getElementById('Login_Resp').value = contenu.getAttribute('Login_Createur');
		document.getElementById('Date_Commande').value = contenu.getAttribute('Date_Commande');
		
		var etat = contenu.getAttribute('Etat');
		
		if (etat=="V") {		
			document.getElementById('Etat_Commande').value = "En cours de rception";
			var corps = cookie() +"&Page=Facturation/Commandes/getBREnCours.tmpl&ContentType=xml&Commande_Id="+ commande_id;
			var p = requeteHTTP(corps);
			var brEnCours = p.responseXML.documentElement.getAttribute('BR_Id');

			if (isEmpty(brEnCours)) {
				nouveauBR();
			}
			else {
				br_id = brEnCours;
				chargerBR();
			}
		}
		else {
			document.getElementById('Etat_Commande').value = "Termine";
			document.getElementById('bNouveauBR').disabled = true;
			document.getElementById('bVisualiser').disabled = true;
			disableAll();
		}
		
		init_tree_brs();
		afficheInfoFournisseur();		

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/commandes/edition_br.js#init : ' + e);
	}
}


function desinit() {
	try {

		window.parent.removeEventListener("close",demandeEnregistrement,false);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#desinit : ' + e);
  }
}


function afficheInfoFournisseur() {
	try {

    var corps = cookie() +"&Page=Facturation/Fournisseurs/getFournisseur.tmpl&ContentType=xml&Fournisseur_Id="+ fournisseur_id;
		var p = requeteHTTP(corps);

    var contenu = p.responseXML.documentElement;
		document.getElementById('Raison_Sociale').value = contenu.getAttribute('Raison_Sociale');
    var adresse = contenu.getAttribute('Adresse') +" "+ contenu.getAttribute('Comp_Adresse');
		document.getElementById('Adresse').value =  adresse;
		document.getElementById('Code_Postal').value = contenu.getAttribute('Code_Postal');
		document.getElementById('Ville').value = contenu.getAttribute('Ville');

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#afficheInfoFournisseur : ' + e);
  }
}


function reporterQteEntree() {
	try {

		var tree = document.getElementById('commande');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById("QteEntree").value = getCellText(tree,tree.currentIndex,'ColQuantiteDev');;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#reporterQteEntree : ' + e);
  }
}


function reporterQteSortie() {
	try {

		var tree = document.getElementById('bon_reception');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById("QteSortie").value = getCellText(tree,tree.currentIndex,'ColQuantiteLiv');;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#reporterQteSortie : ' + e);
  }
}


function disableAjouter(b,arbre) {
	try {

		var tree = document.getElementById('commande');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1 && mode!="V")) {
			document.getElementById('bAjouter').disabled = b;
			document.getElementById('QteEntree').disabled = b;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#disableAjouter : ' + e);
  }
}


function disableEnlever(b,arbre) {
	try {

		var tree = document.getElementById('bon_reception');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1 && mode!="V")) {
			document.getElementById('bEnlever').disabled = b;
			document.getElementById('QteSortie').disabled = b;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#disableEnlever : ' + e);
  }
}


function disableAll() {
	try {

		document.getElementById('bToutEnlever').disabled = true;
		document.getElementById('bToutAjouter').disabled = true;
		disableAjouter(true,false);
		disableEnlever(true,false);
		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bValider').disabled = true;
		document.getElementById('Commentaires').disabled = true;
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('Num_BL').disabled = true;
		document.getElementById('corps_commande').collapsed = true;
		document.getElementById('corps_transfert').collapsed = true;
		document.getElementById('titre_corps').collapsed = true;
		mode = "V";

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#disableAll : ' + e);
  }
}


function nouveauBR() {
  try {

		mode = "C";

		document.getElementById('corps_commande').collapsed = false;
		document.getElementById('corps_transfert').collapsed = false;
		document.getElementById('titre_corps').collapsed = false;

		document.getElementById('bToutEnlever').disabled = true;
		document.getElementById('bToutAjouter').disabled = false;
		disableAjouter(true,false);
		disableEnlever(true,false);
		document.getElementById('bEnregistrer').disabled = false;
		document.getElementById('bValider').disabled = true;
		document.getElementById('Commentaires').disabled = false;
		document.getElementById('Imp_Com').disabled = false;
		document.getElementById('Num_BL').disabled = false;

		document.getElementById('Commentaires').value = "";
		document.getElementById('Num_BL').value = "";
		document.getElementById('Date_Reception').value = "";
		document.getElementById('Num_Entier').value = "";
		document.getElementById('Imp_Com').checked = false;
		document.getElementById('Etat').value = "Nouveau";

		document.getElementById('Creation').label = "";
		document.getElementById('Modification').label = "";
		document.getElementById('Creation').collapsed = true;
		document.getElementById('Modification').collapsed = true;
		document.getElementById('Fiche').label = "";

		delete_tree_commande();
		delete_tree_br();
		init_tree_commande();

		setModifie(false);
		document.getElementById('bVisualiser').disabled = true;
		document.getElementById('bValider').disabled = true;

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/edition_br.js#nouveauBR : ' + e);
  }
}


function catchBR() {
  try {

		var tree = document.getElementById('brs');
		
		if (tree.view!=null && tree.currentIndex!=-1) {
			
			br_id = getCellText(tree, tree.currentIndex, 'ColBR_Id');			
			chargerBR();
		}		

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/edition_br.js#catchBR : ' + e);
  }
}


function pressOnTree(ev) {
  try {
		
		if (ev.keyCode==13) {
			catchBR();
		}
	
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/edition_br.js#pressOnTree : ' + e);
  }
}


function chargerBR() {
  try {

		var corps = cookie() +"&Page=Facturation/Commandes/loadArticleBRTemp.tmpl&ContentType=xml&BR_Id="+ br_id;

		var p = requeteHTTP(corps);

		delete_tree_commande();
		init_tree_commande();

		delete_tree_br();
		init_tree_br();

		mode = "M";
		document.getElementById('bToutEnlever').disabled = false;

		var corps = cookie() +"&Page=Facturation/Commandes/getBonReception.tmpl&ContentType=xml&BR_Id="+ br_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		if (contenu.getAttribute("Etat")=="V") {
			disableAll();
			etat_br = 'V';
			document.getElementById('Etat').value = "Valid";
		}
		else {
			etat_br = 'N';
			document.getElementById('Etat').value = "En cours";
		}

		document.getElementById('Date_Reception').value = contenu.getAttribute("Date_BR");
		document.getElementById('Commentaires').value = contenu.getAttribute("Commentaires");
		document.getElementById('Num_BL').value = contenu.getAttribute("Num_BL");
		document.getElementById('Num_Entier').value = contenu.getAttribute("Num_Entier");
		document.getElementById('Imp_Com').checked = contenu.getAttribute("Imp_Com")=="1";

		document.getElementById('Creation').label = "Bon de rception cr le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "BR N "+ contenu.getAttribute('Num_Entier');
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		setModifie(false);

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/edition_br.js#chargerBR : ' + e);
  }
}


function enregistrerBR() {
  try {

		var corps;

		if (mode=="C") {
			corps = cookie() +"&Page=Facturation/Commandes/creerBonReception.tmpl&ContentType=xml";
		}
		else {
			corps = cookie() +"&Page=Facturation/Commandes/modifierBonReception.tmpl&ContentType=xml&BR_Id="+ br_id;
		}

		corps += "&Commande_Id="+ commande_id;
		corps += "&Commentaires="+ urlEncode(document.getElementById('Commentaires').value);
		corps += "&Num_BL="+ urlEncode(document.getElementById('Num_BL').value);
		corps += "&Imp_Com="+ (document.getElementById('Imp_Com').checked?"1":"0");

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		if (mode=="C") {
			br_id = contenu.getAttribute("BR_Id");
			chargerBR();
			delete_tree_brs();
			init_tree_brs();
		}

		if (mode=="M") {
			corps = cookie() +"&Page=Facturation/Commandes/saveArticleBRTemp.tmpl&ContentType=xml&BR_Id="+ br_id;
			p = requeteHTTP(corps);
		}

		setModifie(false);

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/edition_br.js#enregistrerBR : ' + e);
  }
}


function ToutTransferer() {
  try {

		if (mode=="C") {
			enregistrerBR();
		}

		var corps = cookie() +"&Page=Facturation/Commandes/ajouterToutBR.tmpl&ContentType=xml&BR_Id="+ br_id +"&Commande_Id="+ commande_id;
		var p = requeteHTTP(corps);

		delete_tree_commande();
		init_tree_commande();

		delete_tree_br();
		init_tree_br();
		setModifie(true);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/commandes/edition_br.js#ToutTransferer : ' + e);
	}
}


function ToutEnlever() {
  try {

		var corps = cookie() +"&Page=Facturation/Commandes/enleverToutBR.tmpl&ContentType=xml&BR_Id="+ br_id;
		var p = requeteHTTP(corps);

		delete_tree_commande();
		init_tree_commande();

		delete_tree_br();
		init_tree_br();
		setModifie(true);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/commandes/edition_br.js#ToutEnlever : ' + e);
	}
}


function Ajouter() {
  try {

		var tree = document.getElementById("commande");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var ligne = getCellText(tree,tree.currentIndex,'ColLigneDev');
			var qteinit = getCellText(tree,tree.currentIndex,'ColQuantiteDev');
			var quantite = document.getElementById("QteEntree").value;

			if (isEmpty(quantite)) {
				showWarning("Veuillez entrer une quantit  transfrer");
			}
			else if (!isPositive(quantite) || !checkDecimal(quantite,2)) {
				showWarning("Quantit incorrecte !");
			}
			else {

				var continuer = true;

				if (parseFloat(qteinit)-parseFloat(quantite)<0) {
					continuer = window.confirm("La quantit  transfrer dpasse la quantit restant  rceptionner !\n\nVoulez-vous vraiment rceptionner plus que la quantit commande ?");
				}

				if (continuer) {

					if (mode=="C") enregistrerBR();

					var corps = cookie() +"&Page=Facturation/Commandes/ajouterArticleBR.tmpl&ContentType=xml&BR_Id="+ br_id +"&Ligne="+ ligne +"&Quantite="+ quantite;
					var httpRequest = new XMLHttpRequest();
					requeteHTTP(corps, httpRequest, Ajouter_2);
				}
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/commandes/edition_br.js#Ajouter : ' + e);
	}
}


function Ajouter_2() {
  try {

		delete_tree_commande();
		init_tree_commande();

		delete_tree_br();
		init_tree_br();
		setModifie(true);

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/commandes/edition_br.js#Ajouter_2 : ' + e);
	}
}


function Enlever() {
  try {

		var tree = document.getElementById("bon_reception");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var ligne = getCellText(tree,tree.currentIndex,'ColLigneLiv');
			var qteinit = getCellText(tree,tree.currentIndex,'ColQuantiteLiv');
			var quantite = document.getElementById("QteSortie").value;

			if (isEmpty(quantite)) {
				showWarning("Veuillez entrer une quantit  enlever");
			}
			else if (!isPositive(quantite) || !checkDecimal(quantite,2)) {
				showWarning("Quantit incorrecte !");
			}
			else if (parseFloat(qteinit)-parseFloat(quantite)<0) {
				showWarning("La quantit  enlever ne peut dpasser la quantit prsente dans le bon de rception !");
			}
			else {
				corps = cookie() +"&Page=Facturation/Commandes/enleverArticleBR.tmpl&ContentType=xml&BR_Id="+ br_id +"&Ligne="+ ligne +"&QteInit="+ qteinit +"&Quantite="+ quantite;
				p = requeteHTTP(corps);

				delete_tree_commande();
				init_tree_commande();

				delete_tree_br();
				init_tree_br();
				setModifie(true);
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/commandes/edition_br.js#Enlever : ' + e);
	}
}


function demandeEnregistrement() {
  try {

		/*if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes au bon de rception ?")) {
				enregistrerBR();
			}
		}*/

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/commandes/edition_br.js#demandeEnregistrement : ' + e);
	}
}


function setModifie(m) {
  try {

		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelBR').setAttribute("label","Bon de rception (modifi)");
			document.getElementById('bValider').disabled = true;
			document.getElementById('bVisualiser').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelBR').setAttribute("label","Bon de rception");
			document.getElementById('bValider').disabled = (etat_br=='V');
			document.getElementById('bVisualiser').disabled = false;
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/commandes/edition_br.js#setModifie : ' + e);
	}
}


function init_tree_commande() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_a_receptionner.tmpl&ContentType=xml&Commande_Id="+ commande_id;
		if (mode=="M") {
			paramlist += "&BR_Id="+ br_id;
		}
    load_rdf('commande', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#init_tree_commande : ' + e);
  }
}


function delete_tree_commande() {
  try {

    var database = document.getElementById("commande").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('commande').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#delete_tree_commande : ' + e);
  }
}


function init_tree_br() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_br.tmpl&ContentType=xml&BR_Id="+ br_id;
    load_rdf('bon_reception', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#init_tree_br : ' + e);
  }
}


function delete_tree_br() {
  try {

    var database = document.getElementById("bon_reception").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('bon_reception').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#delete_tree_br : ' + e);
  }
}


function init_tree_brs() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/brs_commande.tmpl&ContentType=xml&Commande_Id="+ commande_id;
    load_rdf('brs', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#init_tree_brs : ' + e);
  }
}


function delete_tree_brs() {
  try {

    var database = document.getElementById("brs").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('brs').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#delete_tree_brs : ' + e);
  }
}


function visualiserBR() {
  try {

		var tree = document.getElementById("bon_reception");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le bon de rception ne contient aucune ligne !");
		}
		else {
		
			var param_retour = "&Commande_Id="+ commande_id +"&Fournisseur_Id="+ fournisseur_id;

			var page = "chrome://opensi/content/facturation/user/commandes/bon_reception.xul?"+ cookie();
			page += "&BR_Id="+ br_id +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#visualiserBR : ' + e);
  }
}


function validerBR() {
  try {

		var tree = document.getElementById("bon_reception");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le bon de rception ne contient aucune ligne !");
		}
		else if (window.confirm("Confirmez-vous la validation du bon de rception ?\n(Attention le bon de rception valid ne pourra plus tre modifi !)")) {

			var param_retour = "&Commande_Id="+ commande_id +"&Fournisseur_Id="+ fournisseur_id;

			var solder = (document.getElementById('Solder').checked?"1":"0");

			var page = "chrome://opensi/content/facturation/user/commandes/bon_reception.xul?"+ cookie() +"&Solder="+ solder +"&Valider=1";
			page += "&Commande_Id="+ commande_id +"&BR_Id="+ br_id +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#validerBR : ' + e);
  }
}


function retour_commande() {
  try {

    var page = "chrome://opensi/content/facturation/user/commandes/edition_commande.xul?"+ cookie() +"&Mode=M&Commande_Id="+ commande_id;
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#retour_commande : ' + e);
  }
}


function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ urlEncode(parent.document.getElementById("nom_dossier").value);
    window.location = page;

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/edition_br.js#retour_menu_principal : ' + e);
  }
}
