/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
  try {

  	init_tree_commandes();
		init_tree_historique();
		init_tree_receptions();
		
		var corps = cookie() +"&Page=Facturation/Commandes/getTotauxMenu.tmpl&ContentType=xml";
		var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps, httpRequest, init_2);

  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#init : ' + e);
  }
}


function init_2(httpRequest) {
  try {

		var contenu = httpRequest.responseXML.documentElement;
		document.getElementById('TotalEnCours').value = contenu.getAttribute('TotalEnCours');

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#init_2 : ' + e);
  }
}


function basculer(b) {
  try {

		document.getElementById('boxCommandes').collapsed = (b=='R');
		document.getElementById('boxReceptions').collapsed = (b=='C');

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#basculer : ' + e);
  }
}


function nouvelle_commande() {
  try {

		var page = "chrome://opensi/content/facturation/user/commandes/edition_commande.xul?"+ cookie();
    page += "&Mode=C&Etat=N";
    window.location = page;

  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#nouvelle_commande : ' + e);
  }
}


function rechercher_commande() {
  try {

		var url = "chrome://opensi/content/facturation/user/commandes/rech_commande.xul?"+ cookie();
		window.openDialog(url,'','chrome,modal');

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#rechercher_commande : ' + e);
  }
}


function pressOnCommandes(ev) {
  try {

		if (ev.keyCode==13) {
      ouvrir_commande();
    }

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#pressOnCommandes : ' + e);
  }
}


function pressOnReceptions(ev) {
  try {

		if (ev.keyCode==13) {
    	ouvrir_commande_reception();
    }

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#pressOnReceptions : ' + e);
  }
}


function pressOnHistorique(ev) {
  try {

		if (ev.keyCode==13) {
      ouvrir_commande_historique();
    }

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#pressOnHistorique : ' + e);
  }
}


function ouvrir_commande_win(commande_id) {
  try {

    var page = "chrome://opensi/content/facturation/user/commandes/edition_commande.xul?"+ cookie();
    page += "&Mode=M&Commande_Id="+ commande_id;
    window.location = page;

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#ouvrir_commande_win : ' + e);
  }
}


function ouvrir_commande() {
  try {

		var tree = document.getElementById('commandes');

		if (tree.view != null && tree.currentIndex!=-1) {

			var commande_id = getCellText(tree,tree.currentIndex,'ColCommande_Id');

			var page = "chrome://opensi/content/facturation/user/commandes/edition_commande.xul?"+ cookie();
      page += "&Commande_Id="+ commande_id;
      window.location = page;
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#ouvrir_commande : ' + e);
  }
}


function ouvrir_commande_historique() {
  try {

		var tree = document.getElementById('historique');

		if (tree.view != null && tree.currentIndex!=-1) {

			var commande_id = getCellText(tree,tree.currentIndex,'ColCommande_IdH');

			var page = "chrome://opensi/content/facturation/user/commandes/edition_commande.xul?"+ cookie();
      page += "&Commande_Id="+ commande_id;
      window.location = page;
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#ouvrir_commande_historique : ' + e);
  }
}


function ouvrir_commande_reception() {
  try {

		var tree = document.getElementById('receptions');

		if (tree.view != null && tree.currentIndex!=-1) {

			var commande_id = getCellText(tree,tree.currentIndex,'ColCommande_IdR');
			var fournisseur_id = getCellText(tree,tree.currentIndex,'ColFournisseur_IdR');

			var page = "chrome://opensi/content/facturation/user/commandes/edition_br.xul?"+ cookie();
      page += "&Commande_Id="+ commande_id;
      page += "&Fournisseur_Id="+ fournisseur_id;
      window.location = page;
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/commandes/menu_commandes.js#ouvrir_commande_reception : ' + e);
  }
}


function init_tree_commandes() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/commandes.tmpl&ContentType=xml&Etat=encours";
    load_rdf('commandes', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/menu_commandes.js#init_tree_commandes : ' + e);
  }
}


function init_tree_historique() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/commandes.tmpl&ContentType=xml&Etat=historique";
    load_rdf('historique', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/menu_commandes.js#init_tree_historique : ' + e);
  }
}


function init_tree_receptions() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/commandes.tmpl&ContentType=xml&Etat=reception";
    load_rdf('receptions', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/menu_commandes.js#init_tree_receptions : ' + e);
  }
}


function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ urlEncode(parent.document.getElementById("nom_dossier").value);
    window.location = page;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/menu_commandes.js#retour_menu_principal : ' + e);
  }
}
