/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
  try {

    var x = (screen.width / 2) - 450;
    var y = (screen.height / 2) - 250;
    window.resizeTo(900,500);
    window.moveTo(x,y);
    document.getElementById('Numero').focus();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#init : ' + e);
  }
}


function pressOnId(ev) {
  try {

    if (ev.keyCode==13) {

		 	var numero = document.getElementById('Numero').value;

			var commande_id = existeCommande(numero);

			if (commande_id!="") {
       	ouvrirCommande(commande_id);
			}
			else {
        document.getElementById('Fournisseur_Id').value = "";
        document.getElementById('Raison_Sociale').value = "";
				delete_tree();
				init_tree("&Num_Commande="+ urlEncode(document.getElementById('Numero').value));
				unloadApercu();
			}
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#pressOnId : ' + e);
  }
}


function pressOnFournisseurId(ev) {
  try {

    if (ev.keyCode==13) {

      document.getElementById('Numero').value = "";
      document.getElementById('Raison_Sociale').value = "";
			delete_tree();
			init_tree("&Fournisseur_Id="+ urlEncode(document.getElementById('Fournisseur_Id').value));
			unloadApercu();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#pressOnFournisseurId : ' + e);
  }
}


function pressOnRaisonSociale(ev) {
  try {

    if (ev.keyCode==13) {

			document.getElementById('Numero').value = "";
      document.getElementById('Fournisseur_Id').value = "";
			delete_tree();
			init_tree("&Raison_Sociale="+ urlEncode(document.getElementById('Raison_Sociale').value));
			unloadApercu();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#pressOnRaisonSociale : ' + e);
  }
}


function pressOnTree(ev) {
  try {

    if (ev.keyCode==13) {
    	choixCommande();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#pressOnTree : ' + e);
  }
}


function existeCommande(numero) {
  try {

		var corps = cookie() +"&Page=Facturation/Commandes/existeCommande.tmpl&ContentType=xml&Numero="+ urlEncode(numero);
		var p = requeteHTTP(corps);

  	return p.responseXML.documentElement.getAttribute('Commande_Id');

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#existeCommande : ' + e);
  }
}


function ouvrirCommande(commande_id) {
  try {

		window.opener.ouvrir_commande_win(commande_id);
    window.close();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#ouvrirCommande : ' + e);
  }
}


function choixCommande() {
	try {

		var tree = document.getElementById('commandes');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var commande_id = getCellText(tree,tree.currentIndex,'ColCommande_Id');

			ouvrirCommande(commande_id);
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#choixCommande : ' + e);
  }
}


function init_tree(param) {
  try {

    var paramlist = "&Page=Facturation/GetRDF/commandes.tmpl&ContentType=xml"+ param;
    load_rdf('commandes', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {

		var database = document.getElementById("commandes").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('commandes').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#delete_tree : ' + e);
  }
}


function loadApercu() {
	try {

		delete_tree_apercu();

		var tree = document.getElementById('commandes');

		if (tree.view!=null && tree.currentIndex!=-1) {
			var commande_id = getCellText(tree,tree.currentIndex,'ColCommande_Id');
			var numero = getCellText(tree,tree.currentIndex,'ColNum');
			document.getElementById('Num_Commande').value = numero;
			init_tree_apercu(commande_id);
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#loadApercu : ' + e);
  }
}


function unloadApercu() {
	try {

		document.getElementById('Num_Commande').value = "";
		delete_tree_apercu();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#unloadApercu : ' + e);
  }
}


function init_tree_apercu(commande_id) {
  try {

    var paramlist = "&Page=Facturation/GetRDF/apercu_commande_fournisseur.tmpl&ContentType=xml&Commande_Id="+ commande_id;
    load_rdf('apercu', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#init_tree_apercu : ' + e);
  }
}


function delete_tree_apercu() {
  try {

		var database = document.getElementById("apercu").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('apercu').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/commandes/rech_commande.js#delete_tree_apercu : ' + e);
  }
}
