/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
  try {

  	init_tree_devis();
		init_tree_historique();

  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/menu_devis.js#init : ' + e);
  }
}


function nouveau_devis() {
  try {

    window.location = "chrome://opensi/content/facturation/user/devis/edition_devis.xul?" + cookie() +"&Mode=C";

  } catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/menu_devis.js#nouveau_devis : ' + e);
  }
}


function rechercher_devis() {
  try {

		var url = "chrome://opensi/content/facturation/user/devis/rech_devis.xul?"+ cookie();
		window.openDialog(url,'','chrome,modal');

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/menu_devis.js#rechercher_devis : ' + e);
  }
}


function pressOnDevis(ev) {
  try {

		if (ev.keyCode==13) {
    	ouvrir_devis();
    }

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/menu_devis.js#pressOnDevis : ' + e);
  }
}


function pressOnHistorique(ev) {
  try {

		if (ev.keyCode==13) {

    	ouvrir_devis_historique();
    }

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/menu_devis.js#pressOnHistorique : ' + e);
  }
}


function ouvrir_devis_win(devis_id) {
  try {

    window.location = "chrome://opensi/content/facturation/user/devis/edition_devis.xul?" + cookie() +"&Mode=M&Devis_Id="+ devis_id;

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/menu_devis.js#ouvrir_devis_win : ' + e);
  }
}


function ouvrir_devis() {
  try {

		var tree = document.getElementById('devis');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var devis_id = getCellText(tree,tree.currentIndex,'ColDevis_Id');

    	window.location = "chrome://opensi/content/facturation/user/devis/edition_devis.xul?"+ cookie() +"&Mode=M&Devis_Id="+ devis_id;
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/menu_devis.js#ouvrir_devis : ' + e);
  }
}


function ouvrir_devis_historique() {
  try {

		var tree = document.getElementById('historique');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var devis_id = getCellText(tree,tree.currentIndex,'ColDevis_IdH');

    	window.location = "chrome://opensi/content/facturation/user/devis/edition_devis.xul?"+ cookie() +"&Mode=M&Devis_Id="+ devis_id;
		}

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/devis/menu_devis.js#ouvrir_devis_historique : ' + e);
  }
}


function init_tree_devis() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/liste_devis.tmpl&ContentType=xml&Terminees=n";
    load_rdf('devis', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/menu_devis.js#init_tree_devis : ' + e);
  }
}

function delete_tree_devis() {
  try {

    var database = document.getElementById("devis").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('devis').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/menu_devis.js#delete_tree_devis : ' + e);
  }
}

function init_tree_historique() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/liste_devis.tmpl&ContentType=xml&Terminees=y";
    load_rdf('historique', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/menu_devis.js#init_tree_historique : ' + e);
  }
}


function delete_tree_historique() {
  try {

    var database = document.getElementById("historique").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('historique').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/devis/menu_devis.js#delete_tree_historique : ' + e);
  }
}


function archiver() {
  try {

		var nb_mois = document.getElementById('Nb_Mois').value;

		if (isEmpty(nb_mois) || !isPositiveInteger(nb_mois)) {
			showWarning("Nombre de mois incorrect !");
		}
		else if (window.confirm("Confirmez-vous l'archivage des devis ?")) {

			var corps = cookie() +"&Page=Facturation/Devis/archivageDevis.tmpl&ContentType=xml&Nb_Mois="+ nb_mois;
			requeteHTTP(corps);

			showMessage("Archivage termin");
			delete_tree_historique();
			delete_tree_devis();
			init_tree_historique();
			init_tree_devis();
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/devis/menu_devis.js#archiver : ' + e);
  }
}


function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/clients/menu_devis.js#retour_menu_principal : ' + e);
  }
}
