/******************************************************************************/
/* OpenSI Comptabilit? : Outils libre de comptabilit? d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var codeEtat = 'PF';

function init() {
  try {

		var paramlist = "&Page=Facturation/GetRDF/familles_fournisseur.tmpl&ContentType=xml";
  	load_rdf_async('Famille', getUrlOpeneas(paramlist), initFamille);

    enableDates(false);
		document.getElementById('Periode').selectedItem = document.getElementById('PeriodeMC');
		document.getElementById('DetailCA').selectedItem = document.getElementById('DetailCAN');
		
		switchOptions('PF');

  } catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_fournisseurs.js#init : ' + e);
  }
}


function initFamille() {
	try {

		document.getElementById('Famille').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_fournisseurs.js#initFamille : ' + e);
  }
}


function switchOptions(etat) {
  try {

		codeEtat = etat;

		var gPeriode = document.getElementById('gPeriode');
		var gSelection = document.getElementById('gSelection');
		var gDetailCA = document.getElementById('gDetailCA');
		var gTri = document.getElementById('gTri');

		switch (etat) {
			case 'PF': gPeriode.collapsed = false;
								 gSelection.collaped = false;
								 gDetailCA.collapsed = false;
								 gTri.collapsed = true;
								 break;
			case 'LF': gPeriode.collapsed = true;
								 gSelection.collaped = false;
								 gDetailCA.collapsed = true;
								 gTri.collapsed = false;
								 break;
			case 'FF': break;
			case 'AF': break;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_fournisseurs.js#switchOptions : ' + e);
  }
}


function enableDates(b) {
	try {

		document.getElementById("DateDebut").disabled = !b;
		document.getElementById("DateFin").disabled = !b;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_fournisseurs.js#enableDates : ' + e);
  }
}


function editerPalmares() {
	try {

		var page = "chrome://opensi/content/facturation/user/editions/edition_fournisseur.xul?"+ cookie();

		var periode = document.getElementById('Periode').value;
		var detail = document.getElementById('DetailCA').value;
		var date_debut = document.getElementById('DateDebut').value;
		var date_fin = document.getElementById('DateFin').value;
		var famille = document.getElementById('Famille').value;
		var tri1 = document.getElementById('Tri1').value;
		var tri2 = document.getElementById('Tri2').value;
		var tri3 = document.getElementById('Tri3').value;

		if (codeEtat=="PF" && periode=="DD" && !isDate(date_debut)) { showWarning("Date de dbut de priode incorrecte"); }
		else if (codeEtat=="PF" && periode=="DD" && !isDate(date_fin)) { showWarning("Date de fin de priode incorrecte"); }
		else if (codeEtat=="PF" && periode=="DD" && !isDateInterval(date_debut, date_fin)) { showWarning("Plage de date incorrecte"); }
		else {

			if (periode=="DD") {
				date_fin = prepareDateJava(date_fin);
				date_debut = prepareDateJava(date_debut);
			}

			var listeParams = "&Periode="+ periode +"&Detail="+ detail;
			listeParams += "&DateDebut="+ date_debut +"&DateFin="+ date_fin;
			listeParams += "&Famille="+ urlEncode(famille);
			listeParams += "&Tri1="+ tri1 +"&Tri2="+ tri2 +"&Tri3="+ tri3;

			window.location = page + "&ListeParams="+ urlEncode(listeParams) +"&CodeEtat="+ codeEtat;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_fournisseurs.js#editerPalmares : ' + e);
  }
}


function menu_editions() {
  try {

    window.location = "chrome://opensi/content/facturation/user/editions/menu_editions.xul?"+ cookie();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_fournisseurs.js#menu_editions : ' + e);
  }
}


function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_fournisseurs.js#retour_menu_principal : ' + e);
  }
}
