/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var codeEtat = 'PA';

function init() {
  try {

		var paramlist = "&Page=Facturation/GetRDF/familles_article.tmpl&ContentType=xml";
  	load_rdf_async('Famille', getUrlOpeneas(paramlist), initFamille);

		paramlist = "&Page=Facturation/GetRDF/marques_article.tmpl&ContentType=xml";
  	load_rdf_async('Marque', getUrlOpeneas(paramlist), initMarque);

    enableDates(false);
		document.getElementById('Periode').selectedItem = document.getElementById('PeriodeMC');
	
		switchOptions('PA');

  } catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#init : ' + e);
  }
}


function initFamille() {
	try {

		document.getElementById('Famille').selectedIndex = 0;
		chargerSousFamilles();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#initFamille : ' + e);
  }
}


function initMarque() {
	try {

		document.getElementById('Marque').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#initMarque : ' + e);
  }
}


function chargerSousFamilles() {
	try {

		delete_sousfamilles();

		var paramlist = "&Page=Facturation/GetRDF/sousfamilles_article.tmpl&ContentType=xml&Famille="+ document.getElementById('Famille').value;
  	load_rdf_async('Sous_Famille', getUrlOpeneas(paramlist), selSousFamille);

	} catch (e) {
		recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#chargerSousFamilles : ' + e);
	}
}


function selSousFamille() {
	try {

		document.getElementById('Sous_Famille').selectedIndex = 0;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#selSousFamille : ' + e);
	}
}


function delete_sousfamilles() {
  try {

    var database = document.getElementById("Sous_Famille").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('Sous_Famille').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#delete_sousfamilles : ' + e);
  }
}


function switchOptions(etat) {
  try {

		codeEtat = etat;

		gPeriode = document.getElementById('gPeriode');
		gSelection = document.getElementById('gSelection');

		switch (etat) {
			case 'PA': gPeriode.collapsed = false;
								 gSelection.collapsed = false;
								 break;
			case 'FA': gPeriode.collapsed = true;
								 gSelection.collapsed = false;
								 break;
			case 'MS': gPeriode.collapsed = false;
								 gSelection.collapsed = false;
								 break;
			case 'ES': gPeriode.collapsed = true;
								 gSelection.collapsed = false;
								 break;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#switchOptions : ' + e);
  }
}


function enableDates(b) {
	try {

		document.getElementById("DateDebut").disabled = !b;
		document.getElementById("DateFin").disabled = !b;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#enableDates : ' + e);
  }
}


function editerPalmares() {
	try {

		var page = "chrome://opensi/content/facturation/user/editions/edition_stock.xul?"+ cookie();

		var periode = document.getElementById('Periode').value;
		var date_debut = document.getElementById('DateDebut').value;
		var date_fin = document.getElementById('DateFin').value;
		var famille = document.getElementById('Famille').value;
		var sous_famille = document.getElementById('Sous_Famille').value;
		var marque = document.getElementById('Marque').value;

		if (codeEtat=="PA" && periode=="DD" && !isDate(date_debut)) { showWarning("Date de dbut de priode incorrecte"); }
		else if (codeEtat=="PA" && periode=="DD" && !isDate(date_fin)) { showWarning("Date de fin de priode incorrecte"); }
		else if (codeEtat=="PA" && periode=="DD" && !isDateInterval(date_debut, date_fin)) { showWarning("Plage de dates incorrecte"); }
		else {

			if (periode=="DD") {
				date_fin = prepareDateJava(date_fin);
				date_debut = prepareDateJava(date_debut);
			}

			var listeParams = "&Periode="+ periode;
			listeParams += "&DateDebut="+ date_debut +"&DateFin="+ date_fin;
			listeParams += "&Famille="+ urlEncode(famille) +"&SousFamille="+ urlEncode(sous_famille);
			listeParams += "&Marque="+ urlEncode(marque);

			window.location = page + "&ListeParams="+ urlEncode(listeParams) +"&CodeEtat="+ codeEtat;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#editerPalmares : ' + e);
  }
}


function menu_editions() {
  try {

    window.location = "chrome://opensi/content/facturation/user/editions/menu_editions.xul?"+ cookie();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#menu_editions : ' + e);
  }
}


function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
    window.location = page;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/editions/menu_stocks.js#retour_menu_principal : ' + e);
  }
}
