/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


//arbre remplissant les diffrentes listes
var arbreFamille = new Arbre("fact","familles_article.tmpl","liste_famille");
var arbreSousFamille = new Arbre("fact","sousfamilles_article.tmpl","liste_sousfamille");
var arbreFournisseur = new Arbre("fact","liste_fournisseurs_tous_article.tmpl","liste_fournisseur");

//arbre permettant d'afficher les rsultats lors de l'appui sur le bouton envoyer
var arbrePrixHT = new Arbre("fact","affiche_arbre_prix_ht.tmpl","tree_maj");
var arbrePrixTTC = new Arbre("fact","affiche_arbre_prix_ttc.tmpl","tree_maj");
var arbrePrixAchat = new Arbre("fact","affiche_arbre_prix_achat.tmpl","tree_maj");
var arbreCoeffVente = new Arbre("fact","affiche_arbre_coeff_vente.tmpl","tree_maj");

function init_maj(){
	try{
		arbreFamille.initTree();
		arbreFournisseur.initTree();
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#init : ' +e);
	}
}

//Affiche ou dsactive les champs selon les choix effectus
function affiche(){
	try{
		var bRadioOp = document.getElementById("choix_op").selectedItem;
		if ( bRadioOp == document.getElementById("prix_achat") ){
			document.getElementById("radio_fournisseur").disabled = false;
			document.getElementById("lbl_fournisseur").disabled = false;
			document.getElementById("liste_fournisseur").disabled = false;
			document.getElementById("box_pa").collapsed = false;
			document.getElementById("box_tarif").collapsed = true;
		}
		else{
			document.getElementById("radio_fournisseur").disabled = true;
			document.getElementById("lbl_fournisseur").disabled = true;
			document.getElementById("liste_fournisseur").disabled = true;
			document.getElementById("box_pa").collapsed = true;
			document.getElementById("box_tarif").collapsed = false;
			document.getElementById("choix_appli").selectedItem = document.getElementById("radio_tous");
		}
		affiche_radio_application()
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche : ' +e);
	}
}

//Vrifie qu'il y a au mois une check box de cocher en permanence
// (sauf si "Prix d'Achat" est slectionn)
function test_checkbox(id){
	try{
		var bRadioOp = document.getElementById("choix_op").selectedItem;
		if ( bRadioOp != document.getElementById("prix_achat") ){
			var tarif_1 = document.getElementById("tarif_1");
			var tarif_2 = document.getElementById("tarif_2");
			var tarif_3 = document.getElementById("tarif_3");
			var tarif_4 = document.getElementById("tarif_4");
			var tarif_5 = document.getElementById("tarif_5");
			if ( !(tarif_1.checked || tarif_2.checked || tarif_3.checked || tarif_4.checked || tarif_5.checked) ){
				alert("Vous devez slectionner au moins un tarif pour lequel sera appliqu la modification");
				document.getElementById(id).checked = true;
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#test_checkbox : ' +e);
	}
}

function affiche_radio_application(){
	try{
		var radioApp = document.getElementById("choix_appli").selectedItem;
		var bRadioOp = document.getElementById("choix_op").selectedItem;

		if ( radioApp == document.getElementById("radio_reference") ){
			document.getElementById("reference").disabled = false;
		}
		else{
			document.getElementById("reference").disabled = true;
		}

		if ( radioApp == document.getElementById("radio_famille") ){
			document.getElementById("liste_famille").disabled = false;
			affiche_sousfamille();
		}
		else{
			document.getElementById("liste_famille").disabled = true;
			document.getElementById("liste_sousfamille").disabled = true;
		}

		if ( radioApp == document.getElementById("radio_fournisseur") && bRadioOp == document.getElementById("prix_achat") ){
			document.getElementById("liste_fournisseur").disabled = false;
		}
		else{
			document.getElementById("liste_fournisseur").disabled = true;
		}

	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche_radio_application : ' +e);
	}
}


function affiche_radio_type_maj(){
	try{
		var radioTypMaj = document.getElementById("choix_type_maj").selectedItem;

		if ( radioTypMaj == document.getElementById("radio_pourcentage") ){
			document.getElementById("maj_pourcentage").disabled = false;
			document.getElementById("maj_valeur").disabled = true;

		}
		else{
			document.getElementById("maj_pourcentage").disabled = true;
			document.getElementById("maj_valeur").disabled = false;
		}

	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche_radio_type_maj : ' +e);
	}
}


//Affiche les ventuelles sous familles d'articles li a la famille choisie
function affiche_sousfamille(){
	try{
		var famille = document.getElementById("liste_famille").selectedItem;

		if ( document.getElementById("liste_famille").disabled == true ){
			document.getElementById("liste_sousfamille").disabled = true;
		}
		else{
			if ( famille != null && !isEmpty(famille.value) ){
				arbreSousFamille.clearParams();
				arbreSousFamille.addParam("Famille",famille.value);
				arbreSousFamille.initTree();
				document.getElementById("liste_sousfamille").disabled = false;
			}
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche_sousfamille : ' +e);
	}
}


//Fonction execut lors de l'appuie sur le bouton "Envoyer"
function calculer(){
	try{
		var bRadioOp = document.getElementById("choix_op").selectedItem;
		pret_pdf = false;
		document.getElementById("valideur").disabled = true;
		document.getElementById("affiche_bar").collapsed = false;
		document.getElementById("bCalculeur").disabled = true;
		document.getElementById("label_bar").value = "Affichage de la mise  jour en cours";

		valide = false;

		pdf_typeApp = null;
		pdf_typeOp = null;
		pdf_typeMaj = null;
		pdf_tarif1 = "";
		pdf_tarif2 = "";
		pdf_tarif3 = "";
		pdf_tarif4 = "";
		pdf_tarif5 = "";
		pdf_famille = null;
		pdf_sousFamille = null;
		pdf_fournisseur = null;
		pdf_reference = null;
		pdf_pourcentage = null;
		pdf_valeur = null;
		pdf_modifPrixVente = false;

		arbrePrixHT.clearParams();
		arbrePrixTTC.clearParams();
		arbrePrixAchat.clearParams();
		arbreCoeffVente.clearParams();

		arbrePrixHT.deleteTree();
		arbrePrixTTC.deleteTree();
		arbrePrixAchat.deleteTree();
		arbreCoeffVente.deleteTree();

		if ( bRadioOp == document.getElementById("prix_ht") ){
			result_ht();
			pdf_typeOp = "prix_ht";
		}

		if ( bRadioOp == document.getElementById("prix_ttc") ){
			result_ttc();
			pdf_typeOp = "prix_ttc";
		}

		if ( bRadioOp == document.getElementById("prix_achat") ){
			result_achat();
			pdf_typeOp = "prix_achat";
		}

		if ( bRadioOp == document.getElementById("coeff_vente") ){
			result_coeff();
			pdf_typeOp = "coeff_vente";
		}

	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#envoyer : ' +e);
	}
}

//fonction qui envoi les paramtre  l'arbre dans le cas o c'est la modif HT
// qui a t choisis
function result_ht(){
	try{
		var tarif_1 = document.getElementById("tarif_1");
		var tarif_2 = document.getElementById("tarif_2");
		var tarif_3 = document.getElementById("tarif_3");
		var tarif_4 = document.getElementById("tarif_4");
		var tarif_5 = document.getElementById("tarif_5");

		if ( tarif_1.checked ){
			arbrePrixHT.addParam("Tarif_1",true);
			document.getElementById("affiche_1").checked = true;
			pdf_tarif1 = true;
		}
		else{
			document.getElementById("affiche_1").checked = false;
			pdf_tarif1 = "";
		}

		if ( tarif_2.checked ){
			arbrePrixHT.addParam("Tarif_2",true);
			document.getElementById("affiche_2").checked = true;
			pdf_tarif2 = true;
		}
		else{
			document.getElementById("affiche_2").checked = false;
			pdf_tarif2 = "";
		}

		if ( tarif_3.checked ){
			arbrePrixHT.addParam("Tarif_3",true);
			document.getElementById("affiche_3").checked = true;
			pdf_tarif3 = true;
		}
		else{
			document.getElementById("affiche_3").checked = false;
			pdf_tarif3 = "";
		}

		if ( tarif_4.checked ){
			arbrePrixHT.addParam("Tarif_4",true);
			document.getElementById("affiche_4").checked = true;
			pdf_tarif4 = true;
		}
		else{
			document.getElementById("affiche_4").checked = false;
			pdf_tarif4 = "";
		}

		if ( tarif_5.checked ){
			arbrePrixHT.addParam("Tarif_5",true);
			document.getElementById("affiche_5").checked = true;
			pdf_tarif5 = true;
		}
		else{
			document.getElementById("affiche_5").checked = false;
			pdf_tarif5 = "";
		}

		result_appli_ht();

	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_ht : ' +e);
	}
}

//fonction qui recupere le choix de l'application pour l'arbre HT
function result_appli_ht(){
	try{
		var bRadioApp = document.getElementById("choix_appli").selectedItem;

		if ( bRadioApp == document.getElementById("radio_reference") ){
			var reference = document.getElementById("reference").value;
			pdf_reference = reference;
			arbrePrixHT.addParam("Reference",reference);
			result_maj_ht();
			pdf_typeApp = 2;
		}
		else if ( bRadioApp == document.getElementById("radio_famille") ){
			var famille = document.getElementById("liste_famille").value;
			if ( !isEmpty(famille ) ){
				arbrePrixHT.addParam("Famille",famille);
				pdf_famille = famille;
				pdf_typeApp = 3;
				var sousFamille = document.getElementById("liste_sousfamille").value;
				pdf_sousFamille = sousFamille;
				if ( !isEmpty(sousFamille) ){
					arbrePrixHT.addParam("Sous_Famille",sousFamille);
				}
				result_maj_ht();
			}
			else{
				alert("Vous avez choisis d'appliquer les modifications sur une famille mais vous n'en avez pas spcifi");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
		else{
			result_maj_ht();
			pdf_typeApp = 1;
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_appli_ht : ' +e);
	}
}

//fonction qui recupere les donne de type de maj pour l'arbre HT
function result_maj_ht(){
	try{
		var bRadioMaj = document.getElementById("choix_type_maj").selectedItem;

		if ( bRadioMaj == document.getElementById("radio_pourcentage") ){
			var pourcentage = document.getElementById("maj_pourcentage").value;
			pdf_typeMaj = "pourcentage";
			if ( !isEmpty(pourcentage) ){
				if ( !isNaN(pourcentage) ){
					pourcentage = parseFloat(pourcentage);
					pdf_pourcentage = parseFloat(pourcentage);
					if ( checkDecimal(pourcentage,2) ){
						arbrePrixHT.addParam("Pourcentage",pourcentage);
						pret_affiche_arbre = true;
						affiche_arbre_ht();
					}
					else{
						alert("Le pourcentage doit tre un nombre de 2 dcimals maximum");
						document.getElementById("affiche_bar").collapsed = true;
						document.getElementById("bCalculeur").disabled = false;
					}
				}
				else{
					alert("Votre pourcentage n'est pas un nombre");
					document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
				}
			}
			else{
				alert("Vous avez choisi de faire une mise  jour par pourcentage mais vous n'avez pas remplit le champ correspondant");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
		else{
			pdf_typeMaj = "valeur";
			var valeur = document.getElementById("maj_valeur").value;
			pdf_valeur = valeur;
			if ( !isEmpty(valeur) ){
				if ( !isNaN(valeur) ){
					valeur = parseFloat(valeur);
					if ( checkDecimal(valeur,4) ){
						arbrePrixHT.addParam("Valeur",valeur);
						pret_affiche_arbre = true;
						affiche_arbre_ht();
					}
					else{
						alert("La valeur doit tre un nombre de 4 dcimals maximum");
						document.getElementById("affiche_bar").collapsed = true;
						document.getElementById("bCalculeur").disabled = false;
					}
				}
				else{
					alert("Votre valeur n'est pas un nombre");
					document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
				}
			}
			else{
				alert("Vous avez choisi de faire une mise  jour par valeur mais vous n'avez pas remplit le champ correspondant");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_maj_ht : ' +e);
	}
}

//fonction qui affiche l'arbre HT
function affiche_arbre_ht(){
	try{
		document.getElementById("col_nouveau_prix_achat").hidden = true;
		var aHT = document.getElementById("affiche_HT");
		var aTTC = document.getElementById("affiche_TTC");
		var aAchat = document.getElementById("affiche_achat");
		var aCoeff = document.getElementById("affiche_coeff");
		aHT.checked = true;
		aAchat.checked = false;
		aCoeff.checked = false;
		aTTC.checked = false;
		affiche_colonne();
		arbrePrixHT.initTree(valide_pdf);
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche_arbre_ht : ' +e);
	}
}


//fonction qui envoi les paramtre  l'arbre dans le cas o c'est la modif TTC
// qui a t choisis
function result_ttc(){
	try{
		var tarif_1 = document.getElementById("tarif_1");
		var tarif_2 = document.getElementById("tarif_2");
		var tarif_3 = document.getElementById("tarif_3");
		var tarif_4 = document.getElementById("tarif_4");
		var tarif_5 = document.getElementById("tarif_5");

		if ( tarif_1.checked ){
			arbrePrixTTC.addParam("Tarif_1",true);
			document.getElementById("affiche_1").checked = true;
			pdf_tarif1 = true;
		}
		else{
			document.getElementById("affiche_1").checked = false;
			pdf_tarif1 = "";
		}

		if ( tarif_2.checked ){
			arbrePrixTTC.addParam("Tarif_2",true);
			document.getElementById("affiche_2").checked = true;
			pdf_tarif2 = true;
		}
		else{
			document.getElementById("affiche_2").checked = false;
			pdf_tarif2 = "";
		}

		if ( tarif_3.checked ){
			arbrePrixTTC.addParam("Tarif_3",true);
			document.getElementById("affiche_3").checked = true;
			pdf_tarif3 = true;
		}
		else{
			document.getElementById("affiche_3").checked = false;
			pdf_tarif3 = "";
		}

		if ( tarif_4.checked ){
			arbrePrixTTC.addParam("Tarif_4",true);
			document.getElementById("affiche_4").checked = true;
			pdf_tarif4 = true;
		}
		else{
			document.getElementById("affiche_4").checked = false;
			pdf_tarif4 = "";
		}

		if ( tarif_5.checked ){
			arbrePrixTTC.addParam("Tarif_5",true);
			document.getElementById("affiche_5").checked = true;
			pdf_tarif5 = true;
		}
		else{
			document.getElementById("affiche_5").checked = false;
			pdf_tarif5 = "";
		}

		result_appli_ttc();

	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_ttc : ' +e);
	}
}

//fonction qui recupere le choix de l'application pour l'arbre TTC
function result_appli_ttc(){
	try{
		var bRadioApp = document.getElementById("choix_appli").selectedItem;

		if ( bRadioApp == document.getElementById("radio_reference") ){
			var reference = document.getElementById("reference").value;
			arbrePrixTTC.addParam("Reference",reference);
			pdf_reference = reference;
			pdf_typeApp = 2;
			result_maj_ttc();
		}
		else if ( bRadioApp == document.getElementById("radio_famille") ){
			var famille = document.getElementById("liste_famille").value;
			if ( !isEmpty(famille ) ){
				arbrePrixTTC.addParam("Famille",famille);
				pdf_famille = famille;
				var sousFamille = document.getElementById("liste_sousfamille").value;
				pdf_sousFamille = sousFamille;
				if ( !isEmpty(sousFamille) ){
					arbrePrixTTC.addParam("Sous_Famille",sousFamille);
				}
				pdf_typeApp = 3;
				result_maj_ttc();
			}
			else{
				alert("Vous avez choisis d'appliquer les modifications sur une famille mais vous n'en avez pas spcifi");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
		else{
			pdf_typeApp = 1;
			result_maj_ttc();
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_appli_ttc : ' +e);
	}
}

//fonction qui recupere les donne de type de maj pour l'arbre TTC
function result_maj_ttc(){
	try{
		var bRadioMaj = document.getElementById("choix_type_maj").selectedItem;

		if ( bRadioMaj == document.getElementById("radio_pourcentage") ){
			pdf_typeMaj = "pourcentage";
			var pourcentage = document.getElementById("maj_pourcentage").value;
			pdf_pourcentage = parseFloat(pourcentage);
			if ( !isEmpty(pourcentage) ){
				if ( !isNaN(pourcentage) ){
					pourcentage = parseFloat(pourcentage);
					if ( checkDecimal(pourcentage,2) ){
						arbrePrixTTC.addParam("Pourcentage",pourcentage);
						pret_affiche_arbre = true;
						affiche_arbre_ttc();
					}
					else{
						alert("Le pourcentage doit tre un nombre de 2 dcimals maximum");
						document.getElementById("affiche_bar").collapsed = true;
						document.getElementById("bCalculeur").disabled = false;
					}
				}
				else{
					alert("Votre pourcentage n'est pas un nombre");
					document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
				}
			}
			else{
				alert("Vous avez choisi de faire une mise  jour par pourcentage mais vous n'avez pas remplit le champ correspondant");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
		else{
			pdf_typeMaj = "valeur";
			var valeur = document.getElementById("maj_valeur").value;
			if ( !isEmpty(valeur) ){
				if (!isNaN(valeur) ){
					valeur = parseFloat(valeur);
					pdf_valeur = parseFloat(valeur);
					if ( checkDecimal(valeur,4) ){
						arbrePrixTTC.addParam("Valeur",valeur);
						pret_affiche_arbre = true;
						affiche_arbre_ttc();
					}
					else{
						alert("La valeur doit tre un nombre de 4 dcimals maximum");
						document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
					}
				}
				else{
					alert("Votre valeur n'est pas un nombre");
					document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
				}
			}
			else{
				alert("Vous avez choisi de faire une mise  jour par valeur mais vous n'avez pas remplit le champ correspondant");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_maj_ttc : ' +e);
	}
}

//fonction qui affiche l'arbre TTC
function affiche_arbre_ttc(){
	try{
		document.getElementById("col_nouveau_prix_achat").hidden = true;
		var aHT = document.getElementById("affiche_HT");
		var aTTC = document.getElementById("affiche_TTC");
		var aAchat = document.getElementById("affiche_achat");
		var aCoeff = document.getElementById("affiche_coeff");
		aHT.checked = false;
		aAchat.checked = false;
		aCoeff.checked = false;
		aTTC.checked = true;
		affiche_colonne();
		arbrePrixTTC.initTree(valide_pdf);
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche_arbre_ttc : ' +e);
	}
}

//fonction qui envoi les paramtre  l'arbre dans le cas o c'est la modif TTC
// qui a t choisis
function result_coeff(){
	try{
		var tarif_1 = document.getElementById("tarif_1");
		var tarif_2 = document.getElementById("tarif_2");
		var tarif_3 = document.getElementById("tarif_3");
		var tarif_4 = document.getElementById("tarif_4");
		var tarif_5 = document.getElementById("tarif_5");

		if ( tarif_1.checked ){
			arbreCoeffVente.addParam("Tarif_1",true);
			document.getElementById("affiche_1").checked = true;
			pdf_tarif1 = true;
		}
		else{
			document.getElementById("affiche_1").checked = false;
			pdf_tarif1 = "";
		}

		if ( tarif_2.checked ){
			arbreCoeffVente.addParam("Tarif_2",true);
			document.getElementById("affiche_2").checked = true;
			pdf_tarif2 = true;
		}
		else{
			document.getElementById("affiche_2").checked = false;
			pdf_tarif2 = "";
		}

		if ( tarif_3.checked ){
			arbreCoeffVente.addParam("Tarif_3",true);
			document.getElementById("affiche_3").checked = true;
			pdf_tarif3 = true;
		}
		else{
			document.getElementById("affiche_3").checked = false;
			pdf_tarif3 = "";
		}

		if ( tarif_4.checked ){
			arbreCoeffVente.addParam("Tarif_4",true);
			document.getElementById("affiche_4").checked = true;
			pdf_tarif4 = true;
		}
		else{
			document.getElementById("affiche_4").checked = false;
			pdf_tarif4 = "";
		}

		if ( tarif_5.checked ){
			arbreCoeffVente.addParam("Tarif_5",true);
			document.getElementById("affiche_5").checked = true;
			pdf_tarif5 = true;
		}
		else{
			document.getElementById("affiche_5").checked = false;
			pdf_tarif5 = "";
		}

		result_appli_coeff();

	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_coeff : ' +e);
	}
}

//fonction qui recupere le choix de l'application pour l'arbre Coeff
function result_appli_coeff(){
	try{
		var bRadioApp = document.getElementById("choix_appli").selectedItem;

		if ( bRadioApp == document.getElementById("radio_reference") ){
			var reference = document.getElementById("reference").value;
			arbreCoeffVente.addParam("Reference",reference);
			pdf_reference = reference;
			pdf_typeApp = 2;
			result_maj_coeff();
		}
		else if ( bRadioApp == document.getElementById("radio_famille") ){
			var famille = document.getElementById("liste_famille").value;
			if ( !isEmpty(famille ) ){
				arbreCoeffVente.addParam("Famille",famille);
				pdf_famille = famille;
				var sousFamille = document.getElementById("liste_sousfamille").value;
				pdf_sousFamille = sousFamille;
				if ( !isEmpty(sousFamille) ){
					arbreCoeffVente.addParam("Sous_Famille",sousFamille);
				}
				pdf_typeApp = 3;
				result_maj_coeff();
			}
			else{
				alert("Vous avez choisis d'appliquer les modifications sur une famille mais vous n'en avez pas spcifi");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
		else{
			pdf_typeApp = 1;
			result_maj_coeff();
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_appli_coeff : ' +e);
	}
}

//fonction qui recupere les donne de type de maj pour l'arbre Coeff
function result_maj_coeff(){
	try{
		var bRadioMaj = document.getElementById("choix_type_maj").selectedItem;

		if ( bRadioMaj == document.getElementById("radio_pourcentage") ){
			var pourcentage = document.getElementById("maj_pourcentage").value;
			if ( !isEmpty(pourcentage) ){
				pdf_typeMaj = "pourcentage";
				if ( !isNaN(pourcentage) ){
					pourcentage = parseFloat(pourcentage);
					pdf_pourcentage = parseFloat(pourcentage);
					if ( checkDecimal(pourcentage,2) ){
						arbreCoeffVente.addParam("Pourcentage",pourcentage);
						pret_affiche_arbre = true;
						affiche_arbre_coeff();
					}
					else{
						alert("Le pourcentage doit tre un nombre de 2 dcimals maximum");
						document.getElementById("affiche_bar").collapsed = true;
						document.getElementById("bCalculeur").disabled = false;
					}
				}
				else{
					alert("Votre pourcentage n'est pas un nombre");
					document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
				}
			}
			else{
				alert("Vous avez choisi de faire une mise  jour par pourcentage mais vous n'avez pas remplit le champ correspondant");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
		else{
			pdf_typeMaj = "valeur";
			var valeur = document.getElementById("maj_valeur").value;
			if ( !isEmpty(valeur) ){
				if ( !isNaN(valeur) ){
					valeur = parseFloat(valeur);
					pdf_valeur = valeur;
					if ( checkDecimal(valeur,5) ){
						arbreCoeffVente.addParam("Valeur",valeur);
						pret_affiche_arbre = true;
						affiche_arbre_coeff();
					}
					else{
						alert("La valeur doit tre un nombre de 4 dcimals maximum");
						document.getElementById("affiche_bar").collapsed = true;
						document.getElementById("bCalculeur").disabled = false;
					}
				}
				else{
					alert("Votre valeur n'est pas un nombre");
					document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
				}
			}
			else{
				alert("Vous avez choisi de faire une mise  jour par valeur mais vous n'avez pas remplit le champ correspondant");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_maj_coeff : ' +e);
	}
}

//fonction qui affiche l'arbre Coeff
function affiche_arbre_coeff(){
	try{
		document.getElementById("col_nouveau_prix_achat").hidden = true;
		var aHT = document.getElementById("affiche_HT");
		var aTTC = document.getElementById("affiche_TTC");
		var aAchat = document.getElementById("affiche_achat");
		var aCoeff = document.getElementById("affiche_coeff");
		aHT.checked = false;
		aAchat.checked = false;
		aCoeff.checked = true;
		aTTC.checked = false;
		affiche_colonne();
		arbreCoeffVente.initTree(valide_pdf);
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche_arbre_coeff : ' +e);
	}
}

//fonction qui envoi les paramtre  l'arbre dans le cas o c'est la modif d'achat
// qui a t choisis
function result_achat(){
	try{
		var choixEffet = document.getElementById("check_vente");
		document.getElementById("affiche_1").disabled = false;
		document.getElementById("affiche_2").disabled = false;
		document.getElementById("affiche_3").disabled = false;
		document.getElementById("affiche_4").disabled = false;
		document.getElementById("affiche_5").disabled = false;
		document.getElementById("affiche_1").checked = false;
		document.getElementById("affiche_2").checked = false;
		document.getElementById("affiche_3").checked = false;
		document.getElementById("affiche_4").checked = false;
		document.getElementById("affiche_5").checked = false;
		if ( choixEffet.checked ){
			arbrePrixAchat.addParam("Appli_Vente",true);
			pdf_modifPrixVente = true;
		}

		result_appli_achat();
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_achat : ' +e);
	}
}

//fonction qui recupere le choix de l'application pour l'arbre Coeff
function result_appli_achat(){
	try{
		var bRadioApp = document.getElementById("choix_appli").selectedItem;

		if ( bRadioApp == document.getElementById("radio_reference") ){
			pdf_typeApp = 2;
			var reference = document.getElementById("reference").value;
			arbrePrixAchat.addParam("Reference",reference);
			pdf_reference = reference;
			result_maj_achat();
		}
		else if ( bRadioApp == document.getElementById("radio_famille") ){
			var famille = document.getElementById("liste_famille").value;
			if ( !isEmpty(famille ) ){
				arbrePrixAchat.addParam("Famille",famille);
				pdf_famille = famille;
				var sousFamille = document.getElementById("liste_sousfamille").value;
				pdf_sousFamille = sousFamille;
				if ( !isEmpty(sousFamille) ){
					arbrePrixAchat.addParam("Sous_Famille",sousFamille);
				}
				pdf_typeApp = 3;
				result_maj_achat();
			}
			else{
				alert("Vous avez choisis d'appliquer les modifications sur une famille mais vous n'en avez pas spcifi");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
		else if ( bRadioApp == document.getElementById("radio_fournisseur") ){
			var fournisseur = document.getElementById("liste_fournisseur").value;
			if ( !isEmpty(fournisseur) ){
				arbrePrixAchat.addParam("Fournisseur",fournisseur);
				pdf_fournisseur = fournisseur;
				pdf_typeApp = 4;
				result_maj_achat();
			}
		}
		else{
			pdf_typeApp = 1;
			result_maj_achat();
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_appli_achat : ' +e);
	}
}

function result_maj_achat(){
	try{
		var bRadioMaj = document.getElementById("choix_type_maj").selectedItem;

		if ( bRadioMaj == document.getElementById("radio_pourcentage") ){
			pdf_typeMaj = "pourcentage";
			var pourcentage = document.getElementById("maj_pourcentage").value;
			if ( !isEmpty(pourcentage) ){
				if ( !isNaN(pourcentage) ){
					pourcentage = parseFloat(pourcentage);
					pdf_pourcentage = pourcentage;
					if ( checkDecimal(pourcentage,2) ){
						arbrePrixAchat.addParam("Pourcentage",pourcentage);
						pret_affiche_arbre = true;
						affiche_arbre_achat();
					}
					else{
						alert("Le pourcentage doit tre un nombre de 2 dcimal maximum");
						document.getElementById("affiche_bar").collapsed = true;
						document.getElementById("bCalculeur").disabled = false;
					}
				}
				else{
					alert("Votre pourcentage n'est pas un nombre");
					document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
				}
			}
			else{
				alert("Vous avez choisi de faire une mise  jour par pourcentage mais vous n'avez pas remplit le champ correspondant");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
		else{
			pdf_typeMaj = "valeur";
			var valeur = document.getElementById("maj_valeur").value;
			if ( !isEmpty(valeur) ){
				if ( !isNaN(valeur) ){
					valeur = parseFloat(valeur);
					pdf_valeur = valeur;
					if ( checkDecimal(valeur,4) ){
						arbrePrixAchat.addParam("Valeur",valeur);
						pret_affiche_arbre = true;
						affiche_arbre_achat();
					}
					else{
						alert("La valeur doit tre un nombre de 4 dcimals maximum");
						document.getElementById("affiche_bar").collapsed = true;
						document.getElementById("bCalculeur").disabled = false;
					}
				}
				else{
					alert("Votre valeur n'est pas un nombre");
					document.getElementById("affiche_bar").collapsed = true;
					document.getElementById("bCalculeur").disabled = false;
				}
			}
			else{
				alert("Vous avez choisi de faire une mise  jour par valeur mais vous n'avez pas remplit le champ correspondant");
				document.getElementById("affiche_bar").collapsed = true;
				document.getElementById("bCalculeur").disabled = false;
			}
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#result_maj_achat : ' +e);
	}
}

//fonction qui affiche l'arbre Achat
function affiche_arbre_achat(){
	try{
		document.getElementById("col_nouveau_prix_achat").hidden = false;
		var aHT = document.getElementById("affiche_HT");
		var aTTC = document.getElementById("affiche_TTC");
		var aAchat = document.getElementById("affiche_achat");
		var aCoeff = document.getElementById("affiche_coeff");
		aHT.checked = true;
		aAchat.checked = true;
		aCoeff.checked = true;
		aTTC.checked = true;
		affiche_colonne();
		arbrePrixAchat.initTree(valide_pdf);
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche_arbre_achat : ' +e);
	}
}

function affiche_colonne(){
	try{
		if ( pret_affiche_arbre ){
			var aT1 = document.getElementById("affiche_1");
			var aT2 = document.getElementById("affiche_2");
			var aT3 = document.getElementById("affiche_3");
			var aT4 = document.getElementById("affiche_4");
			var aT5 = document.getElementById("affiche_5");

			var aHT = document.getElementById("affiche_HT");
			var aTTC = document.getElementById("affiche_TTC");
			var aAchat = document.getElementById("affiche_achat");
			var aCoeff = document.getElementById("affiche_coeff");

			if ( aHT.checked ){
				document.getElementById("ancien_tarif_HT_1").hidden = !aT1.checked;
				document.getElementById("nouveau_tarif_HT_1").hidden = !aT1.checked;

				document.getElementById("ancien_tarif_HT_2").hidden = !aT2.checked;
				document.getElementById("nouveau_tarif_HT_2").hidden = !aT2.checked;

				document.getElementById("ancien_tarif_HT_3").hidden = !aT3.checked;
				document.getElementById("nouveau_tarif_HT_3").hidden = !aT3.checked;

				document.getElementById("ancien_tarif_HT_4").hidden = !aT4.checked;
				document.getElementById("nouveau_tarif_HT_4").hidden = !aT4.checked;

				document.getElementById("ancien_tarif_HT_5").hidden = !aT5.checked;
				document.getElementById("nouveau_tarif_HT_5").hidden = !aT5.checked;
			}
			else{
				document.getElementById("ancien_tarif_HT_1").hidden = true;
				document.getElementById("nouveau_tarif_HT_1").hidden = true;
				document.getElementById("ancien_tarif_HT_2").hidden = true;
				document.getElementById("nouveau_tarif_HT_2").hidden = true;
				document.getElementById("ancien_tarif_HT_3").hidden = true;
				document.getElementById("nouveau_tarif_HT_3").hidden = true;
				document.getElementById("ancien_tarif_HT_4").hidden = true;
				document.getElementById("nouveau_tarif_HT_4").hidden = true;
				document.getElementById("ancien_tarif_HT_5").hidden = true;
				document.getElementById("nouveau_tarif_HT_5").hidden = true;
			}

			if ( aTTC.checked ){
				document.getElementById("ancien_tarif_TTC_1").hidden = !aT1.checked;
				document.getElementById("nouveau_tarif_TTC_1").hidden = !aT1.checked;

				document.getElementById("ancien_tarif_TTC_2").hidden = !aT2.checked;
				document.getElementById("nouveau_tarif_TTC_2").hidden = !aT2.checked;

				document.getElementById("ancien_tarif_TTC_3").hidden = !aT3.checked;
				document.getElementById("nouveau_tarif_TTC_3").hidden = !aT3.checked;

				document.getElementById("ancien_tarif_TTC_4").hidden = !aT4.checked;
				document.getElementById("nouveau_tarif_TTC_4").hidden = !aT4.checked;

				document.getElementById("ancien_tarif_TTC_5").hidden = !aT5.checked;
				document.getElementById("nouveau_tarif_TTC_5").hidden = !aT5.checked;

				document.getElementById("TVA").hidden = false;
			}
			else{
				document.getElementById("ancien_tarif_TTC_1").hidden = true;
				document.getElementById("nouveau_tarif_TTC_1").hidden = true;
				document.getElementById("ancien_tarif_TTC_2").hidden = true;
				document.getElementById("nouveau_tarif_TTC_2").hidden = true;
				document.getElementById("ancien_tarif_TTC_3").hidden = true;
				document.getElementById("nouveau_tarif_TTC_3").hidden = true;
				document.getElementById("ancien_tarif_TTC_4").hidden = true;
				document.getElementById("nouveau_tarif_TTC_4").hidden = true;
				document.getElementById("ancien_tarif_TTC_5").hidden = true;
				document.getElementById("nouveau_tarif_TTC_5").hidden = true;

				document.getElementById("TVA").hidden = true;
			}

			if ( aAchat.checked ){
				document.getElementById("col_prix_achat").hidden = false;
			}
			else{
				document.getElementById("col_prix_achat").hidden = true;
			}


			if ( aCoeff.checked ){
					document.getElementById("ancien_coeff_1").hidden = !aT1.checked;
					document.getElementById("nouveau_coeff_1").hidden = !aT1.checked;

					document.getElementById("ancien_coeff_2").hidden = !aT2.checked;
					document.getElementById("nouveau_coeff_2").hidden = !aT2.checked;

					document.getElementById("ancien_coeff_3").hidden = !aT3.checked;
					document.getElementById("nouveau_coeff_3").hidden = !aT3.checked;

					document.getElementById("ancien_coeff_4").hidden = !aT4.checked;
					document.getElementById("nouveau_coeff_4").hidden = !aT4.checked;

					document.getElementById("ancien_coeff_5").hidden = !aT5.checked;
					document.getElementById("nouveau_coeff_5").hidden = !aT5.checked;
			}
			else{
				document.getElementById("ancien_coeff_1").hidden = true;
				document.getElementById("nouveau_coeff_1").hidden = true;
				document.getElementById("ancien_coeff_2").hidden = true;
				document.getElementById("nouveau_coeff_2").hidden = true;
				document.getElementById("ancien_coeff_3").hidden = true;
				document.getElementById("nouveau_coeff_3").hidden = true;
				document.getElementById("ancien_coeff_4").hidden = true;
				document.getElementById("nouveau_coeff_4").hidden = true;
				document.getElementById("ancien_coeff_5").hidden = true;
				document.getElementById("nouveau_coeff_5").hidden = true;
			}
		}
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#affiche_colonne : ' +e);
	}
}

function test_valide(){
	try{
		var perte = false;
		var arbre = document.getElementById("tree_maj");
		var nb = arbre.view.rowCount;
		var i = 0;
		while( i<nb && !perte){
			if ( getCellText(arbre,i,"incorrect") == 'y' ){
				perte = true;
			}
			i++;
		}
		if ( perte ){
			alert("Attention, la mise  jour que vous avez choisi implique une vente  perte pour certain article, vous ne pouvez valid cette mise  jour dans ce cas");
		}
		else{
			document.getElementById("valideur").disabled = false;
		}
		document.getElementById("bCalculeur").disabled = false;
		document.getElementById("affiche_bar").collapsed = true;
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#test_valide : ' +e);
	}
}


function valider(){
	try{
		valide = true;
		appTarifSpe = document.getElementById("mod_tspe").checked;
		change_affiche();
		document.getElementById("valideur").disabled = true;
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#valider : ' +e);
	}
}

function valide_pdf(){
	try{
		pret_pdf = true;
		document.getElementById("label_bar").value = "Vrification des modifications (pr-dition possible)";
		test_valide();
	}
	catch(e){
		recup_erreur('erreur dans facturation/user/majtarifs/overlay_maj.js#valide_pdf : ' +e);
	}
}


