/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");


function init() {
  try {

   	if (get_cookie("Reglements")=='F') {
			var queryRelances = new QueryHttp("Facturation/Reglements/relances.tmpl");
			queryRelances.execute(initRelances);
  	}

		var queryEcheance = new QueryHttp("Facturation/ReglementsFournisseur/echeanceFournisseur.tmpl");
		queryEcheance.execute(initEcheance);

	  parent.document.getElementById("nom_dossier").value = ParamValeur('Libelle');
    document.getElementById('bouton_tiers').focus();

		var querySuivi = new QueryHttp("Facturation/SuiviActivite.tmpl");
		querySuivi.execute(initActivite);

		var queryCloture = new QueryHttp("Facturation/Transfert/isCloturable.tmpl");
		queryCloture.execute(initCloture);

		document.getElementById('news').setAttribute("src", "http://www.speedinfo.fr/speedinfo/expershop?Page=OpenSI/DisplayNewsOpensi.tmpl"+ nocache());

  } catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#init : ' + e);
  }
}


function initCloture(httpRequest) {
	try {

		var contenu = httpRequest.responseXML.documentElement;

		if (contenu.getAttribute('cloturable')=="true") {
			document.getElementById('boxCloture').collapsed = false;
			document.getElementById('lblPeriode').value = contenu.getAttribute('mois-periode').toUpperCase();
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#initCloture : ' + e);
  }
}


function initActivite(httpRequest) {
  try {

    var contenu = httpRequest.responseXML.documentElement;

    document.getElementById('ComEnCours').value = contenu.getAttribute('ComEnCours') +" \u20AC";
    document.getElementById('CANMois').value = contenu.getAttribute('CANMois') +" \u20AC";
    document.getElementById('CAN1Mois').value = contenu.getAttribute('CAN1Mois') +" \u20AC";
    document.getElementById('CAN').value = contenu.getAttribute('CAN') +" \u20AC";
    document.getElementById('CAN1').value = contenu.getAttribute('CAN1') +" \u20AC";

		var queryGraph = new QueryHttp("Facturation/SuiviActivite2.tmpl");
		queryGraph.setParam("ficPng", contenu.getAttribute('GraphCA'));
		queryGraph.setParam("VListeN", contenu.getAttribute('ListeN'));
		queryGraph.setParam("VListeN1", contenu.getAttribute('ListeN1'));
		queryGraph.execute(initGraph);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#initActivite : ' + e);
  }
}


function initGraph(httpRequest) {
	try {

  	var contenu = httpRequest.responseXML.documentElement;
  	document.getElementById('GraphCA').setAttribute("src", getDirServeur() +"graph/"+ contenu.getAttribute('GraphCA'));

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#initGraph : ' + e);
  }
}


function initRelances(httpRequest) {
  try {

    var resultat = parseIntBis(httpRequest.responseXML.documentElement.getAttribute('relances'));
    if (resultat > 0) {
      var relances = (resultat==1?"relance":"relances");
      document.getElementById('lblRelances').value = resultat +" "+ relances +"  gnrer...";
      document.getElementById('boxRelances').collapsed = false;
    }

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#initRelances : ' + e);
  }
}


function initEcheance(httpRequest) {
  try {

    var resultat = parseIntBis(httpRequest.responseXML.documentElement.getAttribute('echeance'));
    if (resultat > 0) {
      var echeance = (resultat==1?"chance fournisseur":"chances fournisseurs");
      document.getElementById('lblFournisseur').value = resultat +" "+ echeance +"  rgler...";
      document.getElementById('boxFournisseur').collapsed = false;
    }

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#initEcheance : ' + e);
  }
}


function cloturerFacturation() {
  try {

		var queryCloturer = new QueryHttp("Facturation/Transfert/CloturerMois.tmpl");
		queryCloturer.execute();

		showMessage("Facturation de la priode "+ document.getElementById('lblPeriode').value +" cloture");

		document.getElementById('boxCloture').collapsed = true;

		var queryIsCloturable = new QueryHttp("Facturation/Transfert/isCloturable.tmpl");
		queryIsCloturable.execute(initCloture);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#cloturerFacturation : ' + e);
  }
}


function echeancesFournisseur() {
	try {

  	window.location = "chrome://opensi/content/facturation/user/reglements_fournisseur/menu_reglement.xul?"+ cookie();

  } catch (e) {
  	recup_erreur('erreur dans facturation/user/menu_principal.js#echeancesFournisseur : ' + e);
  }
}


function goToMenu(m) {
  try {

		switch(m) {
			case 1:	 window.location = "chrome://opensi/content/facturation/user/clients/menu_clients.xul?"+ cookie();					  break;
			case 2:  window.location = "chrome://opensi/content/facturation/user/fournisseurs/menu_fournisseurs.xul?"+ cookie();  break;
			case 3:  window.location = "chrome://opensi/content/facturation/user/stocks/menu_stocks.xul?"+ cookie();						  break;
			case 4:  window.location = "chrome://opensi/content/facturation/user/commandes/menu_commandes.xul?"+ cookie();			  break;
			case 5:  window.location = "chrome://opensi/content/facturation/user/devis/menu_devis.xul?"+ cookie();							  break;
			case 6:  window.location = "chrome://opensi/content/facturation/user/affaires/menu_affaires.xul?"+ cookie();				  break;
			case 7:  window.location = "chrome://opensi/content/facturation/user/factu_directe/menu_factures.xul?"+ cookie();		  break;
			case 8:  window.location = "chrome://opensi/content/facturation/user/facturation/facturation.xul?"+ cookie();				  break;
			case 9:  window.location = "chrome://opensi/content/facturation/user/avoirs/menu_avoirs.xul?"+ cookie();						  break;
			case 10: window.location = "chrome://opensi/content/facturation/user/tabbord/menu.xul?"+ cookie();									  break;
			case 11: window.location = "chrome://opensi/content/facturation/user/editions/menu_editions.xul?"+ cookie();				  break;
			case 12: window.location = "chrome://opensi/content/facturation/user/reglements/menu_reglement.xul?"+ cookie();			  break;
			case 13: window.location = "chrome://opensi/content/facturation/user/transfert/transfert_factures.xul?"+ cookie();	  break;
			case 14: window.location = "chrome://opensi/content/facturation/user/factu_fournisseur/menu_factures.xul?"+ cookie();	break;
			case 15: window.location = "chrome://opensi/content/facturation/user/avoirs_fournisseur/menu_avoirs.xul?"+ cookie();	break;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#goToMenu : ' + e);
  }
}


function ouvrirSousMenu(idSM) {

	document.getElementById('smTiers').collapsed = true;
	document.getElementById('smVentes').collapsed = true;
	document.getElementById('smAchats').collapsed = true;
	document.getElementById('smStocks').collapsed = true;
	document.getElementById('smOD').collapsed = true;

	document.getElementById(idSM).collapsed = false;
}


function relances() {
  try {

    window.location = "chrome://opensi/content/facturation/user/reglements/relances.xul?"+ cookie();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#relances : ' + e);
  }
}


function retourChoixDossier() {
	try {

    window.location = "chrome://opensi/content/facturation/user/menu.xul?"+ cookie();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/menu_principal.js#retourChoixDossier : ' + e);
  }
}
