/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var aApercu = new Arbre('fact', 'apercu_avoir_fournisseur.tmpl', 'apercu');
var aAvoirs = new Arbre('fact', 'avoirs_fournisseur.tmpl', 'avoirs');


function init() {
  try {

    var x = (screen.width / 2) - 450;
    var y = (screen.height / 2) - 250;
    window.resizeTo(900,500);
    window.moveTo(x,y);
    document.getElementById('Numero').focus();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#init : ' + e);
  }
}


function pressOnId(ev) {
  try {

    if (ev.keyCode==13) {

      document.getElementById('Fournisseur_Id').value = "";
      document.getElementById('Raison_Sociale').value = "";
			aAvoirs.clearParams();
			aAvoirs.setParam('Num_Avoir', document.getElementById('Numero').value);
			aAvoirs.initTree();
			unloadApercu();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#pressOnId : ' + e);
  }
}


function pressOnFournisseurId(ev) {
  try {

    if (ev.keyCode==13) {

      document.getElementById('Numero').value = "";
      document.getElementById('Raison_Sociale').value = "";
			aAvoirs.clearParams();
			aAvoirs.setParam('Fournisseur_Id', document.getElementById('Fournisseur_Id').value);
			aAvoirs.initTree();
			unloadApercu();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#pressOnFournisseurId : ' + e);
  }
}


function pressOnRaisonSociale(ev) {
  try {

    if (ev.keyCode==13) {

			document.getElementById('Numero').value = "";
      document.getElementById('Fournisseur_Id').value = "";
			aAvoirs.clearParams();
			aAvoirs.setParam('Raison_Sociale', document.getElementById('Raison_Sociale').value);
			aAvoirs.initTree();
			unloadApercu();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#pressOnRaisonSociale : ' + e);
  }
}


function pressOnTree(ev) {
  try {

    if (ev.keyCode==13) {
    	choixAvoir();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#pressOnTree : ' + e);
  }
}

function ouvrirAvoir(avoir_id) {
  try {

		window.arguments[0](avoir_id);
    window.close();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#ouvrirAvoir : ' + e);
  }
}


function choixAvoir() {
	try {

		var tree = document.getElementById('avoirs');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var avoir_id = getCellText(tree,tree.currentIndex,'ColAvoir_Id');

			ouvrirAvoir(avoir_id);
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#choixAvoir : ' + e);
  }
}


function loadApercu() {
	try {

		aApercu.deleteTree();

		var tree = document.getElementById('avoirs');

		if (tree.view!=null && tree.currentIndex!=-1) {
			var avoir_id = getCellText(tree,tree.currentIndex,'ColAvoir_Id');
			var numero = getCellText(tree,tree.currentIndex,'ColNum_Entier');
			document.getElementById('Num_Avoir').value = numero;
			aApercu.setParam('Avoir_Id', avoir_id);
			aApercu.initTree();
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#loadApercu : ' + e);
  }
}


function unloadApercu() {
	try {

		document.getElementById('Num_Avoir').value = "";
		aApercu.deleteTree();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_avoir.js#unloadApercu : ' + e);
  }
}


