/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var aApercu = new Arbre('fact', 'apercu_facture_fournisseur.tmpl', 'apercu');
var aFacts = new Arbre('fact', 'liste_factures_fournisseur.tmpl', 'factures');


function init() {
  try {

    var x = (screen.width / 2) - 450;
    var y = (screen.height / 2) - 250;
    window.resizeTo(900,500);
    window.moveTo(x,y);
    document.getElementById('Numero').focus();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#init : ' + e);
  }
}


function pressOnId(ev) {
  try {

    if (ev.keyCode==13) {
      document.getElementById('Fournisseur_Id').value = "";
      document.getElementById('Raison_Sociale').value = "";
			aFacts.clearParams();
			aFacts.setParam('Num_Facture', document.getElementById('Numero').value);
			aFacts.initTree();
			unloadApercu();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#pressOnId : ' + e);
  }
}


function pressOnFournisseurId(ev) {
  try {

    if (ev.keyCode==13) {

      document.getElementById('Numero').value = "";
      document.getElementById('Raison_Sociale').value = "";
			aFacts.clearParams();
			aFacts.setParam('Fournisseur_Id', document.getElementById('Fournisseur_Id').value);
			aFacts.initTree();
			unloadApercu();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#pressOnFournisseurId : ' + e);
  }
}


function pressOnRaisonSociale(ev) {
  try {

    if (ev.keyCode==13) {

			document.getElementById('Numero').value = "";
      document.getElementById('Fournisseur_Id').value = "";
			aFacts.clearParams();
			aFacts.setParam('Raison_Sociale', document.getElementById('Raison_Sociale').value);
			aFacts.initTree();
			unloadApercu();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#pressOnRaisonSociale : ' + e);
  }
}


function pressOnTree(ev) {
  try {

    if (ev.keyCode==13) {
    	choixFacture();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#pressOnTree : ' + e);
  }
}


function ouvrirFacture(facture_id) {
  try {

		window.arguments[0](facture_id);
    window.close();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#ouvrirFacture : ' + e);
  }
}


function choixFacture() {
	try {

		var tree = document.getElementById('factures');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var facture_id = getCellText(tree,tree.currentIndex,'ColFacture_Id');

			ouvrirFacture(facture_id);
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#choixFacture : ' + e);
  }
}


function loadApercu() {
	try {

		aApercu.deleteTree();

		var tree = document.getElementById('factures');

		if (tree.view!=null && tree.currentIndex!=-1) {
			var facture_id = getCellText(tree,tree.currentIndex,'ColFacture_Id');
			var numero = getCellText(tree,tree.currentIndex,'ColNum_Entier');
			document.getElementById('Num_Facture').value = numero;
			aApercu.setParam('Facture_Id', facture_id);
			aApercu.initTree();
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#loadApercu : ' + e);
  }
}


function unloadApercu() {
	try {

		document.getElementById('Num_Facture').value = "";
		aApercu.deleteTree();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/recherches/rech_facture_fournisseur.js#unloadApercu : ' + e);
  }
}
