/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Gestion de l'affectation manuelle d'un rglement ou d'un avoir  une chance
 * Gestion des vnements sur la fentre <facturation/user/reglements/affectation_automatique.xul>
 */

var arbre_banque_client=new Arbre("fact","liste_banque_client.tmpl","affectation_input_Banque_Client");
var arbre_affectation_echeance=new Arbre("fact","liste_echeance.tmpl","tree_affectation_echeance");
var arbre_affectation_reglement=new Arbre("fact","liste_reglement.tmpl","tree_affectation_reglement");

var affectation_param_save="aaa";
var affectation_reglement_param_save="aaa";
var selection=new Array();
var num_Compte;
var type;
var input_Journal_Banque;
var input_Date;
var Client_Id_text;
var Client_text;
var input_Banque_Client;
var input_Mode_R;
var input_Num_Piece;
var input_Montant;
var Commentaire;


function affectation_change_mod() {
	try {
		var mode=document.getElementById('affectation_input_Mode_R').value;
		var corps = cookie() +"&Page=Facturation/Reglements/getTypeReglement.tmpl&ContentType=xml&Mode_R="+urlEncode(mode);
		var p = requeteHTTP(corps);

		var type = p.responseXML.documentElement.getAttribute("type");
		if (type=="ESPECES")
		{
			document.getElementById('affectation_input_Banque_Client').value="";
			document.getElementById('affectation_input_Banque_Client').disabled=true;
		}
		else
		{
			document.getElementById('affectation_input_Banque_Client').disabled=false;
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_change_mod' + e);
	}

}

function affectation_compte(corps) {
	try {

		var p = requeteHTTP(corps);

		var compte = p.responseXML.documentElement.getAttribute("compte");
		document.getElementById('affectation_num_Compte').value=compte;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_compte : ' + e);
	}
}

function affectation_raison(corps) {
	try {
		var p = requeteHTTP(corps);

		var raison = p.responseXML.documentElement.getAttribute("Raison");
		document.getElementById('affectation_Client_text').value=raison;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_raison : ' + e);
	}
}


function affectation_modifier_montant() {
	try {
		var tree = document.getElementById('tree_affectation_reglement');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var Montant_Restant = getCellText(tree,tree.view.selection.currentIndex, 'affectation_reglement_Montant_Restant');
			document.getElementById('affectation_Montant').value=Montant_Restant;
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_modifier_montant : ' + e);
	}
}


function affectation_rechercher() {
	try {

		var url="chrome://opensi/content/facturation/user/clients/rech_client.xul?"+ cookie()+"&Field_Client=affectation_Client";
		window.openDialog(url,'Recherche d\'un client','chrome,modal');

		var code_client=document.getElementById('affectation_Client').value;

		var corps = cookie() +"&Page=Facturation/Reglements/getNumCompte.tmpl&ContentType=xml&Client_Id="+code_client;
		affectation_compte(corps);
		document.getElementById('affectation_Client_text').disabled=true;

		var corps = cookie() +"&Page=Facturation/Reglements/getNomClient.tmpl&ContentType=xml&Client_Id="+code_client;
		affectation_raison(corps);

		arbre_banque_client.clearParams();
		arbre_banque_client.addParam("Client_Id",code_client);
		arbre_banque_client.initTree();


	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_rechercher' + e);
	}

}

function affectation_enlever() {
	try {

		document.getElementById('affectation_Client').value='';
		document.getElementById('affectation_Client_text').disabled=false;
		document.getElementById('affectation_Client_text').value='';
		document.getElementById('affectation_Client_text').focus();

		arbre_banque_client.deleteTree();
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_enlever : ' + e);
	}

}

function affectation_tri(mod) {
	try {

		selection=new Array();
		if (par!=affectation_param_save || mod=="oui")
		{
			affectation_param_save=par;
			arbre_affectation_echeance.clearParams();
			if (mode!="")
			 	arbre_affectation_echeance.addParam("Mode",mode);
			if (isDate(datedeb) && datedeb.length==10)
			 	arbre_affectation_echeance.addParam("Date_Deb",prepareDateJava(datedeb));
			if (isDate(datefin) && datefin.length==10 )
				arbre_affectation_echeance.addParam("Date_Fin",prepareDateJava(datefin));
			if (!isEmpty(client)) {
				arbre_affectation_echeance.addParam("Client",client);
			}
			arbre_affectation_echeance.addParam("Hist",false);

			arbre_affectation_echeance.initTree();


		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_tri' + e);
	}

}

function affectation_reglement_tri(mod) {
	try {

		var check_reg=document.getElementById('check_reglement').checked;
		var check_avo=document.getElementById('check_avoir').checked;
		var param="";

		if (check_reg || check_avo)
		{
			affectation_regl=false;
			arbre_affectation_reglement.clearParams();
			if (check_reg) {
				arbre_affectation_reglement.addParam("Regl",true);
				param+="&Regl="+true;
			}
			if (check_avo) {
				arbre_affectation_reglement.addParam("Avoir",true);
				param+="&Avoir="+true;
			}
			arbre_affectation_reglement.addParam("Hist",false);
			arbre_affectation_reglement.initTree();
			if (param!=affectation_reglement_param_save || mod=="oui")
			{
				affectation_reglement_param_save=param;
				arbre_affectation_reglement.initTree();
				affectation_calcul_total(param);
			}
		}
		else
		{
			affectation_reglement_param_save="";
			document.getElementById('affectation_lblTotNonAff').value="0.00";
			arbre_affectation_reglement.deleteTree();
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_reglement_tri' + e);
	}

}

function affectation_nouv() {
	try {

		document.getElementById('nouv_reg').collapsed=!document.getElementById('nouv').checked;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_nouv' + e);
	}
}

/*   cette fonction de slection pose des problmes : slctionne les mauvaises lignes pendant que ca charge l'arbre

function affectation_selection() {
	try {
		var sel=document.getElementById('tree_affectation_echeance').currentIndex;
		var i=0;
		var supp=false;
		while (i<=selection.length-1 && !supp)
		{
			if (sel==selection[i])
				supp=true;
			i++;
		}
		if (supp)
			selection.splice(i-1,1)
		else
			selection.push(sel);
		selection.sort();
		document.getElementById('tree_affectation_echeance').view.selection.clearSelection();
		for (var d=0;d<=selection.length-1;d++)
		{
			document.getElementById('tree_affectation_echeance').view.selection.rangedSelect(selection[d],selection[d],true);
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_selection' + e);
	}
}
*/

function affectation_regulariser() {
	try {
		var tree = document.getElementById('tree_affectation_reglement');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var corps = cookie() +"&Page=Facturation/Reglements/getTransfert_Reglements.tmpl&ContentType=xml";
			var p = requeteHTTP(corps);

			var type = getCellText(tree,tree.view.selection.currentIndex,'affectation_reglement_Type');
			if (type!="Avoir") {
				var reglement_Id = getCellText(tree,tree.view.selection.currentIndex, 'affectation_reglement_Reglement_Id');
				var Transfert_Reglements = p.responseXML.documentElement.getAttribute("Transfert_Reglements");
				if (Transfert_Reglements=="1")
				{
					var page ="chrome://opensi/content/facturation/user/reglements/regulariser.xul?"+ cookie();
					page +="&Reglement_Id="+reglement_Id;
					window.openDialog(page,'Rgulariser le rglement','chrome,modal',modif_aff);
				}
				else {
					if (confirm("Etes-vous sr de vouloir rgulariser ce rglement?")) {
						var corps = cookie() +"&Page=Facturation/Reglements/regulariserReglement.tmpl&ContentType=xml&Reglement_Id="+reglement_Id;
						var p = requeteHTTP(corps);

						modif_aff(false,false,true,false,true);
					}
				}
			}
			else {
				showWarning("Vous ne pouvez pas rgulariser un avoir");
			}
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_regulariser : ' + e);
	}
}

function affectation_rembourser() {
	try {
		var tree = document.getElementById('tree_affectation_reglement');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var corps = cookie() +"&Page=Facturation/Reglements/getTransfert_Reglements.tmpl&ContentType=xml";
			var p = requeteHTTP(corps);

			var Transfert_Reglements = p.responseXML.documentElement.getAttribute("Transfert_Reglements");
			var page ="chrome://opensi/content/facturation/user/reglements/rembourser.xul?"+ cookie();
			var type = getCellText(tree,tree.view.selection.currentIndex,'affectation_reglement_Type');
			var Client_Id = getCellText(tree,tree.view.selection.currentIndex,'affectation_reglement_Client_Id');
			page +="&type="+urlEncode(type);
			page +="&Client_Id="+urlEncode(Client_Id);
			if (type=="Avoir") {
				page +="&Avoir_Id="+getCellText(tree,tree.view.selection.currentIndex, 'affectation_reglement_Reglement_Id');
			}
			else {
				var reglement_Id=getCellText(tree,tree.view.selection.currentIndex, 'affectation_reglement_Reglement_Id');
				page +="&Reglement_Id="+reglement_Id;
				if (Client_Id!="") {
					var corps = cookie() +"&Page=Facturation/Reglements/getEcheanceReglement.tmpl&ContentType=xml";
					corps+="&Reglement_Id="+reglement_Id;
					var p = requeteHTTP(corps);

					page +="&bloque="+p.responseXML.documentElement.getAttribute("bloque");
				}
				else {
					page +="&bloque=true";
				}
			}
			page +="&Montant="+getCellText(tree,tree.view.selection.currentIndex, 'affectation_reglement_Montant_Restant');
			page +="&Transfert="+Transfert_Reglements;
			window.openDialog(page,'Rembourser le rglement','chrome,modal',changer_page);
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_rembourser : ' + e);
	}
}

function changer_page(page) {
	try {
		window.location = page;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#changer_page : ' + e);
	}
}

function affectation_supprimer() {
	try {
		var tree = document.getElementById('tree_affectation_reglement');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var type = getCellText(tree,tree.view.selection.currentIndex,'affectation_reglement_Type');
			if (type!="Avoir") {
				var reglement_Id = getCellText(tree,tree.view.selection.currentIndex, 'affectation_reglement_Reglement_Id');

				var corps = cookie() +"&Page=Facturation/Reglements/getRegulariserEcheanceReglement.tmpl&ContentType=xml";
				corps+="&Reglement_Id="+reglement_Id;
				var p = requeteHTTP(corps);

				var Regulariser = p.responseXML.documentElement.getAttribute("Regulariser");
				if (Regulariser==0.00) {
					var Comptabilise = getCellText(tree,tree.view.selection.currentIndex, 'affectation_reglement_Comptabilise');
					var ok=true;
					if (Comptabilise==1) {
						ok=confirm("Ce rglement a dj t transfr en comptabilit, etes vous sur de vouloir continuer?");
					}
					if (ok) {
						if (confirm("Etes-vous sr de vouloir supprimer ce rglement?")) {
							var corps = cookie() +"&Page=Facturation/Reglements/supprimerReglement.tmpl&ContentType=xml";
							corps+="&Reglement_Id="+reglement_Id;
							var p = requeteHTTP(corps);

							modif_aff(true,true,true,true,true);
						}
					}
				}
				else {
					showWarning("Vous devez d'abord annuler la rgularisation des chances concernes par ce rglement");
				}
			}
			else {
				showWarning("Vous ne pouvez pas supprimer un avoir");
			}
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_supprimer : ' + e);
	}
}


function affectation_vider() {
	try {
		document.getElementById('affectation_Client').value="";
		document.getElementById('affectation_Client_text').value="";
		document.getElementById('affectation_Client_text').disabled=false;
		document.getElementById("affectation_num_Compte").value="";
		document.getElementById("affectation_input_Banque_Client").value="";
		document.getElementById("affectation_input_Banque_Client").disabled=false;
		document.getElementById("affectation_input_Num_Piece").value="";
		document.getElementById("affectation_input_Montant").value="";
		document.getElementById("affectation_Commentaire").value="";

		var corps = cookie() +"&Page=Facturation/Reglements/getNumCompte.tmpl&ContentType=xml";
		affectation_compte(corps);
		arbre_banque_client.deleteTree();
		document.getElementById("affectation_input_Mode_R").selectedIndex=0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_vider : ' + e);
	}

}

function affectation_calcul_total(param) {
	try {
		var corps = cookie() +"&Page=Facturation/Reglements/getCalculReglement.tmpl&ContentType=xml" + param;
		affectation_calcul(corps);
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_calcul_total' + e);
	}

}

function affectation_calcul(corps) {
	try {
		var p = requeteHTTP(corps);

		var nonAff = p.responseXML.documentElement.getAttribute("nonAff");
		document.getElementById('affectation_lblTotNonAff').value=nonAff;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_calcul : ' + e);
	}

}

function affectation_initMode_R() {
	try {
		document.getElementById('affectation_input_Mode_R').selectedIndex = 0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_initMode_R : ' + e);
	}
}

function affectation_initJournal_Banque() {
	try {
		document.getElementById('affectation_input_Journal_Banque').selectedIndex = 0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_initJournal_Banque : ' + e);
	}
}

/****************************************************
 *	Actions de validation
 ****************************************************/

function affectation_nouv_validSaisie(e) {
	try{

		input_Date = document.getElementById("affectation_input_Date").value;

		var corps = cookie() +"&Page=Facturation/Reglements/compDateRegDebut.tmpl&ContentType=xml&DateReg="+prepareDateJava(input_Date);
		var p = requeteHTTP(corps);

		var correct = p.responseXML.documentElement.getAttribute("correct");
		if (correct=="true") {
			num_Compte = document.getElementById("affectation_num_Compte").value;
			input_Journal_Banque = document.getElementById("affectation_input_Journal_Banque").value;
			Client_Id_text = document.getElementById("affectation_Client").value;
			Client_text = document.getElementById("affectation_Client_text").value;
			input_Banque_Client = document.getElementById("affectation_input_Banque_Client").value;
			input_Mode_R = document.getElementById("affectation_input_Mode_R").value;
			input_Num_Piece = document.getElementById("affectation_input_Num_Piece").value;
			input_Montant = document.getElementById("affectation_input_Montant").value;
			Commentaire = document.getElementById("affectation_Commentaire").value;

			if (isEmpty(input_Date)) { showWarning('Date du rglement manquante !'); return false; }
			else if (!isDate(input_Date)) { showWarning('Date du rglement incorrecte !'); return false; }
			else if (input_Mode_R=="") { showWarning("Le champs Mode de rglement n'est pas renseign !"); return false; }
			else if (input_Mode_R!="Espece" && isEmpty(input_Banque_Client)) { showWarning("le champs 'Banque Client' n'est pas renseign !"); return false; }
			else if (isEmpty(Client_text)) { showWarning("le champs 'Nom du Client' n'est pas renseign !"); return false; }
			else if (isEmpty(input_Montant)) { showWarning("le champs 'Montant' n'est pas renseign !"); return false; }
			else if (isNaN(input_Montant)) { showWarning("Mauvais formatage de la valeur du rglement"); return false; }
			else if (parseFloat(input_Montant)<=0) { showWarning("Le montant doit tre positif"); return false; }

			var corps = cookie() +"&Page=Facturation/Reglements/getTypeReglement.tmpl&ContentType=xml&Mode_R="+urlEncode(input_Mode_R);
			var p = requeteHTTP(corps);
			if (p.status != "200") {
				alert("Rception erreur " + p.status);
				return true;
			}
			else
			{
				type = p.responseXML.documentElement.getAttribute("type");
				if (type=="ESPECES") {
					var corps = cookie() +"&Page=Facturation/Reglements/getTransfert_Reglements.tmpl&ContentType=xml";
					var p = requeteHTTP(corps);

					var Transfert_Reglements = p.responseXML.documentElement.getAttribute("Transfert_Reglements");
					if (Transfert_Reglements=="1"){
						var corps = cookie() +"&Page=Facturation/Reglements/getContrePartie.tmpl&ContentType=xml";
						corps+="&Code_Journal="+urlEncode(input_Journal_Banque);
						var p = requeteHTTP(corps);

						var ContrePartie = p.responseXML.documentElement.getAttribute("Contre_Partie");
						if (ContrePartie!="") {
							creerRegl();
						}
						else {
							var page ="chrome://opensi/content/facturation/user/reglements/changer_ContrePartie.xul?"+ cookie();
							page +="&Journal_Banque="+urlEncode(input_Journal_Banque);
							window.openDialog(page,'Indiquez le compte de contre partie du journal','chrome,modal',creerRegl);
						}
					}
					else {
						creerRegl();
					}
				}
				else {
					creerRegl();
				}
			}
		}
		else {
			showWarning("Date incorrecte, la date doit tre suprieure  la date de dbut du premier exercice");
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_nouv_validSaisie : ' + e);
	}
}


function creerRegl() {
	try{
		var corps = cookie() +"&Page=Facturation/Reglements/creerReglement.tmpl&ContentType=xml";
		input_Date=prepareDateJava(input_Date);
		corps += "&Type_Reg="+urlEncode(type);
		corps += "&Date="+ urlEncode(input_Date);
		corps += "&num_Compte="+ urlEncode(num_Compte);
		corps += "&Journal_Banque="+ urlEncode(input_Journal_Banque);
		corps += "&Client_Id="+ urlEncode(Client_Id_text);
		corps += "&Client="+ urlEncode(Client_text);
		corps += "&Banque_Client="+ urlEncode(input_Banque_Client);
		corps += "&Mode_R="+ urlEncode(input_Mode_R);
		corps += "&Num_Piece="+ urlEncode(input_Num_Piece);
		corps += "&Montant="+ urlEncode(input_Montant);
		corps += "&Commentaire="+ urlEncode(Commentaire);

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;
		if (contenu.getAttribute("message")=="fini")
		{
			affectation_vider();
			modif_aff(false,false,true,false,true);

		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectation.js#creerRegl' + e);
	}
}

function affectation_keypress(e) {
	try {
		switch(e.keyCode) {
			case 13:
			 	affectation_validAffectation();
			break;
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/menu_reglement.js#affectation_keypress : ' + e);
	}
}

function affectation_validAffectation(){
	try{

		var input_Montant=document.getElementById("affectation_Montant").value;

		if (isEmpty(input_Montant)) { showWarning("Le montant doit tre renseign"); return false; }
		else if (parseFloat(input_Montant)<=0) { showWarning("Le montant doit tre positif"); return false; }
		var tree = document.getElementById('tree_affectation_echeance');
		var rangeCount = tree.view.selection.getRangeCount();
		var tree_reg = document.getElementById('tree_affectation_reglement');
		var Cli_Id = getCellText(tree_reg,tree_reg.view.selection.currentIndex,'affectation_reglement_Client_Id');
		var Rais = getCellText(tree_reg,tree_reg.view.selection.currentIndex,'affectation_reglement_Raison');
		if (tree_reg.view!=null && tree_reg.currentIndex!=-1 && tree.view!=null && tree.currentIndex!=-1 )
		{
			Client_Id = new Array();
			Raison = new Array();
			Echeance_Id = new Array();
			Mod = new Array();
			Montant = new Array();
			var j=0;
			for(var i=0; i<rangeCount; i++)
			{
				var start = {};
 				var end = {};
 				tree.view.selection.getRangeAt(i,start,end);
				for(var c=start.value; c<=end.value; c++)
				{
					var client = getCellText(tree,c,'affectation_Client_Id');
					var raison = getCellText(tree,c,'affectation_Raison');

					if (!isEmpty(Cli_Id) && client.toUpperCase()==Cli_Id.toUpperCase()) {
						Client_Id[j] = client;
						Raison[j] = raison;
						Echeance_Id[j] = getCellText(tree,c,'affectation_Echeance_Id');
						Mod[j] = getCellText(tree,c,'affectation_Mode_Reglement');
						Montant[j] = getCellText(tree,c,'affectation_montantresttri');
						j+=1;
					}
					else if (!isEmpty(Rais) && isEmpty(client) && raison.toUpperCase()==Rais.toUpperCase()) {
						Client_Id[j] = client;
						Raison[j] = raison;
						Echeance_Id[j] = getCellText(tree,c,'affectation_Echeance_Id');
						Mod[j] = getCellText(tree,c,'affectation_Mode_Reglement');
						Montant[j] = getCellText(tree,c,'affectation_montantresttri');
						j+=1;
					}
					else {
						showWarning("Vous ne pouvez pas imputer le rglement  un client diffrent que celui indiqu");
						return false;
					}
				}
			}
			var reglement_Id = getCellText(tree_reg,tree_reg.view.selection.currentIndex,'affectation_reglement_Reglement_Id');
			var affectation_Montant_Restant = getCellText(tree_reg,tree_reg.view.selection.currentIndex,'affectation_reglement_montantresttri');
			var type = getCellText(tree_reg,tree_reg.view.selection.currentIndex,'affectation_reglement_Type');

			if ((parseFloat(input_Montant)*100)>parseFloat(affectation_Montant_Restant)) { showWarning("Le montant doit tre infrieur ou gal au montant restant du rglement"); return false; }

			var total=0;
			var montantok=false;
			for (var i=0;i<Montant.length;i++)
			{
				total+=parseFloat(Montant[i]);
			}
			if ((total/100)>=parseFloat(input_Montant))
			{
				montantok=true;
			}
			else
			{
				if (window.confirm("le montant rempli est suprieur au montant restant d des chances slctionns tes-vous sr de vouloir continuer?"))
					montantok=true;
				else
					montantok=false;
			}
			if (montantok)
			{
				if (type=='Avoir')
				{
					var corps = cookie() +"&Page=Facturation/Reglements/affecterAvoir.tmpl&ContentType=xml";
					corps +="&Avoir_Id="+reglement_Id;
				}
				else
				{
					var corps = cookie() +"&Page=Facturation/Reglements/affecterReglement.tmpl&ContentType=xml";
					corps +="&Reglement_Id="+reglement_Id;
				}
				corps += "&Echeance_Id=";

				for (var i=0;i<Echeance_Id.length;i++)
				{
					corps +=Echeance_Id[i];
					if (i!=Echeance_Id.length-1)
						corps +=",";
				}
				corps +="&Montant="+input_Montant;
				if ((parseFloat(input_Montant)*100)>=total)
				{
					corps +="&Montant_Restant="+(parseFloat(affectation_Montant_Restant)-total)/100;
					if (total>=parseFloat(affectation_Montant_Restant))
						corps +="&Tout=true";

				}
				else
				{
					corps +="&Montant_Restant="+(parseFloat(affectation_Montant_Restant)-(parseFloat(input_Montant)*100))/100;
					if ((parseFloat(input_Montant)*100)>=parseFloat(affectation_Montant_Restant))
						corps +="&Tout=true";

				}
				var p = requeteHTTP(corps);

				var message = p.responseXML.documentElement.getAttribute("message");

				if (message=="fini") {

					modif_aff(true,true,true,true,true);
					document.getElementById('affectation_Montant').value="";
				}
				else {
					showWarning("Erreur sur le serveur");
				}
			}
		}
		else
		{
			showWarning("Vous devez slctionner un rglement et une ou plusieurs chances");
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/affectations.js#affectation_validAffectation : ' + e);
	}
}

