/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Fenetre de gestion des relances
 * Gestion des vnements sur la fentre <facturation/user/reglements/relances.xul>
 */


var relances=new Arbre("fact","liste_relances.tmpl","relances");
var relances_en_cours=new Arbre("fact","liste_relances.tmpl","relances_en_cours");
var nb_encours=0;

function init() {
	try {
		relances.addParam("Etat","relances");
		relances.initTree(init_encours);
		var httpRequest = new QueryHttp("Facturation/Reglements/relancesEnCours.tmpl");
		var p = httpRequest.execute();

		nb_encours = p.responseXML.documentElement.getAttribute("nombre");
	} catch (e) {
		recup_erreur('erreur dans erreur dans facturation/user/reglements/relances.js#init : ' + e);
	}
}

function init_encours() {
	try {
		relances_en_cours.addParam("Etat","relances_en_cours");
		relances_en_cours.initTree();
	} catch (e) {
		recup_erreur('erreur dans erreur dans facturation/user/reglements/relances.js#init_encours : ' + e);
	}
}


function liste_rel(type) {
	var rel = false;
	try {
		var tree = document.getElementById(type);
		if (tree.view.rowCount!=0) {
			rel=true;
		}
	} catch (e) {
		recup_erreur('erreur dans erreur dans facturation/user/reglements/relances.js#liste_rel : ' + e);
	}
	return rel;
}


function generer_premier_pdf() {
	try {
		var rel = liste_rel("relances");
		if (rel) {
			var page = "chrome://opensi/content/facturation/user/reglements/relances_pdf.xul?" + cookie();
			page += "&Premier="+true;
			window.location = page;
		}
		else {
			showWarning("Il n'y a pas de relances a gnrer");
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/relances.js#generer_premier_pdf : ' + e);
	}
}

function generer_pdf() {
	try {
		var rel = liste_rel("relances_en_cours");
		if (rel && nb_encours>0) {
			var page = "chrome://opensi/content/facturation/user/reglements/relances_pdf.xul?" + cookie();
			window.location = page;
		}
		else {
			showWarning("Il n'y a pas de relances en cours");
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/relances.js#generer_pdf : ' + e);
	}
}

function generer_en_cours_pdf() {
	try {
		var rel = liste_rel("relances_en_cours");
		if (rel) {
			var page = "chrome://opensi/content/facturation/user/reglements/relances_pdf.xul?" + cookie();
			page += "&Cours="+true;
			window.location = page;
		}
		else {
			showWarning("Il n'y a pas de relances en cours");
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/relances.js#generer_en_cours_pdf : ' + e);
	}
}

function retour_reglements() {
	try {

		var page = "chrome://opensi/content/facturation/user/reglements/menu_reglement.xul?" + cookie();
		page += "&Retour="+true;
		window.location = page;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/relances.js#retour_reglements : ' + e);
	}
}

function ouvrir_relance(id_tree,idop) {
	try {
		var tree = document.getElementById(id_tree);
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var opid = getCellText(tree,tree.view.selection.currentIndex,idop);
			var url = "chrome://opensi/content/facturation/user/reglements/detail_relances.xul?" ;
			url += cookie() +"&id=" + opid;
			window.openDialog(url,'dtail de relance','chrome,modal');
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/relances.js#ouvrir_relance : ' + e);
	}
}

function retour_menu_principal() {
	try {

		var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ parent.document.getElementById("nom_dossier").value;
		window.location = page;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/relances.js#retour_menu_principal : ' + e);
	}
}
