/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Fenetre de rgularisation pour choisir les informations a mettre dans la lettre
 * Gestion des vnements sur la fentre <facturation/user/reglements/rembourser.xul>
 */

var reglement=false;
var transfert;
var page;
var maximum;
var client_Id;

function init() {
	try {

		reglement=!isEmpty(ParamValeur("Reglement_Id"));
		client_Id=!isEmpty(ParamValeur("Client_Id"));
		transfert=ParamValeur("Transfert")==1;

		var x = (screen.width / 2) - 300;
		var y = (screen.height / 2) - 150;
		window.resizeTo(600,300);
		window.moveTo(x,y);

		var arbre=new Arbre("cpta","liste_journaux.tmpl","journal");
		arbre.addParam("Type_Journal","TR");
		arbre.addParam("Factu","1");
		arbre.initTree(initJournaux);

		var arbre_mode=new Arbre("fact","liste_reglements.tmpl","input_Mode_R_Init");
		arbre_mode.addParam("Compta","1");
		arbre_mode.initTree(initMode_R);
		document.getElementById('motif').value="retmarch";
		if (reglement) {
			document.getElementById('type').value="Remboursement du rglement slctionn :";
			document.getElementById('mot').hidden=false;
			document.getElementById('dat').hidden=false;
		}
		else {
			document.getElementById('type').value="Remboursement de l'avoir slctionn :";
		}
		if (transfert) {
			document.getElementById('jour').hidden=false;
		}
		document.getElementById('montant').value=ParamValeur("Montant");
		maximum=ParamValeur("Montant");
		if (ParamValeur("bloque")=="true") {
			document.getElementById('motif').value="autre";
			document.getElementById('motif').setAttribute("label","Autre");
			document.getElementById('motif').disabled=true;
			changer_motif();
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/rembourser.js#init : ' + e);
	}
}

function initJournaux() {
	try {
		document.getElementById('journal').selectedIndex=0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/rembourser.js#initJournaux : ' + e);
	}
}

function initMode_R() {
	try {
		document.getElementById('input_Mode_R_Init').selectedIndex = 0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/rembourser.js#initMode_R : ' + e);
	}
}

function changer_motif() {
	try {
		var val=document.getElementById('motif').value;
		if (val=="retmarch" || val=="recl" || val=="com" ) {
			document.getElementById('dat').hidden=false;
			document.getElementById('text').hidden=true;
			document.getElementById('mreg').hidden=false;
		}
		else if (val=="autre") {
			document.getElementById('dat').hidden=true;
			document.getElementById('text').hidden=false;
			document.getElementById('mreg').hidden=true;
		}
		else {
			document.getElementById('dat').hidden=true;
			document.getElementById('text').hidden=true;
			document.getElementById('mreg').hidden=false;
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/rembourser.js#changer_motif : ' + e);
	}
}

function changer() {
	try {

		var date = document.getElementById("date").value;
		var val=document.getElementById('motif').value;
		var texte=document.getElementById('texte').value;

		var Montant=document.getElementById('montant').value;
		if (isNaN(Montant)) { showWarning("Mauvais formatage de la valeur"); return false; }
		else if (parseFloat(Montant)<=0) { showWarning("Le montant doit tre positif"); return false; }
		else if (parseFloat(Montant)>parseFloat(maximum)) { showWarning("Le montant ne peut pas etre suprieur au montant restant"); return false; }

		page ="chrome://opensi/content/facturation/user/reglements/rembourser_pdf.xul?"+ cookie();
		page+="&Transfert="+transfert;
		if (reglement) {
			page +="&Reglement_Id="+ParamValeur("Reglement_Id");
			var val=document.getElementById('motif').value;
			if (val=="retmarch" || val=="recl" || val=="com") {
				if (!isDate(date)) { showWarning('Date incorrecte !'); return false; }
				page +="&Motif="+urlEncode(val);
				page +="&Date="+prepareDateJava(date);
			}
			else if (val=="autre") {
				if (texte=="") { showWarning("Le champs texte n'est pas renseign !"); return false; }
				page +="&Motif="+urlEncode(val);
				page +="&Texte="+urlEncode(texte);
			}
			else {
				page +="&Motif="+urlEncode(val);
			}
		}
		else {
			page +="&Avoir_Id="+ParamValeur("Avoir_Id");
		}
		page +="&Journal="+urlEncode(document.getElementById('journal').value);
		page +="&Mode_Reg="+urlEncode(document.getElementById('input_Mode_R_Init').value);
		page +="&Montant="+Montant;
		page +="&Montant_Total="+maximum;

		if (transfert) {
			var corps = cookie() +"&Page=Facturation/Reglements/getContrePartie.tmpl&ContentType=xml";
			corps+="&Code_Journal="+urlEncode(document.getElementById('journal').value);
			var p = requeteHTTP(corps);

			var ContrePartie = p.responseXML.documentElement.getAttribute("Contre_Partie");
			if (ContrePartie!="") {
				validchanger(0);
			}
			else {
				var pop ="chrome://opensi/content/facturation/user/reglements/changer_ContrePartie.xul?"+ cookie();
				pop +="&Journal_Banque="+urlEncode(document.getElementById('journal').value);
				window.close();
				window.openDialog(pop,'Indiquez le compte de contre partie du journal','chrome,modal',validchanger,window.arguments[0],page);
			}
		}
		else {
			validchanger(0);
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/rembourser.js#changer : ' + e);
	}
}

function validchanger() {
	try {
		window.close();
		window.arguments[0](page);
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/rembourser.js#validchanger : ' + e);
	}
}
