/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Choix des type de rglement et journal pour remise en banque des rglements
 * Gestion des vnements sur la fentre <facturation/user/reglements/remise.xul>
 */

function liste_regl() {
	var liste = "";
	try {
		var tree = document.getElementById("remises");
		for (var i=0; i < tree.view.rowCount;i++) {
			liste += getCellText(tree,i,'Reglement_Id')+",";
		}
	} catch (e) {
		recup_erreur('erreur dans erreur dans facturation/user/reglements/remise.js#liste_regl : ' + e);
	}
	return liste;
}

function afficher() {
	try {
		var typr = document.getElementById('input_Type_R').value;
		var journal = document.getElementById('input_Journal_Banque').value;
		remises.setParam("Type_R",typr);
		remises.setParam("Journal",journal);
		remises.setParam("Remis",0);
		remises.initTree();
		total();
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/remise.js#afficher : ' + e);
	}
}

function generer_pdf() {
	try {
		var liste = liste_regl();
		if (!isEmpty(liste)) {
			var page = "chrome://opensi/content/facturation/user/reglements/remise_pdf.xul?" + cookie();
			page += "&Journal=" + document.getElementById('input_Journal_Banque').value;
			page += "&TypeR=" + document.getElementById('input_Type_R').value;
			page += "&Liste=" + liste+"&Remis=0";
			window.location = page;
		}
		else {
			showWarning("Aucun rglement ne correspond  ces critres");
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/remise.js#generer_pdf : ' + e);
	}
}

function total() {
	try {
		var typr = document.getElementById('input_Type_R').value;
		var journal = document.getElementById('input_Journal_Banque').value;
		var corps = cookie() +"&Page=Facturation/Reglements/getCalculRemise.tmpl&ContentType=xml";
		corps+="&Type_R="+urlEncode(typr);
		corps+="&Journal="+urlEncode(journal);
		corps+="&Remis=0";
		var p = requeteHTTP(corps);

		var total = p.responseXML.documentElement.getAttribute("total");
		document.getElementById('TotalRemise').value=total;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/remise.js#total' + e);
	}

}
