/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Choix de critres pour afficher l'historique de remise en banque
 * Gestion des vnements sur la fentre <facturation/user/reglements/remise_recherche.xul>
 */

var typr;
var journal;
var client;
var Date_Deb_Reg;
var Date_Deb_Rem;
var Date_Fin_Reg;
var Date_Fin_Rem;
var par;
var par_save="";


function rech_liste_regl() {
	var liste = "";
	try {
		var tree = document.getElementById("rech_remises");
		for (var i=0; i < tree.view.rowCount;i++) {
			liste += getCellText(tree,i,'rech_Reglement_Id')+",";
		}
	} catch (e) {
		recup_erreur('erreur dans erreur dans facturation/user/reglements/remise_recherche.js#liste_regl : ' + e);
	}
	return liste;
}

function rech_afficher() {
	try {
		typr = document.getElementById('rech_input_Type_R').value;
		journal = document.getElementById('rech_input_Journal_Banque').value;
		client = document.getElementById("Client").value;
		Date_Deb_Reg = document.getElementById("Date_Deb_Reg").value;
		Date_Deb_Rem = document.getElementById("Date_Deb_Rem").value;
		Date_Fin_Reg = document.getElementById("Date_Fin_Reg").value;
		Date_Fin_Rem = document.getElementById("Date_Fin_Rem").value;
		par="";
		par+="&Type_R="+urlEncode(typr);
		par+="&Journal="+urlEncode(journal);
		rech_remises.clearParams();
		if (isDate(Date_Deb_Reg) && Date_Deb_Reg.length==10) {
			rech_remises.addParam("Date_Deb_Reg",prepareDateJava(Date_Deb_Reg));
			par+="&Date_Deb_Reg="+prepareDateJava(Date_Deb_Reg);
		}
		if (isDate(Date_Deb_Rem) && Date_Deb_Rem.length==10) {
			rech_remises.addParam("Date_Deb_Rem",prepareDateJava(Date_Deb_Rem));
			par+="&Date_Deb_Rem="+prepareDateJava(Date_Deb_Rem);
		}

		if (isDate(Date_Fin_Reg) && Date_Fin_Reg.length==10) {
			rech_remises.addParam("Date_Fin_Reg",prepareDateJava(Date_Fin_Reg));
			par+="&Date_Fin_Reg="+prepareDateJava(Date_Fin_Reg);
		}

		if (isDate(Date_Fin_Rem) && Date_Fin_Rem.length==10) {
			rech_remises.addParam("Date_Fin_Rem",prepareDateJava(Date_Fin_Rem));
			par+="&Date_Fin_Rem="+prepareDateJava(Date_Fin_Rem);
		}

 		var corps =cookie()+ "&Page=Facturation/Reglements/existeClient.tmpl&ContentType=xml&Client_Id="+client;
		var p = requeteHTTP(corps);

		var message=p.responseXML.documentElement.getAttribute("existe");
		if (message=="true") {
			rech_remises.addParam("Client_Id",urlEncode(client));
			par+="&Client_Id="+client;
		}

		rech_remises.addParam("Type_R",typr);
		rech_remises.addParam("Journal",journal);
		rech_remises.addParam("Remis",1);
		if (par!=par_save) {
			par_save=par;
			rech_remises.initTree();
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/remise_recherche.js#rech_afficher : ' + e);
	}
}

function remise_recherche_keypress(e) {
	try {
		switch(e.keyCode) {
			case 13:
			 	rechercher();
			break;
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/remise_recherche.js#remise_recherche_keypress : ' + e);
	}
}

function rechercher(rech) {
	try {

		client = document.getElementById("Client").value;
		if (client=="") {rech_afficher();return false;}
 		var corps =cookie()+ "&Page=Facturation/Reglements/existeClient.tmpl&ContentType=xml&Client_Id="+client;
		var p = requeteHTTP(corps);

		var message=p.responseXML.documentElement.getAttribute("existe");
		if (message=="true") {
			rech_afficher();
		}
		else if (rech!="fin") {
			var url = "chrome://opensi/content/facturation/user/clients/rech_client.xul?"+ cookie()+"&Client_Id="+client;
			window.openDialog(url,'Recherche d\'un client','chrome,modal');
			rechercher("fin");
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/remise_recherche.js#rechercher' + e);
	}

}

function rech_generer_pdf() {
	try {
		var liste = rech_liste_regl();
		if (!isEmpty(liste)) {
			var url = "chrome://opensi/content/facturation/user/reglements/date_remise.xul?"+ cookie()+par;
			window.openDialog(url,'Recherche d\'une date de remise en banque','chrome,modal',rech_generer_pdf2);
		}
		else {
			showWarning("Aucun rglement ne correspond  ces critres");
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/remise_recherche.js#rech_generer_pdf : ' + e);
	}
}
function rech_generer_pdf2(date,comp) {
	try {
		var page = "chrome://opensi/content/facturation/user/reglements/remise_pdf.xul?" + cookie();
		page += "&Journal=" + document.getElementById('rech_input_Journal_Banque').value;
		page += "&TypeR=" + document.getElementById('rech_input_Type_R').value;
		page += "&Liste=0&Remis=1&Date_Remis="+date+"&Compta="+comp;
		window.location = page;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/remise_recherche.js#rech_generer_pdf2 : ' + e);
	}
}
