/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Choix des type de rglement et journal pour bordereau en banque des rglements
 * Gestion des vnements sur la fentre <facturation/user/reglements_fournisseur/bordereau.xul>
 */

function testcheck_bor() {
	try {

		var liste = document.getElementById("bordereaux");
		if (liste.currentItem!=null) {
			var item = liste.getItemAtIndex(liste.selectedIndex);
			var cks = item.getElementsByTagName("listcell");
			cks.item(0).setAttribute("checked",(cks.item(0).getAttribute("checked")=="true"?"false":"true"));
		}
		total();
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/affectation_automatique.js#testcheck_reg : ' + e);
	}
}

function afficher() {
	try {
		var typr = document.getElementById('input_Type_R').value;
		var journal = document.getElementById('input_Journal_Banque').value;
		bordereaux.setParam("Type_R",typr);
		bordereaux.setParam("Journal",journal);
		bordereaux.setParam("Remis",0);
		bordereaux.initTree(total);
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/bordereau.js#afficher : ' + e);
	}
}

function generer_pdf() {
	try {
		var liste = document.getElementById("bordereaux");
		liste_reglement = "";
		var nombreElements = liste.getRowCount();
		for (var i=0; i<nombreElements; i++) {
			if(liste.getItemAtIndex(i).getElementsByTagName("listcell").item(0).getAttribute("checked","true")=="true") {
				liste_reglement += liste.getItemAtIndex(i).value+",";
			}
		}
		if (!isEmpty(liste_reglement)) {
			var page = "chrome://opensi/content/facturation/user/reglements_fournisseur/bordereau_pdf.xul?" + cookie();
			page += "&Journal=" + document.getElementById('input_Journal_Banque').value;
			page += "&TypeR=" + document.getElementById('input_Type_R').value;
			page += "&Liste_Reglement=" + liste_reglement+"&Remis=0";
			window.location = page;
		}
		else {
			showWarning("Aucun rglement ne correspond  ces critres");
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/bordereau.js#generer_pdf : ' + e);
	}
}

function total() {
	try {
		var liste = document.getElementById("bordereaux");
		var nombreElements = liste.getRowCount();
		var total_Impute=0.00;
		for (var i=0; i<nombreElements; i++) {
			if(liste.getItemAtIndex(i).getElementsByTagName("listcell").item(0).getAttribute("checked","true")=="true"){
				total_Impute+=parseFloat(liste.getItemAtIndex(i).getElementsByTagName("listcell").item(3).getAttribute("label"));
			}
		}
		total_Impute=formatNombre(total_Impute,"0.00")
		document.getElementById('TotalBordereau').value=total_Impute;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/bordereau.js#total' + e);
	}

}
