/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Affichage de l'historique des chances et des reglements
 * Gestion des vnements sur la fentre <facturation/user/reglements_fournisseur/historique.xul>
 */

var historique_param_save="aaa";
var historique_reglement_param_save="aaa";
var selection=new Array();
var selectionEcheance_Id;

var arbre_echeance_reglement=new Arbre("fact","liste_echeance_reglement_fournisseur.tmpl","tree_historique_echeance_reglement");
var arbre_echeance_avoir=new Arbre("fact","liste_echeance_avoir_fournisseur.tmpl","tree_historique_echeance_reglement");
var arbre_historique_reglement_echeance=new Arbre("fact","liste_reglement_echeance_fournisseur.tmpl","tree_historique_reglement_echeance");
var arbre_historique_echeance=new Arbre("fact","liste_echeance_fournisseur.tmpl","tree_historique_echeance");
var arbre_historique_reglement=new Arbre("fact","liste_reglement_fournisseur.tmpl","tree_historique_reglement");

/*****************************************************
 *	@return l'id de l'arbre contenant les critures comptables.
 ****************************************************/

function historique_tri(mod) {
	try {
		if (par!=historique_param_save || mod=="oui")
		{
			historique_param_save=par;
			arbre_historique_echeance.clearParams();
			if (mode!="")
			 	arbre_historique_echeance.addParam("Mode",mode);
			if (isDate(datedeb) && datedeb.length==10)
			 	arbre_historique_echeance.addParam("Date_Deb",prepareDateJava(datedeb));
			if (isDate(datefin) && datefin.length==10 )
				arbre_historique_echeance.addParam("Date_Fin",prepareDateJava(datefin));
			if (!isEmpty(fournisseur))
				arbre_historique_echeance.addParam("Fournisseur",fournisseur);

			arbre_historique_reglement_echeance.deleteTree();
			arbre_historique_echeance.addParam("Hist",true);
			arbre_historique_echeance.initTree();
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#historique_tri' + e);
	}

}

function historique_reglement_tri(mod) {
	try {
		if (par!=historique_reglement_param_save || mod=="oui")
		{
			historique_reglement_param_save=par;

			arbre_historique_reglement.clearParams();
			if (mode!="")
			 	arbre_historique_reglement.addParam("Mode",mode);
			if (isDate(datedeb) && datedeb.length==10)
			 	arbre_historique_reglement.addParam("Date_Deb",prepareDateJava(datedeb));
			if (isDate(datefin) && datefin.length==10 )
				arbre_historique_reglement.addParam("Date_Fin",prepareDateJava(datefin));
			if (!isEmpty(fournisseur))
				arbre_historique_reglement.addParam("Fournisseur",fournisseur);

			arbre_historique_reglement.addParam("Regle","true");
			arbre_historique_reglement.addParam("Avoir","true");
			arbre_historique_reglement.addParam("Hist","true");

			arbre_echeance_reglement.deleteTree();
			arbre_echeance_avoir.deleteTree();
			arbre_historique_reglement.initTree();
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#historique_reglement_tri' + e);
	}
}

function historique_changer() {
	try {
		if(document.getElementById('radio').selectedIndex==0)
		{
			document.getElementById('hist_ech').collapsed=false;
			document.getElementById('hist_reg').collapsed=true;
			document.getElementById('hist_ech_reg').collapsed=true;
			document.getElementById('hist_reg_ech').collapsed=false;
			historique=false;
			historique_tri();
		}
		else
		{
			document.getElementById('hist_ech').collapsed=true;
			document.getElementById('hist_reg').collapsed=false;
			document.getElementById('hist_ech_reg').collapsed=false;
			document.getElementById('hist_reg_ech').collapsed=true;
			historique_regle=false;
			historique_reglement_tri();
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#historique_changer : ' + e);
	}
}

function detail_echeance() {
	try {

		var tree = document.getElementById('tree_historique_echeance');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var Echeance_Id = getCellText(tree,tree.view.selection.currentIndex, 'historique_Echeance_Id');
			selectionEcheance_Id=Echeance_Id;
			arbre_historique_reglement_echeance.setParam("Echeance_Id",Echeance_Id);
			arbre_historique_reglement_echeance.initTree();
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#detail_echeance : ' + e);
	}
}

function historique_pdf() {
	try {
		if(document.getElementById('radio').selectedIndex==0)
		{
			var page = "chrome://opensi/content/facturation/user/reglements_fournisseur/echeance_pdf.xul?" + cookie();
			page += par+"&Hist="+true;
			window.location = page;
		}
		else {
			var page = "chrome://opensi/content/facturation/user/reglements_fournisseur/reglements_pdf.xul?" + cookie();
			page += par+"&Hist="+true;
			window.location = page;
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#historique_pdf : ' + e);
	}
}

function detail_reglement() {
	try {
		var tree = document.getElementById('tree_historique_reglement');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var Reglement_Id = getCellText(tree,tree.view.selection.currentIndex, 'historique_reglement_Reglement_Id');
			var type = getCellText(tree,tree.view.selection.currentIndex, 'historique_reglement_Type');
			if (type=="Avoir")
			{
				arbre_echeance_avoir.clearParams();
				arbre_echeance_avoir.addParam("Avoir_Id",Reglement_Id);
				arbre_echeance_avoir.initTree();
			}
			else
			{
				arbre_echeance_reglement.clearParams();
				arbre_echeance_reglement.addParam("Reglement_Id",Reglement_Id);
				arbre_echeance_reglement.initTree();
			}
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#detail_echeance : ' + e);
	}
}

function historique_supprimer() {
	try {
		var tree = document.getElementById('tree_historique_reglement');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var type = getCellText(tree,tree.view.selection.currentIndex,'historique_reglement_Type');
			if (type!="Avoir") {
				var reglement_Id = getCellText(tree,tree.view.selection.currentIndex, 'historique_reglement_Reglement_Id');
				var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getRegulariserEcheanceReglement.tmpl&ContentType=xml";
				corps+="&Reglement_Id="+reglement_Id;
				var p = requeteHTTP(corps);

				var Regulariser = p.responseXML.documentElement.getAttribute("Regulariser");
				if (Regulariser=="0.00") {
					var Comptabilise = getCellText(tree,tree.view.selection.currentIndex, 'historique_reglement_Comptabilise');
					var ok=true;
					if (Comptabilise==1) {
						ok=confirm("Ce reglement a dj t transfr en comptabilit, etes vous sur de vouloir continuer?");
					}
					if (ok) {
						if (confirm("Etes-vous sr de vouloir supprimer ce reglement?")) {
							var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/supprimerReglement.tmpl&ContentType=xml";
							corps+="&Reglement_Id="+reglement_Id;
							var p = requeteHTTP(corps);

							modif_aff(true,true,true,true,true);
							arbre_echeance_reglement.deleteTree();
						}
					}
				}
				else {
					showWarning("Vous devez d'abord annuler la rgularisation des chances concernes par ce reglement");
				}
			}
			else {
				showWarning("Vous ne pouvez pas supprimer un avoir");
			}
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#historique_supprimer : ' + e);
	}
}


function historique_annuler_regularisation() {
	try {
		var tree = document.getElementById('tree_historique_echeance');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var regul = getCellText(tree,tree.view.selection.currentIndex,'historique_Regul');
			if (regul!="") {
				var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getTransfert_Reglements.tmpl&ContentType=xml";
				var p = requeteHTTP(corps);

				var echeance_Id = getCellText(tree,tree.view.selection.currentIndex, 'historique_Echeance_Id');
				var Transfert_Reglements = p.responseXML.documentElement.getAttribute("Transfert_Reglements");
				if (Transfert_Reglements=="1")
				{
					var page ="chrome://opensi/content/facturation/user/reglements_fournisseur/regulariser.xul?"+ cookie();
					page +="&Echeance_Id="+echeance_Id;
					page +="&Annuler="+true;
					window.openDialog(page,'Annuler la rgularisation de l\'chance','chrome,modal',modif_aff);
				}
				else {
					if (confirm("Etes-vous sr de vouloir annuler la rgularisation cette chance?")) {
						var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/annulerRegulariserEcheance.tmpl&ContentType=xml&Echeance_Id="+echeance_Id;
						var p = requeteHTTP(corps);

						modif_aff(true,true,true,true,true);
						arbre_historique_reglement_echeance.deleteTree();
					}
				}
			}
			else {
				showWarning("Vous devez slctionner une chance rgularise pour pouvoir l'annuler");
			}
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#historique_annuler_regularisation : ' + e);
	}
}


function historique_annuler_affectation() {
	try {
		var tree = document.getElementById('tree_historique_reglement_echeance');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var rangeCount = tree.view.selection.getRangeCount();
			var echeancereglement_Id="";
			var echeanceavoir_Id="";
			for(var i=0; i<rangeCount; i++)
			{
				var start = {};
 				var end = {};
 				tree.view.selection.getRangeAt(i,start,end);
				for(var c=start.value; c<=end.value; c++)
				{
					if (getCellText(tree,c, 'historique_reglement_echeance_Type')=="Avoir") {
						echeanceavoir_Id+=getCellText(tree,c, 'historique_reglement_echeance_Echeance_Reglement_Id')+",";
					}
					else {
						echeancereglement_Id+=getCellText(tree,c, 'historique_reglement_echeance_Echeance_Reglement_Id')+",";
					}
				}
			}
			var texte;
			if (rangeCount>1) {
				texte="Etes-vous sr de vouloir supprimer ces affectations?";
			}
			else {
				texte="Etes-vous sr de vouloir supprimer cette affectation?";
			}
			var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getRegulariserEcheance.tmpl&ContentType=xml";
			corps+="&Echeance_Id="+selectionEcheance_Id;
			var p = requeteHTTP(corps);

			var Regulariser = p.responseXML.documentElement.getAttribute("Regulariser");
			if (Regulariser=="0.00") {
				if (confirm(texte)) {
					var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/annulerAffectation.tmpl&ContentType=xml";
					corps+="&Echeance_Reglement_Id="+echeancereglement_Id;
					corps+="&Echeance_Avoir_Id="+echeanceavoir_Id;
					var p = requeteHTTP(corps);

					modif_aff(true,true,true,true,true);
					arbre_historique_reglement_echeance.deleteTree();
				}
			}
			else {
				showWarning("Vous devez d'abord annuler la rgularisation de cette chance");
			}
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/historique.js#historique_annuler_affectation : ' + e);
	}
}
