/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Echancier et cration de nouveaux rglements correspondant  l'chancier
 * Gestion des vnements sur la fentre <facturation/user/reglements_fournisseur/reglements.xul>
 */

var arbre_reglement_banque_fournisseur=new Arbre("fact","liste_banque_fournisseur.tmpl","reglement_input_Banque_Fournisseur");
var arbre_reglement_echeance=new Arbre("fact","liste_echeance_fournisseur.tmpl","tree_echeance");
var arbre_reglement_fournisseur=new Arbre("fact","liste_echeance_fournisseurs.tmpl","reglement_input_Fournisseur");

var Fournisseur_Id = new Array();
var Raison = new Array();
var Echeance_Id = new Array();
var Mod = new Array();
var Montant = new Array();
var reglement_param_save="aaa";

function reglement_change_mod() {
	try {

		var mode=document.getElementById('reglement_input_Mode_R').value;
		var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getTypeReglement.tmpl&ContentType=xml&Mode_R="+urlEncode(mode);
		var p = requeteHTTP(corps);
		var type = p.responseXML.documentElement.getAttribute("type");
		if (type=="ESPECES")
		{
			document.getElementById('reglement_input_Banque_Fournisseur').value="";
			document.getElementById('reglement_input_Banque_Fournisseur').disabled=true;
		}
		else
		{
			document.getElementById('reglement_input_Banque_Fournisseur').disabled=false;
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_change_mod' + e);
	}

}

function reglement_tri(mod) {
	try {
		if (par!=reglement_param_save || mod=="oui")
		{
			reglement_param_save=par;
			reglement_vider();
			reglement_vider_liste();

			arbre_reglement_echeance.clearParams();
			arbre_reglement_fournisseur.clearParams();
			if (mode!="") {
			 	arbre_reglement_echeance.addParam("Mode",mode);
			 	arbre_reglement_fournisseur.addParam("Mode",mode);
			}
			if (isDate(datedeb) && datedeb.length==10) {
			 	arbre_reglement_echeance.addParam("Date_Deb",prepareDateJava(datedeb));
			 	arbre_reglement_fournisseur.addParam("Date_Deb",prepareDateJava(datedeb));

			}
			if (isDate(datefin) && datefin.length==10 ) {
				arbre_reglement_echeance.addParam("Date_Fin",prepareDateJava(datefin));
				arbre_reglement_fournisseur.addParam("Date_Fin",prepareDateJava(datefin));

			}
			if (!isEmpty(fournisseur)) {
				arbre_reglement_echeance.addParam("Fournisseur",fournisseur);
				arbre_reglement_fournisseur.addParam("Fournisseur",fournisseur);

			}
			arbre_reglement_echeance.addParam("Hist",false);
			arbre_reglement_fournisseur.addParam("Hist",false);

			if (!isEmpty(fournisseur))
				arbre_reglement_fournisseur.initTree(reglement_init_liste_fournisseur2);
			else
				arbre_reglement_fournisseur.initTree(reglement_init_liste_fournisseur);

			arbre_reglement_echeance.initTree(reglement_initEcheance());

			if (document.getElementById('input_Mode_R_Init').value=="")
			{
				reglement_initMode_R();
				document.getElementById('reglement_input_Mode_R').disabled=false;
			}
			else
			{
				document.getElementById('reglement_input_Mode_R').selectedItem=document.getElementById('input_Mode_R_Init').selectedItem;
				document.getElementById('reglement_input_Mode_R').disabled=true;
				reglement_change_mod();
			}
			if (document.getElementById('Fournisseur').value=="")
			{
				document.getElementById('reglement_input_Fournisseur').selectedIndex=0;
			}
			reglement_calcul_total(reglement_param_save);
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_tri' + e);
	}

}

function reglement_pdf() {
	try {
		var page = "chrome://opensi/content/facturation/user/reglements_fournisseur/echeance_pdf.xul?" + cookie();
		page += par+"&Hist=false";
		window.location = page;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_pdf : ' + e);
	}
}


function reglement_changer_fournisseur() {
	try {
		var code_fournisseur=document.getElementById('reglement_input_Fournisseur').value;
		var nom_fournisseur=document.getElementById('reglement_input_Fournisseur').getAttribute("label");

		if (code_fournisseur=="")
		{
			var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getNumCompteFournisseur.tmpl&ContentType=xml";
			reglement_compte(corps);
			arbre_reglement_banque_fournisseur.deleteTree();
		}
		else
		{
			var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getNumCompteFournisseur.tmpl&ContentType=xml&Fournisseur_Id="+code_fournisseur;
			reglement_compte(corps);

			arbre_reglement_banque_fournisseur.setParam("Fournisseur_Id",code_fournisseur);
			arbre_reglement_banque_fournisseur.initTree(setTimeout("reglement_initBanque()",200));
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_changer_Fournisseur : ' + e);
	}
}

function affecter_champs() {
	try {

		var tree = document.getElementById('tree_echeance');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var Champs_Fournisseur_Id = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Fournisseur_Id');
			var Champs_Raison = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Raison');
			var Champs_anc_Mode_Reg = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Mode_Reglement');
			var Champs_Montant_Regle = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Montant_Restant');

			document.getElementById('reglement_input_Fournisseur').value=Champs_Fournisseur_Id;
			document.getElementById('reglement_input_Fournisseur').setAttribute("label",Champs_Fournisseur_Id+" : "+Champs_Raison);
			document.getElementById('reglement_input_Montant').value=Champs_Montant_Regle;
			document.getElementById('reglement_input_Mode_R').value=Champs_anc_Mode_Reg;
			reglement_changer_fournisseur();
			reglement_change_mod();
		}


	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/reglements.js#affecter_champs : ' + e);
	}
}

function reglement_compte(corps) {
	try {
		var p = requeteHTTP(corps);

		var compte = p.responseXML.documentElement.getAttribute("compte");
		document.getElementById('reglement_num_Compte').value=compte;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_compte : ' + e);
	}
}

function reglement_calcul_total(param) {
	try {

		var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getCalcul.tmpl&ContentType=xml&Hist=false" + param;
		reglement_calcul(corps);
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_calcul_total' + e);
	}

}

function reglement_calcul(corps) {
	try {
		var p = requeteHTTP(corps);

		var du = p.responseXML.documentElement.getAttribute("du");
		var restant = p.responseXML.documentElement.getAttribute("restant");
		document.getElementById('reglement_lblTotRegl').value=du;
		document.getElementById('reglement_lblTotRestant').value=restant;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_calcul : ' + e);
	}
}

function reglement_enlever() {
	try {

		document.getElementById('reglement_Fournisseur').value='';
		document.getElementById('reglement_Fournisseur_text').disabled=false;
		document.getElementById('reglement_Fournisseur_text').value='';
		document.getElementById('reglement_Fournisseur_text').focus();
		arbre_reglement_banque_fournisseur.deleteTree();

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_enlever : ' + e);
	}

}

function reglement_vider() {
	try {
		document.getElementById("reglement_num_Compte").value="";
		document.getElementById("reglement_input_Banque_Fournisseur").value="";
		document.getElementById("reglement_input_Banque_Fournisseur").disabled=false;
		document.getElementById("reglement_input_Num_Piece").value="";
		document.getElementById("reglement_input_Montant").value="";
		document.getElementById("reglement_Commentaire").value="";

		var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getNumCompteFournisseur.tmpl&ContentType=xml";

		reglement_compte(corps);
		arbre_reglement_banque_fournisseur.deleteTree();
		document.getElementById("reglement_input_Mode_R").selectedIndex=0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_vider : ' + e);
	}
}

function reglement_init_liste_fournisseur() {
	try {
		document.getElementById('reglement_input_Fournisseur').selectedIndex = 0;
		document.getElementById('reglement_input_Fournisseur').maxwidth="160px";
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglement.js#reglement_init_liste_fournisseur : ' + e);
	}
}

function reglement_init_liste_fournisseur2() {
	try {
		document.getElementById('reglement_input_Fournisseur').selectedIndex = 1;
		document.getElementById('reglement_input_Fournisseur').maxwidth="500px";
		reglement_changer_fournisseur();
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglement.js#reglement_init_liste_fournisseur2 : ' + e);
	}
}


function reglement_vider_liste() {
	try {
		Fournisseur_Id = new Array();
		Raison = new Array();
		Echeance_Id = new Array();
		Mod = new Array();
		Montant = new Array();

	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_vider_liste : ' + e);
	}

}

function reglement_changer_infos() {
	try {
		var tree = document.getElementById('tree_echeance');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var echeance_fournisseur_Id = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Echeance_Id');
			var anc_Date = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Date_Echeance');
			var anc_Mode_Reg = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Mode_Reglement');
			var Montant_Regle = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Montant_Regle');
			var page ="chrome://opensi/content/facturation/user/reglements_fournisseur/changer_echeance.xul?"+ cookie();
			page +="&Echeance_Id="+echeance_fournisseur_Id;
			page +="&anc_Date="+anc_Date;
			page +="&anc_Mode_Reg="+urlEncode(anc_Mode_Reg);
			page +="&Montant_Regle="+Montant_Regle;
			window.openDialog(page,'Changer l\'chance','chrome,modal',modif_aff);
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_changer_infos : ' + e);
	}
}


function reglement_regulariser() {
	try {
		var tree = document.getElementById('tree_echeance');
		if (tree.view!=null && tree.currentIndex!=-1)
		{
			var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getTransfert_Reglements.tmpl&ContentType=xml";
			var p = requeteHTTP(corps);

			var echeance_Id = getCellText(tree,tree.view.selection.currentIndex, 'reglement_Echeance_Id');
			var Transfert_Reglements = p.responseXML.documentElement.getAttribute("Transfert_Reglements");
			if (Transfert_Reglements=="1")
			{
				var page ="chrome://opensi/content/facturation/user/reglements_fournisseur/regulariser.xul?"+ cookie();
				page +="&Echeance_Id="+echeance_Id;
				window.openDialog(page,'Rgulariser l\'chance','chrome,modal',modif_aff);
			}
			else {
				if (confirm("Etes-vous sr de vouloir rgulariser cette chance?")) {
					var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/regulariserEcheance.tmpl&ContentType=xml&Echeance_Id="+echeance_Id;
					var p = requeteHTTP(corps);

					modif_aff(true,true,false,true,false);
				}
			}
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_regulariser: ' + e);
	}
}

function reglement_initMode_R() {
	try {
		document.getElementById('reglement_input_Mode_R').selectedIndex = 0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglement.js#reglement_initMode_R : ' + e);
	}
}

function reglement_initJournal_Banque() {
	try {
		document.getElementById('reglement_input_Journal_Banque').selectedIndex = 0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglement.js#reglement_initJournal_Banque : ' + e);
	}
}

function reglement_initBanque () {
	try {
		document.getElementById('reglement_input_Banque_Fournisseur').selectedIndex = 0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/reglements.js#initBanque : ' + e);
	}
}

function reglement_initEcheance() {
	try {
		document.getElementById('tree_echeance').focus();
		
		setTimeout("reglement_tree_selection();",1000);
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/reglements.js#reglement_initEcheance : ' + e);
	}
}

function reglement_tree_selection() {
	try {
		tree=document.getElementById('tree_echeance');
		if (tree.view!=null && tree.view.rowCount>0)
		{
			tree.view.selection.select(0);
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements/reglements.js#reglement_tree_selection : ' + e);
	}
}

function reglement_keypress(e) {
  try {
    switch(e.keyCode){
      case 13: // 'Enter'
				reglement_validSaisie();
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans compta/user/consultation/consultation.js#keypress : ' + e);
  }
}

/****************************************************
 *	Action de validation
 ****************************************************/

function reglement_validSaisie(e) {

	try{

		var input_Date = document.getElementById("reglement_input_Date").value;

		var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/compDateReglDebut.tmpl&ContentType=xml&DateRegle="+prepareDateJava(input_Date);
		var p = requeteHTTP(corps);

		var correct = p.responseXML.documentElement.getAttribute("correct");
		if (correct=="true") {

			var num_Compte = document.getElementById("reglement_num_Compte").value;
			var input_Journal_Banque = document.getElementById("reglement_input_Journal_Banque").value;
			var Fournisseur_Id_text = document.getElementById("reglement_input_Fournisseur").value;
			var Fournisseur_text = document.getElementById("reglement_input_Fournisseur").getAttribute("label");
			if (Fournisseur_text=="[Fournisseur]") { showWarning('Nom du fournisseur manquant !'); return false; }
			if (Fournisseur_Id_text=="")
			{
				Fournisseur_text=Fournisseur_text.slice(2,Fournisseur_text.length);
			}
			else
			{
				Fournisseur_text=Fournisseur_text.slice(Fournisseur_Id_text.length+2,Fournisseur_text.length);
			}
			var input_Banque_Fournisseur = document.getElementById("reglement_input_Banque_Fournisseur").value;
			var input_Mode_R = document.getElementById("reglement_input_Mode_R").value;
			var input_Num_Piece = document.getElementById("reglement_input_Num_Piece").value;
			var input_Montant = document.getElementById("reglement_input_Montant").value;
			var Commentaire = document.getElementById("reglement_Commentaire").value;



			if (input_Mode_R=="") {
				showWarning("Le champs Mode de rglement n'est pas renseign !");
				document.getElementById("reglement_input_Mode_R").focus();
				return false;
			}

			var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getTypeReglement.tmpl&ContentType=xml&Mode_R="+urlEncode(input_Mode_R);
			var p = requeteHTTP(corps);
			
			var input_type = p.responseXML.documentElement.getAttribute("type");

			if (isEmpty(input_Date)) {
				showWarning('Date du rglement manquante!');
				document.getElementById("reglement_input_Date").focus();
				 return false;
		  }
			else if (!isDate(input_Date)) {
				showWarning('Date du rglement incorrecte !');
				document.getElementById("reglement_input_Date").focus();
				return false;
			}

			else if (input_type!="ESPECES" && isEmpty(input_Banque_Fournisseur)) {
				showWarning("le champs 'Banque Fournisseur' n'est pas renseign !");
				document.getElementById("reglement_input_Banque_Fournisseur").focus();
				return false;
			}

			else if (isEmpty(Fournisseur_text) || Fournisseur_text=="") {
				showWarning("le champs 'Fournisseur' n'est pas renseign !");
				document.getElementById("reglement_input_Fournisseur").focus();
				return false;
			}
			else if (isEmpty(input_Montant)) {
				showWarning("le champs 'Montant' n'est pas renseign !");
				document.getElementById("reglement_input_Montant").focus();
				return false;
			}
			else if (isNaN(input_Montant)) {
				showWarning("Mauvais formatage de la valeur du rglement");
				document.getElementById("reglement_input_Montant").focus();
				return false;
			}
			else if (parseFloat(input_Montant)<=0) {
				showWarning("Le montant doit tre positif");
				document.getElementById("reglement_input_Montant").focus();
				return false;
			}

			input_Montant=formatNombre(input_Montant,"0.00")

			var url = "chrome://opensi/content/facturation/user/reglements_fournisseur/affectation_automatique.xul?"+ cookie();
			url += "&Date="+ urlEncode(input_Date);
			url += "&num_Compte="+ urlEncode(num_Compte);
			url += "&Journal_Banque="+ urlEncode(input_Journal_Banque);
			url += "&Fournisseur_Id="+ urlEncode(Fournisseur_Id_text);
			url += "&Fournisseur="+ urlEncode(Fournisseur_text);
			url += "&Banque_Fournisseur="+ urlEncode(input_Banque_Fournisseur);
			url += "&Mode_Reg="+ urlEncode(input_Mode_R);
			url += "&Num_Piece="+ urlEncode(input_Num_Piece);
			url += "&Montant="+ urlEncode(input_Montant);
			url += "&Commentaire="+ urlEncode(Commentaire);
			window.openDialog(url,'Affectation du rglement','chrome,modal',ouvrir_affectation,modif_aff,reglement_vider);
		}
		else {
			showWarning("Date incorrecte, la date doit tre suprieure  la date de dbut du premier exercice");
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/reglements.js#reglement_validSaisie : ' + e);
	}
}
