/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/
/*
 * Fenetre de rgularisation pour choisir les informations a mettre dans la lettre
 * Gestion des vnements sur la fentre <facturation/user/reglements_fournisseur/rembourser.xul>
 */

var reglement=false;
var transfert;
var page;
var maximum;
var fournisseur_Id;
var Montant;

function init() {
	try {

		reglement=!isEmpty(ParamValeur("Reglement_Id"));
		fournisseur_Id=!isEmpty(ParamValeur("Fournisseur_Id"));
		transfert=ParamValeur("Transfert")==1;
		var x = (screen.width / 2) - 200;
		var y = (screen.height / 2) - 100;
		window.resizeTo(400,200);
		window.moveTo(x,y);

		var arbre=new Arbre("cpta","liste_journaux.tmpl","journal");
		arbre.addParam("Type_Journal","TR");
		arbre.addParam("Factu","1");
		arbre.initTree(initJournaux);

		if (transfert) {
			document.getElementById('jour').hidden=false;
		}
		document.getElementById('montant').value=ParamValeur("Montant");
		maximum=ParamValeur("Montant");
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/rembourser.js#init : ' + e);
	}
}

function initJournaux() {
	try {
		document.getElementById('journal').selectedIndex=0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/rembourser.js#initJournaux : ' + e);
	}
}

function changer() {
	try {

		Montant=document.getElementById('montant').value;
		if (isNaN(Montant)) { showWarning("Mauvais formatage de la valeur"); return false; }
		else if (parseFloat(Montant)<=0) { showWarning("Le montant doit tre positif"); return false; }
		else if (parseFloat(Montant)>parseFloat(maximum)) { showWarning("Le montant ne peut pas etre suprieur au montant restant"); return false; }

		if (transfert) {
			var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/getContrePartie.tmpl&ContentType=xml";
			corps+="&Code_Journal="+urlEncode(document.getElementById('journal').value);
			var p = requeteHTTP(corps);

			var ContrePartie = p.responseXML.documentElement.getAttribute("Contre_Partie");
			if (ContrePartie!="") {
				validchanger();
			}
			else {
				var pop ="chrome://opensi/content/facturation/user/reglements_fournisseur/changer_ContrePartie.xul?"+ cookie();
				pop +="&Journal_Banque="+urlEncode(document.getElementById('journal').value);
				window.close();
				window.openDialog(pop,'Indiquez le compte de contre partie du journal','chrome,modal',validchanger);
			}
		}
		else {
			validchanger();
		}
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/rembourser.js#changer : ' + e);
	}
}

function validchanger() {
	try {

		var corps = cookie() +"&Page=Facturation/ReglementsFournisseur/rembourserFournisseur.tmpl&ContentType=xml";
		corps+="&Transfert="+transfert;
		if (reglement) {
			corps +="&Reglement_Id="+ParamValeur("Reglement_Id");
		}
		else {
			corps +="&Avoir_Id="+ParamValeur("Avoir_Id");
		}
		corps +="&Journal="+urlEncode(document.getElementById('journal').value);
		corps +="&Montant="+Montant;
		corps +="&Montant_Total="+maximum;
		var p = requeteHTTP(corps);

		window.close();
	} catch (e) {
		recup_erreur('erreur dans facturation/user/reglements_fournisseur/rembourser.js#validchanger : ' + e);
	}
}
