/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {

		paramlist = "&Page=Facturation/GetRDF/familles_fournisseur.tmpl&ContentType=xml";
  	load_rdf_async('Famille_Fournisseur', getUrlOpeneas(paramlist), initFamille);

		window.parent.document.getElementById('Loaded').setAttribute('label', nocache());

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#init : ' + e);
  }
}


function initFamille() {
	try {

    document.getElementById('Famille_Fournisseur').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#initFamille : ' + e);
  }
}



function filtrerFournisseurs() {
	try {

		var param = "&Famille="+ document.getElementById('Famille_Fournisseur').value;
		delete_tree_fdispo();
		init_tree_fdispo(param);
		disableAjouter(true, false);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#filtrerFournisseurs : ' + e);
  }
}


function disableAjouter(b,arbre) {
	try {

		var tree = document.getElementById('fdispo');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1)) {
			document.getElementById('bAjouter').disabled = b;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseur.js#disableAjouter : ' + e);
  }
}


function disableEnlever(b,arbre) {
	try {

		var tree = document.getElementById('farticle');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1)) {
			document.getElementById('bEnlever').disabled = b;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseur.js#disableEnlever : ' + e);
  }
}


function pressOnFournisseursArticle(ev) {
  try {

    switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrirDetails();
      break;
  	}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#pressOnFournisseurArticle : ' + e);
  }
}


function ajouterFournisseur() {
  try {

		var tree = document.getElementById('fdispo');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var fournisseur_id = getCellText(tree,tree.view.selection.currentIndex,'ColFournisseur_Id');

			var article_id = parent.document.getElementById('Article').value;
			var taux_tva = parent.document.getElementById('contenu_prix').contentDocument.getElementById('Code_TVA').label;

			var corps = cookie() + "&Page=Facturation/Stocks/existeFournisseurArticle.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id) +"&Fournisseur_Id="+ urlEncode(fournisseur_id);
			var p = requeteHTTP(corps);

			if (p.status != "200") {
  			alert("Rception erreur " + p.status);
			}
			else {

				var contenu = p.responseXML.documentElement;
  			if (contenu.getAttribute('existe')=="false") {
					var url = "chrome://opensi/content/facturation/user/stocks/details_fournisseur.xul?" + cookie() +"&Taux_TVA="+ taux_tva +"&Mode=C&Fournisseur_Id="+ urlEncode(fournisseur_id) +"&Article_Id="+ urlEncode(article_id);
					window.openDialog(url,'','chrome,modal');

  				delete_tree_farticle();
  				init_tree_farticle();
				}
				else {
					showWarning("Ce fournisseur fournit dj cet article !");
				}
			}
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#ajouterFournisseur : ' + e);
  }
}


function enleverFournisseur() {
  try {

		var tree = document.getElementById('farticle');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var fournisseur_id = getCellText(tree,tree.view.selection.currentIndex,'ColFournisseur_Id2');

			var article_id = parent.document.getElementById('Article').value;

			var corps = cookie() + "&Page=Facturation/Stocks/enleverFournisseurArticle.tmpl&ContentType=xml&Article_Id="+urlEncode(article_id)+"&Fournisseur_Id="+ urlEncode(fournisseur_id);
			var p = requeteHTTP(corps);

			if (p.status != "200") {
  			alert("Rception erreur " + p.status);
			}
			else {
				delete_tree_farticle();
				init_tree_farticle();
				disableEnlever(true, false);
			}
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#enleverFournisseur : ' + e);
  }
}


function ouvrirDetails() {
  try {

    var tree = document.getElementById('farticle');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var fournisseur_id = getCellText(tree,tree.view.selection.currentIndex,'ColFournisseur_Id2');

			var article_id = parent.document.getElementById('Article').value;

			var url = "chrome://opensi/content/facturation/user/stocks/details_fournisseur.xul?"+ cookie() +"&Mode=M&Fournisseur_Id="+ urlEncode(fournisseur_id) +"&Article_Id="+ urlEncode(article_id);
			window.openDialog(url,'','chrome,modal');

  		delete_tree_farticle();
  		init_tree_farticle();
			disableEnlever(true, false);
		}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#ouvrirDetails : ' + e);
  }
}


function init_tree_fdispo(param) {
  try {

    var paramlist = "&Page=Facturation/GetRDF/liste_fournisseurs.tmpl&ContentType=xml"+param;
    load_rdf('fdispo', getUrlOpeneas(paramlist));
    document.getElementById('fdispo').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#init_tree_fdispo : ' + e);
  }
}


function delete_tree_fdispo() {
  try {

    var database = document.getElementById("fdispo").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#delete_tree_fdispo : ' + e);
  }
}


function init_tree_farticle() {
  try {

    var article_id = parent.document.getElementById("Article").value;
    var paramlist = "&Page=Facturation/GetRDF/liste_fournisseurs_article.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id);
    load_rdf('farticle', getUrlOpeneas(paramlist));
    document.getElementById('farticle').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#init_tree_farticle : ' + e);
  }
}


function delete_tree_farticle() {
  try {

    var database = document.getElementById("farticle").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuFournisseurs.js#delete_tree_farticle : ' + e);
  }
}
