/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {

		paramlist = "&Page=Facturation/GetRDF/familles_article.tmpl&ContentType=xml";
  	load_rdf_async('Famille_Article', getUrlOpeneas(paramlist), initFamille);

		document.getElementById('Quantite').value = 1;

		window.parent.document.getElementById('Loaded').setAttribute('label', nocache());

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#init : ' + e);
  }
}


function initFamille() {
	try {

    document.getElementById('Famille_Article').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#initFamille : ' + e);
  }
}


function filtrerComposants() {
	try {

		var param = "&Famille="+ urlEncode(document.getElementById('Famille_Article').value);
		delete_tree_articles();
		init_tree_articles(param);
		disableAjouter(true,false);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#filtrerComposants : ' + e);
  }
}


function disableAjouter(b,arbre) {
	try {

		var tree = document.getElementById('articles');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1)) {
			document.getElementById('bAjouter').disabled = b;
			document.getElementById('Quantite').disabled = b;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#disableAjouter : ' + e);
  }
}


function disableEnlever(b,arbre) {
	try {

		var tree = document.getElementById('composants');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1)) {
			document.getElementById('bEnlever').disabled = b;
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#disableEnlever : ' + e);
  }
}


function pressOnComposants(ev) {
	try {

		switch(ev.keyCode) {
      case 13: // 'Enter'
        ouvrirQuantite();
      break;
  	}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#pressOnComposants : ' + e);
  }
}


function ouvrirQuantite() {
	try {

		var tree = document.getElementById('composants');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var article_comp_id = getCellText(tree,tree.view.selection.currentIndex,'ColArticleComp_Id');
			var article_id = parent.document.getElementById('Article').value;
			var quantite = getCellText(tree,tree.view.selection.currentIndex,'ColQuantite');
			var designation = getCellText(tree,tree.view.selection.currentIndex,'ColDesignation');

			var url = "chrome://opensi/content/facturation/user/stocks/quantite_composant.xul?"+ cookie() +"&ArticleComp_Id="+ urlEncode(article_comp_id) +"&Article_Id="+ urlEncode(article_id);
					url += "&Quantite="+ quantite +"&Designation="+ designation;
			window.openDialog(url,'','chrome,modal');

  		delete_tree_composants();
  		init_tree_composants();
			disableEnlever(true,false);
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#ouvrirQuantite : ' + e);
  }
}


function ajouterComposant() {
  try {

		var tree = document.getElementById('articles');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var article_comp_id = getCellText(tree,tree.view.selection.currentIndex,'ColArticle_Id');

			var article_id = parent.document.getElementById("Article").value;
    	var quantite = document.getElementById('Quantite').value;

			if (isEmpty(quantite)) {
				showWarning("Veuillez spcifier une quantit");
			}
			else if (!isPositive(quantite) || !checkDecimal(quantite,2)) {
				showWarning("Quantit incorrecte");
			}
			else {

				var corps = cookie() + "&Page=Facturation/Stocks/existeArticleNomenclature.tmpl&ContentType=xml&Article_Id="+urlEncode(article_id)+"&ArticleComp_Id="+ urlEncode(article_comp_id);
				var p = requeteHTTP(corps);

				if (p.status != "200") {
  				alert("Rception erreur " + p.status);
				}
				else {
					var contenu = p.responseXML.documentElement;

  				if (contenu.getAttribute('existe')=="false") {
    				var corps = cookie() + "&Page=Facturation/Stocks/ajouterArticleNomenclature.tmpl&ContentType=xml";
    				corps += "&ArticleComp_Id="+ urlEncode(article_comp_id) +"&Article_Id="+ urlEncode(article_id) +"&Quantite="+ quantite;
    				var p = requeteHTTP(corps);

						if (p.status != "200") {
      				alert("Rception erreur " + p.status);
      			}
  					else {
    					delete_tree_composants();
    					init_tree_composants();
						}
					}
					else {
						showWarning("Cet article est dj composant de l'article !");
					}
					document.getElementById('Quantite').value = 1;
				}
			}
		}

  } catch (e) {
  	recup_erreur('erreur dans facturation/user/clients/contenuNomenclature.js#ajouterComposant : ' + e);
	}
}


function enleverComposant() {
	try {

    var tree = document.getElementById('composants');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var article_comp_id = getCellText(tree,tree.view.selection.currentIndex,'ColArticleComp_Id');

			var article_id = parent.document.getElementById("Article").value;

    	var corps = cookie() + "&Page=Facturation/Stocks/enleverArticleNomenclature.tmpl&ContentType=xml";
    	corps += "&ArticleComp_Id="+ urlEncode(article_comp_id) +"&Article_Id="+ urlEncode(article_id);

    	var p = requeteHTTP(corps);

			if (p.status != "200") {
      	alert("Rception erreur " + p.status);
      }
  		else {
    		delete_tree_composants();
    		init_tree_composants();
				disableEnlever(true, false);
			}
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/contenuNomenclature.js#enleverComposant : ' + e);
	}
}


function init_tree_articles(param) {
  try {

    var paramlist = "&Page=Facturation/GetRDF/composants_dispo.tmpl&ContentType=xml"+ param;
    load_rdf('articles', getUrlOpeneas(paramlist));
    document.getElementById('articles').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#init_tree_articles : ' + e);
  }
}


function delete_tree_articles() {
  try {

    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#delete_tree_articles : ' + e);
  }
}


function init_tree_composants() {
  try {

    var article_id = parent.document.getElementById("Article").value;
    var paramlist = "&Page=Facturation/GetRDF/composants_article.tmpl&ContentType=xml&Article_Id="+ article_id;
    load_rdf('composants', getUrlOpeneas(paramlist));
    document.getElementById('composants').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#init_tree_composants : ' + e);
  }
}


function delete_tree_composants() {
  try {

    var database = document.getElementById("composants").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuNomenclature.js#delete_tree_composants : ' + e);
  }
}
