/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


function init() {
	try {

		setModeTarif();

		var paramlist = "&Page=Manager/GetRDF/taux_tva.tmpl&ContentType=xml";
    load_rdf_async('Code_TVA', getUrlOpeneas(paramlist), initTVA);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#init : ' + e);
  }
}


function initTVA() {
	try {

    document.getElementById('Code_TVA').value = 4;
		window.parent.document.getElementById('Loaded').setAttribute('label', nocache());
		window.parent.document.getElementById('Modifie').value = "n";

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#initTVA : ' + e);
  }
}

function setModeTarif() {
	try {

		var dossier_id = get_cookie("Dossier_Id");

    var corps = cookie() +"&Page=Manager/ParamDossier/getParamDossier.tmpl&ContentType=xml&Dossier_Id="+ urlEncode(dossier_id);
    var httpRequest = new XMLHttpRequest();
		requeteHTTP(corps,httpRequest,setModeTarif2);

	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#setModeTarif : ' + e);
	}
}

function setModeTarif2(httpRequest) {
  try {

    var contenu = httpRequest.responseXML.documentElement;

		if (contenu.getAttribute('Mode_Tarif')=='G') {
			document.getElementById('Grille_Tarif').collapsed = false;
			document.getElementById('Grille_Qte').collapsed = true;
		}
		else {
			document.getElementById('Grille_Tarif').collapsed = true;
			document.getElementById('Grille_Qte').collapsed = false;
		}

	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#setModeTarif2 : ' + e);
	}
}


function setModifie() {
	try {

		window.parent.document.getElementById('Modifie').value = "y";

	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#setModifie : ' + e);
	}
}


function calculerPoids(ch) {
	try {

		var pb = parseFloat(document.getElementById('Poids_Brut').value);
		var pbu = parseFloat(document.getElementById('Poids_Unite').value);
		var uv = parseIntBis(document.getElementById('Unite_Vente').value);

		if (!isPositive(pb)) { pb = 0; }
		if (!isPositive(pbu)) { pbu = 0; }
		if (!isPositiveInteger(uv)) { uv = 1; }

		if (ch=="PBU" || ch=="UV") { document.getElementById('Poids_Brut').value = pbu * uv; }
		else { document.getElementById('Poids_Unite').value = pb / uv; }

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#calculerPoids : ' + e);
  }
}


function calculerRevient() {
	try {

		var pa = parseFloat(document.getElementById('Prix_Achat').value);
		var fa = parseFloat(document.getElementById('Frais_Appro').value);

		if (isPositiveOrNull(pa) && isPositiveOrNull(fa)) {
			document.getElementById('Prix_Revient').value = formatNombre(pa + fa, "0.00");
			calculerTarif('coeff',1);
			calculerTarif('coeff',2);
			calculerTarif('coeff',3);
			calculerTarif('coeff',4);
			calculerTarif('coeff',5);
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#calculerRevient : ' + e);
  }
}


function refreshTarifs() {
	try {

		if (parent.document.getElementById('Action').value=='M') {
			delete_tree_tarifs();
			init_tree_tarifs();
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#refreshTarifs : ' + e);
  }
}


function calculerTarif(origine,tarif) {
	try {

		var pr = parseFloat(document.getElementById('Prix_Revient').value);
		var tva = parseFloat(document.getElementById('Code_TVA').label)/100 + 1;

		if (origine=="ht") {
			var pvht = parseFloat(document.getElementById('Tarif_'+tarif).value);
			document.getElementById('Coeff_'+tarif).value = formatNombre(pvht / pr, "0.#####");
			document.getElementById('TTC_'+tarif).value = formatNombre(pvht * tva, "0.00");
			document.getElementById('Marge_'+tarif).value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else if (origine=="coeff") {
			var pvht = parseFloat(document.getElementById('Coeff_'+tarif).value) * pr;
			document.getElementById('Tarif_'+tarif).value = formatNombre(pvht, "0.00");
			document.getElementById('TTC_'+tarif).value = formatNombre(pvht * tva, "0.00");
			document.getElementById('Marge_'+tarif).value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else if (origine=="ttc") {
			var pvht = parseFloat(document.getElementById('TTC_'+tarif).value) / tva;
			document.getElementById('Tarif_'+tarif).value = formatNombre(pvht, "0.00");
			document.getElementById('Coeff_'+tarif).value = formatNombre(pvht / pr, "0.#####");
			document.getElementById('Marge_'+tarif).value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else {
			if (parseFloat(document.getElementById('Marge_'+tarif).value)>=100) {
				showWarning("Le pourcentage de marge doit tre infrieur  100 % !");
			}
			else {
				var pvht = pr / (1 - parseFloat(document.getElementById('Marge_'+tarif).value)/100);
				document.getElementById('Tarif_'+tarif).value = formatNombre(pvht, "0.00");
				document.getElementById('Coeff_'+tarif).value = formatNombre(pvht / pr, "0.#####");
				document.getElementById('TTC_'+tarif).value = formatNombre(pvht * tva, "0.00");
			}
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#calculerTarif : ' + e);
  }
}


function validerLigne() {
  try {

		var article_id = parent.document.getElementById("Article").value;

		var quantite = document.getElementById('Quantite_Ligne').value;
		var prix = document.getElementById('Prix_Ligne').value;
		var lib_ext = document.getElementById('Lib_Ext').value;
		var lib_int = document.getElementById('Lib_Int').value;
		var coeff = document.getElementById('Coeff_Ligne').value;
		var tarif_id = document.getElementById('Tarif_Id').value;

		if (isEmpty(prix) || !isPositiveOrNull(prix) || !checkDecimal(prix,4)) {
			showWarning("Prix HT incorrect !");
		}
		else if (isEmpty(quantite) || !isPositive(quantite) || !checkDecimal(quantite,2)) {
			showWarning("Quantit incorrecte !");
		}
		else if (document.getElementById('Base_Calcul').checked && (isEmpty(coeff) || !isPositive(coeff))) {
			showWarning("Coefficient incorrect !");
		}
		else if (document.getElementById('Prix_Revient').value <= 0) {
			showWarning("Le prix de revient doit tre suprieur  0 !");
		}
		else {

			var corps;

			if (isEmpty(tarif_id)) {
				corps = cookie() +"&Page=Facturation/Stocks/ajouterTarifQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id);
			}
			else {
				corps = cookie() +"&Page=Facturation/Stocks/modifierTarifQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(article_id) +"&Tarif_Id="+ tarif_id;
			}

			corps += "&Quantite="+ quantite +"&Prix="+ prix +"&Lib_Ext="+ urlEncode(lib_ext) +"&Lib_Int="+ urlEncode(lib_int) +"&Coeff="+ coeff;
			var p = requeteHTTP(corps);

  		delete_tree_tarifs();
			init_tree_tarifs();

			annulerLigne();
		}

  } catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#validerLigne : ' + e);
	}
}


function changeModeTarifQte() {
  try {

		if (document.getElementById('Base_Calcul').checked) {
			document.getElementById('ColMarge').collapsed = false;
			document.getElementById('ColCoeff').collapsed = false;
			document.getElementById('Marge_Ligne').collapsed = false;
			document.getElementById('Coeff_Ligne').collapsed = false;
			document.getElementById('Box_Achat').collapsed = false;
		}
		else {
			document.getElementById('ColMarge').collapsed = true;
			document.getElementById('ColCoeff').collapsed = true;
			document.getElementById('Marge_Ligne').collapsed = true;
			document.getElementById('Coeff_Ligne').collapsed = true;
			document.getElementById('Box_Achat').collapsed = true;
			if (document.getElementById('Prix_Revient').value <= 0) {
				document.getElementById('Prix_Achat').value = 1;
				calculerRevient();
				calculerLigne("h");
			}
		}

		delete_tree_tarifs();
		init_tree_tarifs();

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#changeModeTarifQte : ' + e);
	}
}


function annulerLigne() {
  try {

		document.getElementById('Lib_Int').value = "";
		document.getElementById('Lib_Ext').value = "";
		document.getElementById('Quantite_Ligne').value = "";
		document.getElementById('Prix_Ligne').value = "";
		document.getElementById('Marge_Ligne').value = "";
		document.getElementById('Coeff_Ligne').value = "";
		document.getElementById('Prix_Ligne_TTC').value = "";
		document.getElementById('Tarif_Id').value = "";
		document.getElementById('bSupprimer').disabled = true;

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#annulerLigne : ' + e);
	}
}

function calculerLigne(t) {
  try {

		var tva = parseFloat(document.getElementById('Code_TVA').label)/100 + 1;

		var pr = document.getElementById('Prix_Revient').value;

		if (t=="h") {
			var pvht = parseFloat(document.getElementById('Prix_Ligne').value);
			document.getElementById('Coeff_Ligne').value = formatNombre(pvht / pr, "0.#####");
			document.getElementById('Prix_Ligne_TTC').value = formatNombre(pvht * tva, "0.00");
			document.getElementById('Marge_Ligne').value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else if (t=="c") {
			var pvht = parseFloat(document.getElementById('Coeff_Ligne').value) * pr;
			document.getElementById('Prix_Ligne').value = formatNombre(pvht, "0.00");
			document.getElementById('Prix_Ligne_TTC').value = formatNombre(pvht * tva, "0.00");
			document.getElementById('Marge_Ligne').value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else if (t=="t") {
			var pvht = parseFloat(document.getElementById('Prix_Ligne_TTC').value) / tva;
			document.getElementById('Prix_Ligne').value = formatNombre(pvht, "0.00");
			document.getElementById('Coeff_Ligne').value = formatNombre(pvht / pr, "0.#####");
			document.getElementById('Marge_Ligne').value = formatNombre((pvht-pr)/pvht * 100, "0.00");
		}
		else if (t=="m") {

			if (parseFloat(document.getElementById('Marge_Ligne').value)>=100) {
				showWarning("Le pourcentage de marge doit tre infrieur  100 % !");
			}
			else {
				var pvht = pr / (1 - parseFloat(document.getElementById('Marge_Ligne').value)/100);
				document.getElementById('Prix_Ligne').value = formatNombre(pvht, "0.00");
				document.getElementById('Coeff_Ligne').value = formatNombre(pvht / pr, "0.#####");
				document.getElementById('Prix_Ligne_TTC').value = formatNombre(pvht * tva, "0.00");
			}
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#calculerLigne : ' + e);
	}
}

function reporterLigne() {
  try {

		var tree = document.getElementById('tarifs_qte');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById('Lib_Int').value = getCellText(tree,tree.view.selection.currentIndex,'ColLibInt');
			document.getElementById('Lib_Ext').value = getCellText(tree,tree.view.selection.currentIndex,'ColLibExt');
			document.getElementById('Quantite_Ligne').value = getCellText(tree,tree.view.selection.currentIndex,'ColQuantite');
			document.getElementById('Prix_Ligne').value = getCellText(tree,tree.view.selection.currentIndex,'ColHT');
			document.getElementById('Marge_Ligne').value = getCellText(tree,tree.view.selection.currentIndex,'ColMarge');
			document.getElementById('Coeff_Ligne').value = getCellText(tree,tree.view.selection.currentIndex,'ColCoeff');
			document.getElementById('Prix_Ligne_TTC').value = getCellText(tree,tree.view.selection.currentIndex,'ColTTC');
			document.getElementById('Tarif_Id').value = getCellText(tree,tree.view.selection.currentIndex,'ColTarif_Id');
			document.getElementById('bSupprimer').disabled = false;
		}

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#reporterLigne : ' + e);
	}
}

function supprimerLigne() {
  try {

		var tarif_id = document.getElementById("Tarif_Id").value;

    var corps = cookie() +"&Page=Facturation/Stocks/supprimerTarifQte.tmpl&ContentType=xml&Tarif_Id="+ tarif_id;

    var p = requeteHTTP(corps);

   	delete_tree_tarifs();
   	init_tree_tarifs();
		annulerLigne();

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#supprimerLigne : ' + e);
	}
}


function disableBoutons(b) {
  try {

		document.getElementById('bAnnuler').disabled = b;
		document.getElementById('bValider').disabled = b;
		document.getElementById('bSupprimer').disabled = b;

		document.getElementById('Base_Calcul').disabled = b;

	} catch (e) {
  	recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#disableBoutons : ' + e);
	}
}


function init_tree_tarifs() {
  try {

    var article_id = parent.document.getElementById("Article").value;
		var tva = document.getElementById('Code_TVA').label;

    var paramlist = "&Page=Facturation/GetRDF/tarifs_qte.tmpl&ContentType=xml&Article_Id="+ article_id +"&Taux_TVA="+ tva;

		if (document.getElementById('Base_Calcul').checked) {
			paramlist += "&Prix_Achat="+ document.getElementById('Prix_Revient').value;
		}

    load_rdf('tarifs_qte', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#init_tree_tarifs : ' + e);
  }
}


function delete_tree_tarifs() {
  try {

    var database = document.getElementById("tarifs_qte").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('tarifs_qte').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/contenuPrix.js#delete_tree_tarifs : ' + e);
  }
}

function rechcompte(id) {
	try {
	
    setModifie();

		var debCompte="";
		var nom="";
    switch (id) {
      case 'Compte_Vente':
  			debCompte="7";
        nom="VENTE";
        break;
      case 'Compte_Achat':
  			debCompte="6";
        nom="ACHAT";
        break;
    }
    var url ="chrome://opensi/content/config/util/rechcompte.xul?"+ cookie();
    url += "&Compte_Gen=G";
		url += "&Force_Deb="+ debCompte;
    url += "&nom="+ urlEncode(nom);
    window.openDialog(url,'rechcompte','chrome,modal',debCompte,id,false);

	} catch (e) {
		recup_erreur('erreur dans facturation/user/clients/elems_fact.js#rechcompte : ' + e);
	}
}

