/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*

Paramtres d'entre non obligatoires :
	- Nouv - true->affichage du bouton nouveau - defaut=true
	- Modif_Action - true->modification du champs Action (fentre appelante) - defaut=true
	- Field_Article - id du champs o est reporte la rfrence article choisie (fentre appelante) - defaut=Article

*/

var cookieWrapper;

function init() {
  try {

    cookieWrapper = getWrapper();
    var nouv = ParamValeur('Nouv');
    if (! isEmpty(nouv)) {
      if (nouv == 'false') {
        document.getElementById('bouton_nouveau').collapsed = true;
      }
    }

		var paramlist = "&Page=Facturation/GetRDF/familles_article.tmpl&ContentType=xml";
  	load_rdf_async('Famille', getUrlOpeneas(paramlist), initFamille);

		paramlist = "&Page=Facturation/GetRDF/marques_article.tmpl&ContentType=xml";
  	load_rdf_async('Marque', getUrlOpeneas(paramlist), initMarque);

		paramlist = "&Page=Facturation/GetRDF/collections_article.tmpl&ContentType=xml";
  	load_rdf_async('Collection', getUrlOpeneas(paramlist), initCollection);

		paramlist = "&Page=Facturation/GetRDF/couleurs_article.tmpl&ContentType=xml";
  	load_rdf_async('Couleur', getUrlOpeneas(paramlist), initCouleur);

		paramlist = "&Page=Facturation/GetRDF/tailles_article.tmpl&ContentType=xml";
  	load_rdf_async('Taille', getUrlOpeneas(paramlist), initTaille);

    var x = (screen.width / 2) - 450;
    var y = (screen.height / 2) - 250;
    window.resizeTo(900,500);
    window.moveTo(x,y);
    document.getElementById('Article_Id').focus();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#init : ' + e);
  }
}

function initFamille() {
	try {

		document.getElementById('Famille').selectedIndex = 0;
		chargerSousFamilles();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#initFamille : ' + e);
  }
}


function chargerSousFamilles() {
	try {

		delete_sousfamilles();

		var paramlist = "&Page=Facturation/GetRDF/sousfamilles_article.tmpl&ContentType=xml&Famille="+ document.getElementById('Famille').value;
  	load_rdf_async('Sous_Famille', getUrlOpeneas(paramlist), selSousFamille);

	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#chargerSousFamilles : ' + e);
	}
}


function selSousFamille() {
	try {

		document.getElementById('Sous_Famille').selectedIndex = 0;

	} catch (e) {
		recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#selSousFamille : ' + e);
	}
}


function delete_sousfamilles() {
  try {

    var database = document.getElementById("Sous_Famille").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('Sous_Famille').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#delete_sousfamilles : ' + e);
  }
}


function initMarque() {
	try {

		document.getElementById('Marque').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#initMarque : ' + e);
  }
}


function initCollection() {
	try {

		document.getElementById('Collection').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#initCollection : ' + e);
  }
}


function initCouleur() {
	try {

		document.getElementById('Couleur').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#initCouleur : ' + e);
  }
}


function initTaille() {
	try {

		document.getElementById('Taille').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#initTaille : ' + e);
  }
}


function pressOnId(ev) {
  try {

    if (ev.keyCode==13) {

			var code_article = document.getElementById('Article_Id').value;

			if (existeArticle(code_article))
        ouvrirArticle(code_article);
			else
				rechercher();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnId : ' + e);
  }
}


function pressOnNom(ev) {
  try {

    if (ev.keyCode==13) {
			rechercher();
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnNom : ' + e);
  }
}


function pressOnFamille() {
  try {

		rechercher();
		chargerSousFamilles();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnFamille : ' + e);
  }
}


function pressOnTree(ev) {
  try {

    if (ev.keyCode==13) {
			choixArticle();
  	}

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#pressOnTree : ' + e);
  }
}


function existeArticle(code_article) {
  try {

		var corps = cookie() +"&Page=Facturation/Stocks/existeArticle.tmpl&ContentType=xml&Article_Id="+ urlEncode(code_article);
		var p = requeteHTTP(corps);

  	var contenu = p.responseXML.documentElement;
  	return (contenu.getAttribute('existe')=="true" && contenu.getAttribute('supprime')=="false");

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#existeArticle : ' + e);
  }
}


function nouveauArticle() {
  try {

		var modif_action = !(ParamValeur('Modif_Action')=="false");

		if (modif_action) {
			cookieWrapper.getElementById("Action").value = "C";
		}

		window.close();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#nouveauArticle : ' + e);
  }
}


function ouvrirArticle(code_article) {
  try {

		var modif_action = !(ParamValeur('Modif_Action')=="false");

		if (modif_action) {
			cookieWrapper.getElementById('Action').value = "M";
		}

		var field_article = ParamValeur('Field_Article');

		if (isEmpty(field_article)) {
			cookieWrapper.getElementById('Article').value = code_article;
		}
		else {
			cookieWrapper.getElementById(field_article).value = code_article;
		}
    window.close();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#ouvrirArticle : ' + e);
  }
}


function choixArticle() {
	try {

		var tree = document.getElementById('articles');

		if (tree.view!=null && tree.currentIndex!=-1) {

			var code_article = getCellText(tree,tree.view.selection.currentIndex, 'ColArticle_Id');

			ouvrirArticle(code_article);
		}

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#reporterId : ' + e);
  }
}


function rechercher() {
	try {

		var param = "&Article_Id="+ urlEncode(document.getElementById('Article_Id').value);
		param += "&Designation="+ urlEncode(document.getElementById('Designation').value);
		param += "&Marque="+ urlEncode(document.getElementById('Marque').value);
		param += "&Famille="+ urlEncode(document.getElementById('Famille').value);
		param += "&Sous_Famille="+ urlEncode(document.getElementById('Sous_Famille').value);
		param += "&Collection="+ urlEncode(document.getElementById('Collection').value);
		param += "&Couleur="+ urlEncode(document.getElementById('Couleur').value);
		param += "&Taille="+ urlEncode(document.getElementById('Taille').value);

		delete_tree();
		init_tree(param);

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#rechercher : ' + e);
  }
}


function reinitialiser() {
	try {

		delete_tree();

		document.getElementById('Article_Id').value = "";
		document.getElementById('Designation').value = "";
		document.getElementById('Marque').selectedIndex = 0;
		document.getElementById('Famille').selectedIndex = 0;
		document.getElementById('Sous_Famille').selectedIndex = 0;
		document.getElementById('Collection').selectedIndex = 0;
		document.getElementById('Couleur').selectedIndex = 0;
		document.getElementById('Taille').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#reinitialiser : ' + e);
  }
}


function init_tree(param) {
  try {

    var fournisseur = ParamValeur('Fournisseur');
    var paramlist = "&Page=Facturation/GetRDF/liste_articles.tmpl&ContentType=xml"+ param;
    if (!isEmpty(fournisseur)) {
      paramlist += "&Fournisseur_Id="+ fournisseur;
    }
    load_rdf('articles', getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {

    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('articles').builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans facturation/user/stocks/rech_stocks.js#delete_tree : ' + e);
  }
}
