/******************************************************************************/
/* OpenSI Comptabilit? : Outils libre de comptabilit? d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Gestion des vnements sur la fenetre <facturation/user/tabbord/achats/achats.xul>
 *
 */

var httpRequest;
var frm;

 
/******************************************************************************/
/*                               INIT                                         */
/******************************************************************************/

function init() {
  try {

    frm = ParamValeur('onglet');
    switch(frm) {
      case 'frmGlobal':
        loadfrmGlobal();
        break;
      case 'frmFournisseur':
        loadfrmFournisseur();
        break;
      case 'frmArticle':
        loadfrmArticle();
        break;
      case 'frmCommercial':
        loadfrmCommercial();
        break;
    }

  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#init : ' + e);
  }
}

function init_rdf(param) {
  try {
    document.getElementById('tableau_bord').collapsed = false;
    document.getElementById('lblDates').collapsed = false;
    var paramlist = "&Page=Facturation/GetRDF/tableau_bord_achats.tmpl&ContentType=xml";
    paramlist += param;
    load_rdf('lignes_tabbord', getUrlOpeneas(paramlist));
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#init_rdf : ' + e);
  }
}

function delete_rdf() {
  try {

    document.getElementById('tableau_bord').collapsed = true;
    document.getElementById('lblDates').collapsed = true;
    
    var database = document.getElementById('lignes_tabbord').database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('lignes_tabbord').builder.rebuild();
		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#delete_rdf : ' + e);
  }
}

function reinit_rdf(param) {
  try {
    delete_rdf();
    init_rdf(param);
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#reinit_rdf : ' + e);
  }
}

function loadfrmGlobal() {
  try {
    document.getElementById('totCol').collapsed = true;
    document.getElementById('pourcentageCol').collapsed = true;
    init_rdf("&Global=1");
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#loadfrmGlobal : ' + e);
  }
}

/******************************************************************************/
/*                             CLIENT                                         */
/******************************************************************************/

function loadfrmFournisseur() {
  try {
    document.getElementById('infos_fournisseur').collapsed = false;
		var paramlist = "&&Page=Facturation/GetRDF/familles_fournisseur.tmpl&ContentType=xml"+ nocache();
  	load_rdf_async('FamilleFournisseur', getUrlOpeneas(paramlist), initFamilleFournisseur);
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#loadfrmFournisseur : ' + e);
  }
}

function rechercherFournisseur() {
  try {
		var url = "chrome://opensi/content/facturation/user/fournisseurs/rech_fournisseur.xul?"+ cookie();
    url += "&Nouv=false&Modif_Action=false&Field_Fournisseur=Fournisseur_Id&Bloque=true";
    window.openDialog(url,'','chrome,modal');
		if (document.getElementById("Fournisseur_Id").value != "") {
			chargerFournisseur();
		}
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/tabbord/achats/achats.js#rechercherFournisseur : ' + e);
  }
}

function chargerFournisseur() {
  try {
		var fournisseur_id = document.getElementById("Fournisseur_Id").value;
		var corps = cookie() + "&Page=Facturation/Fournisseurs/getFournisseur.tmpl&ContentType=xml";
    corps += "&Fournisseur_Id="+ urlEncode(fournisseur_id);
    httpRequest = new XMLHttpRequest();
    requeteHTTP(corps,httpRequest,suite_chargerFournisseur);
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#chargerFournisseur : ' + e);
  }
}


function suite_chargerFournisseur() {
  try {
  	if (httpRequest.status != "200") {
    	alert("Rception erreur " + p.status);
  	} 
		else {
			var contenu = httpRequest.responseXML.documentElement;
			document.getElementById('Raison_Sociale').value = contenu.getAttribute('Raison_Sociale');
			document.getElementById('Adresse').value = contenu.getAttribute('Adresse');
			document.getElementById('Comp_Adresse').value = contenu.getAttribute('Comp_Adresse');
			document.getElementById('Code_Postal').value = contenu.getAttribute('Code_Postal');
			document.getElementById('Ville').value = contenu.getAttribute('Ville');

      var param = "&Fournisseur=1";
      param += "&Fournisseur_Id=" + document.getElementById('Fournisseur_Id').value;
      reinit_rdf(param);

		}
	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/tabbord/achats/achats.js#suite_chargerFournisseur : ' + e);
  }
}

function selectTabFournisseur(nomtab) {
  try {
    switch(nomtab) {
      case 'fournisseur':
        if (isEmpty(document.getElementById('Fournisseur_Id').value)) {
          delete_rdf();
        } else {
          chargerFournisseur();
        }
        break;
      case 'famille':
        var famille = document.getElementById('FamilleFournisseur').value;
        if (isEmpty(famille)) {
          delete_rdf();
        } else {
          pressOnFamilleFournisseur();
        }
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#selectTabFournisseur : ' + e);
  }
}

function initFamilleFournisseur() {
	try {
		document.getElementById('FamilleFournisseur').selectedIndex = 0;
	} catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#initFamilleFournisseur : ' + e);
  }
}

function pressOnFamilleFournisseur() {
  try {
    var famille = document.getElementById('FamilleFournisseur').value;
    if (isEmpty(famille)) {
      delete_rdf();
    } else {
      var param = "&Fournisseur=1";
      param += "&FamilleFournisseur="+ urlEncode(famille);
      reinit_rdf(param);
    }
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#pressOnFamilleFournisseur : ' + e);
  }
}

/******************************************************************************/
/*                                ARTICLE                                     */
/******************************************************************************/

function loadfrmArticle() {
  try {
    document.getElementById('infos_article').collapsed = false;

		var paramlist = "&Page=Facturation/GetRDF/familles_article.tmpl&ContentType=xml"+ nocache();
  	load_rdf_async('FamilleArticle', getUrlOpeneas(paramlist), initFamilleArticle);

		var paramlist2 = "&Page=Facturation/GetRDF/marques_article.tmpl&ContentType=xml"+ nocache();
  	load_rdf_async('MarqueArticle', getUrlOpeneas(paramlist2), initMarque);

  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#loadfrmArticle : ' + e);
  }
}

function rechercherArticle() {
  try {
    var url = "chrome://opensi/content/facturation/user/stocks/rech_stocks.xul?"+ cookie();
    url += "&Nouv=false&Modif_Action=false&Field_Article=Reference";
    window.openDialog(url,'','chrome,modal');
    chargerArticle();
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#rechercherArticle : ' + e);
  }
}

function chargerArticle() {
	try {
    var reference = document.getElementById('Reference').value;
    if (isEmpty(reference)) {
      delete_rdf();
    } else {
		  var corps = cookie() + "&Page=Facturation/Stocks/getArticle.tmpl&ContentType=xml";
      corps += "&Article_Id="+ urlEncode(reference);
      httpRequest = new XMLHttpRequest();
      requeteHTTP(corps,httpRequest,suite_chargerArticle);
    }
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#chargerArticle : ' + e);
  }
}

function suite_chargerArticle() {

	try {

  	if (httpRequest.status != "200") {
      alert("Rception erreur " + p.status);
  	} 

		else {

			var contenu = httpRequest.responseXML.documentElement;			
			document.getElementById('Marque').value = contenu.getAttribute('Marque');
			document.getElementById('Designation').value = contenu.getAttribute('Designation');
			document.getElementById('Famille').value = contenu.getAttribute('Famille');
			document.getElementById('Sous_Famille').value = contenu.getAttribute('Sous_Famille');

      var param = "&Article=1";
      param += "&Reference=" + document.getElementById('Reference').value;
      reinit_rdf(param);

    }
		
	} catch (e) {
  	recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#suite_chargerArticle : ' + e);
  }

}

function selectTabArticle(nomtab) {
  try {
    switch(nomtab) {
      case 'article':
        if (isEmpty(document.getElementById('Reference').value)) {
          delete_rdf();
        } else {
          chargerArticle();
        }
        break;
      case 'famille':
        var famille = document.getElementById('FamilleArticle').value;
        if (isEmpty(famille)) {
          delete_rdf();
        } else {
          pressOnSousFamilleArticle();
        }
        break;
      case 'marque':
        var marque = document.getElementById('MarqueArticle').value;
        if (isEmpty(marque)) {
          delete_rdf();
        } else {
          pressOnMarque();
        }
        break;
    }
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#selectTabArticle : ' + e);
  }
}

function initFamilleArticle() {
	try {
	
		document.getElementById('FamilleArticle').selectedIndex = 0;
		chargerSousFamillesArticle();
	
	} catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#initFamilleArticle : ' + e);
  }
}


function chargerSousFamillesArticle() {
	try {

		delete_sousfamillesArticle();

		var paramlist = "&Page=Facturation/GetRDF/sousfamilles_article.tmpl&ContentType=xml" + nocache();
    paramlist += "&Famille="+ document.getElementById('FamilleArticle').value;
  	load_rdf_async('Sous_FamilleArticle', getUrlOpeneas(paramlist), selSousFamilleArticle);

	} catch (e) {
		recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#chargerSousFamillesArticle : ' + e);
	}
}


function selSousFamilleArticle() {
	try {
		document.getElementById('Sous_FamilleArticle').selectedIndex = 0;
	} catch (e) {
		recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#selSousFamilleArticle : ' + e);
	}
}


function delete_sousfamillesArticle() {
  try {
    var database = document.getElementById('Sous_FamilleArticle').database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }		
		document.getElementById('Sous_FamilleArticle').builder.rebuild();
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#delete_sousfamillesArticle : ' + e);
  }
}

function initMarque() {
	try {
		document.getElementById('MarqueArticle').selectedIndex = 0;
	} catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#initMarque : ' + e);
  }
}

function pressOnMarque() {
  try {
    var marque = document.getElementById('MarqueArticle').value;
    if (isEmpty(marque)) {
      delete_rdf();
    } else {
      var param = "&Article=1";
      param += "&Marque="+ urlEncode(marque);
      reinit_rdf(param);
    }
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#pressOnMarque : ' + e);
  }
}


function pressOnFamilleArticle() {
  try {
    var param = "&Article=1";
    param += "&FamilleArticle="+ urlEncode(document.getElementById('FamilleArticle').value);
    reinit_rdf(param);
		chargerSousFamillesArticle();
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#pressOnFamilleArticle : ' + e);
  }
}


function pressOnSousFamilleArticle() {
  try {
    var famille = document.getElementById('FamilleArticle').value;
    if (isEmpty(famille)) {
      delete_rdf();
    } else {
      var param = "&Article=1";
      param += "&FamilleArticle="+ urlEncode(famille);
      var sousfamille = document.getElementById('Sous_FamilleArticle').value;
      if (! isEmpty(sousfamille)) {
        param += "&SousFamilleArticle="+ urlEncode(document.getElementById('Sous_FamilleArticle').value);
      }
      reinit_rdf(param);
    }
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#pressOnSousFamilleArticle : ' + e);
  }
}

/******************************************************************************/
/*                             ACHETEUR                                       */
/******************************************************************************/

function loadfrmCommercial() {
  try {
    document.getElementById('infos_commercial').collapsed = false;
		paramlist = "&Page=Facturation/GetRDF/liste_commerciaux.tmpl&ContentType=xml";
    paramlist += "&tabbord=1";
  	load_rdf_async('Login_Resp', getUrlOpeneas(paramlist), initResp);		
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#loadfrmCommercial : ' + e);
  }
}

function initResp() {
  try { 
		document.getElementById('Login_Resp').selectedIndex = 0;
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#initResp : ' + e);
  }
}

function changeResp() {
  try {
    reinit_rdf("&Login_Resp=" + document.getElementById('Login_Resp').value);
  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#changeResp : ' + e);
  }
}

/******************************************************************************/
/*                           DATES                                            */
/******************************************************************************/

function majDates() {

  try {

    var date_debut = document.getElementById('date_debut').value;
    var date_fin = document.getElementById('date_fin').value;

    var paramlist = "&Periode=1";

    if (isEmpty(date_debut) && isEmpty(date_fin)) {
      return false;
    }
    if (isDate(date_debut)) {
      paramlist += "&Date_Debut=" + prepareDateJava(date_debut);
    } else if (! isEmpty(date_debut)){
      showWarning("Veuillez saisir un format de date correct (jj/mm/aaaa)");
      return false;
    }
    if (isDate(date_fin)) {
      paramlist += "&Date_Fin=" + prepareDateJava(date_fin);
    } else if (! isEmpty(date_fin)) {
      showWarning("Veuillez saisir un format de date correct (jj/mm/aaaa)");
      return false;
    }

    switch(frm) {
      case 'frmGlobal':
        paramlist += "&Global=1";
        break;
      case 'frmFournisseur':
        paramlist += "&Fournisseur_Id=" + urlEncode(document.getElementById('Fournisseur_Id').value);
        break;
      case 'frmArticle':
        paramlist += "&Reference=" + urlEncode(document.getElementById('Reference').value);
        break;
      case 'frmCommercial':
        paramlist += "&Login_Resp=" + urlEncode(document.getElementById('Login_Resp').value);
        break;
    }

    reinit_rdf(paramlist);

  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js#majDates : ' + e);
  }

}

/*
function () {
  try {

  } catch (e) {
    recup_erreur('erreur dans facturation/user/tabbord/achats/achats.js# : ' + e);
  }
}
*/