/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");


var aFactures;
var aAvoirs;
var aPeriodes;


function init() {
  try {

		aPeriodes = new Arbre('fact', 'liste_12_dernieres_periodes.tmpl', 'Periode');
		aPeriodes.initTree(initPeriode);

		var aJournaux = new Arbre('cpta', 'liste_journaux.tmpl', 'Journal');
		aJournaux.addParam('Factu', '1');
		aJournaux.addParam('Type_Journal', 'AC');
		aJournaux.initTree(initJournal);

	} catch (e) {
  	recup_erreur('erreur dans erreur dans facturation/user/transfert/transfert_achats.js#init : ' + e);
  }
}


function initPeriode() {
  try {

		document.getElementById('Periode').selectedIndex = 0;

		aFactures = new Arbre('fact', 'factures_achats_transfert.tmpl', 'factures');
		aFactures.addParam('SansTrans','true');
		aFactures.addParam('Periode', document.getElementById('Periode').value);
		aFactures.initTree();

		aAvoirs = new Arbre('fact', 'avoirs_achats_transfert.tmpl', 'avoirs');
		aAvoirs.addParam('SansTrans','true');
		aAvoirs.addParam('Periode', document.getElementById('Periode').value);
		aAvoirs.initTree();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/transfert/transfert_achats.js#initPeriode : ' + e);
  }
}


function initJournal() {
  try {

    document.getElementById('Journal').selectedIndex = 0;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/transfert/transfert_achats.js#initJournal : ' + e);
  }
}


function changePeriode(periode) {
  try {

		aAvoirs.setParam('Periode', periode);
		aAvoirs.initTree();
		aFactures.setParam('Periode', periode);
		aFactures.initTree();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/transfert/transfert_achats.js#initJournal : ' + e);
  }
}


function chgAffFactures(etat) {
  try {

		if (etat) {
			aFactures.removeParam('SansTrans');
		}
		else {
			aFactures.addParam('SansTrans','true');
		}

		aFactures.initTree();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/transfert/transfert_achats.js#chgAffFactures : ' + e);
  }
}


function chgAffAvoirs(etat) {
  try {

		if (etat) {
			aAvoirs.removeParam('SansTrans');
		}
		else {
			aAvoirs.addParam('SansTrans','true');
		}

		aAvoirs.initTree();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/transfert/transfert_achats.js#chgAffAvoirs : ' + e);
  }
}


function transferer() {

	var corps = cookie() +"&Page=Facturation/Transfert/TransfertAchats.tmpl&ContentType=xml";
	corps += "&Periode="+ document.getElementById('Periode').value;
	corps += "&Code_Journal="+ document.getElementById('Journal').value;

	requeteHTTP(corps);

	aFactures.initTree();
	aAvoirs.initTree();
}


function goToVentes() {
  try {

		window.location = "chrome://opensi/content/facturation/user/transfert/transfert_factures.xul?"+ cookie();

	} catch (e) {
    recup_erreur('erreur dans facturation/user/transfert/transfert_achats.js#goToVentes : ' + e);
  }
}


function retour_menu_principal() {
  try {

    var page = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();
		page += "&Libelle="+ urlEncode(parent.document.getElementById("nom_dossier").value);
    window.location = page;

	} catch (e) {
    recup_erreur('erreur dans facturation/user/transfert/transfert_achats.js#retour_menu_principal : ' + e);
  }
}
