/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Bibliothque de fonctions utiles  OpenSi
 */

// objet pour charger des librairies js  partir d'une autre fichier js
var jsLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);


function get_num_version() {
  return 3;
}

function get_release() {
  return 4;
}

function get_sous_release() {
  return 0;
}

var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

try {
  // Extraction des paramtres de la requte HTTP
  // et initialise la variable "paramOk"  false
  // s'il n'y a aucun paramtre.
  if (!location.search) {
    paramOk = false;
  }
  else {
    // liminer le "?"
    nReq = location.search.substring(1,location.search.length)
    // Extrait les diffrents paramtres avec leur valeur.
    nReq = nReq.split("&");
    param = new FaitTableau(nReq.length-1)
    for (var i=0;i<(nReq.length);i++) {
      param[i] = nReq[i]
    }
  }
} catch (e) {
  recup_erreur('erreur dans libs/util.js# : ' + e);
}


function get_version() {
  try {

    return get_num_version() +'.'+ get_release() +'.'+ get_sous_release();

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_version : ' + e);
  }
}


function get_os() {
  try {

    return navigator.platform;

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_os : ' + e);
  }
}


function get_pref_module() {
  try {

    if (prefs.getPrefType("opensi.serveur.module") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.serveur.module")
    } else {
      return "Compta";
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_module : ' + e);
  }
}


function get_pref_ssl() {
  try {

    if (prefs.getPrefType("opensi.serveur.ssl") == prefs.PREF_BOOL){
      return prefs.getBoolPref("opensi.serveur.ssl")
    } else {
      return false;
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_ssl : ' + e);
  }
}


function get_pref_protocol() {
  try {

    if (get_pref_ssl()){
      return "https";
    } else {
      return "http";
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_protocol : ' + e);
  }
}


function get_pref_ipserveur() {
  try {

    if (prefs.getPrefType("opensi.serveur.addresse") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.serveur.addresse");
    } else {
      return "localhost";
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_ipserveur : ' + e);
  }
}


function get_pref_porttomcat() {
  try {

    if (prefs.getPrefType("opensi.serveur.port") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.serveur.port");
    } else {
      return "8080";
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_porttomcat : ' + e);
  }
}


function get_pref_servlet() {
  try {

    if (prefs.getPrefType("opensi.serveur.servlet") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.serveur.servlet");
    } else {
      return "OpenSI";
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_servlet : ' + e);
  }
}


function get_pref_mailcomptable() {
  try {

    if (prefs.getPrefType("opensi.mailcomptable") == prefs.PREF_STRING){
      return prefs.getCharPref("opensi.mailcomptable");
    } else {
      return "";
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_mailcomptable : ' + e);
  }
}


function get_pref_logmail() {
  try {

    if (prefs.getPrefType("network.protocol-handler.app.mailto") == prefs.PREF_STRING) {
      return prefs.getCharPref("network.protocol-handler.app.mailto");
    } else {
      return "";
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_pref_logmail : ' + e);
  }
}


function set_pref_module(value) {
  try {

    prefs.setCharPref("opensi.serveur.module",value );

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_module : ' + e);
  }
}


function set_pref_ssl(value) {
  try {

    prefs.setBoolPref("opensi.serveur.ssl",value );

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_ssl : ' + e);
  }
}


function set_pref_ipserveur(value) {
  try {

    prefs.setCharPref("opensi.serveur.addresse",value );

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_ipserveur : ' + e);
  }
}


function set_pref_porttomcat(value) {
  try {

    prefs.setCharPref("opensi.serveur.port",value );

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_porttomcat : ' + e);
  }
}


function set_pref_servlet(value) {
  try {

    prefs.setCharPref("opensi.serveur.servlet",value );

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_servlet : ' + e);
  }
}


function set_pref_mailcomptable(value) {
  try {

    prefs.setCharPref("opensi.mailcomptable",value );

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_mailcomptable : ' + e);
  }
}


function set_pref_logmail(value) {
  try {

    prefs.setCharPref("network.protocol-handler.app.mailto",value );

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_pref_logmail : ' + e);
  }
}

BASE_CALENDRIER = 2000;
MODULO = 2000 - BASE_CALENDRIER;

/* res est une string transmise par l'element XUL d'origine de l'appel */
function launchExternalMailer(res) {
  try {

    if (res) {
      var url = "mailto:"+ res;
      var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
      var uri = ioService.newURI(url, null, null);
      var extProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
      extProtocolSvc.loadUrl(uri);
    }

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#launchExternalMailer : ' + e);
  }
}


// =====================================================================


// ********************************************
// Rcupration de paramtre d'une requte HTTP
// ou rcupration des donnes d'un formulaire.
// Auteur : Oznog (www.trucsweb.com)
// ********************************************

// NE PAS MODIFIER CE CODE
var paramOk = true;


/* cration d'un tableau (array) aux dimensions du nombre de paramtres */
function FaitTableau(n) {
  try {

    this.length = n;
    for (var i = 0; i <= n; i++) {
      this[i] = 0
    }

    return this;

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#FaitTableau : ' + e);
  }
}


/* rcupration de la valeur d'une variable pour crer la variable en javascript */
function ParamValeur(nValeur) {
  try {

    if (paramOk) {
      var nTemp = "";
      for (var i=0;i<(param.length+1);i++) {
        if (param[i].substring(0,param[i].indexOf("=")) == nValeur)
          nTemp = param[i].substring(param[i].indexOf("=")+1,param[i].length)
      }
      return Decode(nTemp);
    } else {
      return '';
    }

  } catch (e) {
//    alert('erreur dans libs/util.js#ParamValeur : ' + e);
  }
}


/* Decoder la requete HTTP manuellement pour le signe (+) */
function Decode(tChaine) {
  try {

    while (true) {
      var i = tChaine.indexOf('+');
      if (i < 0) break;
      tChaine = tChaine.substring(0,i) +'%20'+ tChaine.substring(i + 1, tChaine.length);
    }
    return unescape(tChaine);

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#Decode : ' + e);
  }
}


// =====================================================================


/* recuperation du numero de session OpenEAS */
function cookie() {
	try {

  	return "S_="+ ParamValeur("S_") + nocache();

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#cookie : ' + e);
  }
}


function getDirServeur() {
    var url = get_pref_protocol() +"://";
    url += get_pref_ipserveur();
    url += ":"+ get_pref_porttomcat();
    url += "/"+ get_pref_servlet() +"/";
    return url;
}


/* retourne le repertoire d'entre/sortie du serveur */
function getDirBuffer() {
  try {

    return getDirServeur() +"iobuffer/";

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#getDirBuffer : ' + e);
  }
}


/* retourne le repertoire de stockage des pdf */
function getDirPdf() {
  try {

    return getDirServeur() +"pdf/";

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#getDirPdf : ' + e);
  }
}


function getUrlOpeneas(paramlist) {
  var retour = getDirServeur() +"openeas";
  if (paramlist != '') {
    retour += "?"+ cookie() + paramlist;
  }
  return retour;
}

/* ne pas utiliser */
function requeteHTTP(param,httpRequest,callbackFn,callbackParams) {
  try {

    if (httpRequest==undefined) {

      var p = new XMLHttpRequest();
      p.onload = null;
      p.open("POST",getUrlOpeneas(''), false);
      p.setRequestHeader("Content-type","application/x-www-form-urlencoded");
      p.send(param);
      return p;

    }	else {

      httpRequest.onload = null;

      if (callbackFn==undefined) {
        httpRequest.open("POST",getUrlOpeneas(''), false);
      } else {
//        httpRequest.onreadystatechange = callbackFn;
//        httpRequest.onload = callbackFn;
        httpRequest.onload = function (aEvt) {
          callbackFn(httpRequest,callbackParams);
        };
        httpRequest.open("POST",getUrlOpeneas(''), true);
      }
      httpRequest.setRequestHeader("Content-type","application/x-www-form-urlencoded");
      httpRequest.send(param);
    }

  } catch (e) {
    alert("Le serveur est introuvable.\n Veuillez v\u00E9rifier son adresse et son port dans les param\u00E8tres avanc\u00E9s");
    alert(e);
    return p;
  }
}


/* insertion d'un cookie dans la session OpenEAS */
function set_cookie(pname,pvalue) {
  try {

    var corps = cookie() +"&Page=SetCookie.tmpl&Name="+ pname +"&Value="+ pvalue;
    requeteHTTP(corps);

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#set_cookie : ' + e);
  }
}


/*  retourne le nombre de jours dans le mois correspondant  la saisie */
function nb_jours(mois,annee) {
  if (isNaN(annee)) {
    recup_erreur("erreur dans libs/util.js#nb_jours : mauvais format d'anne : " + annee );
    return false;
  }
  if (isNaN(mois)) {
    recup_erreur("erreur dans libs/util.js#nb_jours : mauvais format de mois : " + mois );
    return false;
  }
  switch (mois) {
    case 1:
    case 3:
    case 5:
    case 7:
    case 8:
    case 10:
    case 12:
      return 31;
      break;
    case 4:
    case 6:
    case 9:
    case 11:
      return 30;
      break;
    case 2:
      if ((annee != 0) && ((annee % 4) == 0)) {
        return 29;
      } else {
        return 28;
      }
      break;
    default:
      recup_erreur("erreur dans libs/util.js#nb_jours : mauvais format de mois : " + mois );
      return false;
  }
}


function get_mois(mois) {

	switch(mois) {
    case '01': return 'Janvier';  break;
    case '02': return 'Fvrier';  break;
    case '03': return 'Mars';     break;
    case '04': return 'Avril';    break;
    case '05': return 'Mai';      break;
    case '06': return 'Juin';     break;
    case '07': return 'Juillet';  break;
    case '08': return 'Aout';     break;
    case '09': return 'Septembre';break;
    case '10': return 'Octobre';  break;
    case '11': return 'Novembre'; break;
    case '12': return 'Dcembre'; break;
    default:
      recup_erreur("erreur dans libs/util.js#get_mois : mauvais format de mois : "+ mois);
      return false;
  }
}


/* rcupration d'une date au format OpenEAS */
function get_date(day,month,year) {
  try {

    var corps = "&Page=GetDate.tmpl&ContentType=xml&Day="+ day +"&Month="+ month +"&Year="+ year ;
    var p = requeteHTTP(corps);

    return p.responseXML.documentElement.getAttribute('date');

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_date : ' + e);
  }
}


/* rcupration d'un cookie de la session OpenEAS */
function get_cookie(name) {
  try {

    var corps = cookie() +"&Page=GetCookie.tmpl&ContentType=xml&Name="+ name;
    var p = requeteHTTP(corps);

    return p.responseXML.documentElement.getAttribute('cookie');

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#get_cookie : ' + e);
  }
}


function reset_session(cookie) {
  try {

    var p = new XMLHttpRequest();

    p.onload = null;
    p.open("POST",getUrlOpeneas(''), false);
    p.setRequestHeader("Content-type","application/x-www-form-urlencoded");

    var corps = cookie +"&Page=SetCookie.tmpl&Reset=True";

    p.send(corps);

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#reset_session : ' + e);
  }
}


function quit() {
	try {

  	reset_session(cookie());
  	window.open('chrome://opensi/content/login.xul','login','chrome');
  	window.parent.close();

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#quit : ' + e);
  }
}


function parseIntBis(nb) {
  try {

		// parseInt en base 10
    return parseInt(nb, 10);

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#parseIntBis : ' + e);
  }
}


/* rcupration des erreurs provenant des exceptions */
function recup_erreur(err) {
  try {

    var corps = cookie() +"&Page=RapportDeBug.tmpl";
    corps += "&Err="+ urlEncode(err);
    corps += "&Version="+ get_version() +"&Os="+ urlEncode(get_os());
    var httpRequest = new XMLHttpRequest();
    httpRequest.onload = null;
    httpRequest.open("POST",getUrlOpeneas(''), false);
    httpRequest.setRequestHeader("Content-type","application/x-www-form-urlencoded");
    httpRequest.send(corps);

  } catch (e) {
    alert('erreur dans libs/util.js#recup_erreur : ' + e);
  }
}


/* criture d'une trace client dans les logs tomcat */
function debug(msg) {
  try {

    var corps = cookie() +"&Page=Debug.tmpl&Msg="+ urlEncode(msg);
    var httpRequest = new XMLHttpRequest();
    httpRequest.onload = null;
    httpRequest.open("POST",getUrlOpeneas(''), false);
    httpRequest.setRequestHeader("Content-type","application/x-www-form-urlencoded");
    httpRequest.send(corps);

  } catch (e) {
    alert('erreur dans libs/util.js#debug : ' + e);
  }
}


/* renvoie une date au format yyyy:MM:dd */
function prepareDateJava(val) {
  try {

    var retour = "";

    if (val.length == 10) {
      retour = val.substring(6,10) +':'+ val.substring(3,5) +':'+ val.substring(0,2);
    }
		else if (val.length == 8) {
      retour = "20" + val.substring(6,8) +':'+ val.substring(3,5) +':'+ val.substring(0,2);
    }

    return retour;

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#prepareDateJava : ' + e);
  }
}


/* renvoie une periode au format 20yy:MM:01 */
function preparePeriodeJava(val) {
  try {

    return '20'+ val.substring(2,4) +':'+ val.substring(0,2) +':01';

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#preparePeriodeJava : ' + e);
  }
}


/* encode une chaine 'str' en url */
function urlEncode(str) {
  try {

		var url = escape(str);

		// signe euro
		url = url.replace(/%u20AC/g, '%80');

		// transformation des retours de ligne en \n
		url = url.replace(/%0A/g, '%5Cn');

		// encodage des '+'
		url = url.replace(/\+/g, '%2B');

		return url;

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#urlEncode : ' + e);
  }
}


/* enlve les caractres "invisibles" de dbut et de fin de la chaine 'str' */
function trim(str) {
  try {

	  var i = 0;
  	var lg = str.length;
	  var j = lg-1;

  	while (i<lg && ((str.charCodeAt(i)==9) || (str.charCodeAt(i)==10) || (str.charCodeAt(i)==13) || (str.charCodeAt(i)==32))) {
	  	i++;
	  }

  	while (j>i && ((str.charCodeAt(j)==9) || (str.charCodeAt(j)==10) || (str.charCodeAt(j)==13) || (str.charCodeAt(j)==32))) {
	  	j--;
	  }

	  return str.substring(i,j+1);

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#trim : ' + e);
  }
}


/* renvoie un parametre http fictif pour forcer le rechargement de la page a partir du serveur */
function nocache() {
	try {

		var nocache = new Date();
		return "&NoCache="+ nocache.getMilliseconds();

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#nocache : ' + e);
  }
}


/* renvoie le nom du fichier contenu dans le chemin 'path' */
function getFileName(path) {
	try {

		var lastslash = path.lastIndexOf('/');
		var lastantislash = path.lastIndexOf('\\');
		var lastsep = (lastslash>lastantislash)?lastslash:lastantislash;

		return path.substring(lastsep+1,path.length);

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#getFileName : ' + e);
  }
}


/* renvoie l'extension du fichier 'file' */
function getFileExtension(file) {
	try {

		var lastPoint = file.lastIndexOf('.');

		if (lastPoint==-1 || lastPoint==file.length-1) {
			return "";
		}
		else {
			return file.substring(lastPoint+1,file.length);
		}

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#getFileExtension : ' + e);
  }
}


/* Message d'information */
function showMessage(msg) {
	try {

		var url = "chrome://opensi/content/popup/message.xul?"+ cookie() +"&Msg="+ urlEncode(msg);
		window.openDialog(url,'Information','chrome,modal');

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#showMessage : ' + e);
  }
}


/* Message d'alerte */
function showWarning(msg) {
	try {

		var url = "chrome://opensi/content/popup/warning.xul?"+ cookie() +"&Msg="+ urlEncode(msg);
		window.openDialog(url,'Warning','chrome,modal');

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#showWarning : ' + e);
  }
}


/* Message d'erreur */
function showError(msg,err) {
	try {

		var url = "chrome://opensi/content/popup/error.xul?"+ cookie();
    url += "&Msg="+ msg +"&Err="+ err;
		window.openDialog(url,'Erreur','chrome,modal');

	} catch (e) {
    alert('erreur dans libs/util.js#showError : ' + e);
  }
}


/* valuation d'une expression mathmatique */
function calcExpr(expr) {
	try {

		return eval(expr.replace(/ /gi, ''));

	}	catch(e) {
		showWarning("Expression incorrecte !");
		return expr;
	}
}


/* fentre de choix d'un fichier */
function fileChooser(mode, suggestedFile) {
	try {

		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

		if (mode=="save") {
			var pickerMode = nsIFilePicker.modeSave;
			var titre = "Enregistrer sous ...";
		}
		else if (mode=="open") {
			var pickerMode = nsIFilePicker.modeOpen;
			var titre = "Ouvrir un fichier";
		}
		else if (mode=="folder") {
			var pickerMode = nsIFilePicker.modeGetFolder;
			var titre = "Ouvrir un rpertoire";
		}

		fp.init(window, titre, pickerMode);
		fp.appendFilters(nsIFilePicker.filterAll); // filtre obligatoire sinon ca plante
		fp.defaultString = suggestedFile;

		var res = fp.show();

		if (res == nsIFilePicker.returnOK){
  		return fp.file;
		}
		else {
			return null;
		}

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#fileChooser : ' + e);
  }
}


/* tlchargement d'un fichier depuis l'url 'url' dans le fichier local 'file' */
function downloadFile(url, file) {
	try {

		var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var uri = ios.newURI(url, "", null);
		var wp = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);

		wp.saveURI(uri,null,null,null,null,file);

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#downloadFile : ' + e);
  }
}


/* ouverture de la page d'aide 'page' du guide opensi */
function aide(page) {
	try {

		var url = getDirServeur() +"aide/opensiguide/"+ page;
		window.openDialog(url,'','chrome,centerscreen');

	} catch (e) {
    recup_erreur('erreur dans libs/util.js#aide : ' + e);
  }
}


/* fonctions de compatibilit entre les versions 1.0 et 1.5 de firefox */
function geckoVersion() {
  var versionindex=navigator.userAgent.indexOf("rv:1")+3;
  if (parseInt(navigator.userAgent.charAt(versionindex))>=1) {
    return navigator.userAgent.substr(versionindex,3);
  } else {
    return false;
  }
}

function getCellText(tree,idligne,idcolumn) {
  if (parseFloat(geckoVersion()) >= 1.8) {
    return tree.view.getCellText(idligne,tree.columns.getNamedColumn(idcolumn)); // FF1.5+ / XulRunner
  } else {
    return tree.view.getCellText(idligne,idcolumn); // FF1.0-
  }
}

function getCellValue(tree,idligne,idcolumn) {
  if (parseFloat(geckoVersion()) >= 1.8) {
    return tree.view.getCellValue(idligne,tree.columns.getNamedColumn(idcolumn)); // FF1.5+ / XulRunner
  } else {
    return tree.view.getCellValue(idligne,idcolumn); // FF1.0-
  }
}

function getWrapper() {
  var cookieWrapper = opener.document;
  if (parseFloat(geckoVersion()) >= 1.8) {
    var winWrapper = new XPCNativeWrapper(window.opener, 'document','getElementById');
    cookieWrapper = new XPCNativeWrapper(winWrapper.document,"getElementById");
  }
  return cookieWrapper;
}



/************ NE PLUS UTILISER LES FONCTIONS SUIVANTES ****************/

/* formattage d'un nombre selon un pattern */
// Original JavaScript code by Duncan Crombie: dcrombie@chirp.com.au
// ne plus utiliser, utiliser le package formatter.js
function formatNombre(number, format) {
	try {

		var separator = " ";  // use space as 000's separator
  	var decpoint = ".";  // use period as decimal point
  	var percent = "%";
  	var currency = "-";

  	if (number - 0 != number) return null;  // if number is NaN return null
  	var useSeparator = format.indexOf(separator) != -1;  // use separators in number
  	var usePercent = format.indexOf(percent) != -1;  // convert output to percentage
  	var useCurrency = format.indexOf(currency) != -1;  // use currency format
  	var isNegative = (number < 0);
  	number = Math.abs (number);
  	if (usePercent) number *= 100;
  	format = strip(format, separator + percent + currency);  // remove key characters
  	number = "" + number;  // convert number input to string

  	// split input value into LHS and RHS using decpoint as divider
  	var dec = number.indexOf(decpoint) != -1;
  	var nleftEnd = (dec) ? number.substring(0, number.indexOf(".")) : number;
  	var nrightEnd = (dec) ? number.substring(number.indexOf(".") + 1) : "";

  	// split format string into LHS and RHS using decpoint as divider
  	dec = format.indexOf(decpoint) != -1;
  	var sleftEnd = (dec) ? format.substring(0, format.indexOf(".")) : format;
  	var srightEnd = (dec) ? format.substring(format.indexOf(".") + 1) : "";

  	// adjust decimal places by cropping or adding zeros to LHS of number
  	if (srightEnd.length < nrightEnd.length) {
    	var nextChar = nrightEnd.charAt(srightEnd.length) - 0;
    	nrightEnd = nrightEnd.substring(0, srightEnd.length);
    	if (nextChar >= 5) nrightEnd = "" + ((nrightEnd - 0) + 1);  // round up

			// patch provided by Patti Marcoux 1999/08/06
    	while (srightEnd.length > nrightEnd.length) {
      	nrightEnd = "0" + nrightEnd;
    	}

    	if (srightEnd.length < nrightEnd.length) {
      	nrightEnd = nrightEnd.substring(1);
      	nleftEnd = (nleftEnd - 0) + 1;
    	}
  	} else {
    	for (var i=nrightEnd.length; srightEnd.length > nrightEnd.length; i++) {
      	if (srightEnd.charAt(i) == "0") nrightEnd += "0";  // append zero to RHS of number
      	else break;
    	}
  	}

  	// adjust leading zeros
  	sleftEnd = strip(sleftEnd, "#");  // remove hashes from LHS of format
  	while (sleftEnd.length > nleftEnd.length) {
    	nleftEnd = "0" + nleftEnd;  // prepend zero to LHS of number
  	}

  	if (useSeparator) nleftEnd = separate(nleftEnd, separator);  // add separator
  	var output = nleftEnd + ((nrightEnd != "") ? "." + nrightEnd : "");  // combine parts
  	output = ((useCurrency) ? currency : "") + output + ((usePercent) ? percent : "");
  	if (isNegative) {
    	// patch suggested by Tom Denn 25/4/2001
    	output = (useCurrency) ? "(" + output + ")" : "-" + output;
  	}
  	return output;

	} catch (e) {
    alert('erreur dans libs/util.js#formatNumber : ' + e);
  }
}

// utilise par formatNombre
function strip(input, chars) {  // strip all characters in 'chars' from input
  var output = "";  // initialise output string
  for (var i=0; i < input.length; i++)
    if (chars.indexOf(input.charAt(i)) == -1)
      output += input.charAt(i);
  return output;
}

// utilise par formatNombre
function separate(input, separator) {  // format input using 'separator' to mark 000's
  input = "" + input;
  var output = "";  // initialise output string
  for (var i=0; i < input.length; i++) {
    if (i != 0 && (input.length - i) % 3 == 0) output += separator;
    output += input.charAt(i);
  }
  return output;
}


/* remplace la virgule d'un nombre par un point */
function formatNumber(number) {
	try {

		return number.toString().replace(/,/i,'.');

	} catch (e) {
		recup_erreur('erreur dans libs/util.js#formatNumber : ' + e);
	}
}


/* formate un chiffre avec 'decimal' chiffres aprs la virgule et un separateur */
/* ne plus utiliser, utiliser package formatter.js */
function format(valeur,decimal,separateur,nbch) {
  try {

    var deci=Math.round( Math.pow(10,decimal)*(Math.abs(valeur)-Math.floor(Math.abs(valeur)))) ;
    var val=Math.floor(Math.abs(valeur));
    if (deci==Math.pow(10,decimal)) {
      val=Math.floor(Math.abs(valeur)) + 1;
      deci=0;
    }
    var val_format=val+"";
    var nb=val_format.length;
    for (var i=1;i<4;i++) {
      if (val>=Math.pow(10,(3*i))) {
        val_format=val_format.substring(0,nb-(3*i))+separateur+val_format.substring(nb-(3*i));
      }
    }
    if (decimal>0) {
      var decim="";
      for (var j=0;j<(decimal-deci.toString().length);j++) {decim+="0";}
      deci=decim+deci.toString();
      val_format=val_format+"."+deci;
    }
    switch (nbch) {
      case 1 :
        if (parseFloat(valeur)<10) {val_format="0"+val_format;}
        break;
      case 2 :
        if (parseFloat(valeur)<10) {val_format="0"+val_format;}
        break;
      case 3 :
        if (parseFloat(valeur)<10) {val_format="00"+val_format;}
        else if (parseFloat(valeur)<100) {val_format="0"+val_format;}
        break;
    }
    if (parseFloat(valeur)<0) {
      val_format="-"+val_format;
    }
    return val_format;

  } catch (e) {
    recup_erreur('erreur dans libs/util.js#format : ' + e);
  }
}




