/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var valcookie = '';
var utilisateur = '';


function getvalue(param) {
  switch(param) {
    case 'cookie':
      return valcookie;
      break;
    case 'utilisateur':
      return utilisateur;
      break;
    default :
      return '';
      break;
  }
}


function init() {
  try {

    document.getElementById('version').value = "OpenSi Client - version "+ get_version();

    var module = get_pref_module();

    document.getElementById('liste').value = module;

    var x = (screen.width / 2) - 300;
    var y = (screen.height / 2) - 200;
    window.resizeTo(600,450);
    window.moveTo(x,y);

		if (module=='Superviseur') {
      setTimeout(affichPassword(),0);
    } else {
      setTimeout(affichTout(),0);
    }

  } catch (e) {
    recup_erreur('erreur dans login.js#init : ' + e);
  }
}


function affiche_param() {
  try {
    document.getElementById('parambutton').collapsed = true;
    document.getElementById('paramavances').collapsed = false;
    document.getElementById('ipserveur').value = get_pref_ipserveur();
    document.getElementById('servlet').value = get_pref_servlet();
    document.getElementById('porttomcat').value = get_pref_porttomcat();
    document.getElementById('is_ssl').checked = get_pref_ssl();
  } catch (e) {
    recup_erreur('erreur dans login.js#affiche_param : ' + e);
  }
}


function checkLogin() {
  try {

    if (!document.getElementById('paramavances').collapsed) {
      set_pref_ipserveur(document.getElementById('ipserveur').value);
      set_pref_porttomcat(document.getElementById('porttomcat').value);
      set_pref_servlet(document.getElementById('servlet').value);
      set_pref_ssl(document.getElementById('is_ssl').checked);
    }
    var login = document.getElementById('login').value;
    var password = document.getElementById('password').value;

    var corps = "Page=Login.tmpl&ContentType=xml&newversion=1";
    corps += "&Login="+ login +"&Password="+ password +"&os="+ get_os();

		requeteHTTP(corps,new XMLHttpRequest(),checkLogin2);
		document.getElementById('ok').disabled = true;

  } catch(e) {
    recup_erreur('erreur dans login.js#checkLogin : ' + e);
  }
}


function checkLogin2(httpRequest) {
  try {

    // if(httpRequest.readyState != 4) return false;
    //4==document completement charge; 1==en cours; 2==charge; 3==interactif 0==initialise

    if (httpRequest.status == "0") {
      enableAll();
      return false;
    }

    if ( httpRequest.status != "200" ) {
      alert("Rception erreur "+ httpRequest.status);
      enableAll();
 	 	} else {

     var contenu=httpRequest.responseXML;
      if (contenu == null) {
        alert("Le serveur ncessite une connexion scurise. Veuillez cocher la case correspondante dans les paramtres avancs.");
        window.location = "chrome://opensi/content/login.xul";
        return -1;
      } else {

        var session = contenu.documentElement;
        valcookie = session.getAttribute('cookie');
        document.getElementById('valcookie').value = valcookie;

        if (valcookie=="") {
          alert('Login incorrect');
          window.location = "chrome://opensi/content/login.xul";
          return -1;
        } else {

          var user = session.getElementsByTagName('user')[0];
          var numversion = user.getAttribute('numversion');
          var releasename = user.getAttribute('releasename');
          var clientrelease = user.getAttribute('clientrelease');
          var clientsousrelease = user.getAttribute('clientsousrelease');
          var minrelease = user.getAttribute('minrelease');
          var currentrelease = user.getAttribute('currentrelease');
          var urlupdate = user.getAttribute('urlupdate');

          if (numversion != get_num_version() || clientrelease != get_release() || minrelease > get_sous_release()) {

            var url = "update.html?";
            url += "numversion="+ numversion;
            url += "&releasename="+ releasename;
            url += "&clientrelease="+ clientrelease;
            url += "&urlupdate="+ urlupdate;
            window.location = url;

          } else if (currentrelease > get_sous_release()) {

            var msg = "Une mise  jour (version "+ numversion +"."+ clientrelease +"."+ clientsousrelease +") est disponible\n";
            msg += "Voulez vous mettre  jour votre application ?";
            if (confirm(msg)) {
              window.location = "update2.html?urlupdate="+ urlupdate;
            } else {
              checkLogin3(user);
            }

          } else {
            checkLogin3(user);
          }
        }
      }
    }

  } catch(e) {
		recup_erreur('erreur dans login.js#checkLogin2 : ' + e);
    enableAll();
  }
}


function checkLogin3(user) {
  try {

    utilisateur = user.getAttribute('id');
    document.getElementById('utilisateur').value = utilisateur;
    if (isEmpty(utilisateur)) {
      alert('Login incorrect');
      window.location = "chrome://opensi/content/login.xul";
      return -1;
    } else {
      var url="";
      var root = user.getAttribute('root');
      var choix = document.getElementById('liste').value;
      set_pref_module(choix) ;

      if (root == "true") {
        switch (choix) {
          case 'Configuration' :
            url = "chrome://opensi/content/config/main.xul";
            break;
          case 'Superviseur' :
            url = "chrome://opensi/content/superviseur/main.xul";
            break;
          default:
            alert('Login incorrect');
            window.location = "chrome://opensi/content/login.xul";
            return -1;
            break;
          }
			} else {
        switch (choix) {
          case 'Compta':
            url = "chrome://opensi/content/compta/user/main.xul";
            break;
          case 'Facturation':
            var url = "chrome://opensi/content/facturation/user/main.xul";
            break;
          case 'Configuration':
            var url = "chrome://opensi/content/config/main.xul";
            break;
          default:
            alert('Login incorrect');
            window.location = "chrome://opensi/content/login.xul";
            return -1;
            break;
        }
      }

      window.open(url,'main','chrome,resizable');
    }

  } catch(e) {
		recup_erreur('erreur dans login.js#checkLogin3 : ' + e);
    enableAll();
  }
}


function keypress(e) {
  try {

    if (e.keyCode==13) {

      var ipserveur = document.getElementById('ipserveur');
      var porttomcat = document.getElementById('porttomcat');
      var servlet = document.getElementById('servlet');
      var login = document.getElementById('login');
      var passwd = document.getElementById('password');
      if (! document.getElementById('paramavances').collapsed) {
        if (isEmpty(ipserveur.value)) {
          alert("Vous devez prciser l'adresse et le port du serveur OpenSi");
          ipserveur.focus();
          return false;
        }
        if (isEmpty(porttomcat.value)) {
          alert("Vous devez prciser l'adresse et le port du serveur OpenSi");
          porttomcat.focus();
          return false;
        }
        if (isEmpty(servlet.value)) {
          alert("Vous devez prciser le nom du servlet sur le serveur OpenSi");
          porttomcat.focus();
          return false;
        }
      }
      if (isEmpty(login.value)) {
        login.focus();
      } else if (isEmpty(passwd.value)) {
        passwd.focus();
      } else {
        checkLogin();
      }
    }

  } catch (e) {
    recup_erreur('erreur dans login.js#keypress : ' + e);
  }
}


function enableAll() {
  try {

    document.getElementById('ok').disabled = false;

  } catch (e) {
    recup_erreur('erreur dans login.js#enableAll : ' + e);
  }
}

function affichPassword() {
  try {

    document.getElementById('login').collapsed = true;
    document.getElementById('logintexte').collapsed = true;
    document.getElementById('login').value = "root";
    document.getElementById('login').disabled = true;
    document.getElementById('password').focus();

	} catch (e) {
    recup_erreur('erreur dans login.js#affichPassword : ' + e);
  }
}

function affichTout() {
  try {

    document.getElementById('login').disabled = false;
    document.getElementById('login').collapsed = false;
    document.getElementById('logintexte').collapsed = false;
    if (document.getElementById('login').value == "root") {
      document.getElementById('login').value = "";
    }
    document.getElementById('login').focus();

  } catch (e) {
    recup_erreur('erreur dans login.js#affichTout : ' + e);
  }
}

function opensiweb() {
  window.open('http://www.opensi.org');
}
