/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var date_creation = "";
var ancdebdate = "";


function init() {
	try {

		document.getElementById("Dossier_Id").focus();
		var paramlist = "&Page=Superviseur/GetRDF/listeCentreImpot.tmpl&ContentType=xml";
  	load_rdf('Centre_Impot', getUrlOpeneas(paramlist));

		var paramlist = "&Page=Superviseur/GetRDF/listeTresorerie.tmpl&ContentType=xml";
  	load_rdf('Tresorerie', getUrlOpeneas(paramlist));

		setTimeout("initType();",200);

	} catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#init : ' + e);
  }
}


function initType() {
  try {

		document.getElementById('Type_Societe').value = "SARL";

  } catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#init_tree : ' + e);
  }
}


function changerDate() {
  try {

		var debdate = document.getElementById('Debut_Exercice').value;

		if (!isEmpty(debdate) && isDate(debdate) && ancdebdate!=debdate && debdate.length==10) {

			var annee = parseInt(debdate.substring(6,10));
			var jour = parseInt(debdate.substring(0,2));
			var mois = parseInt(debdate.substring(3,5));
			var separ1 = debdate.substring(2,3);
			var separ2 = debdate.substring(5,6);
			ancdebdate = debdate;

			DateFinExercice(jour,mois,annee,separ1,separ2);
		}

  } catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#changerDate : ' + e);
  }
}


function DateFinExercice (jour,mois,annee,separ1,separ2) {
  try {

		if (jour!=1) {
			jour = jour-1;
		}
		else {
			mois = mois-1;
			switch(mois) {
	  		case 1:case 3:case 5:case 7: case 8:case 10:case 0:
		  		jour = 31;
			  	break;
  			case 4:case 6:case 9:case 11:
	  			jour = 30;
		  		break;
  			case 2:
	  			isBissextile(annee)?jour=29:jour=28;
		  		break;
			}
  	}
		if (mois!=0) {
     	annee = annee+1;
		}
		else {
    	mois = 12;
   	}

		if (jour>=1 && jour<=9) jour = "0"+ jour;
		if (mois>=1 && mois<=9) mois = "0"+ mois;

		document.getElementById('Fin_Exercice').value = jour+separ1+mois+separ2+annee;
		document.getElementById('Fin_Exercice').select();

  } catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#changerDate : ' + e);
  }
}


function etapeDeux() {
	try {

		if (verifInfosSociete()) {

			var corps = cookie() +"&Page=Superviseur/dossiers/existeDossier.tmpl&ContentType=xml&Dossier_Id="+ document.getElementById("Dossier_Id").value;
			var httpRequest = new XMLHttpRequest();
			requeteHTTP(corps, httpRequest, etapeDeux_2);
		}

	} catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#etapeDeux : ' + e);
  }
}


function etapeDeux_2(httpRequest) {
	try {

		var message = httpRequest.responseXML.documentElement.getAttribute("message");

		if (message=="existepas") {

			var infos_societe = "&Dossier_Id=" + urlEncode(document.getElementById("Dossier_Id").value);
			infos_societe += "&Raison_Sociale=" + urlEncode(document.getElementById("Raison_Sociale").value);
			infos_societe += "&Enseigne=" + urlEncode(document.getElementById("Enseigne").value);
			infos_societe += "&Adresse=" + urlEncode(document.getElementById("Adresse").value);
			infos_societe += "&Comp_Adresse=" + urlEncode(document.getElementById("Comp_Adresse").value);
			infos_societe += "&Code_Postal=" + urlEncode(document.getElementById("Code_Postal").value);
			infos_societe += "&Ville=" + urlEncode(document.getElementById("Ville").value);
			infos_societe += "&Email=" + urlEncode(document.getElementById("Email").value);
			infos_societe += "&Telephone=" + urlEncode(document.getElementById("Telephone").value);
			infos_societe += "&Fax=" + urlEncode(document.getElementById("Fax").value);
			infos_societe += "&Num_SIRET=" + urlEncode(document.getElementById("Num_SIRET").value);
			infos_societe += "&Code_NAF=" + urlEncode(document.getElementById("Code_NAF").value);
			infos_societe += "&Type_Societe=" + urlEncode(document.getElementById("Type_Societe").value);
			infos_societe += "&Typologie=" + urlEncode(document.getElementById("Typologie").value);
			infos_societe += "&Date_Creation=" + date_creation;
			infos_societe += "&Duree_Societe=" + urlEncode(document.getElementById("Duree_Societe").value);
			infos_societe += "&Montant_Capital=" + urlEncode(document.getElementById("Montant_Capital").value);
			infos_societe += "&Nb_Parts=" + urlEncode(document.getElementById("Nb_Parts").value);
			infos_societe += "&Expert=" + urlEncode(document.getElementById("Expert").value);
			infos_societe += "&Monnaie_Tenue=" + urlEncode(document.getElementById("Monnaie_Tenue").value);
			infos_societe += "&Debut_Exercice=" + prepareDateJava(document.getElementById("Debut_Exercice").value);
			infos_societe += "&Fin_Exercice=" + prepareDateJava(document.getElementById("Fin_Exercice").value);
			infos_societe += "&Regime_Fiscal=" + urlEncode(document.getElementById("Regime_Fiscal").value);
			infos_societe += "&Regime_Groupe=" + urlEncode(document.getElementById("Regime_Groupe").value);
			infos_societe += "&Centre_Impot=" + urlEncode(document.getElementById("Centre_Impot").value);
			infos_societe += "&Tresorerie=" + urlEncode(document.getElementById("Tresorerie").value);
			infos_societe += "&Centre_Gestion=" + urlEncode(document.getElementById("Centre_Gestion").value);
			infos_societe += "&Site_Web=" + urlEncode(document.getElementById("Site_Web").value);
			infos_societe += "&Num_TVA_Intra=" + urlEncode(document.getElementById("Num_TVA_Intra").value);
			infos_societe += "&Ville_RCS=" + urlEncode(document.getElementById("Ville_RCS").value);

			window.location = "chrome://opensi/content/superviseur/dossiers/choix_modeles.xul?"+ cookie() + infos_societe;
		}
		else if (message=="existe") {
			showWarning("Le dossier "+ document.getElementById("Dossier_Id").value +" existe dj");
		}
		else {
			showWarning("Erreur du serveur");
		}

	} catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#etapeDeux_2 : ' + e);
  }
}


function verifInfosSociete() {
	try {

		var dossier = document.getElementById("Dossier_Id").value;
		date_creation = document.getElementById("Date_Creation").value;
		var debut_exercice = document.getElementById("Debut_Exercice").value;
		var fin_exercice = document.getElementById("Fin_Exercice").value;
		var email = document.getElementById("Email").value;
		var fax = document.getElementById("Fax").value;
		var telephone = document.getElementById("Telephone").value;
		var code_postal = document.getElementById("Code_Postal").value;
		var num_siret = document.getElementById("Num_SIRET").value;
		var code_naf = document.getElementById("Code_NAF").value;
		var duree_societe = document.getElementById("Duree_Societe").value;
		var montant_capital = document.getElementById("Montant_Capital").value;
		var nb_parts = document.getElementById("Nb_Parts").value;

				 if (isEmpty(dossier)) { showWarning('Nom de dossier manquant !'); return false; }
		else if (isEmpty(document.getElementById("Raison_Sociale").value)) { showWarning('Raison sociale manquante !'); return false; }
		else if (isEmpty(document.getElementById("Adresse").value)) { showWarning('Adresse manquante !'); return false; }
		else if (isEmpty(code_postal)) { showWarning('Code postal manquant !'); return false; }
		else if (isEmpty(document.getElementById("Ville").value)) { showWarning('Ville manquante !'); return false; }
		else if (isEmpty(num_siret)) { showWarning('Numro de SIRET manquant !'); return false; }
		else if (isEmpty(code_naf)) { showWarning('Code NAF manquant !'); return false; }
		else if (isEmpty(document.getElementById("Monnaie_Tenue").value)) { showWarning('Monnaie de tenue manquante !'); return false; }
		else if (isEmpty(debut_exercice)) { showWarning('Date de dbut d\'exercice manquante !'); return false; }
		else if (isEmpty(fin_exercice)) { showWarning('Date de fin d\'exercice manquante !'); return false; }

		else if (!isNomDossier(dossier.toString())) { showWarning('Nom de dossier incorrect (A-Z,a-z,_,0-9)'); return false; }
		else if (!isEmpty(date_creation) && !isDate(date_creation)) { showWarning('Date de cration incorrecte (format: jj/mm/aaaa)'); return false; }
		else if (debut_exercice.length!=10 || fin_exercice.length!=10 || !isDate(debut_exercice) || !isDate(fin_exercice)) { showWarning('Dates d\'exercices incorrectes ! (format: jj/mm/aaaa)'); return false; }
		else if (code_postal.length !=5 || !isDigitList(code_postal)) { showWarning('Code postal incorrect !'); return false;}
		else if (!isEmpty(email) && !isEmail(email)) { showWarning('Adresse e-mail incorrecte !'); return false; }
		else if (!isEmpty(fax) && !isPhone(fax)) { showWarning('Numro de fax incorrect !'); return false; }
		else if (!isEmpty(telephone) && !isPhone(telephone)) { showWarning('Numro de tlphone incorrect !'); return false; }
		else if (num_siret.length != 14 || !isDigitList(num_siret)) { showWarning('Numro de SIRET incorrect !'); return false; }
		else if (code_naf.length != 4 || !isDigitList(code_naf.substring(0,3)) || !isAlpha(code_naf.charAt(3))) { showWarning('Code NAF incorrect !'); return false; }
		else if (!isEmpty(duree_societe) && !isPositiveInteger(duree_societe)) { showWarningshowWarning('Dure de socit incorrecte !'); return false; }
		else if (!isEmpty(montant_capital) && !isPositive(montant_capital)) { showWarning('Montant du capital incorrect'); return false; }
		else if (!isEmpty(nb_parts) && !isPositiveInteger(nb_parts)) { showWarning('Nombre de parts incorrect'); return false; }
		else if (!isDateInterval(debut_exercice,fin_exercice)) { showWarning('la date de fin d\'exercice est infrieur  la date de dbut d\'exercice'); return false; }
		else {

			if (!isEmpty(date_creation))
				date_creation = prepareDateJava(date_creation);

			var maintenant = new Date();
			var deb_annee = parseInt(debut_exercice.substring(6,10));
			var deb_mois = parseInt(debut_exercice.substring(3,5));
			var deb_jour = parseInt(debut_exercice.substring(0,2));
			var fin_annee = parseInt(fin_exercice.substring(6,10));
			var fin_mois = parseInt(fin_exercice.substring(3,5));
			var fin_jour = parseInt(fin_exercice.substring(0,2));

			if (deb_annee<1970) {
				showWarning("Les dates infrieures  1970 ne sont pas acceptes !");
				return false;
			}
			else if (deb_annee<maintenant.getFullYear() || deb_annee>maintenant.getFullYear()+1) {
				if (window.confirm("L'anne du dbut de l'exercice est probablement incorrecte : "+deb_annee+"\nEtes vous sr de vouloir continuer ?")) {
					return true;
				}
			}
			else if (fin_annee-deb_annee>1 || (fin_annee-deb_annee==1 && fin_mois>deb_mois) || (fin_annee-deb_annee==1 && fin_mois==deb_mois && fin_jour>=deb_jour)) {
				if (window.confirm("La dure de l'exercice est suprieure  une anne\nEtes vous sr de vouloir continuer ?")) {
					return true;
				}
			}
			else if ((fin_annee-deb_annee==0 && (fin_mois-deb_mois!=11 || fin_jour-deb_jour!=30)) || ((fin_annee-deb_annee==1 && fin_mois<deb_mois))) {
				if (window.confirm("La dure de l'exercice est infrieure  une anne\nEtes vous sr de vouloir continuer ?")) {
					return true;
				}
			}
			else {
				return true;
			}
		}

	} catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#verifInfosSociete : ' + e);
  }
}

function retour_menuManager() {
	try {

  	window.location = "chrome://opensi/content/superviseur/menu_superviseur.xul?"+ cookie();

	} catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#retour_menuManager : ' + e);
  }
}

function retour_menuDossiers() {
	try {

  	window.location = "chrome://opensi/content/superviseur/dossiers/menu_dossiers.xul?"+ cookie();

	} catch (e) {
    recup_erreur('erreur dans superviseur/dossiers/nouveau_dossier.js#retour_menuDossiers : ' + e);
  }
}
