/******************************************************************************/
/* OpenSI Comptabilit : Outils libre de comptabilit d'entreprise            */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var code_tva;
var taux_tva;


function init() {
	try {

		init_tree();

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#init : ' + e);
  }
}


function init_tree() {
  try {

    var paramlist = "&Page=Superviseur/GetRDF/listeTauxTva.tmpl&ContentType=xml";
    load_rdf("liste_TVA", getUrlOpeneas(paramlist));

  } catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {

    var database = document.getElementById("liste_TVA").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
   	document.getElementById("liste_TVA").builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#delete_tree : ' + e);
  }
}


function reporter() {
  try {

    var tree = document.getElementById("liste_TVA");

		if (tree.view!=null && tree.currentIndex!=-1) {

    	document.getElementById('Taux_TVA').value = getCellText(tree,tree.view.selection.currentIndex,'ColMode');
			taux_tva = getCellText(tree,tree.view.selection.currentIndex,'ColMode');
			code_tva = getCellValue(tree,tree.view.selection.currentIndex,'ColMode');
			disableSup(false);
			document.getElementById('nouveau').collapsed = false;
			document.getElementById('bAjouter').collapsed  = true;
			document.getElementById('bModifier').collapsed  = false;
		}

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#reporter : ' + e);
  }
}


function nouvelleTVA() {
  try {

    disableSup(true);
		document.getElementById('bSupprimer').collapsed = true;
		document.getElementById('Taux_TVA').value = "";
		document.getElementById('nouveau').collapsed = true;
		document.getElementById('bAjouter').collapsed  = false;
		document.getElementById('bModifier').collapsed  = true;
  	document.getElementById('Taux_TVA').focus();

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#reporter : ' + e);
  }
}


function disableSup(b) {
	try {

		var tree = document.getElementById("liste_TVA");

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById('bSupprimer').collapsed = b;
		}

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#disableSup : ' + e);
  }
}


function supprimerTVA() {
	try {

		var tree = document.getElementById("liste_TVA");

		if (tree.view!=null && tree.currentIndex!=-1) {

			if (code_tva=="1") {
				showWarning("Le taux de TVA '0.00 %' ne peut pas tre supprim !");
			}
			else if (code_tva=="4") {
				showWarning("Le taux de TVA '"+ taux_tva +" %' ne peut pas tre supprim !");
			}
			else {

				if (window.confirm("Confirmez-vous la suppression du taux de TVA de "+ taux_tva +" % ?")) {

					var corps = cookie() +"&Page=Superviseur/tva/supprimerTVA.tmpl&ContentType=xml&Code_TVA="+ code_tva;
					var httpRequest = new XMLHttpRequest();
					requeteHTTP(corps, httpRequest, supprimerTVA_2);
				}
			}
			nouvelleTVA();
		}

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#supprimerTVA : ' + e);
  }
}


function supprimerTVA_2(httpRequest) {
	try {

		var message = httpRequest.responseXML.documentElement.getAttribute("message");

		if (message=="suppr") {
			showMessage("Le taux de TVA '"+ taux_tva +" %' a t supprim avec succs");
		}
		else if (message=="impossible") {
			showWarning("Impossible de supprimer, ce taux de TVA est utilis par OpenSI !");
		}
		else {
			showWarning("Erreur du serveur !");
		}

		delete_tree();
		init_tree();
		document.getElementById('bSupprimer').collapsed = true;

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#supprimerTVA_2 : ' + e);
  }
}


function modifierTVA() {
	try {

		var Ntaux_tva = document.getElementById('Taux_TVA').value;
		var autoriser = true;
    var tree = document.getElementById("liste_TVA");

		if (tree.view!=null) {

  		for (i=0;i<tree.view.rowCount;i++) {
				if (parseFloat(Ntaux_tva) == parseFloat(getCellText(tree,i,'ColMode'))) {
					autoriser = false;
					showWarning("Le taux de TVA '"+ Ntaux_tva +" %' existe dj !");
				}
    	}

			if (autoriser && (code_tva=="1" ||code_tva=="4")) {
				autoriser = window.confirm("Confirmez-vous la modification du taux de TVA de "+ taux_tva +" % ?")
			}

			if (isEmpty(Ntaux_tva) || !isTaux(Ntaux_tva)) {
				showWarning("Taux de TVA incorrect !");
			}
			else {

 				if (autoriser) {
					var corps = cookie() +"&Page=Superviseur/tva/modifierTVA.tmpl&ContentType=xml&Code_TVA="+code_tva+"&Taux_TVA="+ Ntaux_tva;
					var httpRequest = new XMLHttpRequest();
					requeteHTTP(corps, httpRequest, modifierTVA_2);
				}
			}
		}

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#modifierTVA : ' + e);
  }
}


function modifierTVA_2(httpRequest) {
	try {

		var message = httpRequest.responseXML.documentElement.getAttribute("message");
		if (message=="mod") {
			showMessage("Le taux de TVA a t modifi avec succs");
		}
		else {
			showWarning("Erreur du serveur !");
		}

		delete_tree();
		init_tree();
		nouvelleTVA();

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#modifierTVA_2 : ' + e);
  }
}


function enregistrerTVA(mode) {
	try {

		var taux_tva = document.getElementById('Taux_TVA').value;

		if (isEmpty(taux_tva) || !isTaux(taux_tva)) {
			showWarning("Taux de TVA incorrect !");
		}
		else {

			var autoriser = true;
	    var tree = document.getElementById("liste_TVA");

			if (tree.view!=null) {

  			for (i=0;i<tree.view.rowCount;i++) {
					if (parseFloat(taux_tva) == parseFloat(getCellText(tree,i,'ColMode'))) {
						autoriser = false;
						showWarning("Le taux de TVA '"+ taux_tva +" %' existe dj");
					}
    		}

				if (autoriser) {

					var corps = cookie() +"&Page=Superviseur/tva/creerTVA.tmpl&ContentType=xml&Taux_TVA="+ taux_tva;
					var httpRequest = new XMLHttpRequest();

					requeteHTTP(corps, httpRequest, enregistrerTVA_2);
				}
			}
  	}

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#enregistrerTVA : ' + e);
  }
}


function enregistrerTVA_2(httpRequest) {
	try {

		delete_tree();
		init_tree();
		document.getElementById('Taux_TVA').value = '';

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#enregistrerTVA_2 : ' + e);
  }
}


function retour_menuManager() {
	try {

  	window.location = "chrome://opensi/content/superviseur/menu_superviseur.xul?"+ cookie();

	} catch (e) {
    recup_erreur('erreur dans superviseur/tva/tva.js#retour_menuManager : ' + e);
  }
}
