/******************************************************************************/
/* OpenSI : Outils libre de gestion d'entreprise                              */
/* Copyright (C) 2003 SpeedInfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


var admin = 0;


function init() {
	try {
	
		init_tree();
		document.getElementById("titre").value = "MODIFICATION DE L'UTILISATEUR '"+ ParamValeur('Login') +"'";
		
		document.getElementById('Enlever').disabled = true;
		document.getElementById('Ajouter').disabled = true;
		
		var corps = cookie() +"&Page=Superviseur/utilisateurs/getUtilisateur.tmpl&ContentType=xml&Login="+ ParamValeur('Login');
		var httpRequest = new XMLHttpRequest();		
		requeteHTTP(corps, httpRequest, init_2);	
		
  } catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#init : ' + e);
  }
}


function init_2(httpRequest) {
	try {
	
		var contenu = httpRequest.responseXML.documentElement;
		
		admin = contenu.getAttribute('admin');
		document.getElementById("Nom").value = contenu.getAttribute('nom');
		document.getElementById("Prenom").value = contenu.getAttribute('prenom');
		document.getElementById("Fonction").value = contenu.getAttribute('fonction');
		document.getElementById('admin').checked = (admin==1);
				

	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#init_2 : ' + e);
  }
}


function init_tree() {
  try {
	
		var paramlist = "&Page=Superviseur/GetRDF/listeDroitsUtilisateur.tmpl&ContentType=xml&Login="+ ParamValeur('Login');
		load_rdf('liste_droits', getUrlOpeneas(paramlist));		

		paramlist = "&Page=Superviseur/GetRDF/listeNonDroitsUtilisateur.tmpl&ContentType=xml&Login="+ ParamValeur('Login');
		load_rdf('liste_dossiers', getUrlOpeneas(paramlist));		

  } catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#init_tree : ' + e);
  }
}


function delete_tree() {
  try {
	
    var database = document.getElementById("liste_droits").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById("liste_droits").builder.rebuild();
	
    var database = document.getElementById("liste_dossiers").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById("liste_dossiers").builder.rebuild();

  } catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#delete_tree : ' + e);
  }
}


function affecterDroits() {
	try {
	
		var tree = document.getElementById('liste_dossiers');
		var rangeCount = tree.view.selection.getRangeCount();
		
		for(var i=0; i<rangeCount; i++) {
		
			var start = {};
 			var end = {};
 			tree.view.selection.getRangeAt(i,start,end);
			
 			for(var c=start.value; c<=end.value; c++) {
			
				var dossier_id = getCellText(tree,c,'dossier_id');
				
				if (isEmpty(dossier_id)) {
					showWarning('Aucun dossier slectionn !');
				}
				else {
				
					var corps = cookie() +"&Page=Superviseur/getBase.tmpl&ContentType=xml&Dossier_Id="+ dossier_id;
					var p = requeteHTTP(corps);
 					
					var base = p.responseXML.documentElement.getAttribute('nom');
					
					corps = cookie() +"&Page=Superviseur/utilisateurs/affecterDroits.tmpl&ContentType=xml&Login="+ ParamValeur('Login');
					corps += "&Dossier_Id="+ dossier_id +"&Base="+ base +"&Admin="+ admin;
					p = requeteHTTP(corps);
  				
					var message = p.responseXML.documentElement.getAttribute("message");
					
					if (message=="inexistant") {
						showWarning("Dossier "+ dossier_id +" inexistant !");
					}
					else if (message=="droit") {
						showWarning("L'utilisateur "+ParamValeur('Login')+" a dj les droits sur le dossier "+dossier_id+" !");
					}
					else if (message!="fini") {
						showWarning("erreur du serveur");
					}					
				}
 			}
		}
		
		delete_tree();
		init_tree();
		document.getElementById('Ajouter').disabled = true;
	
	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#affecterDroits : ' + e);
  }
}


function supprimerDroits() {
	try {
	
		var tree = document.getElementById('liste_droits');
		var rangeCount = tree.view.selection.getRangeCount();
		
		for(var i=0; i<rangeCount; i++) {
		
			var start = {};
  		var end = {};
  		tree.view.selection.getRangeAt(i,start,end);
  	
			for(var c=start.value; c<=end.value; c++) {
				
				var dossier_id = getCellText(tree,c,'dossier_id');
				
				if (isEmpty(dossier_id)) {
					showWarning('Aucun dossier slectionn !');
				}
				else {
				
					var corps = cookie() +"&Page=Superviseur/utilisateurs/supprimerDroits.tmpl&ContentType=xml&Login="+ ParamValeur('Login') +"&Dossier_Id="+ dossier_id;
					var p = requeteHTTP(corps);
				}
			}
		}
		
		delete_tree();
		init_tree();
		document.getElementById('Enlever').disabled = true;
		
	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#supprimerDroits : ' + e);
  }
}


function enable(gauche) {
	try {
	
		var tree = (gauche?document.getElementById('liste_dossiers'):document.getElementById('liste_droits'));
		
		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById('Enlever').disabled = gauche;
			document.getElementById('Ajouter').disabled = !gauche;
		}
	
	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#enable : ' + e);
  }
}


function changer_password() {
	try {
 		
		var page ="chrome://opensi/content/superviseur/utilisateurs/password.xul?"+ cookie() +"&Login="+ ParamValeur('Login');
		window.openDialog(page,'','chrome,modal');
 	
	} catch (e) {
    recup_erreur('erreur dans	superviseur/utilisateurs/modifier_utilisateur.js#changer_password : ' + e);
  }
}


function enregistrer_utilisateur() {
	try {
	
		var nom = document.getElementById('Nom').value;
		var prenom = document.getElementById('Prenom').value;
		var fonction = document.getElementById('Fonction').value;
		var admin = document.getElementById('admin').checked?"1":"0";
		
		if (isEmpty(prenom) || isEmpty(nom)) {
			showWarning("Vous devez remplir tous les champs !");
		}
		else {
		
			var corps = cookie() +"&Page=Superviseur/utilisateurs/modifierUtilisateur.tmpl&ContentType=xml&Login="+ ParamValeur('Login');
			corps += "&Nom="+ urlEncode(nom) +"&Prenom="+ urlEncode(prenom) +"&Fonction="+ urlEncode(fonction) +"&Administrateur="+ admin;
			
			var httpRequest = new XMLHttpRequest();			
			requeteHTTP(corps, httpRequest, enregistrer_utilisateur_2);
		}
	
	}	catch (e) {
		recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#enregistrer_utilisateur : ' + e);
	}
}


function enregistrer_utilisateur_2(httpRequest) {
	try {

		var message = httpRequest.responseXML.documentElement.getAttribute("message");
		
		if (message=="inexistant") {
			showWarning("Utilisateur non modifi !");
		}
		else if (message=="fini") {
			showMessage("L'utilisateur "+ ParamValeur('Login') +" a t modifi avec succs");
		}
		else {
			showWarning("Erreur du serveur !");
		}			

	}	catch (e) {
		recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#enregistrer_utilisateur_2 : ' + e);
	}
}


function supprimer_utilisateur() {
	try {
	
		var rep = window.confirm("Confirmez-vous la suppression de l'utilisateur '"+ ParamValeur('Login') +"' ?");
	
		if (rep) {
		
			var corps = cookie() +"&Page=Superviseur/utilisateurs/supprimerUtilisateur.tmpl&ContentType=xml&Login="+ ParamValeur('Login');
			var httpRequest = new XMLHttpRequest();			
			requeteHTTP(corps, httpRequest, supprimerUtilisateur_2);  		
		}
		
	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#supprimer_utilisateur : ' + e);
  }
}


function supprimerUtilisateur_2(httpRequest) {
	try {
	
		var message = httpRequest.responseXML.documentElement.getAttribute("message");
		
		if (message=="inexistant") {
			showWarning("Utilisateur non supprim !");
		}
		else if (message=="fini") {
			showMessage("L'utilisateur "+ ParamValeur('Login') +" a t supprim avec succs");
		}
		else {
			showWarning("Erreur du serveur !");
		}

  	window.location = "chrome://opensi/content/superviseur/utilisateurs/menu_utilisateurs.xul?"+ cookie();
			
	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#supprimerUtilisateur_2 : ' + e);
  }
}


function retour_menuManager() {
	try {

  	window.location = "chrome://opensi/content/superviseur/menu_superviseur.xul?"+ cookie();
		
	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#retour_menuManager : ' + e);
  }
}


function retour_menuUtilisateurs() {
	try {

  	window.location = "chrome://opensi/content/superviseur/utilisateurs/menu_utilisateurs.xul?"+ cookie();
		
	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#retour_menuUtilisateurs : ' + e);
  }
}


function nouveau_utilisateur() {
	try {
	
  	window.location = "chrome://opensi/content/superviseur/utilisateurs/nouveau_utilisateur.xul?"+ cookie();
	
	} catch (e) {
    recup_erreur('erreur dans superviseur/utilisateurs/modifier_utilisateur.js#nouveau_utilisateur : ' + e);
  }
}
